/*
 * Copyright (C) 2016 MediaTek Inc.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 */

#include <linux/kernel.h>
#include <linux/module.h>

#include <mach/upmu_sw.h>
#include <mach/upmu_hw.h>
#include <mt-plat/upmu_common.h>

#include "include/pmic.h"
/* -------- generated by version : ldo gen v1.0 ------------ */
/* -------- date : 2015-11-13                   ------------ */
/* -------- date : 2015-11-13                   ------------ */

/* -------- LDO VTCXO28 API ------------ LDO Type3 */
/* define EN by sw mode */
void pmic_ldo_vtcxo28_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO28; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO28_EN);
	PMICLOG("ldo : VTCXO28; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vtcxo28_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO28; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO28_EN_SEL);
	PMICLOG("ldo : VTCXO28; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vtcxo28_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO28; sw stb sel = %d\n", sel_value);
	/* stb = 100, 130 */
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO28_STBTD);
	PMICLOG("ldo : VTCXO28; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vtcxo28_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO28; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO28_LP_MODE);
	PMICLOG("ldo : VTCXO28; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vtcxo28_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO28; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO28_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO28_LP_SEL);
	PMICLOG("ldo : VTCXO28; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VTCXO28 API end -------- */

/* -------- LDO VTCXO24 API ------------ LDO Type4 */
void pmic_ldo_vtcxo24_sw_en(int en_value)
{				/*  api skip : (8)ALLEN+ALLLP */
	unsigned short read_back;

	PMICLOG("ldo : VTCXO24; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_SWITCH, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO24_EN);
	PMICLOG("ldo : VTCXO24; sw en_value readback = %d\n", read_back);
}


/*  api skip : (8)ALLEN+ALLLP */
/*void pmic_ldo_vtcxo24_hw_en*/
/* define EN by hw mode */
void pmic_ldo_vtcxo24_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO24; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_SWITCH, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO24_EN_SEL);
	PMICLOG("ldo : VTCXO24; hw en_sel readback = %d\n", read_back);
}

/* define EN STB by sw mode */
void pmic_ldo_vtcxo24_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO24; sw stb sel = %d\n", sel_value);
	/* stb = 100, 130 */
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO24_STBTD);
	PMICLOG("ldo : VTCXO24; sel_value readback = %d\n", read_back);
}

/*  api skip : (8)ALLEN+ALLLP */
/*void pmic_ldo_vtcxo24_sw_lp_mode*/
/*  api skip : (8)ALLEN+ALLLP */
/*void pmic_ldo_vtcxo24_hw_lp_mode *//* -------- LDO VTCXO24 API end -------- */
/* define LP by sw mode */
void pmic_ldo_vtcxo24_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO24; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO24_LP_MODE);
	PMICLOG("ldo : VTCXO24; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vtcxo24_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VTCXO24; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VTCXO24_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VTCXO24_LP_SEL);
	PMICLOG("ldo : VTCXO24; hw mode_sel_value readback = %d\n", read_back);
}

/* -------- LDO VXO22  API ------------ LDO Type4 */
/* define EN by sw mode */
void pmic_ldo_vxo22_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VXO22 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VXO22_EN);
	PMICLOG("ldo : VXO22 ; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vxo22_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VXO22 ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VXO22_EN_SEL);
	PMICLOG("ldo : VXO22 ; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vxo22_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VXO22 ; sw stb sel = %d\n", sel_value);
	/* stb = 100, 130 */
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VXO22_STBTD);
	PMICLOG("ldo : VXO22 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vxo22_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VXO22 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VXO22_LP_MODE);
	PMICLOG("ldo : VXO22 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vxo22_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VXO22 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VXO22_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VXO22_LP_SEL);
	PMICLOG("ldo : VXO22 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VXO22  API end -------- */

/* -------- LDO VRF18  API ------------ LDO Type3 */
/* define EN by sw mode */
void pmic_ldo_vrf18_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF18 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF18_EN);
	PMICLOG("ldo : VRF18 ; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vrf18_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF18 ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF18_EN_SEL);
	PMICLOG("ldo : VRF18 ; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vrf18_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF18 ; sw stb sel = %d\n", sel_value);
	/* stb = 200, 255 */
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF18_STBTD);
	PMICLOG("ldo : VRF18 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vrf18_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF18 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF18_LP_MODE);
	PMICLOG("ldo : VRF18 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vrf18_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF18 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VRF18_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF18_LP_SEL);
	PMICLOG("ldo : VRF18 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VRF18  API end -------- */

/* -------- LDO VRF12  API ------------ LDO Type3 */
/* define EN by sw mode */
void pmic_ldo_vrf12_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_EN);
	PMICLOG("ldo : VRF12 ; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vrf12_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_EN_SEL);
	PMICLOG("ldo : VRF12 ; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vrf12_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; sw stb sel = %d\n", sel_value);
	/* stb = 200, 255 */
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_STBTD);
	PMICLOG("ldo : VRF12 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vrf12_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_LP_MODE);
	PMICLOG("ldo : VRF12 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vrf12_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_LP_SEL);
	PMICLOG("ldo : VRF12 ; hw mode_sel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by sw mode */
void pmic_ldo_vrf12_sw_fs_trans_dl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; sw fs_trans_dl_en = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_DL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_DL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_DL_EN);
	PMICLOG("ldo : VRF12 ; sw fs trans dl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by sw mode */
void pmic_ldo_vrf12_sw_fs_trans_cl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; sw fs_trans_cl_en = %d", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_CL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_CL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_CL_EN);
	PMICLOG("ldo : VRF12 ; sw fs trans cl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by hw mode */
void pmic_ldo_vrf12_hw_fs_trans_dl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; hw fs_trans_dl_ensel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_DL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_DL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_DL_SRCLKEN_SEL);
	PMICLOG("ldo : VRF12 ; hw fs trans dl ensel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by hw mode */
void pmic_ldo_vrf12_hw_fs_trans_cl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VRF12 ; sw fs_trans_cl_en = %d", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_CL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_CL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VRF12_FAST_TRAN_CL_SRCLKEN_SEL);
	PMICLOG("ldo : VRF12 ; hw fs trans cl ensel_value readback = %d\n", read_back);
}
/* -------- LDO VRF12  API end -------- */

/* -------- LDO VCN33  API ------------ LDO Type3 */
void pmic_ldo_vcn33_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN33 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_CTRL_BT, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_BT, en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_CTRL_WIFI, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_WIFI, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_EN_BT);
	PMICLOG("ldo : VCN33 ; sw en_value readback = %d\n", read_back);
}


void pmic_ldo_vcn33_bt_sw_en(int en_value)
{				/*  api skip : (3)ALLEN */
	unsigned short read_back;

	PMICLOG("ldo : VCN33_BT; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_CTRL_BT, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_BT, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_EN_BT);
	PMICLOG("ldo : VCN33_BT; sw en_value readback = %d\n", read_back);
}

void pmic_ldo_vcn33_wifi_sw_en(int en_value)
{				/*  api skip : (3)ALLEN */
	unsigned short read_back;

	PMICLOG("ldo : VCN33_WIFI; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_CTRL_WIFI, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_WIFI, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_EN_WIFI);
	PMICLOG("ldo : VCN33_WIFI; sw en_value readback = %d\n", read_back);
}

/*  api skip : (3)ALLEN */
/*void pmic_ldo_vcn33_hw_en*/
/* define EN by hw mode */
void pmic_ldo_vcn33_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN33 ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_CTRL_BT, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_SEL_BT, ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_CTRL_WIFI, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_EN_SEL_WIFI, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_EN_SEL_BT);
	PMICLOG("ldo : VCN33 ; hw en_sel readback = %d\n", read_back);
}
/* -------- LDO VCN33  API end -------- */

/* define EN STB by sw mode */
void pmic_ldo_vcn33_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN33 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_STBTD);
	PMICLOG("ldo : VCN33 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vcn33_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN33 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_LP_MODE);
	PMICLOG("ldo : VCN33 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vcn33_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN33 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN33_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN33_LP_SEL);
	PMICLOG("ldo : VCN33 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VCN33  API end -------- */

/* -------- LDO VCN28  API ------------ LDO Type3 */
/* define EN by sw mode */
void pmic_ldo_vcn28_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN28 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN28_EN);
	PMICLOG("ldo : VCN28 ; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vcn28_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN28 ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN28_EN_SEL);
	PMICLOG("ldo : VCN28 ; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vcn28_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN28 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN28_STBTD);
	PMICLOG("ldo : VCN28 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vcn28_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN28 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN28_LP_MODE);
	PMICLOG("ldo : VCN28 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vcn28_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN28 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN28_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN28_LP_SEL);
	PMICLOG("ldo : VCN28 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VCN28  API end -------- */

/* -------- LDO VCN18  API ------------ LDO Type3 */
/* define EN by sw mode */
void pmic_ldo_vcn18_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN18 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN18_EN);
	PMICLOG("ldo : VCN18 ; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vcn18_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN18 ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN18_EN_SEL);
	PMICLOG("ldo : VCN18 ; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vcn18_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN18 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN18_STBTD);
	PMICLOG("ldo : VCN18 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vcn18_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN18 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN18_LP_MODE);
	PMICLOG("ldo : VCN18 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vcn18_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCN18 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VCN18_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCN18_LP_SEL);
	PMICLOG("ldo : VCN18 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VCN18  API end -------- */

/* -------- LDO VCAMA  API ------------ LDO Type0 */
/* define EN by sw mode */
void pmic_ldo_vcama_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMA ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCAMA_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMA_EN);
	PMICLOG("ldo : VCAMA ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vcama_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMA ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VCAMA_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMA_STBTD);
	PMICLOG("ldo : VCAMA ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vcama_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMA ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCAMA_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMA_LP_MODE);
	PMICLOG("ldo : VCAMA ; sw lp mode_value readback = %d\n", read_back);
}
/* -------- LDO VCAMA  API end -------- */

/* -------- LDO VCAMIO API ------------ LDO Type0 */
/* define EN by sw mode */
void pmic_ldo_vcamio_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMIO; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCAMIO_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMIO_EN);
	PMICLOG("ldo : VCAMIO; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vcamio_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMIO; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VCAMIO_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMIO_STBTD);
	PMICLOG("ldo : VCAMIO; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vcamio_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMIO; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCAMIO_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMIO_LP_MODE);
	PMICLOG("ldo : VCAMIO; sw lp mode_value readback = %d\n", read_back);
}
/* -------- LDO VCAMIO API end -------- */

/* -------- LDO VLDO28 API ------------ LDO Type1 */
/* void pmic_ldo_vldo28_sw_en*/ /*  api skip : (3)ALLEN */
/* define EN by sw mode */
void pmic_ldo_vldo28_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_EN_0, en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_EN_1, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_EN_0);
	PMICLOG("ldo : VLDO28; sw en_value readback = %d\n", read_back);
}

void pmic_ldo_vldo28_0_sw_en(int en_value)
{				/*  api skip : (3)ALLEN */
	unsigned short read_back;

	PMICLOG("ldo : VLDO28_0; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_EN_0, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_EN_0);
	PMICLOG("ldo : VLDO28_0; sw en_value readback = %d\n", read_back);
}

void pmic_ldo_vldo28_1_sw_en(int en_value)
{				/*  api skip : (3)ALLEN */
	unsigned short read_back;

	PMICLOG("ldo : VLDO28_1; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_EN_1, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_EN_1);
	PMICLOG("ldo : VLDO28_1; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vldo28_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_STBTD);
	PMICLOG("ldo : VLDO28; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vldo28_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_LP_MODE);
	PMICLOG("ldo : VLDO28; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vldo28_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_LP_SEL);
	PMICLOG("ldo : VLDO28; hw mode_sel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by sw mode */
void pmic_ldo_vldo28_sw_fs_trans_dl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; sw fs_trans_dl_en = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_DL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_DL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_DL_EN);
	PMICLOG("ldo : VLDO28; sw fs trans dl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by sw mode */
void pmic_ldo_vldo28_sw_fs_trans_cl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; sw fs_trans_cl_en = %d", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_CL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_CL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_CL_EN);
	PMICLOG("ldo : VLDO28; sw fs trans cl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by hw mode */
void pmic_ldo_vldo28_hw_fs_trans_dl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; hw fs_trans_dl_ensel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_DL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_DL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_DL_SRCLKEN_SEL);
	PMICLOG("ldo : VLDO28; hw fs trans dl ensel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by hw mode */
void pmic_ldo_vldo28_hw_fs_trans_cl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VLDO28; sw fs_trans_cl_en = %d", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_CL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_CL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VLDO28_FAST_TRAN_CL_SRCLKEN_SEL);
	PMICLOG("ldo : VLDO28; hw fs trans cl ensel_value readback = %d\n", read_back);
}
/* -------- LDO VLDO28 API end -------- */

/* -------- LDO VCAMD  API ------------ LDO Type0 */
/* define EN by sw mode */
void pmic_ldo_vcamd_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMD ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCAMD_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMD_EN);
	PMICLOG("ldo : VCAMD ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vcamd_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMD ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VCAMD_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMD_STBTD);
	PMICLOG("ldo : VCAMD ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vcamd_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VCAMD ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VCAMD_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VCAMD_LP_MODE);
	PMICLOG("ldo : VCAMD ; sw lp mode_value readback = %d\n", read_back);
}
/* -------- LDO VCAMD  API end -------- */

/* -------- LDO VAUX18 API ------------ LDO Type4 */
/* define EN by sw mode */
void pmic_ldo_vaux18_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUX18; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUX18_EN);
	PMICLOG("ldo : VAUX18; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vaux18_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUX18; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUX18_EN_SEL);
	PMICLOG("ldo : VAUX18; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vaux18_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUX18; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUX18_STBTD);
	PMICLOG("ldo : VAUX18; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vaux18_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUX18; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUX18_LP_MODE);
	PMICLOG("ldo : VAUX18; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vaux18_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUX18; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VAUX18_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUX18_LP_SEL);
	PMICLOG("ldo : VAUX18; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VAUX18 API end -------- */

/* -------- LDO VAUD28 API ------------ LDO Type4 */
/* define EN by sw mode */
void pmic_ldo_vaud28_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUD28; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUD28_EN);
	PMICLOG("ldo : VAUD28; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vaud28_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUD28; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUD28_EN_SEL);
	PMICLOG("ldo : VAUD28; hw en_sel readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vaud28_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUD28; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUD28_STBTD);
	PMICLOG("ldo : VAUD28; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vaud28_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUD28; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUD28_LP_MODE);
	PMICLOG("ldo : VAUD28; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vaud28_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VAUD28; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VAUD28_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VAUD28_LP_SEL);
	PMICLOG("ldo : VAUD28; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VAUD28 API end -------- */

/* -------- LDO VSRAM_PROC API ------------ LDO Type4 */
/* define EN by sw mode */
#if 0 /*---defined in buck---*/
void pmic_ldo_vsram_proc_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSRAM_PROC; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSRAM_PROC_EN);
	PMICLOG("ldo : VSRAM_PROC; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_vsram_proc_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSRAM_PROC; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSRAM_PROC_EN_SEL);
	PMICLOG("ldo : VSRAM_PROC; hw en_sel readback = %d\n", read_back);
}
#endif

/* define EN STB by sw mode */
void pmic_ldo_vsram_proc_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSRAM_PROC; sw stb sel = %d\n", sel_value);
	/* stb = 200, 255 */
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSRAM_PROC_STBTD);
	PMICLOG("ldo : VSRAM_PROC; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vsram_proc_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSRAM_PROC; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSRAM_PROC_LP_MODE);
	PMICLOG("ldo : VSRAM_PROC; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vsram_proc_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSRAM_PROC; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VSRAM_PROC_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSRAM_PROC_LP_SEL);
	PMICLOG("ldo : VSRAM_PROC; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VSRAM_PROC API end -------- */

/* -------- LDO VDRAM  API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vdram_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_EN);
	PMICLOG("ldo : VDRAM ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vdram_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_STBTD);
	PMICLOG("ldo : VDRAM ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vdram_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_LP_MODE);
	PMICLOG("ldo : VDRAM ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vdram_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_LP_SEL);
	PMICLOG("ldo : VDRAM ; hw mode_sel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by sw mode */
void pmic_ldo_vdram_sw_fs_trans_dl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; sw fs_trans_dl_en = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_DL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_DL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_DL_EN);
	PMICLOG("ldo : VDRAM ; sw fs trans dl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by sw mode */
void pmic_ldo_vdram_sw_fs_trans_cl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; sw fs_trans_cl_en = %d", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_CL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_CL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_CL_EN);
	PMICLOG("ldo : VDRAM ; sw fs trans cl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by hw mode */
void pmic_ldo_vdram_hw_fs_trans_dl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; hw fs_trans_dl_ensel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_DL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_DL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_DL_SRCLKEN_SEL);
	PMICLOG("ldo : VDRAM ; hw fs trans dl ensel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by hw mode */
void pmic_ldo_vdram_hw_fs_trans_cl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VDRAM ; sw fs_trans_cl_en = %d", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_CL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_CL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VDRAM_FAST_TRAN_CL_SRCLKEN_SEL);
	PMICLOG("ldo : VDRAM ; hw fs trans cl ensel_value readback = %d\n", read_back);
}
/* -------- LDO VDRAM  API end -------- */

/* -------- LDO VSIM1  API ------------ LDO Type1 */
/* define EN by sw mode */
void pmic_ldo_vsim1_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM1 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM1_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM1_EN);
	PMICLOG("ldo : VSIM1 ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vsim1_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM1 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VSIM1_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM1_STBTD);
	PMICLOG("ldo : VSIM1 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vsim1_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM1 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM1_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM1_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM1_LP_MODE);
	PMICLOG("ldo : VSIM1 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vsim1_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM1 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM1_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM1_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM1_LP_SEL);
	PMICLOG("ldo : VSIM1 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VSIM1  API end -------- */

/* -------- LDO VSIM2  API ------------ LDO Type1 */
/* define EN by sw mode */
void pmic_ldo_vsim2_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM2 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM2_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM2_EN);
	PMICLOG("ldo : VSIM2 ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vsim2_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM2 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VSIM2_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM2_STBTD);
	PMICLOG("ldo : VSIM2 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vsim2_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM2 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM2_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM2_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM2_LP_MODE);
	PMICLOG("ldo : VSIM2 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vsim2_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VSIM2 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM2_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VSIM2_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VSIM2_LP_SEL);
	PMICLOG("ldo : VSIM2 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VSIM2  API end -------- */

/* -------- LDO VIO28  API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vio28_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO28 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIO28_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO28_EN);
	PMICLOG("ldo : VIO28 ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vio28_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO28 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VIO28_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO28_STBTD);
	PMICLOG("ldo : VIO28 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vio28_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO28 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIO28_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VIO28_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO28_LP_MODE);
	PMICLOG("ldo : VIO28 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vio28_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO28 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIO28_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VIO28_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO28_LP_SEL);
	PMICLOG("ldo : VIO28 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VIO28  API end -------- */

/* -------- LDO VMC    API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vmc_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_EN);
	PMICLOG("ldo : VMC   ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vmc_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VMC_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_STBTD);
	PMICLOG("ldo : VMC   ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vmc_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_LP_MODE);
	PMICLOG("ldo : VMC   ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vmc_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_LP_SEL);
	PMICLOG("ldo : VMC   ; hw mode_sel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by sw mode */
void pmic_ldo_vmc_sw_fs_trans_dl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; sw fs_trans_dl_en = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_DL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_DL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_DL_EN);
	PMICLOG("ldo : VMC   ; sw fs trans dl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by sw mode */
void pmic_ldo_vmc_sw_fs_trans_cl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; sw fs_trans_cl_en = %d", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_CL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_CL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_CL_EN);
	PMICLOG("ldo : VMC   ; sw fs trans cl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by hw mode */
void pmic_ldo_vmc_hw_fs_trans_dl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; hw fs_trans_dl_ensel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_DL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_DL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_DL_SRCLKEN_SEL);
	PMICLOG("ldo : VMC   ; hw fs trans dl ensel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by hw mode */
void pmic_ldo_vmc_hw_fs_trans_cl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMC   ; sw fs_trans_cl_en = %d", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_CL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_CL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMC_FAST_TRAN_CL_SRCLKEN_SEL);
	PMICLOG("ldo : VMC   ; hw fs trans cl ensel_value readback = %d\n", read_back);
}
/* -------- LDO VMC    API end -------- */

/* -------- LDO VMCH   API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vmch_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_EN);
	PMICLOG("ldo : VMCH  ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vmch_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; sw stb sel = %d\n", sel_value);
	/* stb = 40, 240 */
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_STBTD);
	PMICLOG("ldo : VMCH  ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vmch_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_LP_MODE);
	PMICLOG("ldo : VMCH  ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vmch_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_LP_SEL);
	PMICLOG("ldo : VMCH  ; hw mode_sel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by sw mode */
void pmic_ldo_vmch_sw_fs_trans_dl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; sw fs_trans_dl_en = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_DL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_DL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_DL_EN);
	PMICLOG("ldo : VMCH  ; sw fs trans dl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by sw mode */
void pmic_ldo_vmch_sw_fs_trans_cl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; sw fs_trans_cl_en = %d", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_CL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_CL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_CL_EN);
	PMICLOG("ldo : VMCH  ; sw fs trans cl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by hw mode */
void pmic_ldo_vmch_hw_fs_trans_dl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; hw fs_trans_dl_ensel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_DL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_DL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_DL_SRCLKEN_SEL);
	PMICLOG("ldo : VMCH  ; hw fs trans dl ensel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by hw mode */
void pmic_ldo_vmch_hw_fs_trans_cl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VMCH  ; sw fs_trans_cl_en = %d", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_CL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_CL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VMCH_FAST_TRAN_CL_SRCLKEN_SEL);
	PMICLOG("ldo : VMCH  ; hw fs trans cl ensel_value readback = %d\n", read_back);
}
/* -------- LDO VMCH   API end -------- */

/* -------- LDO VUSB33 API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vusb33_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VUSB33; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VUSB33_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VUSB33_EN);
	PMICLOG("ldo : VUSB33; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vusb33_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VUSB33; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VUSB33_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VUSB33_STBTD);
	PMICLOG("ldo : VUSB33; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vusb33_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VUSB33; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VUSB33_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VUSB33_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VUSB33_LP_MODE);
	PMICLOG("ldo : VUSB33; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vusb33_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VUSB33; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VUSB33_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VUSB33_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VUSB33_LP_SEL);
	PMICLOG("ldo : VUSB33; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VUSB33 API end -------- */

/* -------- LDO VEMC33 API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vemc33_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_EN);
	PMICLOG("ldo : VEMC33; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vemc33_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; sw stb sel = %d\n", sel_value);
	/* stb = 40, 240 */
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_STBTD);
	PMICLOG("ldo : VEMC33; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vemc33_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_LP_MODE);
	PMICLOG("ldo : VEMC33; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vemc33_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_LP_SEL);
	PMICLOG("ldo : VEMC33; hw mode_sel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by sw mode */
void pmic_ldo_vemc33_sw_fs_trans_dl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; sw fs_trans_dl_en = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_DL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_DL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_DL_EN);
	PMICLOG("ldo : VEMC33; sw fs trans dl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by sw mode */
void pmic_ldo_vemc33_sw_fs_trans_cl(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; sw fs_trans_cl_en = %d", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_CL_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_CL_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_CL_EN);
	PMICLOG("ldo : VEMC33; sw fs trans cl en_value readback = %d\n", read_back);
}


/* define FAST_TRAN_DL_EN by hw mode */
void pmic_ldo_vemc33_hw_fs_trans_dl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; hw fs_trans_dl_ensel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_DL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_DL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_DL_SRCLKEN_SEL);
	PMICLOG("ldo : VEMC33; hw fs trans dl ensel_value readback = %d\n", read_back);
}


/* define FAST_TRAN_CL_EN by hw mode */
void pmic_ldo_vemc33_hw_fs_trans_cl(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VEMC33; sw fs_trans_cl_en = %d", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_CL_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_CL_SRCLKEN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VEMC33_FAST_TRAN_CL_SRCLKEN_SEL);
	PMICLOG("ldo : VEMC33; hw fs trans cl ensel_value readback = %d\n", read_back);
}
/* -------- LDO VEMC33 API end -------- */

/* -------- LDO VIO18  API ------------ LDO Type5 */
/* define EN by sw mode */
void pmic_ldo_vio18_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO18 ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIO18_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO18_EN);
	PMICLOG("ldo : VIO18 ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vio18_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO18 ; sw stb sel = %d\n", sel_value);
	/* stb = 240, 312 */
	pmic_set_register_value_nolock(PMIC_LDO_VIO18_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO18_STBTD);
	PMICLOG("ldo : VIO18 ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vio18_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO18 ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIO18_LP_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_VIO18_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO18_LP_MODE);
	PMICLOG("ldo : VIO18 ; sw lp mode_value readback = %d\n", read_back);
}


/* define LP MODE by hw mode */
void pmic_ldo_vio18_hw_lp_mode(int mode_sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIO18 ; hw lp_sel = %d\n", mode_sel_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIO18_LP_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_VIO18_LP_SEL, mode_sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIO18_LP_SEL);
	PMICLOG("ldo : VIO18 ; hw mode_sel_value readback = %d\n", read_back);
}
/* -------- LDO VIO18  API end -------- */

/* -------- LDO VIBR   API ------------ LDO Type0 */
/* define EN by sw mode */
void pmic_ldo_vibr_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIBR  ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIBR_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIBR_EN);
	PMICLOG("ldo : VIBR  ; sw en_value readback = %d\n", read_back);
}


/* define EN STB by sw mode */
void pmic_ldo_vibr_sw_stb(int sel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIBR  ; sw stb sel = %d\n", sel_value);
	/* stb = 40, 52 */
	pmic_set_register_value_nolock(PMIC_LDO_VIBR_STBTD, sel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIBR_STBTD);
	PMICLOG("ldo : VIBR  ; sel_value readback = %d\n", read_back);
}


/* define LP by sw mode */
void pmic_ldo_vibr_sw_lp_mode(int mode_value)
{
	unsigned short read_back;

	PMICLOG("ldo : VIBR  ; sw lp mode = %d", mode_value);
	pmic_set_register_value_nolock(PMIC_LDO_VIBR_LP_MODE, mode_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_VIBR_LP_MODE);
	PMICLOG("ldo : VIBR  ; sw lp mode_value readback = %d\n", read_back);
}
/* -------- LDO VIBR   API end -------- */

/* -------- LDO TREF   API ------------ LDO Type2 */
/* define EN by sw mode */
void pmic_ldo_tref_sw_en(int en_value)
{
	unsigned short read_back;

	PMICLOG("ldo : TREF  ; sw enable = %d\n", en_value);
	pmic_set_register_value_nolock(PMIC_LDO_TREF_EN_CTRL, 0);
	pmic_set_register_value_nolock(PMIC_LDO_TREF_EN, en_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_TREF_EN);
	PMICLOG("ldo : TREF  ; sw en_value readback = %d\n", read_back);
}


/* define EN by hw mode */
void pmic_ldo_tref_hw_en(int ensel_value)
{
	unsigned short read_back;

	PMICLOG("ldo : TREF  ; hw en_sel = %d\n", ensel_value);
	pmic_set_register_value_nolock(PMIC_LDO_TREF_EN_CTRL, 1);
	pmic_set_register_value_nolock(PMIC_LDO_TREF_EN_SEL, ensel_value);

	/* read back check */
	read_back = pmic_get_register_value_nolock(PMIC_LDO_TREF_EN_SEL);
	PMICLOG("ldo : TREF  ; hw en_sel readback = %d\n", read_back);
}

/*  api skip : (10)ALLLP+OCFB+STB */
/*void pmic_ldo_tref_sw_stb*/
/*  api skip : (10)ALLLP+OCFB+STB */
/*void pmic_ldo_tref_sw_lp_mode */
/* -------- LDO TREF   API end -------- */
