/* Copyright Statement:
*
* This software/firmware and related documentation ("MediaTek Software") are
* protected under relevant copyright laws. The information contained herein
* is confidential and proprietary to MediaTek Inc. and/or its licensors.
* Without the prior written permission of MediaTek inc. and/or its licensors,
* any reproduction, modification, use or disclosure of MediaTek Software,
* and information contained herein, in whole or in part, shall be strictly prohibited.
 MediaTek Inc. (C) 2010. All rights reserved.
* BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
* THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
* RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER ON
* AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
* NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*/



/*****************************************************************************
*
* Filename:
* ---------
*   sensor.c
*
* Project:
* --------
*   DUMA
*
* Description:
* ------------
*   Source code of Sensor driver
* Author:
* -------
*   PC Huang (MTK02204)
*
*============================================================================
*------------------------------------------------------------------------------
* Upper this line, this part is controlled by CC/CQ. DO NOT MODIFY!!
*============================================================================
****************************************************************************/
#include <linux/videodev2.h>
#include <linux/i2c.h>
#include <linux/platform_device.h>
#include <linux/delay.h>
#include <linux/cdev.h>
#include <linux/uaccess.h>
#include <linux/fs.h>
#include <asm/atomic.h>
#include <asm/io.h>
//#include <asm/system.h>  
#include "kd_camera_hw.h"
#include "kd_imgsensor.h"
#include "kd_imgsensor_define.h"
#include "kd_imgsensor_errcode.h"
#include "kd_camera_feature.h"
#include "HM2131mipiyuv_Sensor.h"
#include "HM2131mipiyuv_Camera_Sensor_para.h"
#include "HM2131mipiyuv_CameraCustomized.h" 

#define HM2131MIPIYUV_DEBUG
#ifdef HM2131MIPIYUV_DEBUG
//#define HM2131MIPISENSORDB printk
#define HM2131MIPISENSORDB(a,arg... ) printk("[XC7022]" a,##arg)
#define TV_SWITCH_PRINT(a,arg... ) printk("[TV_SWITCH/XC7022]" a,##arg)
#else
#define HM2131MIPISENSORDB(x,...)
#define TV_SWITCH_PRINT(x,...)
#endif

// GM7150, by zhangxueping
//extern UINT32 GM7150_On(bool force);
//extern struct mutex TV_switch_lock;

#define CAMERA_INIT_NONE              0
#define CAMERA_INIT_ONCE              1
#define CAMERA_INIT_ALWAYS           2

// VGA size, by zhangxueping
#undef HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH
#undef HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT
#define HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH        1920    //640
#define HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT       1080     //480

#define HM2131MIPI_SENSOR_ID HM2131_SENSOR_ID

//#define mutex_lock(...)
//#define mutex_unlock(...)

//set XC7022 colorbar test mode
//#define TEST_COLORBAR_MODE    

//bool is_KERN_EMERG = false;

static bool isCameraOpen = false;

static DEFINE_SPINLOCK(HM2131mipi_drv_lock);
static MSDK_SCENARIO_ID_ENUM CurrentScenarioId = MSDK_SCENARIO_ID_CAMERA_PREVIEW;
extern int iReadReg(u16 a_u2Addr , u8 * a_puBuff , u16 i2cId);
extern int iWriteReg(u16 a_u2Addr , u32 a_u4Data , u32 a_u4Bytes , u16 i2cId);

#define HM2131MIPI_write_cmos_sensor(addr, para) iWriteReg((u16) addr , (u32) para ,1,HM2131MIPI_WRITE_ID)
//#define HM2131MIPI_write_cmos_sensor(addr, para) do {iWriteReg((u16) addr , (u32) para ,1,HM2131MIPI_WRITE_ID); HM2131MIPISENSORDB("HM2131MIPI_write, addr=%x\n", addr);	}while(0)

static void XC7022InitialSetting(void);
extern	int Af_VCOMA2_Power_On(void);

static int XC7022_write_cmos_sensor(u16 addr, u8 para)
{
	//HM2131MIPISENSORDB("[XC7022RegWrite,0411.1.3] addr:%d  value:%x\n",addr,para);  		
	if(iWriteReg((u16) addr , (u32) para ,1,XC7022_WRITE_ID)<0)
		return -1;
	else
		return 0;
}

static kal_uint16 XC7022_read_cmos_sensor(kal_uint32 addr)
{
	kal_uint16 get_byte=0;

	iReadReg((u16) addr ,(u8*)&get_byte,XC7022_WRITE_ID);

	//HM2131MIPISENSORDB("XC7022_read_cmos_sensor addr=%x, get_byte=%x\n", addr,get_byte);		 // by zhangxueping

	return get_byte;
}

#define mDELAY(ms)  mdelay(ms)

typedef enum
{
	PRV_W=1920,
	PRV_H=1080
}PREVIEW_VIEW_SIZE;

static kal_uint16 HM2131MIPIYUV_read_cmos_sensor(kal_uint32 addr)
{
	kal_uint16 get_byte=0;
	iReadReg((u16) addr ,(u8*)&get_byte,HM2131MIPI_WRITE_ID);
	//HM2131MIPISENSORDB("HM2131MIPIYUV_read_cmos_sensor addr=%x, get_byte=%x\n", addr, get_byte);	 // by zhangxueping

	return get_byte;
}

#if 0
static struct
{
//kal_uint8   Banding;
kal_bool      NightMode;
kal_bool      VideoMode;
kal_uint16  Fps;
kal_uint16  ShutterStep;
kal_uint8   IsPVmode;
kal_uint32  PreviewDummyPixels;
kal_uint32  PreviewDummyLines;
kal_uint32  CaptureDummyPixels;
kal_uint32  CaptureDummyLines;
kal_uint32  PreviewPclk;
kal_uint32  CapturePclk;
kal_uint32  ZsdturePclk;
kal_uint32  PreviewShutter;
kal_uint32  PreviewExtraShutter;
kal_uint32  SensorGain;
kal_bool        manualAEStart;
kal_bool        userAskAeLock;
kal_bool     userAskAwbLock;
kal_uint32      currentExposureTime;
kal_uint32      currentShutter;
kal_uint32      currentextshutter;
kal_uint32      currentAxDGain;
kal_uint32      sceneMode;
unsigned char isoSpeed;
unsigned char zsd_flag;
HM2131MIPI_SENSOR_MODE SensorMode;
} HM2131MIPISensor;

#endif

/* Global Valuable */
MSDK_SENSOR_CONFIG_STRUCT HM2131MIPISensorConfigData;

#define HM2131_TEST_PATTERN_CHECKSUM (0x55dbda78)  
//#define HM2131_TEST_PATTERN_CHECKSUM (0x3b969447)  

//CRC_accum 0x3b969447


// by zhangxueping
//#define HM2131MIPI_SENSOR_ID   HM2131_SENSOR_ID 		   

//static int saturation_level=ISP_SAT_MIDDLE;          // by zhangxueping

/*
void HM2131MIPIGetExifInfo(UINT32 exifAddr)
{
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIGetExifInfo function\n");
	SENSOR_EXIF_INFO_STRUCT* pExifInfo = (SENSOR_EXIF_INFO_STRUCT*)(uintptr_t)exifAddr;
	pExifInfo->FNumber = 20;
	//pExifInfo->AEISOSpeed = HM2131MIPISensor.isoSpeed;
	pExifInfo->FlashLightTimeus = 0;
	//pExifInfo->RealISOValue = HM2131MIPISensor.isoSpeed;
	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIGetExifInfo function\n");
}
*/

// add by zhangxueping
UINT32 HM2131SetTestPatternMode(kal_bool bEnable)
{
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131SetTestPatternMode 0331\n");
	#if 1
	if(bEnable){
		if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return -1;
		XC7022_write_cmos_sensor(0xfffe ,0x50);
		XC7022_write_cmos_sensor(0x004d ,0x01);
		HM2131MIPI_write_cmos_sensor(0x0601, 0x01);
		XC7022_write_cmos_sensor(0x004d ,0x00);
	}
	else{
		if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return -1;
		//XC7022_write_cmos_sensor(0xfffe ,0x50);
		//XC7022_write_cmos_sensor(0x004d ,0x01);
		//HM2131MIPI_write_cmos_sensor(0x503D, 0x00);
		//XC7022_write_cmos_sensor(0x004d ,0x00);
	} 
	#else
	if(bEnable){
	XC7022_write_cmos_sensor(0xfffd ,0x80);
	//XC7022_write_cmos_sensor(0xfffE ,0x06); 
	//XC7022_write_cmos_sensor(0x3022 ,0x82);
	//XC7022_write_cmos_sensor(0xfffE ,0x21); 
	//XC7022_write_cmos_sensor(0x0000 ,0x01);
	//XC7022_write_cmos_sensor(0x0001 ,0x00);
	//XC7022_write_cmos_sensor(0x0003 ,0x20);
	//XC7022_write_cmos_sensor(0xfffe ,0x50);
	//XC7022_write_cmos_sensor(0x004d ,0x01);
	//HM2131MIPI_write_cmos_sensor(0x503D, 0xa0);
	//XC7022_write_cmos_sensor(0x004d ,0x00);
	}
	else{
	XC7022_write_cmos_sensor(0xfffd ,0x80);
	//XC7022_write_cmos_sensor(0xfffE ,0x06); 
	//XC7022_write_cmos_sensor(0x3022 ,0x80);
	//XC7022_write_cmos_sensor(0xfffE ,0x21); 
	//XC7022_write_cmos_sensor(0x0000 ,0x47);
	//XC7022_write_cmos_sensor(0x0001 ,0x82);
	//XC7022_write_cmos_sensor(0x0003 ,0xb1);
	//XC7022_write_cmos_sensor(0xfffe ,0x50);
	//XC7022_write_cmos_sensor(0x004d ,0x01);
	//HM2131MIPI_write_cmos_sensor(0x503D, 0x00);
	//XC7022_write_cmos_sensor(0x004d ,0x00);
	}

	#endif
	return ERROR_NONE;
}

#define HM2131_REG_READBACK

#if defined(HM2131_REG_READBACK)

#define READ_PERIOD_S       2
// 2 second

static struct hrtimer HM2131_readback_timer;
static   bool isHM2131HrtimerStart= KAL_FALSE;

static struct work_struct readback_work;
static struct workqueue_struct * readback_workqueue = NULL;
enum hrtimer_restart HM2131_read_hrtimer_func(struct hrtimer *timer);

static void reg_readback(struct work_struct *work);

static void HM2131_read_detect_hrtimer_init(void)
{
	ktime_t ktime;


	HM2131MIPISENSORDB("HM2131_read_detect_hrtimer_init\n" );

	if(!readback_workqueue){
		readback_workqueue = create_singlethread_workqueue("HM2131_read_det");
		if(!readback_workqueue) {
			HM2131MIPISENSORDB("Unable to create workqueue\n");
			return;
		}

		INIT_WORK(&readback_work, reg_readback);
	}	

	ktime = ktime_set(READ_PERIOD_S, 0);	// 3s, 10* 1000 ms
	hrtimer_init(&HM2131_readback_timer, CLOCK_MONOTONIC, HRTIMER_MODE_REL);
	HM2131_readback_timer.function = HM2131_read_hrtimer_func;    
	hrtimer_start(&HM2131_readback_timer, ktime, HRTIMER_MODE_REL);
}

enum hrtimer_restart HM2131_read_hrtimer_func(struct hrtimer *timer)
{
	ktime_t ktime;

	HM2131MIPISENSORDB("HM2131_read_hrtimer_func, by zxp \n" );

	queue_work(readback_workqueue, &readback_work);

	ktime = ktime_set(READ_PERIOD_S, 0);	
	hrtimer_start(&HM2131_readback_timer, ktime, HRTIMER_MODE_REL);

	return HRTIMER_NORESTART;		
}
#endif  //  HM2131_REG_READBACK

void reg_readback(struct work_struct *work)
{
	//int ret=0;
	//int var1,var2,var3,var4;
	int gain = 0;
	int night_mode = 0;
	printk(KERN_WARNING"Nathan_0911 : [XC7022_REG]reg_read_back\n ");  

	//is_KERN_EMERG = true;
	//mutex_lock(&TV_switch_lock);

	/*	XC7022_write_cmos_sensor(0xfffd ,0x80);
	XC7022_write_cmos_sensor(0xfffe ,0x50);
	XC7022_write_cmos_sensor(0x004d ,0x01);


	var1=HM2131MIPIYUV_read_cmos_sensor(0x300f);
	var2=HM2131MIPIYUV_read_cmos_sensor(0x3010); 
	var3=HM2131MIPIYUV_read_cmos_sensor(0x3011);
	var4=HM2131MIPIYUV_read_cmos_sensor(0x3012);                                 
	printk(KERN_WARNING"[XC7022_REG]CLK,0x300f=%x,%x,%x,%x\n", var1, var2, var3, var4);  // sensor clock

	// AE
	var1=HM2131MIPIYUV_read_cmos_sensor(0x3500);                                   
	var2=HM2131MIPIYUV_read_cmos_sensor(0x3501);                                   
	var3=HM2131MIPIYUV_read_cmos_sensor(0x3502);    
	var1 = ((var1&0x0f)<<16)|((var2&0xff)<<8) | (var3&0xff);
	//printk(KERN_WARNING"[XC7022_REG]AE,0x3500=%x,%x,%x", var1, var2, var3);
	printk(KERN_WARNING"[XC7022_REG]AE,0x3500=%x\n", var1);

	// GAIN
	var1=HM2131MIPIYUV_read_cmos_sensor(0x350A);                                  
	var2=HM2131MIPIYUV_read_cmos_sensor(0x350B);                                  
	printk(KERN_WARNING"[XC7022_REG]GAIN,0x350A=%x,%x\n", var1, var2);


	XC7022_write_cmos_sensor(0xfffd ,0x80);
	XC7022_write_cmos_sensor(0xfffe ,0x50);
	XC7022_write_cmos_sensor(0x004d ,0x00);                                
	*/															  
	// XC7022_write_cmos_sensor(0xfffe ,0x21);                          
	// ret=XC7022_read_cmos_sensor(0x0004);                             
	//HM2131MIPISENSORDB("reg:0x0004%x\n ",ret);
	//printk(KERN_WARNING"[XC7022_REG]0x04=%x\n ",ret);

	//  XC7022_write_cmos_sensor(0xfffe ,0x26);

	//  sensor size 
	//  var1=XC7022_read_cmos_sensor(0x0038);
	//  var2=XC7022_read_cmos_sensor(0x0039);
	//  var3=XC7022_read_cmos_sensor(0x003a);
	//  var4=XC7022_read_cmos_sensor(0x003b);
	//  printk(KERN_WARNING"[XC7022_REG]SIZE(0x60,09,38,04), 0x38=%x,%x,%x,%x\n", var1, var2, var3, var4);

	//  XC7022_write_cmos_sensor(0xfffe ,0x21);

	//awb, change    
	// var1=XC7022_read_cmos_sensor(0x0098);
	// var2=XC7022_read_cmos_sensor(0x0099);
	// var3=XC7022_read_cmos_sensor(0x009c);
	// var4=XC7022_read_cmos_sensor(0x009d);
	//printk(KERN_WARNING"[XC7022_REG]AWB,0x0098=%x,%x,0x9c=%x,%x\n", var1, var2, var3, var4);
#if 0
	XC7022_write_cmos_sensor(0xfffe ,0x14);
	ret=XC7022_read_cmos_sensor(0x0002);
	printk(KERN_WARNING"[XC7022_REG]AE_ON,0x0002=%x\n ",ret);      //AE, on/off

	ret=XC7022_read_cmos_sensor(0x0026);
	printk(KERN_WARNING"[XC7022_REG]LINE,0x0026=%x\n ",ret);      // exposure line, max 0x3c

	gain = XC7022_read_cmos_sensor(0x002b);
	printk(KERN_WARNING"[XC7022_REG]GAIN,0x002b=%x\n ",ret);     //gain 0x10~0x78(0x0037)

	ret=XC7022_read_cmos_sensor(0x003c);
	printk(KERN_WARNING"[XC7022_REG]LUM,0x003c=%x\n ",ret);     // lum value

	ret=XC7022_read_cmos_sensor(0x0022);
	printk(KERN_WARNING"[XC7022_REG]0x0022=%x\n ",ret);    // 0x00/0x01
#endif
	if((gain > 0x5a) && (night_mode == 0)){    
		printk(KERN_WARNING"[XC7022_REG]------ inter night mode" );    // 0x00/0x01

		if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return;
		XC7022_write_cmos_sensor(0xfffe,0x14);                                                                    
		

		night_mode = 1;
	}
	else if(gain < 0x3a && night_mode == 1){
		printk(KERN_WARNING"[XC7022_REG]------ inter day mode" );    // 0x00/0x01

		if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return;
		XC7022_write_cmos_sensor(0xfffe,0x14);                                                                    


		night_mode = 0;
	}

	//mutex_unlock(&TV_switch_lock);
	//is_KERN_EMERG = false;

	return;

}	


/*************************************************************************
* FUNCTION
*   HM2131MIPI_GetSensorID
*
* DESCRIPTION
*   This function get the sensor ID
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 HM2131MIPI_GetSensorID_dummy(kal_uint32 *sensorID)
{
	HM2131MIPISENSORDB("HM2131MIPI_GetSensorID: FAIL, ONLY FOR DEBUG");
	*sensorID = 0xFFFFFFFF;
	return ERROR_SENSOR_CONNECT_FAIL;

	//*sensorID=HM2131MIPI_SENSOR_ID;
	//HM2131MIPISENSORDB("[HM2131MIPI] HM2131MIPI_GetSensorID: OK, only for test");
	//return ERROR_NONE; 	
}

//static kal_uint32 gSensorID = 0;

kal_uint32 HM2131MIPI_GetSensorID(kal_uint32 *sensorID)
{
	//volatile signed char i;
	kal_uint32 sensor_id=0;
	//kal_uint8 temp_sccb_addr = 0;
	kal_uint32 isp_id=0;
	//kal_uint32 j;

	//HM2131MIPISENSORDB("HM2131MIPI_GetSensorID: ZHENGFENG_0320\n ");
	HM2131MIPISENSORDB("HM2131MIPI_GetSensorID-4: 150618\n ");

	//mDELAY(10);
/*	if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return -1;
	XC7022_write_cmos_sensor(0xfffe ,0x50);
	//XC7022_write_cmos_sensor(0x004D ,0x00);
	mDELAY(10);
	for (j=0;j<4;j++){
		isp_id[j]=XC7022_read_cmos_sensor(j);
		HM2131MIPISENSORDB("Nathan_0911 : XC7022_ID[%d]=0x%x \n",j,isp_id[j]);       // 0x01, 0x11, 0x43, 0x58
	}
 */
 	isp_id = (XC7022_read_cmos_sensor(0xfffb) << 8) | XC7022_read_cmos_sensor(0xfffc);
 		HM2131MIPISENSORDB("Nathan_0114 : XC7022_ID=0x%x \n",isp_id);       // 0x7160
	if (isp_id==0x7160 )
	{		
		HM2131MIPISENSORDB("Nathan_0911 : start get img sensor id ");  
		mDELAY(10);
		XC7022InitialSetting();

		//TODO: need to check it: which one is selected.

		if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return -1;
		XC7022_write_cmos_sensor(0xfffe,0x50); 
		XC7022_write_cmos_sensor(0x0050,0x13);  //  PWDN,GPIO1,GPIO0 en   
		XC7022_write_cmos_sensor(0x0054,0x13);  //  PWDN,GPIO1,ouput 控制sensorPWDN&reset ; GPIO0 被MTK6572来控制XC7022 PWDN

		XC7022_write_cmos_sensor(0x0058,0x13);
		mDELAY(5);

		XC7022_write_cmos_sensor(0xfffd ,0x80);
		XC7022_write_cmos_sensor(0xfffe ,0x50);
		XC7022_write_cmos_sensor(0x004d ,0x01);   //by Nathan 20170114
		//HM2131MIPISENSORDB("HM2131MIPI_GetSensorID\n");    // by zhangxueping
		//for(i=0;i<3;i++)
		{
		// by zhangxueping
		#ifdef TEST_COLORBAR_MODE
		sensor_id = (XC7022_read_cmos_sensor(0xfffb) << 8) | XC7022_read_cmos_sensor(0xfffc);
		#else
		sensor_id = (HM2131MIPIYUV_read_cmos_sensor(0x0000) << 8) | HM2131MIPIYUV_read_cmos_sensor(0x0001);
		#endif
		printk("Nathan_0911 : HM2131MIPI_GetSensorID: ID=%x\n",sensor_id);

		//sensor_id = HM2131MIPI_SENSOR_ID;   // by zhangxueping
		#ifdef TEST_COLORBAR_MODE
		if(sensor_id != 0x7160){
		#else		
			if(sensor_id != HM2131MIPI_SENSOR_ID){
		#endif
				*sensorID =0xffffffff;
				printk("HM2131MIPI_GetSensorID: FAIL . \n");
				//return ERROR_SENSOR_CONNECT_FAIL;
			}
			else{
				*sensorID=HM2131MIPI_SENSOR_ID;
				printk("HM2131MIPI_GetSensorID: OK . \n");
				//break;
			}
		}

	}
		*sensorID = 0x2131;

	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x0); //bypass off


	HM2131MIPISENSORDB("Nathan_0911 : [HM2131MIPI]exit HM2131MIPI_GetSensorID \n ");
	return ERROR_NONE;    

}   


/*************************************************************************
* FUNCTION
*    HM2131MIPIInitialSetting
*
* DESCRIPTION
*    This function initialize the registers of CMOS sensor.
*
* PARAMETERS
*    None
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static    void XC7022InitialSetting(void)
{
	//mipi_2lane, MCLK=24M , mipi=768M
	HM2131MIPISENSORDB("XC7022_ISP_InitialSetting start \n");

	if(XC7022_write_cmos_sensor(0xfffd ,0x80)<0)
			return;
XC7022_write_cmos_sensor(0xfffd,0x80);
XC7022_write_cmos_sensor(0xfffe,0x50);
XC7022_write_cmos_sensor(0x001c,0xff);
XC7022_write_cmos_sensor(0x001d,0xff);
XC7022_write_cmos_sensor(0x001e,0xff);
XC7022_write_cmos_sensor(0x001f,0xff);
XC7022_write_cmos_sensor(0x0018,0x00);
XC7022_write_cmos_sensor(0x0019,0x00);
XC7022_write_cmos_sensor(0x001a,0x00);
XC7022_write_cmos_sensor(0x001b,0x00);

XC7022_write_cmos_sensor(0x0020,0x01);
XC7022_write_cmos_sensor(0x0022,0x01);
XC7022_write_cmos_sensor(0x0023,0x85);
XC7022_write_cmos_sensor(0x0024,0x04);
XC7022_write_cmos_sensor(0x0025,0x01);
XC7022_write_cmos_sensor(0x0026,0x01);
XC7022_write_cmos_sensor(0x0027,0x06);
XC7022_write_cmos_sensor(0x0028,0x01);
XC7022_write_cmos_sensor(0x0029,0x00);
XC7022_write_cmos_sensor(0x002a,0x01);
XC7022_write_cmos_sensor(0x002b,0x05);
XC7022_write_cmos_sensor(0x0031,0xf4);
XC7022_write_cmos_sensor(0x0032,0x71);

XC7022_write_cmos_sensor(0x00bc,0x19);
XC7022_write_cmos_sensor(0x0090,0x38);

XC7022_write_cmos_sensor(0x0050,0x13);
XC7022_write_cmos_sensor(0x0054,0x13);
XC7022_write_cmos_sensor(0x0058,0x13);

XC7022_write_cmos_sensor(0xfffe,0x26);
XC7022_write_cmos_sensor(0x8012,0x80);
XC7022_write_cmos_sensor(0x8013,0x07);
XC7022_write_cmos_sensor(0x8014,0x38);
XC7022_write_cmos_sensor(0x8015,0x04);
XC7022_write_cmos_sensor(0x8016,0x00);
XC7022_write_cmos_sensor(0x8017,0x00);
XC7022_write_cmos_sensor(0x8018,0x00);
XC7022_write_cmos_sensor(0x8019,0x00);

XC7022_write_cmos_sensor(0x8010,0x05);

XC7022_write_cmos_sensor(0xfffe,0x2c);
XC7022_write_cmos_sensor(0x0000,0x00);
XC7022_write_cmos_sensor(0x0001,0x07);
XC7022_write_cmos_sensor(0x0002,0x80);
XC7022_write_cmos_sensor(0x0004,0x04);
XC7022_write_cmos_sensor(0x0005,0x38);
XC7022_write_cmos_sensor(0x0044,0x08);
XC7022_write_cmos_sensor(0x0045,0x04);
XC7022_write_cmos_sensor(0x0048,0x0e);
XC7022_write_cmos_sensor(0x0049,0xf0);

XC7022_write_cmos_sensor(0xfffe,0x26);
XC7022_write_cmos_sensor(0x8000,0x1d);
XC7022_write_cmos_sensor(0x8001,0x80);
XC7022_write_cmos_sensor(0x8002,0x07);
XC7022_write_cmos_sensor(0x8003,0x38);
XC7022_write_cmos_sensor(0x8004,0x04);

XC7022_write_cmos_sensor(0xfffe,0x26);
XC7022_write_cmos_sensor(0x2019,0x07);
XC7022_write_cmos_sensor(0x201a,0x80);
XC7022_write_cmos_sensor(0x201b,0x04);
XC7022_write_cmos_sensor(0x201c,0x38);
XC7022_write_cmos_sensor(0x201d,0x00);
XC7022_write_cmos_sensor(0x201e,0x00);
XC7022_write_cmos_sensor(0x201f,0x00);
XC7022_write_cmos_sensor(0x2020,0x00);

XC7022_write_cmos_sensor(0x2015,0x83);
XC7022_write_cmos_sensor(0x2017,0x1e);
XC7022_write_cmos_sensor(0x2018,0x00);
XC7022_write_cmos_sensor(0x2023,0x03);//mipi_tx_set

XC7022_write_cmos_sensor(0x0000,0x20);
XC7022_write_cmos_sensor(0x0009,0xc4);//mipi_rx_set

///////////////ISP1////////////////

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x0000,0x01);
XC7022_write_cmos_sensor(0x0001,0x00);
XC7022_write_cmos_sensor(0x0002,0x10);
XC7022_write_cmos_sensor(0x0003,0x20);
XC7022_write_cmos_sensor(0x0004,0x10);

XC7022_write_cmos_sensor(0x0019,0x01);
XC7022_write_cmos_sensor(0x0050,0x20);

XC7022_write_cmos_sensor(0x005e,0x7f);
XC7022_write_cmos_sensor(0x005f,0x07);
XC7022_write_cmos_sensor(0x0060,0x37);
XC7022_write_cmos_sensor(0x0061,0x04);
XC7022_write_cmos_sensor(0x0064,0x80);
XC7022_write_cmos_sensor(0x0065,0x07);
XC7022_write_cmos_sensor(0x0066,0x38);
XC7022_write_cmos_sensor(0x0067,0x04);

XC7022_write_cmos_sensor(0x0006,0x07);
XC7022_write_cmos_sensor(0x0007,0x80);
XC7022_write_cmos_sensor(0x0008,0x04);
XC7022_write_cmos_sensor(0x0009,0x38);
XC7022_write_cmos_sensor(0x000a,0x07);
XC7022_write_cmos_sensor(0x000b,0x80);
XC7022_write_cmos_sensor(0x000c,0x04);
XC7022_write_cmos_sensor(0x000d,0x38);
  
XC7022_write_cmos_sensor(0xfffe,0x50);
XC7022_write_cmos_sensor(0x0226,0x02); //RX2 off
  
	mDELAY(10);

	HM2131MIPISENSORDB("XC7022_ISP_InitialSetting end\n");
}


void HM2131MIPIInitialSetting(void)
{
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIInitialSetting function:\n ");

HM2131MIPI_write_cmos_sensor(0x0103,0x00);
HM2131MIPI_write_cmos_sensor(0x0304,0x2A);
HM2131MIPI_write_cmos_sensor(0x0305,0x0C);
HM2131MIPI_write_cmos_sensor(0x0307,0x55);
HM2131MIPI_write_cmos_sensor(0x0303,0x04);
HM2131MIPI_write_cmos_sensor(0x0309,0x00);
HM2131MIPI_write_cmos_sensor(0x030A,0x0A);
HM2131MIPI_write_cmos_sensor(0x030D,0x02);
HM2131MIPI_write_cmos_sensor(0x030F,0x14);
HM2131MIPI_write_cmos_sensor(0x5268,0x01);
HM2131MIPI_write_cmos_sensor(0x5264,0x24);
HM2131MIPI_write_cmos_sensor(0x5265,0x92);
HM2131MIPI_write_cmos_sensor(0x5266,0x23);
HM2131MIPI_write_cmos_sensor(0x5267,0x07);
HM2131MIPI_write_cmos_sensor(0x5269,0x02);
HM2131MIPI_write_cmos_sensor(0x0100,0x02);
HM2131MIPI_write_cmos_sensor(0x0100,0x02);
HM2131MIPI_write_cmos_sensor(0x0111,0x01);
HM2131MIPI_write_cmos_sensor(0x0112,0x0A);
HM2131MIPI_write_cmos_sensor(0x0113,0x0A);
HM2131MIPI_write_cmos_sensor(0x4B20,0x8E);
HM2131MIPI_write_cmos_sensor(0x4B18,0x12);
HM2131MIPI_write_cmos_sensor(0x4B02,0x05);
HM2131MIPI_write_cmos_sensor(0x4B43,0x07);
HM2131MIPI_write_cmos_sensor(0x4B05,0x1C);
HM2131MIPI_write_cmos_sensor(0x4B0E,0x00);
HM2131MIPI_write_cmos_sensor(0x4B0F,0x0D);
HM2131MIPI_write_cmos_sensor(0x4B06,0x06);
HM2131MIPI_write_cmos_sensor(0x4B39,0x0B);
HM2131MIPI_write_cmos_sensor(0x4B42,0x07);
HM2131MIPI_write_cmos_sensor(0x4B03,0x0C);
HM2131MIPI_write_cmos_sensor(0x4B04,0x07);
HM2131MIPI_write_cmos_sensor(0x4B3A,0x0B);
HM2131MIPI_write_cmos_sensor(0x4B51,0x80);
HM2131MIPI_write_cmos_sensor(0x4B52,0x09);
HM2131MIPI_write_cmos_sensor(0xFFFF,0x05); 
HM2131MIPI_write_cmos_sensor(0x4B52,0xC9);
HM2131MIPI_write_cmos_sensor(0x4B57,0x07);
HM2131MIPI_write_cmos_sensor(0x4B68,0x6B);
HM2131MIPI_write_cmos_sensor(0x0350,0x37);
HM2131MIPI_write_cmos_sensor(0x5030,0x10);
HM2131MIPI_write_cmos_sensor(0x5032,0x02);
HM2131MIPI_write_cmos_sensor(0x5033,0xD1);
HM2131MIPI_write_cmos_sensor(0x5034,0x01);
HM2131MIPI_write_cmos_sensor(0x5035,0x67);
HM2131MIPI_write_cmos_sensor(0x5229,0x90);
HM2131MIPI_write_cmos_sensor(0x5061,0x00);
HM2131MIPI_write_cmos_sensor(0x5062,0x94);
HM2131MIPI_write_cmos_sensor(0x50F5,0x06);
HM2131MIPI_write_cmos_sensor(0x5230,0x00);
HM2131MIPI_write_cmos_sensor(0x526C,0x00);
HM2131MIPI_write_cmos_sensor(0x520B,0x41);
HM2131MIPI_write_cmos_sensor(0x5254,0x08);
HM2131MIPI_write_cmos_sensor(0x522B,0x00);
HM2131MIPI_write_cmos_sensor(0x4144,0x08);
HM2131MIPI_write_cmos_sensor(0x4148,0x03);
HM2131MIPI_write_cmos_sensor(0x4024,0x40);
HM2131MIPI_write_cmos_sensor(0x4B66,0x00);
HM2131MIPI_write_cmos_sensor(0x4B31,0x06);
HM2131MIPI_write_cmos_sensor(0x0202,0x04);
HM2131MIPI_write_cmos_sensor(0x0203,0x50);
HM2131MIPI_write_cmos_sensor(0x0340,0x04);
HM2131MIPI_write_cmos_sensor(0x0341,0x52);
HM2131MIPI_write_cmos_sensor(0x0342,0x05);
HM2131MIPI_write_cmos_sensor(0x0343,0x00);
HM2131MIPI_write_cmos_sensor(0x034C,0x07);
HM2131MIPI_write_cmos_sensor(0x034D,0x88);
HM2131MIPI_write_cmos_sensor(0x034E,0x04);
HM2131MIPI_write_cmos_sensor(0x034F,0x40);
HM2131MIPI_write_cmos_sensor(0x0101,0x03);   //mirror
HM2131MIPI_write_cmos_sensor(0x4020,0x10);
HM2131MIPI_write_cmos_sensor(0x50DD,0x01);//HII gain
HM2131MIPI_write_cmos_sensor(0x0350,0x37);
HM2131MIPI_write_cmos_sensor(0x4131,0x01);
HM2131MIPI_write_cmos_sensor(0x4132,0x00);    //BLI target
HM2131MIPI_write_cmos_sensor(0x5011,0x00);
HM2131MIPI_write_cmos_sensor(0x5015,0x00);
HM2131MIPI_write_cmos_sensor(0x501D,0x1C);
HM2131MIPI_write_cmos_sensor(0x501E,0x00);
HM2131MIPI_write_cmos_sensor(0x501F,0x00);   // BLCTGT
HM2131MIPI_write_cmos_sensor(0x50D5,0xF0);
HM2131MIPI_write_cmos_sensor(0x50D7,0x12);
HM2131MIPI_write_cmos_sensor(0x50BB,0x14);
HM2131MIPI_write_cmos_sensor(0x5040,0x07);
HM2131MIPI_write_cmos_sensor(0x50B7,0x00);
HM2131MIPI_write_cmos_sensor(0x50B8,0x10);
HM2131MIPI_write_cmos_sensor(0x50B9,0xFF);
HM2131MIPI_write_cmos_sensor(0x50BA,0xFF);
HM2131MIPI_write_cmos_sensor(0x5200,0x26);
HM2131MIPI_write_cmos_sensor(0x5201,0x00);
HM2131MIPI_write_cmos_sensor(0x5202,0x00);
HM2131MIPI_write_cmos_sensor(0x5203,0x00);
HM2131MIPI_write_cmos_sensor(0x5217,0x01);
HM2131MIPI_write_cmos_sensor(0x5219,0x01);
HM2131MIPI_write_cmos_sensor(0x5234,0x01);
HM2131MIPI_write_cmos_sensor(0x526B,0x03);
HM2131MIPI_write_cmos_sensor(0x4C00,0x00);
HM2131MIPI_write_cmos_sensor(0x0310,0x00);
HM2131MIPI_write_cmos_sensor(0x4B31,0x06);
HM2131MIPI_write_cmos_sensor(0x4B3B,0x02);
HM2131MIPI_write_cmos_sensor(0x4B44,0x0C);
HM2131MIPI_write_cmos_sensor(0x4B45,0x01);
HM2131MIPI_write_cmos_sensor(0x50A1,0x00);
HM2131MIPI_write_cmos_sensor(0x50AA,0x2E);
HM2131MIPI_write_cmos_sensor(0x50AC,0x44);
HM2131MIPI_write_cmos_sensor(0x50AB,0x04);
HM2131MIPI_write_cmos_sensor(0x50A0,0xB0);
HM2131MIPI_write_cmos_sensor(0x50A2,0x1B);
HM2131MIPI_write_cmos_sensor(0x50AF,0x00);
HM2131MIPI_write_cmos_sensor(0x5208,0x55);
HM2131MIPI_write_cmos_sensor(0x5209,0x03);
HM2131MIPI_write_cmos_sensor(0x520D,0x40);
HM2131MIPI_write_cmos_sensor(0x5214,0x18);
HM2131MIPI_write_cmos_sensor(0x5215,0x03);
HM2131MIPI_write_cmos_sensor(0x5216,0x00);
HM2131MIPI_write_cmos_sensor(0x521A,0x10);
HM2131MIPI_write_cmos_sensor(0x521B,0x24);
HM2131MIPI_write_cmos_sensor(0x5232,0x04);
HM2131MIPI_write_cmos_sensor(0x5233,0x03);
HM2131MIPI_write_cmos_sensor(0x5106,0xF0);
HM2131MIPI_write_cmos_sensor(0x510E,0xC1);
HM2131MIPI_write_cmos_sensor(0x5166,0xF0);
HM2131MIPI_write_cmos_sensor(0x516E,0xC1);
HM2131MIPI_write_cmos_sensor(0x5196,0xF0);
HM2131MIPI_write_cmos_sensor(0x519E,0xC1);
HM2131MIPI_write_cmos_sensor(0x51C0,0x80);
HM2131MIPI_write_cmos_sensor(0x51C4,0x80);
HM2131MIPI_write_cmos_sensor(0x51C8,0x80);
HM2131MIPI_write_cmos_sensor(0x51CC,0x80);
HM2131MIPI_write_cmos_sensor(0x51D0,0x80);
HM2131MIPI_write_cmos_sensor(0x51D4,0x80);
HM2131MIPI_write_cmos_sensor(0x51D8,0x80);
HM2131MIPI_write_cmos_sensor(0x51DC,0x80);
HM2131MIPI_write_cmos_sensor(0x51C1,0x03);
HM2131MIPI_write_cmos_sensor(0x51C5,0x13);
HM2131MIPI_write_cmos_sensor(0x51C9,0x17);
HM2131MIPI_write_cmos_sensor(0x51CD,0x27);
HM2131MIPI_write_cmos_sensor(0x51D1,0x27);
HM2131MIPI_write_cmos_sensor(0x51D5,0x2B);
HM2131MIPI_write_cmos_sensor(0x51D9,0x2B);
HM2131MIPI_write_cmos_sensor(0x51DD,0x2B);
HM2131MIPI_write_cmos_sensor(0x51C2,0x4B);
HM2131MIPI_write_cmos_sensor(0x51C6,0x4B);
HM2131MIPI_write_cmos_sensor(0x51CA,0x4B);
HM2131MIPI_write_cmos_sensor(0x51CE,0x49);
HM2131MIPI_write_cmos_sensor(0x51D2,0x49);
HM2131MIPI_write_cmos_sensor(0x51D6,0x49);
HM2131MIPI_write_cmos_sensor(0x51DA,0x49);
HM2131MIPI_write_cmos_sensor(0x51DE,0x49);
HM2131MIPI_write_cmos_sensor(0x51C3,0x10);
HM2131MIPI_write_cmos_sensor(0x51C7,0x18);
HM2131MIPI_write_cmos_sensor(0x51CB,0x10);
HM2131MIPI_write_cmos_sensor(0x51CF,0x08);
HM2131MIPI_write_cmos_sensor(0x51D3,0x08);
HM2131MIPI_write_cmos_sensor(0x51D7,0x08);
HM2131MIPI_write_cmos_sensor(0x51DB,0x08);
HM2131MIPI_write_cmos_sensor(0x51DF,0x00);
HM2131MIPI_write_cmos_sensor(0x51E0,0x94);
HM2131MIPI_write_cmos_sensor(0x51E2,0x94);
HM2131MIPI_write_cmos_sensor(0x51E4,0x94);
HM2131MIPI_write_cmos_sensor(0x51E6,0x94);
HM2131MIPI_write_cmos_sensor(0x51E1,0x00);
HM2131MIPI_write_cmos_sensor(0x51E3,0x00);
HM2131MIPI_write_cmos_sensor(0x51E5,0x00);
HM2131MIPI_write_cmos_sensor(0x51E7,0x00);
HM2131MIPI_write_cmos_sensor(0x5264,0x23);
HM2131MIPI_write_cmos_sensor(0x5265,0x07);
HM2131MIPI_write_cmos_sensor(0x5266,0x24);
HM2131MIPI_write_cmos_sensor(0x5267,0x92);
HM2131MIPI_write_cmos_sensor(0x5268,0x01);
HM2131MIPI_write_cmos_sensor(0xBAA2,0xC0);
HM2131MIPI_write_cmos_sensor(0xBAA2,0x40);
HM2131MIPI_write_cmos_sensor(0xBA90,0x01);
HM2131MIPI_write_cmos_sensor(0xBA93,0x02);
HM2131MIPI_write_cmos_sensor(0x3110,0x0B);
HM2131MIPI_write_cmos_sensor(0x373E,0x8A);
HM2131MIPI_write_cmos_sensor(0x373F,0x8A);
HM2131MIPI_write_cmos_sensor(0x3701,0x0A);
HM2131MIPI_write_cmos_sensor(0x3709,0x0A);
HM2131MIPI_write_cmos_sensor(0x3703,0x08);
HM2131MIPI_write_cmos_sensor(0x370B,0x08);
HM2131MIPI_write_cmos_sensor(0x3705,0x0F);
HM2131MIPI_write_cmos_sensor(0x370D,0x0F);
HM2131MIPI_write_cmos_sensor(0x3713,0x00);
HM2131MIPI_write_cmos_sensor(0x3717,0x00);
HM2131MIPI_write_cmos_sensor(0x5043,0x01);
HM2131MIPI_write_cmos_sensor(0x5040,0x05);
HM2131MIPI_write_cmos_sensor(0x5044,0x07);
HM2131MIPI_write_cmos_sensor(0x6000,0x0F);
HM2131MIPI_write_cmos_sensor(0x6001,0xFF);
HM2131MIPI_write_cmos_sensor(0x6002,0x1F);
HM2131MIPI_write_cmos_sensor(0x6003,0xFF);
HM2131MIPI_write_cmos_sensor(0x6004,0xC2);
HM2131MIPI_write_cmos_sensor(0x6005,0x00);
HM2131MIPI_write_cmos_sensor(0x6006,0x00);
HM2131MIPI_write_cmos_sensor(0x6007,0x00);
HM2131MIPI_write_cmos_sensor(0x6008,0x00);
HM2131MIPI_write_cmos_sensor(0x6009,0x00);
HM2131MIPI_write_cmos_sensor(0x600A,0x00);
HM2131MIPI_write_cmos_sensor(0x600B,0x00);
HM2131MIPI_write_cmos_sensor(0x600C,0x00);
HM2131MIPI_write_cmos_sensor(0x600D,0x20);
HM2131MIPI_write_cmos_sensor(0x600E,0x00);
HM2131MIPI_write_cmos_sensor(0x600F,0xA1);
HM2131MIPI_write_cmos_sensor(0x6010,0x01);
HM2131MIPI_write_cmos_sensor(0x6011,0x00);
HM2131MIPI_write_cmos_sensor(0x6012,0x06);
HM2131MIPI_write_cmos_sensor(0x6013,0x00);
HM2131MIPI_write_cmos_sensor(0x6014,0x0B);
HM2131MIPI_write_cmos_sensor(0x6015,0x00);
HM2131MIPI_write_cmos_sensor(0x6016,0x14);
HM2131MIPI_write_cmos_sensor(0x6017,0x00);
HM2131MIPI_write_cmos_sensor(0x6018,0x25);
HM2131MIPI_write_cmos_sensor(0x6019,0x00);
HM2131MIPI_write_cmos_sensor(0x601A,0x43);
HM2131MIPI_write_cmos_sensor(0x601B,0x00);
HM2131MIPI_write_cmos_sensor(0x601C,0x82);
HM2131MIPI_write_cmos_sensor(0x0000,0x00);
HM2131MIPI_write_cmos_sensor(0x0104,0x01);
HM2131MIPI_write_cmos_sensor(0x0104,0x00);
HM2131MIPI_write_cmos_sensor(0x0100,0x03);  

	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIInitialSetting function:\n ");
} 
/*****************************************************************
* FUNCTION
*    HM2131MIPIPreviewSetting
*
* DESCRIPTION
*    This function config Preview setting related registers of CMOS sensor.
*
* PARAMETERS
*    None
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/

// 1952x1092 -> active array size: 1920x1080,  by zhangxueping
// SVGA 800 * 600,  by zhangxueping 
void HM2131MIPIPreviewSetting_SVGA(void)
{
	//HM2131 sensor 1280x960
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIPreviewSetting_SVGA function:\n ");

	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIPreviewSetting_SVGA function:\n ");
}
static void XC7022PreviewSetting_SVGA(void)
{
		HM2131MIPISENSORDB("[XC7022]ENTER XC7022PreviewSetting_SVGA function:\n ");
		mDELAY(5);

//// 1.  AE statistical //////
//////////////////////////////
XC7022_write_cmos_sensor(0xfffe,0x30);   // AE_avg

XC7022_write_cmos_sensor(0x1f00,0x00);   // WIN start X
XC7022_write_cmos_sensor(0x1f01,0x00);
XC7022_write_cmos_sensor(0x1f02,0x00);   // WIN stat Y
XC7022_write_cmos_sensor(0x1f03,0xd0);
XC7022_write_cmos_sensor(0x1f04,0x07);   // WIN width
XC7022_write_cmos_sensor(0x1f05,0x80);
XC7022_write_cmos_sensor(0x1f06,0x03);   // WIN height
XC7022_write_cmos_sensor(0x1f07,0x20);
XC7022_write_cmos_sensor(0x1f08,0x03);

XC7022_write_cmos_sensor(0x0051,0x03);   // ae统计数据选择，gamma后

XC7022_write_cmos_sensor(0xfffe,0x50);
XC7022_write_cmos_sensor(0x000e,0x54);
XC7022_write_cmos_sensor(0xfffe,0x14);
XC7022_write_cmos_sensor(0x0006,0x08);
XC7022_write_cmos_sensor(0x0007,0x82);
XC7022_write_cmos_sensor(0x0014,0x00);
XC7022_write_cmos_sensor(0x0015,0x14);
XC7022_write_cmos_sensor(0x0016,0x22);
XC7022_write_cmos_sensor(0x0017,0x18);
XC7022_write_cmos_sensor(0x2114,0x9c);
XC7022_write_cmos_sensor(0x2115,0x21);
XC7022_write_cmos_sensor(0x2116,0xff);
XC7022_write_cmos_sensor(0x2117,0xf8);
XC7022_write_cmos_sensor(0x2118,0xd4);
XC7022_write_cmos_sensor(0x2119,0x01);
XC7022_write_cmos_sensor(0x211a,0x48);
XC7022_write_cmos_sensor(0x211c,0xd4);
XC7022_write_cmos_sensor(0x211d,0x01);
XC7022_write_cmos_sensor(0x211e,0x50);
XC7022_write_cmos_sensor(0x211f,0x04);
XC7022_write_cmos_sensor(0x2120,0x84);
XC7022_write_cmos_sensor(0x2121,0xc3);
XC7022_write_cmos_sensor(0x2123,0x08);
XC7022_write_cmos_sensor(0x2124,0xa9);
XC7022_write_cmos_sensor(0x2125,0x43);
XC7022_write_cmos_sensor(0x2128,0x9c);
XC7022_write_cmos_sensor(0x2129,0xe0);
XC7022_write_cmos_sensor(0x212c,0x8c);
XC7022_write_cmos_sensor(0x212d,0x66);
XC7022_write_cmos_sensor(0x212f,0xc7);
XC7022_write_cmos_sensor(0x2130,0xbc);
XC7022_write_cmos_sensor(0x2131,0x23);
XC7022_write_cmos_sensor(0x2133,0x01);
XC7022_write_cmos_sensor(0x2134,0x0c);
XC7022_write_cmos_sensor(0x2137,0x06);
XC7022_write_cmos_sensor(0x2138,0x84);
XC7022_write_cmos_sensor(0x2139,0xa6);
XC7022_write_cmos_sensor(0x213a,0x01);
XC7022_write_cmos_sensor(0x213b,0x0c);
XC7022_write_cmos_sensor(0x213c,0xb8);
XC7022_write_cmos_sensor(0x213d,0x65);
XC7022_write_cmos_sensor(0x213f,0x04);
XC7022_write_cmos_sensor(0x2140,0x9c);
XC7022_write_cmos_sensor(0x2141,0x63);
XC7022_write_cmos_sensor(0x2142,0xfe);
XC7022_write_cmos_sensor(0x2147,0x0e);
XC7022_write_cmos_sensor(0x2148,0xb8);
XC7022_write_cmos_sensor(0x2149,0xa3);
XC7022_write_cmos_sensor(0x214b,0x45);
XC7022_write_cmos_sensor(0x214f,0x04);
XC7022_write_cmos_sensor(0x2150,0xb8);
XC7022_write_cmos_sensor(0x2151,0x85);
XC7022_write_cmos_sensor(0x2153,0x45);
XC7022_write_cmos_sensor(0x2154,0x9c);
XC7022_write_cmos_sensor(0x2155,0x67);
XC7022_write_cmos_sensor(0x2157,0x01);
XC7022_write_cmos_sensor(0x2158,0xa4);
XC7022_write_cmos_sensor(0x2159,0xe3);
XC7022_write_cmos_sensor(0x215b,0xff);
XC7022_write_cmos_sensor(0x215c,0xbc);
XC7022_write_cmos_sensor(0x215d,0xa4);
XC7022_write_cmos_sensor(0x215f,0x01);
XC7022_write_cmos_sensor(0x2160,0x0f);
XC7022_write_cmos_sensor(0x2161,0xff);
XC7022_write_cmos_sensor(0x2162,0xff);
XC7022_write_cmos_sensor(0x2163,0xfd);
XC7022_write_cmos_sensor(0x2164,0xb8);
XC7022_write_cmos_sensor(0x2165,0x84);
XC7022_write_cmos_sensor(0x2167,0x41);
XC7022_write_cmos_sensor(0x2168,0xb8);
XC7022_write_cmos_sensor(0x2169,0x85);
XC7022_write_cmos_sensor(0x216b,0x41);
XC7022_write_cmos_sensor(0x216c,0xe0);
XC7022_write_cmos_sensor(0x216d,0x64);
XC7022_write_cmos_sensor(0x216e,0x38);
XC7022_write_cmos_sensor(0x216f,0x48);
XC7022_write_cmos_sensor(0x2170,0xb8);
XC7022_write_cmos_sensor(0x2171,0xa7);
XC7022_write_cmos_sensor(0x2173,0x04);
XC7022_write_cmos_sensor(0x2174,0x9c);
XC7022_write_cmos_sensor(0x2175,0x63);
XC7022_write_cmos_sensor(0x2176,0xff);
XC7022_write_cmos_sensor(0x2177,0xf0);
XC7022_write_cmos_sensor(0x2178,0xe0);
XC7022_write_cmos_sensor(0x2179,0xa3);
XC7022_write_cmos_sensor(0x217a,0x28);
XC7022_write_cmos_sensor(0x217c,0x94);
XC7022_write_cmos_sensor(0x217d,0x86);
XC7022_write_cmos_sensor(0x217f,0xe8);
XC7022_write_cmos_sensor(0x2180,0xa4);
XC7022_write_cmos_sensor(0x2181,0xa5);
XC7022_write_cmos_sensor(0x2183,0xff);
XC7022_write_cmos_sensor(0x2184,0x07);
XC7022_write_cmos_sensor(0x2185,0xfb);
XC7022_write_cmos_sensor(0x2186,0x06);
XC7022_write_cmos_sensor(0x2187,0xe0);
XC7022_write_cmos_sensor(0x2188,0xa8);
XC7022_write_cmos_sensor(0x2189,0x6a);
XC7022_write_cmos_sensor(0x218c,0xa8);
XC7022_write_cmos_sensor(0x218d,0x6a);
XC7022_write_cmos_sensor(0x2190,0x9c);
XC7022_write_cmos_sensor(0x2191,0x80);
XC7022_write_cmos_sensor(0x2192,0x01);
XC7022_write_cmos_sensor(0x2193,0x04);
XC7022_write_cmos_sensor(0x2194,0x07);
XC7022_write_cmos_sensor(0x2195,0xfb);
XC7022_write_cmos_sensor(0x2196,0x06);
XC7022_write_cmos_sensor(0x2197,0xdc);
XC7022_write_cmos_sensor(0x2198,0x9c);
XC7022_write_cmos_sensor(0x2199,0xa0);
XC7022_write_cmos_sensor(0x219b,0x01);
XC7022_write_cmos_sensor(0x219c,0x85);
XC7022_write_cmos_sensor(0x219d,0x21);
XC7022_write_cmos_sensor(0x21a0,0x85);
XC7022_write_cmos_sensor(0x21a1,0x41);
XC7022_write_cmos_sensor(0x21a3,0x04);
XC7022_write_cmos_sensor(0x21a4,0x44);
XC7022_write_cmos_sensor(0x21a6,0x48);
XC7022_write_cmos_sensor(0x21a8,0x9c);
XC7022_write_cmos_sensor(0x21a9,0x21);
XC7022_write_cmos_sensor(0x21ab,0x08);
XC7022_write_cmos_sensor(0x21ac,0x9c);
XC7022_write_cmos_sensor(0x21ad,0x21);
XC7022_write_cmos_sensor(0x21ae,0xff);
XC7022_write_cmos_sensor(0x21af,0xf0);
XC7022_write_cmos_sensor(0x21b0,0xd4);
XC7022_write_cmos_sensor(0x21b1,0x01);
XC7022_write_cmos_sensor(0x21b2,0x48);
XC7022_write_cmos_sensor(0x21b4,0xd4);
XC7022_write_cmos_sensor(0x21b5,0x01);
XC7022_write_cmos_sensor(0x21b6,0x50);
XC7022_write_cmos_sensor(0x21b7,0x04);
XC7022_write_cmos_sensor(0x21b8,0xd4);
XC7022_write_cmos_sensor(0x21b9,0x01);
XC7022_write_cmos_sensor(0x21ba,0x60);
XC7022_write_cmos_sensor(0x21bb,0x08);
XC7022_write_cmos_sensor(0x21bc,0xd4);
XC7022_write_cmos_sensor(0x21bd,0x01);
XC7022_write_cmos_sensor(0x21be,0x70);
XC7022_write_cmos_sensor(0x21bf,0x0c);
XC7022_write_cmos_sensor(0x21c0,0x85);
XC7022_write_cmos_sensor(0x21c1,0x43);
XC7022_write_cmos_sensor(0x21c3,0x08);
XC7022_write_cmos_sensor(0x21c4,0xa9);
XC7022_write_cmos_sensor(0x21c5,0x83);
XC7022_write_cmos_sensor(0x21c8,0x84);
XC7022_write_cmos_sensor(0x21c9,0xca);
XC7022_write_cmos_sensor(0x21ca,0x01);
XC7022_write_cmos_sensor(0x21cb,0x08);
XC7022_write_cmos_sensor(0x21cc,0x94);
XC7022_write_cmos_sensor(0x21cd,0x8a);
XC7022_write_cmos_sensor(0x21cf,0xc8);
XC7022_write_cmos_sensor(0x21d0,0xb8);
XC7022_write_cmos_sensor(0x21d1,0xa6);
XC7022_write_cmos_sensor(0x21d3,0x4c);
XC7022_write_cmos_sensor(0x21d4,0xb9);
XC7022_write_cmos_sensor(0x21d5,0xc6);
XC7022_write_cmos_sensor(0x21d7,0x44);
XC7022_write_cmos_sensor(0x21d8,0x07);
XC7022_write_cmos_sensor(0x21d9,0xfb);
XC7022_write_cmos_sensor(0x21da,0x06);
XC7022_write_cmos_sensor(0x21db,0xcb);
XC7022_write_cmos_sensor(0x21dc,0xa4);
XC7022_write_cmos_sensor(0x21dd,0xa5);
XC7022_write_cmos_sensor(0x21df,0xff);
XC7022_write_cmos_sensor(0x21e0,0x94);
XC7022_write_cmos_sensor(0x21e1,0x8a);
XC7022_write_cmos_sensor(0x21e3,0xca);
XC7022_write_cmos_sensor(0x21e4,0xa8);
XC7022_write_cmos_sensor(0x21e5,0x6c);
XC7022_write_cmos_sensor(0x21e8,0x07);
XC7022_write_cmos_sensor(0x21e9,0xfb);
XC7022_write_cmos_sensor(0x21ea,0x06);
XC7022_write_cmos_sensor(0x21eb,0xc7);
XC7022_write_cmos_sensor(0x21ec,0xa4);
XC7022_write_cmos_sensor(0x21ed,0xae);
XC7022_write_cmos_sensor(0x21ef,0xff);
XC7022_write_cmos_sensor(0x21f0,0xa8);
XC7022_write_cmos_sensor(0x21f1,0x6c);
XC7022_write_cmos_sensor(0x21f4,0x9c);
XC7022_write_cmos_sensor(0x21f5,0x80);
XC7022_write_cmos_sensor(0x21f6,0x01);
XC7022_write_cmos_sensor(0x21f7,0x04);
XC7022_write_cmos_sensor(0x21f8,0x07);
XC7022_write_cmos_sensor(0x21f9,0xfb);
XC7022_write_cmos_sensor(0x21fa,0x06);
XC7022_write_cmos_sensor(0x21fb,0xc3);
XC7022_write_cmos_sensor(0x21fc,0x9c);
XC7022_write_cmos_sensor(0x21fd,0xa0);
XC7022_write_cmos_sensor(0x21ff,0x01);
XC7022_write_cmos_sensor(0x2200,0x85);
XC7022_write_cmos_sensor(0x2201,0x21);
XC7022_write_cmos_sensor(0x2204,0x85);
XC7022_write_cmos_sensor(0x2205,0x41);
XC7022_write_cmos_sensor(0x2207,0x04);
XC7022_write_cmos_sensor(0x2208,0x85);
XC7022_write_cmos_sensor(0x2209,0x81);
XC7022_write_cmos_sensor(0x220b,0x08);
XC7022_write_cmos_sensor(0x220c,0x85);
XC7022_write_cmos_sensor(0x220d,0xc1);
XC7022_write_cmos_sensor(0x220f,0x0c);
XC7022_write_cmos_sensor(0x2210,0x44);
XC7022_write_cmos_sensor(0x2212,0x48);
XC7022_write_cmos_sensor(0x2214,0x9c);
XC7022_write_cmos_sensor(0x2215,0x21);
XC7022_write_cmos_sensor(0x2217,0x10);
XC7022_write_cmos_sensor(0x2218,0x9c);
XC7022_write_cmos_sensor(0x2219,0x21);
XC7022_write_cmos_sensor(0x221a,0xff);
XC7022_write_cmos_sensor(0x221b,0xfc);
XC7022_write_cmos_sensor(0x221c,0xd4);
XC7022_write_cmos_sensor(0x221d,0x01);
XC7022_write_cmos_sensor(0x221e,0x48);
XC7022_write_cmos_sensor(0x2220,0xa8);
XC7022_write_cmos_sensor(0x2221,0x83);
XC7022_write_cmos_sensor(0x2224,0xbc);
XC7022_write_cmos_sensor(0x2225,0x03);
XC7022_write_cmos_sensor(0x2226,0x04);
XC7022_write_cmos_sensor(0x2227,0x0b);
XC7022_write_cmos_sensor(0x2228,0x10);
XC7022_write_cmos_sensor(0x222b,0x07);
XC7022_write_cmos_sensor(0x222c,0xa8);
XC7022_write_cmos_sensor(0x222d,0x66);
XC7022_write_cmos_sensor(0x2230,0xbc);
XC7022_write_cmos_sensor(0x2231,0x04);
XC7022_write_cmos_sensor(0x2232,0x04);
XC7022_write_cmos_sensor(0x2233,0x0c);
XC7022_write_cmos_sensor(0x2234,0x0c);
XC7022_write_cmos_sensor(0x2237,0x0b);
XC7022_write_cmos_sensor(0x2238,0x9d);
XC7022_write_cmos_sensor(0x2239,0x60);
XC7022_write_cmos_sensor(0x223f,0x06);
XC7022_write_cmos_sensor(0x2240,0x15);
XC7022_write_cmos_sensor(0x2244,0x07);
XC7022_write_cmos_sensor(0x2245,0xff);
XC7022_write_cmos_sensor(0x2246,0xff);
XC7022_write_cmos_sensor(0x2247,0xda);
XC7022_write_cmos_sensor(0x2248,0x15);
XC7022_write_cmos_sensor(0x224f,0x05);
XC7022_write_cmos_sensor(0x2250,0x9d);
XC7022_write_cmos_sensor(0x2251,0x60);
XC7022_write_cmos_sensor(0x2254,0x07);
XC7022_write_cmos_sensor(0x2255,0xff);
XC7022_write_cmos_sensor(0x2256,0xff);
XC7022_write_cmos_sensor(0x2257,0xb0);
XC7022_write_cmos_sensor(0x2258,0x15);
XC7022_write_cmos_sensor(0x225c,0x9d);
XC7022_write_cmos_sensor(0x225d,0x60);
XC7022_write_cmos_sensor(0x2260,0x85);
XC7022_write_cmos_sensor(0x2261,0x21);
XC7022_write_cmos_sensor(0x2264,0x44);
XC7022_write_cmos_sensor(0x2266,0x48);
XC7022_write_cmos_sensor(0x2268,0x9c);
XC7022_write_cmos_sensor(0x2269,0x21);
XC7022_write_cmos_sensor(0x226b,0x04);

XC7022_write_cmos_sensor(0xfffe,0x50);
XC7022_write_cmos_sensor(0x0137,0x99);

//////////// 2.  AE SENSOR     //////
/////////////////////////////////////
XC7022_write_cmos_sensor(0xfffe,0x14); 
XC7022_write_cmos_sensor(0x010e,0x48);  	//camera i2c id
XC7022_write_cmos_sensor(0x010f,0x01);  	//camera i2c bits
XC7022_write_cmos_sensor(0x0110,0x05);  	//sensor type gain
XC7022_write_cmos_sensor(0x0113,0x01);
XC7022_write_cmos_sensor(0x0111,0x0f);  	//sensor type exposure

//exposure
XC7022_write_cmos_sensor(0x0114,0x02);  //write camera exposure variable [19:16]
XC7022_write_cmos_sensor(0x0115,0x02);
XC7022_write_cmos_sensor(0x0116,0x02);  //write camera exposure variable [15:8]
XC7022_write_cmos_sensor(0x0117,0x03);

XC7022_write_cmos_sensor(0x011c,0x00);  //camera exposure addr mask 1
XC7022_write_cmos_sensor(0x011d,0xff);      
XC7022_write_cmos_sensor(0x011e,0x00);  //camera exposure addr mask 2
XC7022_write_cmos_sensor(0x011f,0xff);

//gain
XC7022_write_cmos_sensor(0x0134,0x02);  //camera gain addr
XC7022_write_cmos_sensor(0x0135,0x05);

XC7022_write_cmos_sensor(0x013c,0x00);  //camera gain addr mask 1
XC7022_write_cmos_sensor(0x013d,0xff);

XC7022_write_cmos_sensor(0x0145,0x00);  //gain delay frame

XC7022_write_cmos_sensor(0x0031,0x01);    //effect exposure mode
XC7022_write_cmos_sensor(0x0032,0x01);    //effect gain mode

/////////3.AENORMAL//////
//////////////////////////////////
XC7022_write_cmos_sensor(0xfffe,0x14);
XC7022_write_cmos_sensor(0x004c,0x00);//AECmode
XC7022_write_cmos_sensor(0x002b,0x01);//aeenable
XC7022_write_cmos_sensor(0x004d,0x01);//aeForcewrite

XC7022_write_cmos_sensor(0x00fa,0x00);
XC7022_write_cmos_sensor(0x00fb,0x80);//maxgain

XC7022_write_cmos_sensor(0x00fc,0x00);
XC7022_write_cmos_sensor(0x00fd,0x20);//mingain

XC7022_write_cmos_sensor(0x00e2,0x42);//maxexposurelines
XC7022_write_cmos_sensor(0x00e3,0x00);

XC7022_write_cmos_sensor(0x00de,0x0);
XC7022_write_cmos_sensor(0x00df,0x10);//minexp

XC7022_write_cmos_sensor(0x00a0,0x01);//daytarget
XC7022_write_cmos_sensor(0x00a1,0xc0);

//flicker
XC7022_write_cmos_sensor(0x0104,0x02);
XC7022_write_cmos_sensor(0x0105,0x01);//MinFlickerLinesEnable
XC7022_write_cmos_sensor(0x0108,0x14);
XC7022_write_cmos_sensor(0x0109,0xC0);

//weight
XC7022_write_cmos_sensor(0x0055,0x04);
XC7022_write_cmos_sensor(0x0056,0x04);
XC7022_write_cmos_sensor(0x0057,0x04);
XC7022_write_cmos_sensor(0x0058,0x04);
XC7022_write_cmos_sensor(0x0059,0x04);

XC7022_write_cmos_sensor(0x005a,0x04);
XC7022_write_cmos_sensor(0x005b,0x04);
XC7022_write_cmos_sensor(0x005c,0x04);
XC7022_write_cmos_sensor(0x005d,0x04);
XC7022_write_cmos_sensor(0x005e,0x04);

XC7022_write_cmos_sensor(0x005f,0x10);
XC7022_write_cmos_sensor(0x0060,0x20);
XC7022_write_cmos_sensor(0x0061,0x20);
XC7022_write_cmos_sensor(0x0062,0x20);
XC7022_write_cmos_sensor(0x0063,0x10);

XC7022_write_cmos_sensor(0x0064,0x10);
XC7022_write_cmos_sensor(0x0065,0x40);
XC7022_write_cmos_sensor(0x0066,0x40);
XC7022_write_cmos_sensor(0x0067,0x40);
XC7022_write_cmos_sensor(0x0068,0x10);

XC7022_write_cmos_sensor(0x0069,0x04);
XC7022_write_cmos_sensor(0x006a,0x10);
XC7022_write_cmos_sensor(0x006b,0x10);
XC7022_write_cmos_sensor(0x006c,0x10);
XC7022_write_cmos_sensor(0x006d,0x04);//权重forCurAvg

XC7022_write_cmos_sensor(0x0088,0x00);
XC7022_write_cmos_sensor(0x0089,0xE7);
XC7022_write_cmos_sensor(0x008a,0x00);
XC7022_write_cmos_sensor(0x008b,0x00);//关注区域for亮块

XC7022_write_cmos_sensor(0x0050,0x01);//refresh

//////////4.AESPEED/////
//////////////////////////////////
XC7022_write_cmos_sensor(0x00c6,0x01);//delayframe

XC7022_write_cmos_sensor(0x00ca,0x00);//1.thresholdlow
XC7022_write_cmos_sensor(0x00cb,0x60);

XC7022_write_cmos_sensor(0x01bc,0x00);//thr_l_all
XC7022_write_cmos_sensor(0x01bd,0x50);//thr_l_all

XC7022_write_cmos_sensor(0x01be,0x00);//thr_l_avg
XC7022_write_cmos_sensor(0x01bf,0x40);//thr_l_avg

XC7022_write_cmos_sensor(0x00cc,0x00);//2.thresholdhigh
XC7022_write_cmos_sensor(0x00cd,0x80);

XC7022_write_cmos_sensor(0x00c7,0x18);//3.finallythr

XC7022_write_cmos_sensor(0x00c8,0x01);//totalspeed
XC7022_write_cmos_sensor(0x0208,0x2);//speedlimitfactor

XC7022_write_cmos_sensor(0x00da,0x00);//LumaDiffThrLow
XC7022_write_cmos_sensor(0x00db,0x80);

XC7022_write_cmos_sensor(0x00dc,0x03);//LumaDiffThrHigh
XC7022_write_cmos_sensor(0x00dd,0x00);

//////////5.AESMART////
/////////////////////////////////
XC7022_write_cmos_sensor(0x0092,0x01);//smartmode
XC7022_write_cmos_sensor(0x0093,0x15);//XC7022_write_cmos_sensor(0x15//analysismode+zhifangtu
XC7022_write_cmos_sensor(0x0094,0x00);//smartspeedlimit//打开会造成震荡

XC7022_write_cmos_sensor(0x00ad,0x02);//ATTblockCnt关注区域亮块数算平均

////////////tablereftarget/////////
XC7022_write_cmos_sensor(0x0022,0x1e);//usecurfps

XC7022_write_cmos_sensor(0x01e4,0x00);//ExpvalueTable
XC7022_write_cmos_sensor(0x01e5,0x00);
XC7022_write_cmos_sensor(0x01e6,0x11);
XC7022_write_cmos_sensor(0x01e7,0x80);//table01/4maxexp*1gain

XC7022_write_cmos_sensor(0x01e8,0x00);
XC7022_write_cmos_sensor(0x01e9,0x00);
XC7022_write_cmos_sensor(0x01ea,0x23);
XC7022_write_cmos_sensor(0x01eb,0x40);//table11/2maxexp*1gain

XC7022_write_cmos_sensor(0x01ec,0x00);
XC7022_write_cmos_sensor(0x01ed,0x00);
XC7022_write_cmos_sensor(0x01ee,0x42);
XC7022_write_cmos_sensor(0x01ef,0x80);//table2maxexp*1gain

XC7022_write_cmos_sensor(0x01f0,0x00);
XC7022_write_cmos_sensor(0x01f1,0x00);
XC7022_write_cmos_sensor(0x01f2,0x84);
XC7022_write_cmos_sensor(0x01f3,0xC0);//table3maxexp*4gain

XC7022_write_cmos_sensor(0x01f4,0x00);
XC7022_write_cmos_sensor(0x01f5,0x01);
XC7022_write_cmos_sensor(0x01f6,0x09);
XC7022_write_cmos_sensor(0x01f7,0x80);//table4maxexp*8gain

XC7022_write_cmos_sensor(0x01f8,0x00);
XC7022_write_cmos_sensor(0x01f9,0x02);
XC7022_write_cmos_sensor(0x01fa,0x13);
XC7022_write_cmos_sensor(0x01fb,0x40);//table5maxexp*16gain

//////////reftarget///////////////
XC7022_write_cmos_sensor(0x00b2,0x02);//reftargettable0可更改的目标亮度
XC7022_write_cmos_sensor(0x00b3,0x20);
XC7022_write_cmos_sensor(0x00b4,0x02);//reftargettable1
XC7022_write_cmos_sensor(0x00b5,0x00);
XC7022_write_cmos_sensor(0x00b6,0x01);//reftargettable2
XC7022_write_cmos_sensor(0x00b7,0x80);
XC7022_write_cmos_sensor(0x00b8,0x01);//reftargettable3
XC7022_write_cmos_sensor(0x00b9,0x20);
XC7022_write_cmos_sensor(0x00ba,0x00);//reftargettable4
XC7022_write_cmos_sensor(0x00bb,0xc0);
XC7022_write_cmos_sensor(0x00bc,0x00);//reftargettable5
XC7022_write_cmos_sensor(0x00bd,0xc0);

XC7022_write_cmos_sensor(0x01cd,0x28);//avgaffectval
XC7022_write_cmos_sensor(0x01cb,0x00);//avgthr_l
XC7022_write_cmos_sensor(0x01cc,0x40);//avgthr_h

///////////overexposureoffest//////
XC7022_write_cmos_sensor(0x01d6,0x00);
XC7022_write_cmos_sensor(0x01d7,0x08);
XC7022_write_cmos_sensor(0x01d8,0x40);
XC7022_write_cmos_sensor(0x01d9,0xc0);
XC7022_write_cmos_sensor(0x01da,0x80);
XC7022_write_cmos_sensor(0x01db,0x80);

/////////att//////////////////
XC7022_write_cmos_sensor(0x00c0,0x30);//HistHighThr_1
XC7022_write_cmos_sensor(0x00c1,0x34);//HistHighThr_2
XC7022_write_cmos_sensor(0x01c0,0x0a);//PDFUSECNT
XC7022_write_cmos_sensor(0x01c7,0x06);//PDFH_max
XC7022_write_cmos_sensor(0x01c9,0x02);//PDFH_target
XC7022_write_cmos_sensor(0x01ca,0x50);
XC7022_write_cmos_sensor(0x01d1,0x60);


XC7022_write_cmos_sensor(0x00ab,0x05);
XC7022_write_cmos_sensor(0x00ac,0x05);
XC7022_write_cmos_sensor(0x00ad,0x02);


XC7022_write_cmos_sensor(0x016c,0x00);//minattthr
XC7022_write_cmos_sensor(0x016d,0x00);//minattthr

XC7022_write_cmos_sensor(0x016e,0x02);
XC7022_write_cmos_sensor(0x016f,0x40);//MaxATTthrshold关注区域的门限值

XC7022_write_cmos_sensor(0x01d3,0x00);//nouseAttlimitratioL
XC7022_write_cmos_sensor(0x01d4,0x60);//AttlimitratioH关注区域的调整值



//XC7022_write_cmos_sensor(0x01ba,0x8);//BrightRatio2

////////////smartaeend/////////
XC7022_write_cmos_sensor(0x1a74,0x02);//2framewrite
XC7022_write_cmos_sensor(0x0212,0x00);//aechufamenxian

/////////////AE  END/////////////////
////////////////////////////////////

XC7022_write_cmos_sensor(0xfffe,0x30);                    
XC7022_write_cmos_sensor(0x0013,0x00);//bias              
XC7022_write_cmos_sensor(0x0014,0x00);                    
XC7022_write_cmos_sensor(0x071b,0x00);//blc   

XC7022_write_cmos_sensor(0xfffe,0x30);	
XC7022_write_cmos_sensor(0x03ca,0x0C);	
XC7022_write_cmos_sensor(0x03cb,0xCC);	
XC7022_write_cmos_sensor(0x03cc,0x16);	
XC7022_write_cmos_sensor(0x03cd,0xC1);	
XC7022_write_cmos_sensor(0x03ce,0x0C);	
XC7022_write_cmos_sensor(0x03cf,0xCC);	
XC7022_write_cmos_sensor(0x03d0,0x0B);	
XC7022_write_cmos_sensor(0x03d1,0x60);


XC7022_write_cmos_sensor(0xfffe,0x14);

XC7022_write_cmos_sensor(0x002c,0x01);
XC7022_write_cmos_sensor(0x0030,0x01);
XC7022_write_cmos_sensor(0x0620,0x01);	
XC7022_write_cmos_sensor(0x0621,0x01);	

XC7022_write_cmos_sensor(0x0928,0x00);	//ct
XC7022_write_cmos_sensor(0x0929,0x67);
XC7022_write_cmos_sensor(0x092a,0x00);	
XC7022_write_cmos_sensor(0x092b,0xb3);
XC7022_write_cmos_sensor(0x092c,0x01);	
XC7022_write_cmos_sensor(0x092d,0x32);

XC7022_write_cmos_sensor(0x06e5,0x3c);//A_9);20161101_v2
XC7022_write_cmos_sensor(0x06e6,0x1e);
XC7022_write_cmos_sensor(0x06e7,0x15);
XC7022_write_cmos_sensor(0x06e8,0x11);
XC7022_write_cmos_sensor(0x06e9,0x11);
XC7022_write_cmos_sensor(0x06ea,0x13);
XC7022_write_cmos_sensor(0x06eb,0x1c);
XC7022_write_cmos_sensor(0x06ec,0x32);
XC7022_write_cmos_sensor(0x06ed,0x08);
XC7022_write_cmos_sensor(0x06ee,0x05);
XC7022_write_cmos_sensor(0x06ef,0x03);
XC7022_write_cmos_sensor(0x06f0,0x03);
XC7022_write_cmos_sensor(0x06f1,0x03);
XC7022_write_cmos_sensor(0x06f2,0x03);
XC7022_write_cmos_sensor(0x06f3,0x05);
XC7022_write_cmos_sensor(0x06f4,0x09);
XC7022_write_cmos_sensor(0x06f5,0x03);
XC7022_write_cmos_sensor(0x06f6,0x01);
XC7022_write_cmos_sensor(0x06f7,0x01);
XC7022_write_cmos_sensor(0x06f8,0x01);
XC7022_write_cmos_sensor(0x06f9,0x01);
XC7022_write_cmos_sensor(0x06fa,0x01);
XC7022_write_cmos_sensor(0x06fb,0x02);
XC7022_write_cmos_sensor(0x06fc,0x04);
XC7022_write_cmos_sensor(0x06fd,0x01);
XC7022_write_cmos_sensor(0x06fe,0x00);
XC7022_write_cmos_sensor(0x06ff,0x00);
XC7022_write_cmos_sensor(0x0700,0x00);
XC7022_write_cmos_sensor(0x0701,0x00);
XC7022_write_cmos_sensor(0x0702,0x00);
XC7022_write_cmos_sensor(0x0703,0x01);
XC7022_write_cmos_sensor(0x0704,0x01);
XC7022_write_cmos_sensor(0x0705,0x01);
XC7022_write_cmos_sensor(0x0706,0x00);
XC7022_write_cmos_sensor(0x0707,0x00);
XC7022_write_cmos_sensor(0x0708,0x00);
XC7022_write_cmos_sensor(0x0709,0x00);
XC7022_write_cmos_sensor(0x070a,0x00);
XC7022_write_cmos_sensor(0x070b,0x01);
XC7022_write_cmos_sensor(0x070c,0x02);
XC7022_write_cmos_sensor(0x070d,0x03);
XC7022_write_cmos_sensor(0x070e,0x01);
XC7022_write_cmos_sensor(0x070f,0x01);
XC7022_write_cmos_sensor(0x0710,0x01);
XC7022_write_cmos_sensor(0x0711,0x01);
XC7022_write_cmos_sensor(0x0712,0x01);
XC7022_write_cmos_sensor(0x0713,0x02);
XC7022_write_cmos_sensor(0x0714,0x03);
XC7022_write_cmos_sensor(0x0715,0x09);
XC7022_write_cmos_sensor(0x0716,0x06);
XC7022_write_cmos_sensor(0x0717,0x03);
XC7022_write_cmos_sensor(0x0718,0x03);
XC7022_write_cmos_sensor(0x0719,0x03);
XC7022_write_cmos_sensor(0x071a,0x04);
XC7022_write_cmos_sensor(0x071b,0x05);
XC7022_write_cmos_sensor(0x071c,0x0b);
XC7022_write_cmos_sensor(0x071d,0x3f);
XC7022_write_cmos_sensor(0x071e,0x21);
XC7022_write_cmos_sensor(0x071f,0x16);
XC7022_write_cmos_sensor(0x0720,0x12);
XC7022_write_cmos_sensor(0x0721,0x11);
XC7022_write_cmos_sensor(0x0722,0x14);
XC7022_write_cmos_sensor(0x0723,0x20);
XC7022_write_cmos_sensor(0x0724,0x28);
XC7022_write_cmos_sensor(0x0725,0xf);
XC7022_write_cmos_sensor(0x0726,0x1a);
XC7022_write_cmos_sensor(0x0727,0x1b);
XC7022_write_cmos_sensor(0x0728,0x1c);
XC7022_write_cmos_sensor(0x0729,0x1c);
XC7022_write_cmos_sensor(0x072a,0x1a);
XC7022_write_cmos_sensor(0x072b,0x18);
XC7022_write_cmos_sensor(0x072c,0x14);
XC7022_write_cmos_sensor(0x072d,0x1d);
XC7022_write_cmos_sensor(0x072e,0x1e);
XC7022_write_cmos_sensor(0x072f,0x1f);
XC7022_write_cmos_sensor(0x0730,0x1f);
XC7022_write_cmos_sensor(0x0731,0x1f);
XC7022_write_cmos_sensor(0x0732,0x20);
XC7022_write_cmos_sensor(0x0733,0x1f);
XC7022_write_cmos_sensor(0x0734,0x1e);
XC7022_write_cmos_sensor(0x0735,0x1d);
XC7022_write_cmos_sensor(0x0736,0x20);
XC7022_write_cmos_sensor(0x0737,0x1f);
XC7022_write_cmos_sensor(0x0738,0x20);
XC7022_write_cmos_sensor(0x0739,0x20);
XC7022_write_cmos_sensor(0x073a,0x20);
XC7022_write_cmos_sensor(0x073b,0x1f);
XC7022_write_cmos_sensor(0x073c,0x20);
XC7022_write_cmos_sensor(0x073d,0x1e);
XC7022_write_cmos_sensor(0x073e,0x20);
XC7022_write_cmos_sensor(0x073f,0x20);
XC7022_write_cmos_sensor(0x0740,0x20);
XC7022_write_cmos_sensor(0x0741,0x20);
XC7022_write_cmos_sensor(0x0742,0x20);
XC7022_write_cmos_sensor(0x0743,0x20);
XC7022_write_cmos_sensor(0x0744,0x21);
XC7022_write_cmos_sensor(0x0745,0x1e);
XC7022_write_cmos_sensor(0x0746,0x20);
XC7022_write_cmos_sensor(0x0747,0x20);
XC7022_write_cmos_sensor(0x0748,0x20);
XC7022_write_cmos_sensor(0x0749,0x20);
XC7022_write_cmos_sensor(0x074a,0x21);
XC7022_write_cmos_sensor(0x074b,0x21);
XC7022_write_cmos_sensor(0x074c,0x20);
XC7022_write_cmos_sensor(0x074d,0x1d);
XC7022_write_cmos_sensor(0x074e,0x20);
XC7022_write_cmos_sensor(0x074f,0x20);
XC7022_write_cmos_sensor(0x0750,0x20);
XC7022_write_cmos_sensor(0x0751,0x20);
XC7022_write_cmos_sensor(0x0752,0x20);
XC7022_write_cmos_sensor(0x0753,0x20);
XC7022_write_cmos_sensor(0x0754,0x20);
XC7022_write_cmos_sensor(0x0755,0x1c);
XC7022_write_cmos_sensor(0x0756,0x1f);
XC7022_write_cmos_sensor(0x0757,0x1f);
XC7022_write_cmos_sensor(0x0758,0x20);
XC7022_write_cmos_sensor(0x0759,0x20);
XC7022_write_cmos_sensor(0x075a,0x1f);
XC7022_write_cmos_sensor(0x075b,0x20);
XC7022_write_cmos_sensor(0x075c,0x1d);
XC7022_write_cmos_sensor(0x075d,0xe);
XC7022_write_cmos_sensor(0x075e,0x18);
XC7022_write_cmos_sensor(0x075f,0x1a);
XC7022_write_cmos_sensor(0x0760,0x1b);
XC7022_write_cmos_sensor(0x0761,0x1b);
XC7022_write_cmos_sensor(0x0762,0x1b);
XC7022_write_cmos_sensor(0x0763,0x17);
XC7022_write_cmos_sensor(0x0764,0x1b);
XC7022_write_cmos_sensor(0x0765,0x1f);
XC7022_write_cmos_sensor(0x0766,0x22);
XC7022_write_cmos_sensor(0x0767,0x22);
XC7022_write_cmos_sensor(0x0768,0x23);
XC7022_write_cmos_sensor(0x0769,0x24);
XC7022_write_cmos_sensor(0x076a,0x24);
XC7022_write_cmos_sensor(0x076b,0x23);
XC7022_write_cmos_sensor(0x076c,0x22);
XC7022_write_cmos_sensor(0x076d,0x25);
XC7022_write_cmos_sensor(0x076e,0x23);
XC7022_write_cmos_sensor(0x076f,0x23);
XC7022_write_cmos_sensor(0x0770,0x22);
XC7022_write_cmos_sensor(0x0771,0x22);
XC7022_write_cmos_sensor(0x0772,0x22);
XC7022_write_cmos_sensor(0x0773,0x22);
XC7022_write_cmos_sensor(0x0774,0x23);
XC7022_write_cmos_sensor(0x0775,0x24);
XC7022_write_cmos_sensor(0x0776,0x21);
XC7022_write_cmos_sensor(0x0777,0x21);
XC7022_write_cmos_sensor(0x0778,0x21);
XC7022_write_cmos_sensor(0x0779,0x21);
XC7022_write_cmos_sensor(0x077a,0x21);
XC7022_write_cmos_sensor(0x077b,0x21);
XC7022_write_cmos_sensor(0x077c,0x22);
XC7022_write_cmos_sensor(0x077d,0x23);
XC7022_write_cmos_sensor(0x077e,0x21);
XC7022_write_cmos_sensor(0x077f,0x21);
XC7022_write_cmos_sensor(0x0780,0x20);
XC7022_write_cmos_sensor(0x0781,0x20);
XC7022_write_cmos_sensor(0x0782,0x20);
XC7022_write_cmos_sensor(0x0783,0x20);
XC7022_write_cmos_sensor(0x0784,0x21);
XC7022_write_cmos_sensor(0x0785,0x23);
XC7022_write_cmos_sensor(0x0786,0x21);
XC7022_write_cmos_sensor(0x0787,0x20);
XC7022_write_cmos_sensor(0x0788,0x20);
XC7022_write_cmos_sensor(0x0789,0x20);
XC7022_write_cmos_sensor(0x078a,0x20);
XC7022_write_cmos_sensor(0x078b,0x20);
XC7022_write_cmos_sensor(0x078c,0x21);
XC7022_write_cmos_sensor(0x078d,0x24);
XC7022_write_cmos_sensor(0x078e,0x21);
XC7022_write_cmos_sensor(0x078f,0x21);
XC7022_write_cmos_sensor(0x0790,0x21);
XC7022_write_cmos_sensor(0x0791,0x21);
XC7022_write_cmos_sensor(0x0792,0x21);
XC7022_write_cmos_sensor(0x0793,0x21);
XC7022_write_cmos_sensor(0x0794,0x22);
XC7022_write_cmos_sensor(0x0795,0x24);
XC7022_write_cmos_sensor(0x0796,0x22);
XC7022_write_cmos_sensor(0x0797,0x22);
XC7022_write_cmos_sensor(0x0798,0x22);
XC7022_write_cmos_sensor(0x0799,0x22);
XC7022_write_cmos_sensor(0x079a,0x22);
XC7022_write_cmos_sensor(0x079b,0x22);
XC7022_write_cmos_sensor(0x079c,0x23);
XC7022_write_cmos_sensor(0x079d,0x22);
XC7022_write_cmos_sensor(0x079e,0x22);
XC7022_write_cmos_sensor(0x079f,0x24);
XC7022_write_cmos_sensor(0x07a0,0x24);
XC7022_write_cmos_sensor(0x07a1,0x24);
XC7022_write_cmos_sensor(0x07a2,0x24);
XC7022_write_cmos_sensor(0x07a3,0x23);
XC7022_write_cmos_sensor(0x07a4,0x21);

XC7022_write_cmos_sensor(0x07a5,0x3d);
XC7022_write_cmos_sensor(0x07a6,0x1e);
XC7022_write_cmos_sensor(0x07a7,0x15);
XC7022_write_cmos_sensor(0x07a8,0x11);
XC7022_write_cmos_sensor(0x07a9,0x10);
XC7022_write_cmos_sensor(0x07aa,0x13);
XC7022_write_cmos_sensor(0x07ab,0x1c);
XC7022_write_cmos_sensor(0x07ac,0x33);
XC7022_write_cmos_sensor(0x07ad,0x08);
XC7022_write_cmos_sensor(0x07ae,0x05);
XC7022_write_cmos_sensor(0x07af,0x03);
XC7022_write_cmos_sensor(0x07b0,0x03);
XC7022_write_cmos_sensor(0x07b1,0x03);
XC7022_write_cmos_sensor(0x07b2,0x03);
XC7022_write_cmos_sensor(0x07b3,0x05);
XC7022_write_cmos_sensor(0x07b4,0x09);
XC7022_write_cmos_sensor(0x07b5,0x03);
XC7022_write_cmos_sensor(0x07b6,0x01);
XC7022_write_cmos_sensor(0x07b7,0x00);
XC7022_write_cmos_sensor(0x07b8,0x01);
XC7022_write_cmos_sensor(0x07b9,0x01);
XC7022_write_cmos_sensor(0x07ba,0x01);
XC7022_write_cmos_sensor(0x07bb,0x02);
XC7022_write_cmos_sensor(0x07bc,0x03);
XC7022_write_cmos_sensor(0x07bd,0x01);
XC7022_write_cmos_sensor(0x07be,0x00);
XC7022_write_cmos_sensor(0x07bf,0x00);
XC7022_write_cmos_sensor(0x07c0,0x00);
XC7022_write_cmos_sensor(0x07c1,0x00);
XC7022_write_cmos_sensor(0x07c2,0x00);
XC7022_write_cmos_sensor(0x07c3,0x01);
XC7022_write_cmos_sensor(0x07c4,0x01);
XC7022_write_cmos_sensor(0x07c5,0x01);
XC7022_write_cmos_sensor(0x07c6,0x00);
XC7022_write_cmos_sensor(0x07c7,0x00);
XC7022_write_cmos_sensor(0x07c8,0x00);
XC7022_write_cmos_sensor(0x07c9,0x00);
XC7022_write_cmos_sensor(0x07ca,0x00);
XC7022_write_cmos_sensor(0x07cb,0x01);
XC7022_write_cmos_sensor(0x07cc,0x02);
XC7022_write_cmos_sensor(0x07cd,0x03);
XC7022_write_cmos_sensor(0x07ce,0x01);
XC7022_write_cmos_sensor(0x07cf,0x01);
XC7022_write_cmos_sensor(0x07d0,0x01);
XC7022_write_cmos_sensor(0x07d1,0x01);
XC7022_write_cmos_sensor(0x07d2,0x01);
XC7022_write_cmos_sensor(0x07d3,0x02);
XC7022_write_cmos_sensor(0x07d4,0x03);
XC7022_write_cmos_sensor(0x07d5,0x09);
XC7022_write_cmos_sensor(0x07d6,0x06);
XC7022_write_cmos_sensor(0x07d7,0x03);
XC7022_write_cmos_sensor(0x07d8,0x03);
XC7022_write_cmos_sensor(0x07d9,0x03);
XC7022_write_cmos_sensor(0x07da,0x04);
XC7022_write_cmos_sensor(0x07db,0x05);
XC7022_write_cmos_sensor(0x07dc,0x0a);
XC7022_write_cmos_sensor(0x07dd,0x3f);
XC7022_write_cmos_sensor(0x07de,0x21);
XC7022_write_cmos_sensor(0x07df,0x16);
XC7022_write_cmos_sensor(0x07e0,0x12);
XC7022_write_cmos_sensor(0x07e1,0x11);
XC7022_write_cmos_sensor(0x07e2,0x14);
XC7022_write_cmos_sensor(0x07e3,0x1f);
XC7022_write_cmos_sensor(0x07e4,0x2e);
XC7022_write_cmos_sensor(0x07e5,0x13);
XC7022_write_cmos_sensor(0x07e6,0x1a);
XC7022_write_cmos_sensor(0x07e7,0x1b);
XC7022_write_cmos_sensor(0x07e8,0x1c);
XC7022_write_cmos_sensor(0x07e9,0x1c);
XC7022_write_cmos_sensor(0x07ea,0x1a);
XC7022_write_cmos_sensor(0x07eb,0x18);
XC7022_write_cmos_sensor(0x07ec,0x17);
XC7022_write_cmos_sensor(0x07ed,0x1c);
XC7022_write_cmos_sensor(0x07ee,0x1e);
XC7022_write_cmos_sensor(0x07ef,0x1f);
XC7022_write_cmos_sensor(0x07f0,0x1f);
XC7022_write_cmos_sensor(0x07f1,0x1f);
XC7022_write_cmos_sensor(0x07f2,0x1f);
XC7022_write_cmos_sensor(0x07f3,0x1f);
XC7022_write_cmos_sensor(0x07f4,0x1d);
XC7022_write_cmos_sensor(0x07f5,0x1d);
XC7022_write_cmos_sensor(0x07f6,0x1f);
XC7022_write_cmos_sensor(0x07f7,0x1f);
XC7022_write_cmos_sensor(0x07f8,0x20);
XC7022_write_cmos_sensor(0x07f9,0x20);
XC7022_write_cmos_sensor(0x07fa,0x20);
XC7022_write_cmos_sensor(0x07fb,0x1f);
XC7022_write_cmos_sensor(0x07fc,0x1f);
XC7022_write_cmos_sensor(0x07fd,0x1e);
XC7022_write_cmos_sensor(0x07fe,0x20);
XC7022_write_cmos_sensor(0x07ff,0x20);
XC7022_write_cmos_sensor(0x0800,0x21);
XC7022_write_cmos_sensor(0x0801,0x20);
XC7022_write_cmos_sensor(0x0802,0x21);
XC7022_write_cmos_sensor(0x0803,0x20);
XC7022_write_cmos_sensor(0x0804,0x20);
XC7022_write_cmos_sensor(0x0805,0x1e);
XC7022_write_cmos_sensor(0x0806,0x20);
XC7022_write_cmos_sensor(0x0807,0x20);
XC7022_write_cmos_sensor(0x0808,0x21);
XC7022_write_cmos_sensor(0x0809,0x21);
XC7022_write_cmos_sensor(0x080a,0x21);
XC7022_write_cmos_sensor(0x080b,0x20);
XC7022_write_cmos_sensor(0x080c,0x20);
XC7022_write_cmos_sensor(0x080d,0x1d);
XC7022_write_cmos_sensor(0x080e,0x1f);
XC7022_write_cmos_sensor(0x080f,0x20);
XC7022_write_cmos_sensor(0x0810,0x20);
XC7022_write_cmos_sensor(0x0811,0x20);
XC7022_write_cmos_sensor(0x0812,0x20);
XC7022_write_cmos_sensor(0x0813,0x20);
XC7022_write_cmos_sensor(0x0814,0x1f);
XC7022_write_cmos_sensor(0x0815,0x1c);
XC7022_write_cmos_sensor(0x0816,0x1e);
XC7022_write_cmos_sensor(0x0817,0x1f);
XC7022_write_cmos_sensor(0x0818,0x1f);
XC7022_write_cmos_sensor(0x0819,0x1f);
XC7022_write_cmos_sensor(0x081a,0x1f);
XC7022_write_cmos_sensor(0x081b,0x1f);
XC7022_write_cmos_sensor(0x081c,0x1d);
XC7022_write_cmos_sensor(0x081d,0x11);
XC7022_write_cmos_sensor(0x081e,0x18);
XC7022_write_cmos_sensor(0x081f,0x1a);
XC7022_write_cmos_sensor(0x0820,0x1b);
XC7022_write_cmos_sensor(0x0821,0x1b);
XC7022_write_cmos_sensor(0x0822,0x1b);
XC7022_write_cmos_sensor(0x0823,0x18);
XC7022_write_cmos_sensor(0x0824,0x19);
XC7022_write_cmos_sensor(0x0825,0x1a);
XC7022_write_cmos_sensor(0x0826,0x1e);
XC7022_write_cmos_sensor(0x0827,0x1f);
XC7022_write_cmos_sensor(0x0828,0x20);
XC7022_write_cmos_sensor(0x0829,0x20);
XC7022_write_cmos_sensor(0x082a,0x20);
XC7022_write_cmos_sensor(0x082b,0x1f);
XC7022_write_cmos_sensor(0x082c,0x1e);
XC7022_write_cmos_sensor(0x082d,0x22);
XC7022_write_cmos_sensor(0x082e,0x21);
XC7022_write_cmos_sensor(0x082f,0x21);
XC7022_write_cmos_sensor(0x0830,0x21);
XC7022_write_cmos_sensor(0x0831,0x21);
XC7022_write_cmos_sensor(0x0832,0x21);
XC7022_write_cmos_sensor(0x0833,0x21);
XC7022_write_cmos_sensor(0x0834,0x21);
XC7022_write_cmos_sensor(0x0835,0x22);
XC7022_write_cmos_sensor(0x0836,0x21);
XC7022_write_cmos_sensor(0x0837,0x21);
XC7022_write_cmos_sensor(0x0838,0x21);
XC7022_write_cmos_sensor(0x0839,0x21);
XC7022_write_cmos_sensor(0x083a,0x21);
XC7022_write_cmos_sensor(0x083b,0x21);
XC7022_write_cmos_sensor(0x083c,0x21);
XC7022_write_cmos_sensor(0x083d,0x22);
XC7022_write_cmos_sensor(0x083e,0x20);
XC7022_write_cmos_sensor(0x083f,0x20);
XC7022_write_cmos_sensor(0x0840,0x20);
XC7022_write_cmos_sensor(0x0841,0x20);
XC7022_write_cmos_sensor(0x0842,0x20);
XC7022_write_cmos_sensor(0x0843,0x20);
XC7022_write_cmos_sensor(0x0844,0x21);
XC7022_write_cmos_sensor(0x0845,0x22);
XC7022_write_cmos_sensor(0x0846,0x20);
XC7022_write_cmos_sensor(0x0847,0x20);
XC7022_write_cmos_sensor(0x0848,0x20);
XC7022_write_cmos_sensor(0x0849,0x20);
XC7022_write_cmos_sensor(0x084a,0x20);
XC7022_write_cmos_sensor(0x084b,0x20);
XC7022_write_cmos_sensor(0x084c,0x21);
XC7022_write_cmos_sensor(0x084d,0x22);
XC7022_write_cmos_sensor(0x084e,0x20);
XC7022_write_cmos_sensor(0x084f,0x20);
XC7022_write_cmos_sensor(0x0850,0x20);
XC7022_write_cmos_sensor(0x0851,0x21);
XC7022_write_cmos_sensor(0x0852,0x20);
XC7022_write_cmos_sensor(0x0853,0x21);
XC7022_write_cmos_sensor(0x0854,0x20);
XC7022_write_cmos_sensor(0x0855,0x21);
XC7022_write_cmos_sensor(0x0856,0x20);
XC7022_write_cmos_sensor(0x0857,0x21);
XC7022_write_cmos_sensor(0x0858,0x21);
XC7022_write_cmos_sensor(0x0859,0x21);
XC7022_write_cmos_sensor(0x085a,0x21);
XC7022_write_cmos_sensor(0x085b,0x21);
XC7022_write_cmos_sensor(0x085c,0x22);
XC7022_write_cmos_sensor(0x085d,0x1c);
XC7022_write_cmos_sensor(0x085e,0x1e);
XC7022_write_cmos_sensor(0x085f,0x20);
XC7022_write_cmos_sensor(0x0860,0x20);
XC7022_write_cmos_sensor(0x0861,0x21);
XC7022_write_cmos_sensor(0x0862,0x20);
XC7022_write_cmos_sensor(0x0863,0x20);
XC7022_write_cmos_sensor(0x0864,0x1a);

XC7022_write_cmos_sensor(0x0865,0x3c);//d_95);20161101_v2
XC7022_write_cmos_sensor(0x0866,0x1e);
XC7022_write_cmos_sensor(0x0867,0x15);
XC7022_write_cmos_sensor(0x0868,0x10);
XC7022_write_cmos_sensor(0x0869,0x10);
XC7022_write_cmos_sensor(0x086a,0x13);
XC7022_write_cmos_sensor(0x086b,0x1b);
XC7022_write_cmos_sensor(0x086c,0x32);
XC7022_write_cmos_sensor(0x086d,0x08);
XC7022_write_cmos_sensor(0x086e,0x05);
XC7022_write_cmos_sensor(0x086f,0x03);
XC7022_write_cmos_sensor(0x0870,0x03);
XC7022_write_cmos_sensor(0x0871,0x03);
XC7022_write_cmos_sensor(0x0872,0x03);
XC7022_write_cmos_sensor(0x0873,0x05);
XC7022_write_cmos_sensor(0x0874,0x09);
XC7022_write_cmos_sensor(0x0875,0x03);
XC7022_write_cmos_sensor(0x0876,0x01);
XC7022_write_cmos_sensor(0x0877,0x00);
XC7022_write_cmos_sensor(0x0878,0x01);
XC7022_write_cmos_sensor(0x0879,0x01);
XC7022_write_cmos_sensor(0x087a,0x01);
XC7022_write_cmos_sensor(0x087b,0x02);
XC7022_write_cmos_sensor(0x087c,0x03);
XC7022_write_cmos_sensor(0x087d,0x01);
XC7022_write_cmos_sensor(0x087e,0x00);
XC7022_write_cmos_sensor(0x087f,0x00);
XC7022_write_cmos_sensor(0x0880,0x00);
XC7022_write_cmos_sensor(0x0881,0x00);
XC7022_write_cmos_sensor(0x0882,0x01);
XC7022_write_cmos_sensor(0x0883,0x01);
XC7022_write_cmos_sensor(0x0884,0x01);
XC7022_write_cmos_sensor(0x0885,0x01);
XC7022_write_cmos_sensor(0x0886,0x00);
XC7022_write_cmos_sensor(0x0887,0x00);
XC7022_write_cmos_sensor(0x0888,0x00);
XC7022_write_cmos_sensor(0x0889,0x00);
XC7022_write_cmos_sensor(0x088a,0x01);
XC7022_write_cmos_sensor(0x088b,0x01);
XC7022_write_cmos_sensor(0x088c,0x02);
XC7022_write_cmos_sensor(0x088d,0x03);
XC7022_write_cmos_sensor(0x088e,0x01);
XC7022_write_cmos_sensor(0x088f,0x01);
XC7022_write_cmos_sensor(0x0890,0x01);
XC7022_write_cmos_sensor(0x0891,0x01);
XC7022_write_cmos_sensor(0x0892,0x01);
XC7022_write_cmos_sensor(0x0893,0x02);
XC7022_write_cmos_sensor(0x0894,0x03);
XC7022_write_cmos_sensor(0x0895,0x09);
XC7022_write_cmos_sensor(0x0896,0x05);
XC7022_write_cmos_sensor(0x0897,0x03);
XC7022_write_cmos_sensor(0x0898,0x03);
XC7022_write_cmos_sensor(0x0899,0x03);
XC7022_write_cmos_sensor(0x089a,0x04);
XC7022_write_cmos_sensor(0x089b,0x05);
XC7022_write_cmos_sensor(0x089c,0x0a);
XC7022_write_cmos_sensor(0x089d,0x3f);
XC7022_write_cmos_sensor(0x089e,0x20);
XC7022_write_cmos_sensor(0x089f,0x16);
XC7022_write_cmos_sensor(0x08a0,0x12);
XC7022_write_cmos_sensor(0x08a1,0x11);
XC7022_write_cmos_sensor(0x08a2,0x14);
XC7022_write_cmos_sensor(0x08a3,0x1f);
XC7022_write_cmos_sensor(0x08a4,0x2e);
XC7022_write_cmos_sensor(0x08a5,0x18);
XC7022_write_cmos_sensor(0x08a6,0x1c);
XC7022_write_cmos_sensor(0x08a7,0x1d);
XC7022_write_cmos_sensor(0x08a8,0x1d);
XC7022_write_cmos_sensor(0x08a9,0x1d);
XC7022_write_cmos_sensor(0x08aa,0x1c);
XC7022_write_cmos_sensor(0x08ab,0x1b);
XC7022_write_cmos_sensor(0x08ac,0x1b);
XC7022_write_cmos_sensor(0x08ad,0x1d);
XC7022_write_cmos_sensor(0x08ae,0x1e);
XC7022_write_cmos_sensor(0x08af,0x1f);
XC7022_write_cmos_sensor(0x08b0,0x1f);
XC7022_write_cmos_sensor(0x08b1,0x1f);
XC7022_write_cmos_sensor(0x08b2,0x1f);
XC7022_write_cmos_sensor(0x08b3,0x1f);
XC7022_write_cmos_sensor(0x08b4,0x1e);
XC7022_write_cmos_sensor(0x08b5,0x1e);
XC7022_write_cmos_sensor(0x08b6,0x1f);
XC7022_write_cmos_sensor(0x08b7,0x1f);
XC7022_write_cmos_sensor(0x08b8,0x20);
XC7022_write_cmos_sensor(0x08b9,0x20);
XC7022_write_cmos_sensor(0x08ba,0x20);
XC7022_write_cmos_sensor(0x08bb,0x1f);
XC7022_write_cmos_sensor(0x08bc,0x1f);
XC7022_write_cmos_sensor(0x08bd,0x1e);
XC7022_write_cmos_sensor(0x08be,0x20);
XC7022_write_cmos_sensor(0x08bf,0x20);
XC7022_write_cmos_sensor(0x08c0,0x20);
XC7022_write_cmos_sensor(0x08c1,0x20);
XC7022_write_cmos_sensor(0x08c2,0x20);
XC7022_write_cmos_sensor(0x08c3,0x20);
XC7022_write_cmos_sensor(0x08c4,0x1f);
XC7022_write_cmos_sensor(0x08c5,0x1f);
XC7022_write_cmos_sensor(0x08c6,0x1f);
XC7022_write_cmos_sensor(0x08c7,0x20);
XC7022_write_cmos_sensor(0x08c8,0x20);
XC7022_write_cmos_sensor(0x08c9,0x20);
XC7022_write_cmos_sensor(0x08ca,0x20);
XC7022_write_cmos_sensor(0x08cb,0x20);
XC7022_write_cmos_sensor(0x08cc,0x20);
XC7022_write_cmos_sensor(0x08cd,0x1e);
XC7022_write_cmos_sensor(0x08ce,0x1f);
XC7022_write_cmos_sensor(0x08cf,0x1f);
XC7022_write_cmos_sensor(0x08d0,0x20);
XC7022_write_cmos_sensor(0x08d1,0x20);
XC7022_write_cmos_sensor(0x08d2,0x1f);
XC7022_write_cmos_sensor(0x08d3,0x1f);
XC7022_write_cmos_sensor(0x08d4,0x1e);
XC7022_write_cmos_sensor(0x08d5,0x1c);
XC7022_write_cmos_sensor(0x08d6,0x1e);
XC7022_write_cmos_sensor(0x08d7,0x1e);
XC7022_write_cmos_sensor(0x08d8,0x1f);
XC7022_write_cmos_sensor(0x08d9,0x1f);
XC7022_write_cmos_sensor(0x08da,0x1f);
XC7022_write_cmos_sensor(0x08db,0x1e);
XC7022_write_cmos_sensor(0x08dc,0x1e);
XC7022_write_cmos_sensor(0x08dd,0x17);
XC7022_write_cmos_sensor(0x08de,0x1b);
XC7022_write_cmos_sensor(0x08df,0x1c);
XC7022_write_cmos_sensor(0x08e0,0x1c);
XC7022_write_cmos_sensor(0x08e1,0x1c);
XC7022_write_cmos_sensor(0x08e2,0x1c);
XC7022_write_cmos_sensor(0x08e3,0x1b);
XC7022_write_cmos_sensor(0x08e4,0x1d);
XC7022_write_cmos_sensor(0x08e5,0x19);
XC7022_write_cmos_sensor(0x08e6,0x1f);
XC7022_write_cmos_sensor(0x08e7,0x1f);
XC7022_write_cmos_sensor(0x08e8,0x21);
XC7022_write_cmos_sensor(0x08e9,0x21);
XC7022_write_cmos_sensor(0x08ea,0x21);
XC7022_write_cmos_sensor(0x08eb,0x1f);
XC7022_write_cmos_sensor(0x08ec,0x1e);
XC7022_write_cmos_sensor(0x08ed,0x22);
XC7022_write_cmos_sensor(0x08ee,0x21);
XC7022_write_cmos_sensor(0x08ef,0x22);
XC7022_write_cmos_sensor(0x08f0,0x22);
XC7022_write_cmos_sensor(0x08f1,0x22);
XC7022_write_cmos_sensor(0x08f2,0x22);
XC7022_write_cmos_sensor(0x08f3,0x22);
XC7022_write_cmos_sensor(0x08f4,0x21);
XC7022_write_cmos_sensor(0x08f5,0x23);
XC7022_write_cmos_sensor(0x08f6,0x21);
XC7022_write_cmos_sensor(0x08f7,0x21);
XC7022_write_cmos_sensor(0x08f8,0x21);
XC7022_write_cmos_sensor(0x08f9,0x21);
XC7022_write_cmos_sensor(0x08fa,0x21);
XC7022_write_cmos_sensor(0x08fb,0x21);
XC7022_write_cmos_sensor(0x08fc,0x22);
XC7022_write_cmos_sensor(0x08fd,0x23);
XC7022_write_cmos_sensor(0x08fe,0x20);
XC7022_write_cmos_sensor(0x08ff,0x21);
XC7022_write_cmos_sensor(0x0900,0x20);
XC7022_write_cmos_sensor(0x0901,0x20);
XC7022_write_cmos_sensor(0x0902,0x20);
XC7022_write_cmos_sensor(0x0903,0x21);
XC7022_write_cmos_sensor(0x0904,0x21);
XC7022_write_cmos_sensor(0x0905,0x22);
XC7022_write_cmos_sensor(0x0906,0x20);
XC7022_write_cmos_sensor(0x0907,0x20);
XC7022_write_cmos_sensor(0x0908,0x20);
XC7022_write_cmos_sensor(0x0909,0x20);
XC7022_write_cmos_sensor(0x090a,0x20);
XC7022_write_cmos_sensor(0x090b,0x20);
XC7022_write_cmos_sensor(0x090c,0x21);
XC7022_write_cmos_sensor(0x090d,0x23);
XC7022_write_cmos_sensor(0x090e,0x21);
XC7022_write_cmos_sensor(0x090f,0x21);
XC7022_write_cmos_sensor(0x0910,0x21);
XC7022_write_cmos_sensor(0x0911,0x21);
XC7022_write_cmos_sensor(0x0912,0x21);
XC7022_write_cmos_sensor(0x0913,0x21);
XC7022_write_cmos_sensor(0x0914,0x20);
XC7022_write_cmos_sensor(0x0915,0x22);
XC7022_write_cmos_sensor(0x0916,0x21);
XC7022_write_cmos_sensor(0x0917,0x21);
XC7022_write_cmos_sensor(0x0918,0x21);
XC7022_write_cmos_sensor(0x0919,0x21);
XC7022_write_cmos_sensor(0x091a,0x21);
XC7022_write_cmos_sensor(0x091b,0x21);
XC7022_write_cmos_sensor(0x091c,0x22);
XC7022_write_cmos_sensor(0x091d,0x1b);
XC7022_write_cmos_sensor(0x091e,0x1e);
XC7022_write_cmos_sensor(0x091f,0x20);
XC7022_write_cmos_sensor(0x0920,0x21);
XC7022_write_cmos_sensor(0x0921,0x22);
XC7022_write_cmos_sensor(0x0922,0x20);
XC7022_write_cmos_sensor(0x0923,0x20);
XC7022_write_cmos_sensor(0x0924,0x1b);


XC7022_write_cmos_sensor(0xfffe,0x14);//0805
XC7022_write_cmos_sensor(0x0248,0x02);//0.AWB_ARITH_ORIGIN211.AWB_ARITH_SW_PRO2.AWB_ARITH_M
XC7022_write_cmos_sensor(0x0282,0x06);//intBgain
XC7022_write_cmos_sensor(0x0283,0x00);
XC7022_write_cmos_sensor(0x0286,0x04);//intGbgain
XC7022_write_cmos_sensor(0x0287,0x00);
XC7022_write_cmos_sensor(0x028a,0x04);//intGrgain
XC7022_write_cmos_sensor(0x028b,0x00);
XC7022_write_cmos_sensor(0x028e,0x04);//intRgain
XC7022_write_cmos_sensor(0x028f,0x04);
XC7022_write_cmos_sensor(0x02b6,0x06);//B_temp
XC7022_write_cmos_sensor(0x02b7,0x00);
XC7022_write_cmos_sensor(0x02ba,0x04);//G_temp
XC7022_write_cmos_sensor(0x02bb,0x00);
XC7022_write_cmos_sensor(0x02be,0x04);//R_temp
XC7022_write_cmos_sensor(0x02bf,0x04);

XC7022_write_cmos_sensor(0xfffe,0x14);
XC7022_write_cmos_sensor(0x0248,0x01);//0.AWB_ARITH_ORIGIN211.AWB_ARITH_SW_PRO2.AWB_ARITH_MANUAL
XC7022_write_cmos_sensor(0x0249,0x01);//AWBFlexiMap_en
XC7022_write_cmos_sensor(0x024a,0x00);//AWBMove_en
XC7022_write_cmos_sensor(0x027a,0x01);//nCTBasedMinNum//20
XC7022_write_cmos_sensor(0x027b,0x00);
XC7022_write_cmos_sensor(0x027c,0x0f);
XC7022_write_cmos_sensor(0x027d,0xff);//nMaxAWBGain

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x0708,0x02);//pixelmaxvalue[9:8]//03
XC7022_write_cmos_sensor(0x0709,0xa0);//pixelmaxvalue[7:0]//f0
XC7022_write_cmos_sensor(0x070a,0x00);//pixelminvalue[9:8]
XC7022_write_cmos_sensor(0x070b,0x0c);//pixelminvalue[7:0]
XC7022_write_cmos_sensor(0x071c,0x0a);//simpleawb
XC7022_write_cmos_sensor(0x0003,0x31);

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x0730,0x80);  // win1 startx
XC7022_write_cmos_sensor(0x0731,0xab);  // win1 endx
XC7022_write_cmos_sensor(0x0732,0x48);  // win1 starty
XC7022_write_cmos_sensor(0x0733,0x60);  // win1 endy
XC7022_write_cmos_sensor(0x0734,0x74);  // win2 startx
XC7022_write_cmos_sensor(0x0735,0x9a);  // win2 endx
XC7022_write_cmos_sensor(0x0736,0x5f);  // win2 starty
XC7022_write_cmos_sensor(0x0737,0x76);  // win2 endy
XC7022_write_cmos_sensor(0x0738,0x4c);  // win3 startx
XC7022_write_cmos_sensor(0x0739,0x64);  // win3 endx
XC7022_write_cmos_sensor(0x073a,0x5f);  // win3 starty
XC7022_write_cmos_sensor(0x073b,0x7a);  // win3 endy
XC7022_write_cmos_sensor(0x073c,0x60);  // win4 startx
XC7022_write_cmos_sensor(0x073d,0x8d);  // win4 endx
XC7022_write_cmos_sensor(0x073e,0x48);  // win4 starty
XC7022_write_cmos_sensor(0x073f,0x63);  // win4 endy
XC7022_write_cmos_sensor(0x0740,0x60);  // win5 startx
XC7022_write_cmos_sensor(0x0741,0x75);  // win5 endx
XC7022_write_cmos_sensor(0x0742,0x62);  // win5 starty
XC7022_write_cmos_sensor(0x0743,0x8a);  // win5 endy
XC7022_write_cmos_sensor(0x0744,0x6f);  // win6 startx
XC7022_write_cmos_sensor(0x0745,0xd4);  // win6 endx
XC7022_write_cmos_sensor(0x0746,0x34);  // win6 starty
XC7022_write_cmos_sensor(0x0747,0x49);  // win6 endy
XC7022_write_cmos_sensor(0x0748,0x00);  // win7 startx
XC7022_write_cmos_sensor(0x0749,0x00);  // win7 endx
XC7022_write_cmos_sensor(0x074a,0x00);  // win7 starty
XC7022_write_cmos_sensor(0x074b,0x00);  // win7 endy
XC7022_write_cmos_sensor(0x074c,0x00);  // win8 startx
XC7022_write_cmos_sensor(0x074d,0x00);  // win8 endx
XC7022_write_cmos_sensor(0x074e,0x00);  // win8 starty
XC7022_write_cmos_sensor(0x074f,0x00);  // win8 endy
XC7022_write_cmos_sensor(0x0750,0x00);  // win9 startx
XC7022_write_cmos_sensor(0x0751,0x00);  // win9 endx
XC7022_write_cmos_sensor(0x0752,0x00);  // win9 starty
XC7022_write_cmos_sensor(0x0753,0x00);  // win9 endy
XC7022_write_cmos_sensor(0x0754,0x00);  // win10 startx
XC7022_write_cmos_sensor(0x0755,0x00);  // win10 endx
XC7022_write_cmos_sensor(0x0756,0x00);  // win10 starty
XC7022_write_cmos_sensor(0x0757,0x00);  // win10 endy
XC7022_write_cmos_sensor(0x0758,0x00);  // win11 startx
XC7022_write_cmos_sensor(0x0759,0x00);  // win11 endx
XC7022_write_cmos_sensor(0x075a,0x00);  // win11 starty
XC7022_write_cmos_sensor(0x075b,0x00);  // win11 endy
XC7022_write_cmos_sensor(0x075c,0x00);  // win12 startx
XC7022_write_cmos_sensor(0x075d,0x00);  // win12 endx
XC7022_write_cmos_sensor(0x075e,0x00);  // win12 starty
XC7022_write_cmos_sensor(0x075f,0x00);  // win12 endy
XC7022_write_cmos_sensor(0x0760,0x00);  // win13 startx
XC7022_write_cmos_sensor(0x0761,0x00);  // win13 endx
XC7022_write_cmos_sensor(0x0762,0x00);  // win13 starty
XC7022_write_cmos_sensor(0x0763,0x00);  // win13 endy
XC7022_write_cmos_sensor(0x0764,0x00);  // win14 startx
XC7022_write_cmos_sensor(0x0765,0x00);  // win14 endx
XC7022_write_cmos_sensor(0x0766,0x00);  // win14 starty
XC7022_write_cmos_sensor(0x0767,0x00);  // win14 endy
XC7022_write_cmos_sensor(0x0768,0x00);  // win15 startx
XC7022_write_cmos_sensor(0x0769,0x00);  // win15 endx
XC7022_write_cmos_sensor(0x076a,0x00);  // win15 starty
XC7022_write_cmos_sensor(0x076b,0x00);  // win15 endy
XC7022_write_cmos_sensor(0x076c,0x00);  // win16 startx
XC7022_write_cmos_sensor(0x076d,0x00);  // win16 endx
XC7022_write_cmos_sensor(0x076e,0x00);  // win16 starty
XC7022_write_cmos_sensor(0x076f,0x00);  // win16 endy
XC7022_write_cmos_sensor(0x0770,0x22);  // wt1 wt2
XC7022_write_cmos_sensor(0x0771,0x21);  // wt3 wt4
XC7022_write_cmos_sensor(0x0772,0x11);  // wt5 wt6
XC7022_write_cmos_sensor(0x0773,0x00);  // wt7 wt8
XC7022_write_cmos_sensor(0x0774,0x00);  // wt9 wt10
XC7022_write_cmos_sensor(0x0775,0x00);  // wt11 wt12
XC7022_write_cmos_sensor(0x0776,0x00);  // wt13 wt14
XC7022_write_cmos_sensor(0x0777,0x00);  // wt15 wt16

XC7022_write_cmos_sensor(0xfffd,0x80);
XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x1400,0x00);
XC7022_write_cmos_sensor(0x1401,0x05);
XC7022_write_cmos_sensor(0x1402,0x09);
XC7022_write_cmos_sensor(0x1403,0x0e);
XC7022_write_cmos_sensor(0x1404,0x12);
XC7022_write_cmos_sensor(0x1405,0x17);
XC7022_write_cmos_sensor(0x1406,0x1b);
XC7022_write_cmos_sensor(0x1407,0x1f);
XC7022_write_cmos_sensor(0x1408,0x24);
XC7022_write_cmos_sensor(0x1409,0x28);
XC7022_write_cmos_sensor(0x140a,0x2c);
XC7022_write_cmos_sensor(0x140b,0x31);
XC7022_write_cmos_sensor(0x140c,0x35);
XC7022_write_cmos_sensor(0x140d,0x39);
XC7022_write_cmos_sensor(0x140e,0x3d);
XC7022_write_cmos_sensor(0x140f,0x41);
XC7022_write_cmos_sensor(0x1410,0x45);
XC7022_write_cmos_sensor(0x1411,0x49);
XC7022_write_cmos_sensor(0x1412,0x4d);
XC7022_write_cmos_sensor(0x1413,0x50);
XC7022_write_cmos_sensor(0x1414,0x54);
XC7022_write_cmos_sensor(0x1415,0x57);
XC7022_write_cmos_sensor(0x1416,0x5b);
XC7022_write_cmos_sensor(0x1417,0x5e);
XC7022_write_cmos_sensor(0x1418,0x61);
XC7022_write_cmos_sensor(0x1419,0x64);
XC7022_write_cmos_sensor(0x141a,0x67);
XC7022_write_cmos_sensor(0x141b,0x6a);
XC7022_write_cmos_sensor(0x141c,0x6d);
XC7022_write_cmos_sensor(0x141d,0x6f);
XC7022_write_cmos_sensor(0x141e,0x72);
XC7022_write_cmos_sensor(0x141f,0x75);
XC7022_write_cmos_sensor(0x1420,0x77);
XC7022_write_cmos_sensor(0x1421,0x7c);
XC7022_write_cmos_sensor(0x1422,0x80);
XC7022_write_cmos_sensor(0x1423,0x84);
XC7022_write_cmos_sensor(0x1424,0x88);
XC7022_write_cmos_sensor(0x1425,0x8c);
XC7022_write_cmos_sensor(0x1426,0x90);
XC7022_write_cmos_sensor(0x1427,0x93);
XC7022_write_cmos_sensor(0x1428,0x96);
XC7022_write_cmos_sensor(0x1429,0x99);
XC7022_write_cmos_sensor(0x142a,0x9c);
XC7022_write_cmos_sensor(0x142b,0x9f);
XC7022_write_cmos_sensor(0x142c,0xa1);
XC7022_write_cmos_sensor(0x142d,0xa4);
XC7022_write_cmos_sensor(0x142e,0xa6);
XC7022_write_cmos_sensor(0x142f,0xa8);
XC7022_write_cmos_sensor(0x1430,0xab);
XC7022_write_cmos_sensor(0x1431,0xaf);
XC7022_write_cmos_sensor(0x1432,0xb3);
XC7022_write_cmos_sensor(0x1433,0xb7);
XC7022_write_cmos_sensor(0x1434,0xbb);
XC7022_write_cmos_sensor(0x1435,0xc0);
XC7022_write_cmos_sensor(0x1436,0xc4);
XC7022_write_cmos_sensor(0x1437,0xc9);
XC7022_write_cmos_sensor(0x1438,0xce);
XC7022_write_cmos_sensor(0x1439,0xd4);
XC7022_write_cmos_sensor(0x143a,0xda);
XC7022_write_cmos_sensor(0x143b,0xe0);
XC7022_write_cmos_sensor(0x143c,0xe6);
XC7022_write_cmos_sensor(0x143d,0xec);
XC7022_write_cmos_sensor(0x143e,0xf3);
XC7022_write_cmos_sensor(0x143f,0xf9);
XC7022_write_cmos_sensor(0x1440,0xff);

XC7022_write_cmos_sensor(0xfffe,0x30);
//XC7022_write_cmos_sensor(0x0001,0x02);   //bit[1]:cmx_en
XC7022_write_cmos_sensor(0x1200,0x05);	//d_2130_1208_v2      //changed                
XC7022_write_cmos_sensor(0x1201,0xF4);	                                               
XC7022_write_cmos_sensor(0x1202,0x00);	                                               
XC7022_write_cmos_sensor(0x1203,0xC2);	                                               
XC7022_write_cmos_sensor(0x1204,0x00);	                                               
XC7022_write_cmos_sensor(0x1205,0x8F);	                                               
XC7022_write_cmos_sensor(0x1206,0x00);	                                               
XC7022_write_cmos_sensor(0x1207,0x65);	                                               
XC7022_write_cmos_sensor(0x1208,0x00);                                                 
XC7022_write_cmos_sensor(0x1209,0x27);	                                               
XC7022_write_cmos_sensor(0x120A,0x03);                                                 
XC7022_write_cmos_sensor(0x120B,0x2A);
XC7022_write_cmos_sensor(0x122e,0x12);
XC7022_write_cmos_sensor(0x1228,0x00); 
XC7022_write_cmos_sensor(0x1229,0x71);
	          
XC7022_write_cmos_sensor(0x120C,0x07);	//a_2130_1209_v2                               
XC7022_write_cmos_sensor(0x120D,0x0B);	                                                 
XC7022_write_cmos_sensor(0x120E,0x00);                                               
XC7022_write_cmos_sensor(0x120F,0x4F);	                                               
XC7022_write_cmos_sensor(0x1210,0x00);	                                               
XC7022_write_cmos_sensor(0x1211,0x22);	                                               
XC7022_write_cmos_sensor(0x1212,0x01);                                               
XC7022_write_cmos_sensor(0x1213,0x5D);	                                               
XC7022_write_cmos_sensor(0x1214,0x00);	                                               
XC7022_write_cmos_sensor(0x1215,0x6F); 	                                               
XC7022_write_cmos_sensor(0x1216,0x01);//grass	                                               
XC7022_write_cmos_sensor(0x1217,0xFA);	 
XC7022_write_cmos_sensor(0x122F,0x1A);
XC7022_write_cmos_sensor(0x122A,0x00);
XC7022_write_cmos_sensor(0x122B,0xC8);
            
XC7022_write_cmos_sensor(0x1218,0x04);//c_2130_1209_v3                              
XC7022_write_cmos_sensor(0x1219,0xFE);                                                 
XC7022_write_cmos_sensor(0x121A,0x00);                                                 
XC7022_write_cmos_sensor(0x121B,0xA2);                                                 
XC7022_write_cmos_sensor(0x121C,0x00);                                                 
XC7022_write_cmos_sensor(0x121D,0xA9);                                                 
XC7022_write_cmos_sensor(0x121E,0x01);                                                 
XC7022_write_cmos_sensor(0x121F,0x51);	                                               
XC7022_write_cmos_sensor(0x1220,0x00);                                                 
XC7022_write_cmos_sensor(0x1221,0x56);	                                               
XC7022_write_cmos_sensor(0x1222,0x05);                                                 
XC7022_write_cmos_sensor(0x1223,0x25);
XC7022_write_cmos_sensor(0x1230,0x1A);
XC7022_write_cmos_sensor(0x122C,0x01);
XC7022_write_cmos_sensor(0x122D,0x2A);
            
XC7022_write_cmos_sensor(0x1231,0x02);
XC7022_write_cmos_sensor(0x1232,0x50);
                          	
	
//dns&cip
//advance_raw_dns
//advance_raw_dns
XC7022_write_cmos_sensor(0xfffe,0x30);
//XC7022_write_cmos_sensor(0x0002,0x02);   //bit[1]advance_raw_dns_en

XC7022_write_cmos_sensor(0x2000,0x1a);  //s0_sigma_0
XC7022_write_cmos_sensor(0x2001,0x1c);
XC7022_write_cmos_sensor(0x2002,0x20);
XC7022_write_cmos_sensor(0x2003,0x24);
XC7022_write_cmos_sensor(0x2004,0x28);
XC7022_write_cmos_sensor(0x2005,0x28);  //s0_sigma_5
                                    
XC7022_write_cmos_sensor(0x2006,0x14);  //s0_Gsl_0
XC7022_write_cmos_sensor(0x2007,0x12);
XC7022_write_cmos_sensor(0x2008,0x10);
XC7022_write_cmos_sensor(0x2009,0x0c);
XC7022_write_cmos_sensor(0x200a,0x0a);
XC7022_write_cmos_sensor(0x200b,0x08);  //s0_Gsl_5
                                    
XC7022_write_cmos_sensor(0x200c,0x14);  //s0_RBsl_0
XC7022_write_cmos_sensor(0x200d,0x12);
XC7022_write_cmos_sensor(0x200e,0x10);
XC7022_write_cmos_sensor(0x200f,0x0c);
XC7022_write_cmos_sensor(0x2010,0x0a);
XC7022_write_cmos_sensor(0x2011,0x08);   //s0_RBsl_5
                                    
XC7022_write_cmos_sensor(0x2012,0x10);   //s0_ps00
XC7022_write_cmos_sensor(0x2013,0x10);
XC7022_write_cmos_sensor(0x2014,0x10);
XC7022_write_cmos_sensor(0x2015,0x10);
XC7022_write_cmos_sensor(0x2016,0x10);
XC7022_write_cmos_sensor(0x2017,0x10);   //s0_ps05
                                    
XC7022_write_cmos_sensor(0x2018,0x0c);   //s0_ps10
XC7022_write_cmos_sensor(0x2019,0x0c);
XC7022_write_cmos_sensor(0x201a,0x0c);
XC7022_write_cmos_sensor(0x201b,0x0c);
XC7022_write_cmos_sensor(0x201c,0x0c);
XC7022_write_cmos_sensor(0x201d,0x0c);  //s0_ps15
                                    
XC7022_write_cmos_sensor(0x201e,0x08);  //s0_ps20
XC7022_write_cmos_sensor(0x201f,0x08);
XC7022_write_cmos_sensor(0x2020,0x08);
XC7022_write_cmos_sensor(0x2021,0x08);
XC7022_write_cmos_sensor(0x2022,0x08);
XC7022_write_cmos_sensor(0x2023,0x08);   //s0_ps25
                                    
XC7022_write_cmos_sensor(0x2024,0x04);//s0_ps30
XC7022_write_cmos_sensor(0x2025,0x04);
XC7022_write_cmos_sensor(0x2026,0x04);
XC7022_write_cmos_sensor(0x2027,0x04);
XC7022_write_cmos_sensor(0x2028,0x04);
XC7022_write_cmos_sensor(0x2029,0x04);//s0_ps35
                                    
XC7022_write_cmos_sensor(0x202a,0x20);//s0_pl00//h2_scale小
XC7022_write_cmos_sensor(0x202b,0x20);
XC7022_write_cmos_sensor(0x202c,0x20);
XC7022_write_cmos_sensor(0x202d,0x20);
XC7022_write_cmos_sensor(0x202e,0x20);
XC7022_write_cmos_sensor(0x202f,0x20);//s0_pl05

XC7022_write_cmos_sensor(0x2030,0x20);//s0_pl10
XC7022_write_cmos_sensor(0x2031,0x20);
XC7022_write_cmos_sensor(0x2032,0x20);
XC7022_write_cmos_sensor(0x2033,0x20);
XC7022_write_cmos_sensor(0x2034,0x20);
XC7022_write_cmos_sensor(0x2035,0x20);//s0_pl15

XC7022_write_cmos_sensor(0x2036,0x20);//s0_pl20
XC7022_write_cmos_sensor(0x2037,0x20);
XC7022_write_cmos_sensor(0x2038,0x20);
XC7022_write_cmos_sensor(0x2039,0x20);
XC7022_write_cmos_sensor(0x203a,0x20);
XC7022_write_cmos_sensor(0x203b,0x20);//s0_pl25

XC7022_write_cmos_sensor(0x203c,0x20);//s0_pl30
XC7022_write_cmos_sensor(0x203d,0x20);
XC7022_write_cmos_sensor(0x203e,0x20);
XC7022_write_cmos_sensor(0x203f,0x20);
XC7022_write_cmos_sensor(0x2040,0x20);
XC7022_write_cmos_sensor(0x2041,0x20);//s0_pl35

XC7022_write_cmos_sensor(0x2044,0x10);//bit[4:0]thre_y




//UVDNS
XC7022_write_cmos_sensor(0xfffe,0x30);
//XC7022_write_cmos_sensor(0x0002,0x04);   //bit[2]uv_dns_en
XC7022_write_cmos_sensor(0x2100,0x02);   //l_noise_list0
XC7022_write_cmos_sensor(0x2101,0x04);
XC7022_write_cmos_sensor(0x2102,0x08);
XC7022_write_cmos_sensor(0x2103,0x0c);
XC7022_write_cmos_sensor(0x2104,0x10);
XC7022_write_cmos_sensor(0x2105,0x14);   //l_noise_list5
XC7022_write_cmos_sensor(0x2106,0x5f);   //bit[7]l_noise_man_en; bit[6]l_sdw_ext_en; bit[4:0]l_sdw_ext_ns
XC7022_write_cmos_sensor(0x2107,0x08);   //l_noise_man

//CIP						//cip1015
XC7022_write_cmos_sensor(0xfffe,0x30);
//XC7022_write_cmos_sensor(0x0000,0x01);   //bit[0] cip_en
XC7022_write_cmos_sensor(0x0f00,0x0f);   //bit[7:4] noise_y_slp  bit[3:0] Lsharp
XC7022_write_cmos_sensor(0x0f02,0x00);  //noise_list_0
XC7022_write_cmos_sensor(0x0f03,0x00);
XC7022_write_cmos_sensor(0x0f04,0x00);
XC7022_write_cmos_sensor(0x0f05,0x00);
XC7022_write_cmos_sensor(0x0f06,0x00);
XC7022_write_cmos_sensor(0x0f07,0x00);
XC7022_write_cmos_sensor(0x0f08,0x00);
XC7022_write_cmos_sensor(0x0f09,0x00);  //noise_list_7
XC7022_write_cmos_sensor(0x0f0a,0x01);   //min_shp
XC7022_write_cmos_sensor(0x0f0b,0x12);   //max_shp
XC7022_write_cmos_sensor(0x0f0c,0x01);   //min_detail
XC7022_write_cmos_sensor(0x0f0d,0x02);   //max_detail
XC7022_write_cmos_sensor(0x0f0e,0x01);   //min_shp_gain
XC7022_write_cmos_sensor(0x0f0f,0x08);   //max_shp_gain


XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x2b04,0x09);//bit[3:0]
XC7022_write_cmos_sensor(0x2b16,0x06);//bit[3]pdf_avg_mode;bit[2]detail_enhance_en;bit[1]wdr_en;bit[0]:jdark_en

//ISP1Firmware
XC7022_write_cmos_sensor(0xfffe,0x14);
XC7022_write_cmos_sensor(0x002f,0x01);   
XC7022_write_cmos_sensor(0x09ab,0x02);   //Gmax
XC7022_write_cmos_sensor(0x09ac,0x0c);   //map_rang[0]
XC7022_write_cmos_sensor(0x09ad,0xE0);   //map_rang[1]
XC7022_write_cmos_sensor(0x09ae,0x41);   //nzPDF64_num_thd
XC7022_write_cmos_sensor(0x09af,0xff);   //grayhigh    //bug，必须写成XC7022_write_cmos_sensor(0xff
XC7022_write_cmos_sensor(0x09b2,0x3f);
XC7022_write_cmos_sensor(0x09b3,0xff);   //gain_thd[7:0]
XC7022_write_cmos_sensor(0x09b4,0x10);   //Extratio
XC7022_write_cmos_sensor(0x09b5,0x14);   //Extratio max
XC7022_write_cmos_sensor(0x09b6,0x00);  //weak_adj_on  XC7022_write_cmos_sensor(0x00:强均衡；XC7022_write_cmos_sensor(0x01:弱均衡

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x2b9a,0x00);//gain0
XC7022_write_cmos_sensor(0x2b9b,0x00);
XC7022_write_cmos_sensor(0x2b9c,0x10);//gain1
XC7022_write_cmos_sensor(0x2b9d,0x00);
XC7022_write_cmos_sensor(0x2b9e,0x20);//gain2
XC7022_write_cmos_sensor(0x2b9f,0x00);
XC7022_write_cmos_sensor(0x2ba0,0x40);//gain3
XC7022_write_cmos_sensor(0x2ba1,0x00);
XC7022_write_cmos_sensor(0x2ba2,0x80);//gain4
XC7022_write_cmos_sensor(0x2ba3,0x00);
XC7022_write_cmos_sensor(0x2ba4,0x00);  //gain5
XC7022_write_cmos_sensor(0x2ba5,0x01);  
XC7022_write_cmos_sensor(0x2ba6,0x00);  //gain6
XC7022_write_cmos_sensor(0x2ba7,0x02);  
XC7022_write_cmos_sensor(0x2ba8,0x00);   //gain7
XC7022_write_cmos_sensor(0x2ba9,0x04);  
XC7022_write_cmos_sensor(0x2bac,0x00);  //thd0
XC7022_write_cmos_sensor(0x2bad,0x01); 
XC7022_write_cmos_sensor(0x2bae,0x02); 
XC7022_write_cmos_sensor(0x2baf,0x03); 
XC7022_write_cmos_sensor(0x2bb0,0x04); 
XC7022_write_cmos_sensor(0x2bb1,0x04); 
XC7022_write_cmos_sensor(0x2bb2,0x04); 
XC7022_write_cmos_sensor(0x2bb3,0x04);  //thd7
XC7022_write_cmos_sensor(0x2bb4,0x70);   //thd0_max
XC7022_write_cmos_sensor(0x2bb5,0x70); 
XC7022_write_cmos_sensor(0x2bb6,0x70); 
XC7022_write_cmos_sensor(0x2bb7,0x70); 
XC7022_write_cmos_sensor(0x2bb8,0x70); 
XC7022_write_cmos_sensor(0x2bb9,0x70); 
XC7022_write_cmos_sensor(0x2bba,0x70); 
XC7022_write_cmos_sensor(0x2bbb,0x70);   //thd7_max
XC7022_write_cmos_sensor(0x2bbc,0x12);  //enhance_ratio0 
XC7022_write_cmos_sensor(0x2bbd,0x12);
XC7022_write_cmos_sensor(0x2bbe,0x10);
XC7022_write_cmos_sensor(0x2bbf,0x0e);
XC7022_write_cmos_sensor(0x2bc0,0x0c);
XC7022_write_cmos_sensor(0x2bc1,0x0c);
XC7022_write_cmos_sensor(0x2bc2,0x0c);
XC7022_write_cmos_sensor(0x2bc3,0x0c);  //enhance_ratio7  
//defog end
                                                          
//isp top
XC7022_write_cmos_sensor(0xfffe,0x14);
XC7022_write_cmos_sensor(0x002c,0x01);   //isp0 awb_en
XC7022_write_cmos_sensor(0x0030,0x01);    //isp0 lenc_en
XC7022_write_cmos_sensor(0x0620,0x01);   //lenc mode
XC7022_write_cmos_sensor(0x0621,0x01);    //online mode

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x0000,0x47); //47
XC7022_write_cmos_sensor(0x0001,0x82); //82                                              
XC7022_write_cmos_sensor(0x0002,0x96); //90  satuation
XC7022_write_cmos_sensor(0x0003,0x35); //31
XC7022_write_cmos_sensor(0x0004,0x10);

XC7022_write_cmos_sensor(0x0019,0x09);
XC7022_write_cmos_sensor(0x0051,0x03);//ae 统计数据选择
XC7022_write_cmos_sensor(0x1700,0x09);
XC7022_write_cmos_sensor(0x1701,0x44);
XC7022_write_cmos_sensor(0x1702,0x48);
XC7022_write_cmos_sensor(0x1704,0x2a);

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x1451,0x03);
XC7022_write_cmos_sensor(0x1452,0x78);
XC7022_write_cmos_sensor(0x1453,0x70);

// auto sat	
XC7022_write_cmos_sensor(0xfffe,0x14);
XC7022_write_cmos_sensor(0x026c,0x01);//[ 7: 0] nAwbMinStableDiff; 
//	XC7022_write_cmos_sensor(0x026d,0x30));//[ 7: 0] nAwbMinStableDiff;
XC7022_write_cmos_sensor(0x026e,0x4d);//[ 7: 0] sat_u[0]; 0x3f        
XC7022_write_cmos_sensor(0x026f,0x28);//[ 7: 0] sat_u[1]; 0x5f       
XC7022_write_cmos_sensor(0x0270,0x28);//[ 7: 0] sat_u[2]; 0x7f        
XC7022_write_cmos_sensor(0x0271,0x28);//[ 7: 0] sat_u[3]; 0x9f        
XC7022_write_cmos_sensor(0x0272,0x20);//[ 7: 0] sat_u[4]; 0xbf       
XC7022_write_cmos_sensor(0x0273,0x20);//[ 7: 0] sat_u[5];         
XC7022_write_cmos_sensor(0x0274,0x3a);//[ 7: 0] sat_v[0];         
XC7022_write_cmos_sensor(0x0275,0x28);//[ 7: 0] sat_v[1];         
XC7022_write_cmos_sensor(0x0276,0x28);//[ 7: 0] sat_v[2];         
XC7022_write_cmos_sensor(0x0277,0x28);//[ 7: 0] sat_v[3];         
XC7022_write_cmos_sensor(0x0278,0x20);//[ 7: 0] sat_v[4];         
XC7022_write_cmos_sensor(0x0279,0x20);//[ 7: 0] sat_v[5];    

XC7022_write_cmos_sensor(0xfffe,0x30);
XC7022_write_cmos_sensor(0x006c,0x50);
XC7022_write_cmos_sensor(0x0715,0x04);
         
                                                              
		HM2131MIPISENSORDB("[XC7022]exit  XC7022PreviewSetting_SVGA function end :\n ");
}


/*************************************************************************
* FUNCTION
*     XC7022 ISP FullSizeCaptureSetting
*
* DESCRIPTION
*    This function config full size capture setting by XC7022.
*
* PARAMETERS
*    None
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
/*static void XC7022FullSizeCaptureSetting(void)
{
	HM2131MIPISENSORDB("XC7022_ISP_5MCaptureSetting start \n");

	HM2131MIPISENSORDB("XC7022_ISP_5MCaptureSetting  end \n");
}*/




void  HM2131MIPI_Preview_Init(void); // by zhangxueping

/*************************************************************************
* FUNCTION
*   HM2131MIPIOpen
*
* DESCRIPTION
*   This function initialize the registers of CMOS sensor
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
//#define XC7022_ISP_ID 0x7160

UINT32 HM2131MIPIOpen(void)
{
	kal_uint32 isp_id = 0;
	kal_uint32 ret;


	volatile signed int i;
	//kal_uint16 isp_id = 0;
	kal_uint16 sensor_id = 0;    

	//TV_SWITCH_PRINT("[HM2131MIPI]HM2131MIPIOpen: ZHENGFENG_0320\n ");
	TV_SWITCH_PRINT("[HM2131MIPI]HM2131MIPIOpen-4: 150618\n ");

	if(isCameraOpen){
		TV_SWITCH_PRINT("[HM2131MIPI]HM2131MIPIOpen, has opened\n ");
		return ERROR_NONE;
	}

	//is_KERN_EMERG = true;
	//mutex_lock(&TV_switch_lock);

	#if 1
/*	
	if(XC7022_write_cmos_sensor(0xfffd,0x80)<0)
		return -1;
	XC7022_write_cmos_sensor(0xfffe,0x50);
	mDELAY(10);
	

	for (j=0;j<4;j++){
		isp_id[j]=XC7022_read_cmos_sensor(j);
		HM2131MIPISENSORDB("[HM2131MIPI_ISP]ISP_id[%d]=0x%x \n",j,isp_id[j]);
	}
*/
 	isp_id = (XC7022_read_cmos_sensor(0xfffb) << 8) | XC7022_read_cmos_sensor(0xfffc);
   	HM2131MIPISENSORDB("[XC7022MIPI_ISP]ISP_id=0x%x \n",isp_id);

	XC7022InitialSetting(); 
	if(XC7022_write_cmos_sensor(0xfffd,0x80)<0)
		return -1;
	XC7022_write_cmos_sensor(0x0050,0x13);  //  PWDN,GPIO1,GPIO0 en   by Nathan 20150719
	XC7022_write_cmos_sensor(0x0054,0x13);  //  PWDN,GPIO1,ouput 控制sensorPWDN&reset ; GPIO0 被MTK6572来控制XC7022 PWDN
	XC7022_write_cmos_sensor(0x0058,0x13); 
	mDELAY(5);
	XC7022_write_cmos_sensor(0xfffd,0x80);
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x01);

	ret=XC7022_read_cmos_sensor(0x0030);
	HM2131MIPISENSORDB("[XC7022] XC7022 Preview ret:0x0030---%x\n ",ret);
	ret=XC7022_read_cmos_sensor(0x0031);
	HM2131MIPISENSORDB("[XC7022]XC7022 Preview ret:0x0031---%x\n ",ret);
	ret=XC7022_read_cmos_sensor(0x0058);
	HM2131MIPISENSORDB("[XC7022]XC7022 Preview ret:0x0058---%x\n ",ret);
	ret=XC7022_read_cmos_sensor(0x004d);
	HM2131MIPISENSORDB("[XC7022]XC7022 Preview ret:0x004d---%x\n ",ret);

	//HM2131MIPI_write_cmos_sensor(0x3103,0x11);    //open debug mode
	//HM2131MIPI_write_cmos_sensor(0x3008,0x82);    //reset HM2131
	#endif
	mDELAY(10);
	for(i=0;i<3;i++){
		sensor_id = (HM2131MIPIYUV_read_cmos_sensor(0x0000) << 8) | HM2131MIPIYUV_read_cmos_sensor(0x0001);
		HM2131MIPISENSORDB("HM2131MIPIOpen: READ ID :%x\n",sensor_id);
		if(sensor_id != HM2131MIPI_SENSOR_ID){
			//mutex_unlock(&TV_switch_lock);
			//is_KERN_EMERG = false;

			TV_SWITCH_PRINT("[HM2131MIPI] return FAIL\n ");
			#ifndef TEST_COLORBAR_MODE
			return ERROR_SENSOR_CONNECT_FAIL;
			#endif
		}
	}

	HM2131MIPIInitialSetting();

	ret=HM2131MIPIYUV_read_cmos_sensor(0x300f);
	HM2131MIPISENSORDB("[HM2131]HM2131MIPIPreview ret:0x300f---%x\n ",ret);
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3010);
	HM2131MIPISENSORDB("[HM2131] HM2131MIPIPreview ret:0x3010---%x\n ",ret);
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3011);
	HM2131MIPISENSORDB("[HM2131]HM2131MIPIPreview ret:0x3011---%x\n ",ret);
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3012);
	HM2131MIPISENSORDB("[HM2131] HM2131MIPIPreview ret:0x3012---%x\n ",ret);


	XC7022_write_cmos_sensor(0xfffe ,0x50);
	XC7022_write_cmos_sensor(0xfffe ,0x50);
	XC7022_write_cmos_sensor(0x004d ,0x00);

	HM2131MIPI_Preview_Init(); // by zhangxueping

	TV_SWITCH_PRINT("[HM2131MIPI]exit HM2131MIPIOpen\n ");

	//mutex_unlock(&TV_switch_lock);
	//is_KERN_EMERG = false;

	//GM7150_On(false);           // add by zhangxueping

	//isCameraOpen = true;

	return ERROR_NONE;
}   /* HM2131MIPIOpen() */

/*************************************************************************
* FUNCTION
*   HM2131MIPIClose
*
* DESCRIPTION
*   This function is to turn off sensor module power.
*
* PARAMETERS
*   None
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
UINT32 HM2131MIPIClose(void)
{
	TV_SWITCH_PRINT("HM2131MIPIClose\n ");

	#ifdef HM2131_REG_READBACK
	if(isHM2131HrtimerStart){
		HM2131MIPISENSORDB("Cancel hrtimer\n ");
		hrtimer_cancel(&HM2131_readback_timer);
		isHM2131HrtimerStart = KAL_FALSE;
	}	  
	#endif	

	//CISModulePowerOn(FALSE);
	return ERROR_NONE;
}   /* HM2131MIPIClose() */

/*************************************************************************
* FUNCTION
*   HM2131MIPIPreview
*
* DESCRIPTION
*   This function start the sensor preview.
*
* PARAMETERS
*   *image_window : address pointer of pixel numbers in one period of HSYNC
*  *sensor_config_data : address pointer of line numbers in one period of VSYNC
*
* RETURNS
*   None
*
* GLOBALS AFFECTED
*
*************************************************************************/
UINT32 HM2131MIPIPreview(MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *image_window,
MSDK_SENSOR_CONFIG_STRUCT *sensor_config_data)
{

	//kal_uint32 zsdshutter = 0;
	int ret=0;
	
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIPreview function:\n ");

	// by zhangxueping
	#ifdef HM2131_REG_READBACK   
	if(!isHM2131HrtimerStart){	
		HM2131MIPISENSORDB("Start hrtimer\n ");
		HM2131_read_detect_hrtimer_init();
		isHM2131HrtimerStart = KAL_TRUE;
	}		
	#endif	

	if(XC7022_write_cmos_sensor(0xfffd,0x80)<0)
		return -1;
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x01);

	HM2131MIPIPreviewSetting_SVGA();

	ret=HM2131MIPIYUV_read_cmos_sensor(0x3818);
	HM2131MIPISENSORDB("20150822_P :REG:0x300f---%x\n ",ret);    // sensor clock
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3621); 
	HM2131MIPISENSORDB("20150822_P :REG:0x3621---%x\n ",ret); 
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3803);
	HM2131MIPISENSORDB("20150822_P :REG:0x3803---%x\n ",ret);

	XC7022_write_cmos_sensor(0xfffd,0x80);
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x00);

	HM2131MIPISENSORDB("[HM2131MIPI]END 20150822_P HM2131MIPIPreview function:\n ");
	return ERROR_NONE ;
}


void HM2131MIPI_Preview_Init(void)
{
	int ret=0;

	if(XC7022_write_cmos_sensor(0xfffd,0x80)<0)
		return ;
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x01);

	HM2131MIPIPreviewSetting_SVGA();

	ret=HM2131MIPIYUV_read_cmos_sensor(0x3818);
	HM2131MIPISENSORDB("0908 :REG:0x3818---%x\n ",ret);    // sensor clock
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3621); 
	HM2131MIPISENSORDB("0908 :REG:0x3621---%x\n ",ret); 
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3803);
	HM2131MIPISENSORDB("0908 :REG:0x3803---%x\n ",ret);
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3012);                                 
	HM2131MIPISENSORDB("0908 :REG:0x3012---%x\n ",ret);   // sensor clock

	XC7022_write_cmos_sensor(0xfffd,0x80);
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x00);       

	XC7022PreviewSetting_SVGA();                                     
						  
	XC7022_write_cmos_sensor(0xfffe,0x21);    

	ret=XC7022_read_cmos_sensor(0x0004);                             
	HM2131MIPISENSORDB("Nathan0908 :reg::0x0004=%x\n ",ret);

	XC7022_write_cmos_sensor(0xfffe,0x50);
	ret=XC7022_read_cmos_sensor(0x0090);
	HM2131MIPISENSORDB("Nthan_0911:reg::0x0090---%x\n ",ret);   // 
	ret=XC7022_read_cmos_sensor(0x0033);
	HM2131MIPISENSORDB("Nathan_0911:reg::0x0033---%x\n ",ret);   // 

	XC7022_write_cmos_sensor(0xfffe,0x26);
	ret=XC7022_read_cmos_sensor(0x0038);
	HM2131MIPISENSORDB("Nathan_0911:reg::0x0038---%x\n ",ret);   // snesor size  , 0x60
	ret=XC7022_read_cmos_sensor(0x0039);
	HM2131MIPISENSORDB("Nathan_0911:reg::0x0039---%x\n ",ret);   // snesor size  , 0x09
	ret=XC7022_read_cmos_sensor(0x003a);
	HM2131MIPISENSORDB("Nathan_0911:reg::0x003a---%x\n ",ret);   // snesor size  , 0x38
	ret=XC7022_read_cmos_sensor(0x003b);
	HM2131MIPISENSORDB("Nathan_0911:reg::0x003b---%x\n ",ret);   // snesor size  , 0x04

	XC7022_write_cmos_sensor(0xfffe,0x21);

	ret=XC7022_read_cmos_sensor(0x0098);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x0098---%x\n ",ret);    //awb, change 
	ret=XC7022_read_cmos_sensor(0x0099);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x0099---%x\n ",ret);
	ret=XC7022_read_cmos_sensor(0x009a);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x009a---%x\n ",ret);
	ret=XC7022_read_cmos_sensor(0x009b);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x009b---%x\n ",ret);    
	ret=XC7022_read_cmos_sensor(0x009c);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x009c---%x\n ",ret);
	ret=XC7022_read_cmos_sensor(0x009d);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x009d---%x\n ",ret);				
	
	ret=XC7022_read_cmos_sensor(0x0013);
	HM2131MIPISENSORDB("Nathan_0908 :reg::0x0013---%x\n ",ret);
	XC7022_write_cmos_sensor(0xfffe ,0x25);

	ret=XC7022_read_cmos_sensor(0x6002);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x6002---%x\n ",ret);    //awb, change 
	ret=XC7022_read_cmos_sensor(0x6003);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x6003---%x\n ",ret);

	XC7022_write_cmos_sensor(0xfffe,0x14);
	ret=XC7022_read_cmos_sensor(0x0002);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x0002---%x\n ",ret);      //AE, on/off
	ret=XC7022_read_cmos_sensor(0x0026);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x0026---%x\n ",ret);      // change
	ret=XC7022_read_cmos_sensor(0x002b);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x002b---%x\n ",ret);     //gain 0x10~0x78(0x0037)
	ret=XC7022_read_cmos_sensor(0x003c);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x003c---%x\n ",ret);     // lum value
	ret=XC7022_read_cmos_sensor(0x0022);
	HM2131MIPISENSORDB("Nathan0908 :reg::0x0022---%x\n ",ret);    // 0x00/0x01


	// HM2131MIPI_WRITE_ID  0x6c	
	// iWriteReg(0x0022, 0x01,1, 0x6e);


	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIPreview function:\n ");   

	return ;

}   /* HM2131MIPIPreview() */


UINT32 HM2131MIPICapture(MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *image_window,MSDK_SENSOR_CONFIG_STRUCT *sensor_config_data)
{
	
	int ret=0;
	TV_SWITCH_PRINT("[HM2131MIPI]HM2131MIPICapture\n ");
	//is_KERN_EMERG = true;
	#if 0	
	//mutex_lock(&TV_switch_lock);     

	if(XC7022_write_cmos_sensor(0xfffd,0x80)<0)
		return -1;
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x01);

	//mutex_unlock(&TV_switch_lock);
	#endif	

	//#if defined(HM2131_REG_READBACK)
	reg_readback(NULL);          
	//#endif

	//is_KERN_EMERG = false;

	TV_SWITCH_PRINT("[HM2131MIPI]exit HM2131MIPICapture\n ");
	XC7022_write_cmos_sensor(0xfffd,0x80);
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x01);

	HM2131MIPIPreviewSetting_SVGA();
	#if 1 //mirror
	HM2131MIPI_write_cmos_sensor(0x3818,0xe0);
	HM2131MIPI_write_cmos_sensor(0x3621,0x14);
	HM2131MIPI_write_cmos_sensor(0x3803,0x09);
	#endif

	ret=HM2131MIPIYUV_read_cmos_sensor(0x3818);
	HM2131MIPISENSORDB("20150824_Capture  :REG:0x300f---%x\n ",ret);    // sensor clock
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3621); 
	HM2131MIPISENSORDB("20150824_Capture  :REG:0x3621---%x\n ",ret); 
	ret=HM2131MIPIYUV_read_cmos_sensor(0x3803);
	HM2131MIPISENSORDB("20150824_Capture  :REG:0x3803---%x\n ",ret);

	XC7022_write_cmos_sensor(0xfffd,0x80);
	XC7022_write_cmos_sensor(0xfffe,0x50);
	XC7022_write_cmos_sensor(0x004d,0x00);

	HM2131MIPISENSORDB("[HM2131MIPI]END 20150822_Capture HM2131MIPIPreview function:\n ");
	return ERROR_NONE; 
}/* HM2131MIPICapture() */

UINT32 HM2131MIPIGetResolution(MSDK_SENSOR_RESOLUTION_INFO_STRUCT *pSensorResolution)
{
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIGetResolution:%d,%d\n ", HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH, HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT);

	pSensorResolution->SensorPreviewWidth=  (HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH - 48);   //HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH-2*HM2131MIPI_PV_GRAB_START_X;
	pSensorResolution->SensorPreviewHeight= (HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT - 36);   //HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT-2*HM2131MIPI_PV_GRAB_START_Y;
	pSensorResolution->SensorFullWidth= (HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH - 48);    //HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH-2*HM2131MIPI_FULL_GRAB_START_X; 
	pSensorResolution->SensorFullHeight= (HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT - 36);   //HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT-2*HM2131MIPI_FULL_GRAB_START_Y;
	pSensorResolution->SensorVideoWidth= (HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH - 48);   //HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH-2*HM2131MIPI_PV_GRAB_START_X; 
	pSensorResolution->SensorVideoHeight= (HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT - 36);   //HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT-2*HM2131MIPI_PV_GRAB_START_Y;;
	HM2131MIPISENSORDB("Nathan - >>>>>[HM2131MIPI]exit HM2131MIPIGetResolution function:\n ");
	return ERROR_NONE;
}   /* HM2131MIPIGetResolution() */

UINT32 HM2131MIPIGetInfo(MSDK_SCENARIO_ID_ENUM ScenarioId,MSDK_SENSOR_INFO_STRUCT *pSensorInfo,MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData)
{
	HM2131MIPISENSORDB("[HM2131MIPI]HM2131MIPIGetInfo-619: ScenarioId=%d %d, %d\n ", ScenarioId, HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH,HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT);
	//switch (ScenarioId)
	//{
	//case MSDK_SCENARIO_ID_CAMERA_ZSD:
	//  pSensorInfo->SensorPreviewResolutionX=HM2131MIPI_IMAGE_SENSOR_SVGA_WIDTH-2*HM2131MIPI_FULL_GRAB_START_X;//HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH ;
	//  pSensorInfo->SensorPreviewResolutionY=HM2131MIPI_IMAGE_SENSOR_SVGA_HEIGHT-2*HM2131MIPI_FULL_GRAB_START_Y;//HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT ;
	//  pSensorInfo->SensorCameraPreviewFrameRate=15;
	//  break;
	//default:
	pSensorInfo->SensorPreviewResolutionX=(HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH - 32);//HM2131MIPI_IMAGE_SENSOR_SVGA_WIDTH-2*HM2131MIPI_PV_GRAB_START_X; ;
	pSensorInfo->SensorPreviewResolutionY=(HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT  - 24);//HM2131MIPI_IMAGE_SENSOR_SVGA_HEIGHT-2*HM2131MIPI_PV_GRAB_START_Y;
	pSensorInfo->SensorCameraPreviewFrameRate=30;
	//break;
	//}             
	pSensorInfo->SensorFullResolutionX= (HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH - 32);//HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH-2*HM2131MIPI_FULL_GRAB_START_X;
	pSensorInfo->SensorFullResolutionY= (HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT  - 24);//HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT-2*HM2131MIPI_FULL_GRAB_START_Y;
	//pSensorInfo->SensorCameraPreviewFrameRate=30;
	pSensorInfo->SensorVideoFrameRate=6;
	pSensorInfo->SensorStillCaptureFrameRate=5;
	pSensorInfo->SensorWebCamCaptureFrameRate=6;
	pSensorInfo->SensorResetActiveHigh=FALSE;
	pSensorInfo->SensorResetDelayCount=4;
	pSensorInfo->SensorOutputDataFormat=SENSOR_OUTPUT_FORMAT_YUYV;

	pSensorInfo->SensorClockPolarity=SENSOR_CLOCK_POLARITY_LOW; 
	pSensorInfo->SensorClockFallingPolarity=SENSOR_CLOCK_POLARITY_LOW;

	//by zhangxueping
	//pSensorInfo->SensorHsyncPolarity = SENSOR_CLOCK_POLARITY_HIGH;  
	pSensorInfo->SensorHsyncPolarity = SENSOR_CLOCK_POLARITY_LOW;  

	pSensorInfo->SensorVsyncPolarity = SENSOR_CLOCK_POLARITY_LOW;
	//pSensorInfo->SensorVsyncPolarity = SENSOR_CLOCK_POLARITY_HIGH;

	pSensorInfo->SensorInterruptDelayLines = 2;
	pSensorInfo->SensroInterfaceType=SENSOR_INTERFACE_TYPE_MIPI;

	pSensorInfo->CaptureDelayFrame = 3;
	pSensorInfo->PreviewDelayFrame = 3; 

	pSensorInfo->VideoDelayFrame = 3;       
	pSensorInfo->SensorMasterClockSwitch = 0; 
	pSensorInfo->YUVAwbDelayFrame = 5;
	pSensorInfo->YUVEffectDelayFrame= 3; 
	pSensorInfo->AEShutDelayFrame= 0;
	pSensorInfo->SensorDrivingCurrent = ISP_DRIVING_8MA;        


	// imx179, add by zhangxueping
	pSensorInfo->MIPIsensorType = MIPI_OPHY_NCSI2;       // MIPI_OPHY_CSI2; 

	pSensorInfo->SettleDelayMode = MIPI_SETTLEDELAY_AUTO;
	//pSensorInfo->SettleDelayMode = MIPI_SETTLEDELAY_MANUAL;  

	pSensorInfo->HighSpeedVideoDelayFrame = 4;    
	//pSensorInfo->SlimVideoDelayFrame = 4;    
	//pSensorInfo->SensorModeNum = 5;


	switch (ScenarioId){
	case MSDK_SCENARIO_ID_CAMERA_PREVIEW:
	case MSDK_SCENARIO_ID_VIDEO_PREVIEW:

		#if 1			
		pSensorInfo->SensorClockFreq=6;

		pSensorInfo->SensorClockDividCount= 5;
		pSensorInfo->SensorClockRisingCount= 0;
		pSensorInfo->SensorClockFallingCount= 2;
		pSensorInfo->SensorPixelClockCount= 3;
		pSensorInfo->SensorDataLatchCount= 2;
		#endif

		pSensorInfo->SensorGrabStartX = HM2131MIPI_PV_GRAB_START_X; 
		pSensorInfo->SensorGrabStartY = HM2131MIPI_PV_GRAB_START_Y;   
		pSensorInfo->SensorMIPILaneNumber = SENSOR_MIPI_2_LANE; //SENSOR_MIPI_1_LANE;    


		pSensorInfo->MIPIDataLowPwr2HighSpeedTermDelayCount = 0;

		//pSensorInfo->MIPIDataLowPwr2HighSpeedSettleDelayCount = 4; 
		pSensorInfo->MIPIDataLowPwr2HighSpeedSettleDelayCount = 14; // 130;  // 13;  // 17; // 4; // 14;    // 4; 

		pSensorInfo->MIPICLKLowPwr2HighSpeedTermDelayCount = 0;		




		#if 0

		MUINT8 MIPIDataLowPwr2HighSpeedTermDelayCount;
		MUINT8 MIPIDataLowPwr2HighSpeedSettleDelayCount;
		MUINT8 MIPICLKLowPwr2HighSpeedTermDelayCount;

		#endif


		pSensorInfo->SensorWidthSampling = 0; 
		pSensorInfo->SensorHightSampling = 0;   
		pSensorInfo->SensorPacketECCOrder = 1;      
		break;


	case MSDK_SCENARIO_ID_CAMERA_CAPTURE_JPEG:
	case MSDK_SCENARIO_ID_CAMERA_ZSD:
		pSensorInfo->SensorClockFreq=6;
		pSensorInfo->SensorClockDividCount= 5;
		pSensorInfo->SensorClockRisingCount= 0;
		pSensorInfo->SensorClockFallingCount= 2;
		pSensorInfo->SensorPixelClockCount= 3;
		pSensorInfo->SensorDataLatchCount= 2;
		pSensorInfo->SensorGrabStartX = HM2131MIPI_FULL_GRAB_START_X; 
		pSensorInfo->SensorGrabStartY = HM2131MIPI_FULL_GRAB_START_Y;             
		pSensorInfo->SensorMIPILaneNumber = SENSOR_MIPI_2_LANE; //SENSOR_MIPI_1_LANE;         
		pSensorInfo->MIPIDataLowPwr2HighSpeedTermDelayCount = 0; 
		pSensorInfo->MIPIDataLowPwr2HighSpeedSettleDelayCount =4; 
		pSensorInfo->MIPICLKLowPwr2HighSpeedTermDelayCount = 0; 
		pSensorInfo->SensorWidthSampling = 0; 
		pSensorInfo->SensorHightSampling = 0;
		pSensorInfo->SensorPacketECCOrder = 1;
		break;
	default:
		pSensorInfo->SensorClockFreq=6;
		pSensorInfo->SensorClockDividCount=5;
		pSensorInfo->SensorClockRisingCount=0;
		pSensorInfo->SensorClockFallingCount=2;
		pSensorInfo->SensorPixelClockCount=3;
		pSensorInfo->SensorDataLatchCount=2;
		pSensorInfo->SensorGrabStartX = HM2131MIPI_PV_GRAB_START_X; 
		pSensorInfo->SensorGrabStartY = HM2131MIPI_PV_GRAB_START_Y;             
		pSensorInfo->SensorMIPILaneNumber = SENSOR_MIPI_2_LANE; //SENSOR_MIPI_1_LANE;         
		pSensorInfo->MIPIDataLowPwr2HighSpeedTermDelayCount = 0; 
		pSensorInfo->MIPIDataLowPwr2HighSpeedSettleDelayCount = 4; 
		pSensorInfo->MIPICLKLowPwr2HighSpeedTermDelayCount = 0;
		pSensorInfo->SensorWidthSampling = 0;
		pSensorInfo->SensorHightSampling = 0;   
		pSensorInfo->SensorPacketECCOrder = 1;
		break;

	}
	memcpy(pSensorConfigData, &HM2131MIPISensorConfigData, sizeof(MSDK_SENSOR_CONFIG_STRUCT));  
	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIGetInfo function:\n ");  
	return ERROR_NONE;
}   /* HM2131MIPIGetInfo() */

UINT32 HM2131MIPIControl(MSDK_SCENARIO_ID_ENUM ScenarioId, MSDK_SENSOR_EXPOSURE_WINDOW_STRUCT *pImageWindow,MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData)
{
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIControl function:\n ");
	spin_lock(&HM2131mipi_drv_lock);
	CurrentScenarioId = ScenarioId;
	spin_unlock(&HM2131mipi_drv_lock);
	switch (ScenarioId){
	case MSDK_SCENARIO_ID_CAMERA_PREVIEW:
	case MSDK_SCENARIO_ID_VIDEO_PREVIEW:
	case MSDK_SCENARIO_ID_CAMERA_ZSD:
		HM2131MIPIPreview(pImageWindow, pSensorConfigData);
		break;
	case MSDK_SCENARIO_ID_CAMERA_CAPTURE_JPEG:
		HM2131MIPICapture(pImageWindow, pSensorConfigData);
		break;
	default:
		return ERROR_INVALID_SCENARIO_ID;
	}
	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIControl function:\n ");
	return ERROR_NONE;
}   /* HM2131MIPIControl() */

UINT32 HM2131MIPIYUVSensorSetting(FEATURE_ID iCmd, UINT32 iPara)
{
	// HM2131MIPISENSORDB("HM2131MIPIYUVSensorSetting:iCmd=%d,iPara=%d, %d \n",iCmd, iPara);
	HM2131MIPISENSORDB("[HM2131MIPI]enter HM2131MIPIYUVSensorSetting function:\n ");
	switch (iCmd) {
	case FID_SCENE_MODE:
		//HM2131MIPI_set_scene_mode(iPara);
		break;      
	case FID_AWB_MODE:
		//HM2131MIPI_set_param_wb(iPara);
		break;
	case FID_COLOR_EFFECT:              
		//HM2131MIPI_set_param_effect(iPara);
		break;
	case FID_AE_EV:   
		//HM2131MIPI_set_param_exposure(iPara);
		break;
	case FID_AE_FLICKER:                    
		//HM2131MIPI_set_param_banding(iPara);
		break;
	case FID_AE_SCENE_MODE: 
		if (iPara == AE_MODE_OFF) {
			spin_lock(&HM2131mipi_drv_lock);
			//HM2131MIPI_AE_ENABLE = KAL_FALSE; 
			spin_unlock(&HM2131mipi_drv_lock);
		}
		else {
			spin_lock(&HM2131mipi_drv_lock);
			//HM2131MIPI_AE_ENABLE = KAL_TRUE; 
			spin_unlock(&HM2131mipi_drv_lock);
		}
		//HM2131MIPI_set_AE_mode(HM2131MIPI_AE_ENABLE);
		break; 
	case FID_ISP_CONTRAST:
		//HM2131MIPI_set_contrast(iPara);
		break;
	case FID_ISP_BRIGHT:
		//HM2131MIPI_set_brightness(iPara);
		break;
	case FID_ISP_SAT:
		//HM2131MIPI_set_saturation(iPara);
		break; 
	case FID_ZOOM_FACTOR:
		HM2131MIPISENSORDB("FID_ZOOM_FACTOR:%d\n", iPara);      
		spin_lock(&HM2131mipi_drv_lock);
		//zoom_factor = iPara; 
		spin_unlock(&HM2131mipi_drv_lock);
		break; 
	case FID_AE_ISO:
		//HM2131MIPI_set_iso(iPara);
		break;
	#if 0 //afc
	case FID_AF_MODE:
	HM2131MIPI_set_param_afmode(iPara);
	break;     
	#endif            
	default:
		break;
	}
	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIYUVSensorSetting function:\n ");

	return TRUE;
}   /* HM2131MIPIYUVSensorSetting */



UINT32 HM2131MIPIFeatureControl(MSDK_SENSOR_FEATURE_ENUM FeatureId,UINT8 *pFeaturePara,UINT32 *pFeatureParaLen)
{
	UINT16 *pFeatureReturnPara16=(UINT16 *) pFeaturePara;
	UINT16 *pFeatureData16=(UINT16 *) pFeaturePara;
	UINT32 *pFeatureReturnPara32=(UINT32 *) pFeaturePara;
	UINT32 *pFeatureData32=(UINT32 *) pFeaturePara;
	unsigned long long *feature_data=(unsigned long long *) pFeaturePara;
	MSDK_SENSOR_CONFIG_STRUCT *pSensorConfigData=(MSDK_SENSOR_CONFIG_STRUCT *) pFeaturePara;
	MSDK_SENSOR_REG_INFO_STRUCT *pSensorRegData=(MSDK_SENSOR_REG_INFO_STRUCT *) pFeaturePara;
	UINT32 Tony_Temp1 = 0;
	UINT32 Tony_Temp2 = 0;
	Tony_Temp1 = pFeaturePara[0];
	Tony_Temp2 = pFeaturePara[1];
	HM2131MIPISENSORDB("[HM2131MIPI][HM2131MIPIFeatureControl]feature id=%d \n",FeatureId);
	switch (FeatureId){
	case SENSOR_FEATURE_GET_RESOLUTION:
		*pFeatureReturnPara16++=HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH;
		*pFeatureReturnPara16=HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT;
		*pFeatureParaLen=4;
		break;

	case SENSOR_FEATURE_GET_PERIOD:
		#if 0 			
		switch(CurrentScenarioId){
		case MSDK_SCENARIO_ID_CAMERA_ZSD:
			*pFeatureReturnPara16++=HM2131MIPI_FULL_PERIOD_PIXEL_NUMS + HM2131MIPISensor.CaptureDummyPixels;
			*pFeatureReturnPara16=HM2131MIPI_FULL_PERIOD_LINE_NUMS + HM2131MIPISensor.CaptureDummyLines;
			*pFeatureParaLen=4;
			break;
		default:
			*pFeatureReturnPara16++=HM2131MIPI_PV_PERIOD_PIXEL_NUMS + HM2131MIPISensor.PreviewDummyPixels;
			*pFeatureReturnPara16=HM2131MIPI_PV_PERIOD_LINE_NUMS + HM2131MIPISensor.PreviewDummyLines;
			*pFeatureParaLen=4;
			break;
		}
		#else
		*pFeatureReturnPara16++=HM2131MIPI_IMAGE_SENSOR_QSXGA_WITDH;
		*pFeatureReturnPara16=HM2131MIPI_IMAGE_SENSOR_QSXGA_HEIGHT;
		*pFeatureParaLen=4;

		#endif			
		break;

	case SENSOR_FEATURE_GET_PIXEL_CLOCK_FREQ:
		#if 0   
		switch(CurrentScenarioId){
		case MSDK_SCENARIO_ID_CAMERA_ZSD:
			*pFeatureReturnPara32 = HM2131MIPISensor.ZsdturePclk * 1000 *100;    //unit: Hz             
			*pFeatureParaLen=4;
			break;
		default:
			*pFeatureReturnPara32 = HM2131MIPISensor.PreviewPclk * 1000 *100;    //unit: Hz
			*pFeatureParaLen=4;

			break;
		}
		#else
		*pFeatureReturnPara32 = 48000000;	 //unit: Hz
		*pFeatureParaLen=4;
		#endif

		break;

	case SENSOR_FEATURE_SET_ESHUTTER:
		break;
	case SENSOR_FEATURE_GET_EXIF_INFO:
		//HM2131MIPIGetExifInfo(*feature_data);
		break;
	case SENSOR_FEATURE_SET_NIGHTMODE:
		//HM2131MIPI_night_mode((BOOL) *pFeatureData16);
		break;
	case SENSOR_FEATURE_SET_GAIN:
		break;
	case SENSOR_FEATURE_SET_FLASHLIGHT:
		break;
	case SENSOR_FEATURE_SET_ISP_MASTER_CLOCK_FREQ:
		break;
	case SENSOR_FEATURE_SET_REGISTER:
		//mutex_lock(&TV_switch_lock);

		if(pSensorRegData->RegAddr & 0x10000)            {            	
			HM2131MIPISENSORDB("SENSOR_FEATURE_SET_REGISTER(HM2131): addr:%x  value:%x\n",pSensorRegData->RegAddr,pSensorRegData->RegData);
			XC7022_write_cmos_sensor(0xfffd,0x80);
			XC7022_write_cmos_sensor(0xfffe,0x50);
			XC7022_write_cmos_sensor(0x004d,0x01);
			HM2131MIPI_write_cmos_sensor(pSensorRegData->RegAddr&0xffff, pSensorRegData->RegData);
			XC7022_write_cmos_sensor(0x004d,0x00);
		}
		else{
			HM2131MIPISENSORDB("SENSOR_FEATURE_SET_REGISTER(XC7022): addr:%x  value:%x\n",pSensorRegData->RegAddr,pSensorRegData->RegData);
			XC7022_write_cmos_sensor(pSensorRegData->RegAddr&0xffff, pSensorRegData->RegData);
		}
		//mutex_unlock(&TV_switch_lock);

		break;
	case SENSOR_FEATURE_GET_REGISTER:

		//mutex_lock(&TV_switch_lock);										
		if(pSensorRegData->RegAddr & 0x10000){
			XC7022_write_cmos_sensor(0xfffd,0x80);
			XC7022_write_cmos_sensor(0xfffe,0x50);
			XC7022_write_cmos_sensor(0x004d,0x01);
			pSensorRegData->RegData = HM2131MIPIYUV_read_cmos_sensor(pSensorRegData->RegAddr&0xffff);				
			XC7022_write_cmos_sensor(0x004d ,0x00);				
			HM2131MIPISENSORDB("SENSOR_FEATURE_GET_REGISTER(HM2131): addr:0x%x  value:0x%x\n",pSensorRegData->RegAddr,pSensorRegData->RegData);
		}
		else{	
			pSensorRegData->RegData = XC7022_read_cmos_sensor(pSensorRegData->RegAddr&0xffff);
			HM2131MIPISENSORDB("SENSOR_FEATURE_GET_REGISTER(XC7022): addr:0x%x  value:0x%x\n",pSensorRegData->RegAddr,pSensorRegData->RegData);
		}
		//mutex_unlock(&TV_switch_lock);	

		break;
	case SENSOR_FEATURE_GET_CONFIG_PARA:
		memcpy(pSensorConfigData, &HM2131MIPISensorConfigData, sizeof(MSDK_SENSOR_CONFIG_STRUCT));
		*pFeatureParaLen=sizeof(MSDK_SENSOR_CONFIG_STRUCT);
		break;
	case SENSOR_FEATURE_SET_CCT_REGISTER:
	case SENSOR_FEATURE_GET_CCT_REGISTER:
	case SENSOR_FEATURE_SET_ENG_REGISTER:
	case SENSOR_FEATURE_GET_ENG_REGISTER:
	case SENSOR_FEATURE_GET_REGISTER_DEFAULT:
	case SENSOR_FEATURE_CAMERA_PARA_TO_SENSOR:
	case SENSOR_FEATURE_SENSOR_TO_CAMERA_PARA:
	case SENSOR_FEATURE_GET_GROUP_INFO:
	case SENSOR_FEATURE_GET_ITEM_INFO:
	case SENSOR_FEATURE_SET_ITEM_INFO:
	case SENSOR_FEATURE_GET_ENG_INFO:
		break;
	case SENSOR_FEATURE_GET_GROUP_COUNT:
		*pFeatureReturnPara32++=0;
		*pFeatureParaLen=4;    
		break; 
	case SENSOR_FEATURE_GET_LENS_DRIVER_ID:
		*pFeatureReturnPara32=LENS_DRIVER_ID_DO_NOT_CARE;
		*pFeatureParaLen=4;
		break;
	case SENSOR_FEATURE_SET_TEST_PATTERN:            
		HM2131SetTestPatternMode((BOOL)*pFeatureData16);            
		break;
	case SENSOR_FEATURE_CHECK_SENSOR_ID:
		HM2131MIPI_GetSensorID(pFeatureData32);
		break;
	case SENSOR_FEATURE_GET_TEST_PATTERN_CHECKSUM_VALUE:
		*pFeatureReturnPara32=HM2131_TEST_PATTERN_CHECKSUM;
		*pFeatureParaLen=4;
		break;


	case SENSOR_FEATURE_SET_YUV_CMD:
		HM2131MIPIYUVSensorSetting((FEATURE_ID)*feature_data, *(feature_data+1));
		break;
	#if 0
	case SENSOR_FEATURE_SET_YUV_3A_CMD:
		HM2131MIPI_3ACtrl((ACDK_SENSOR_3A_LOCK_ENUM)*pFeatureData32);
		break;
	case SENSOR_FEATURE_SET_VIDEO_MODE:
		HM2131MIPIYUVSetVideoMode(*pFeatureData16);
		break;
	case SENSOR_FEATURE_GET_EV_AWB_REF:
		HM2131MIPIGetEvAwbRef(*pFeatureData32);
		break;
	case SENSOR_FEATURE_GET_SHUTTER_GAIN_AWB_GAIN:
		HM2131MIPIGetCurAeAwbInfo(*pFeatureData32);         
		break;
	case SENSOR_FEATURE_SET_MAX_FRAME_RATE_BY_SCENARIO:
		HM2131MIPIMaxFramerateByScenario((MSDK_SCENARIO_ID_ENUM)*pFeatureData32,*(pFeatureData32+1));
		break;
	case SENSOR_FEATURE_GET_DEFAULT_FRAME_RATE_BY_SCENARIO:
		HM2131MIPIGetDefaultFramerateByScenario((MSDK_SCENARIO_ID_ENUM)*pFeatureData32,(MUINT32 *)*(pFeatureData32+1));
		break;
	case SENSOR_FEATURE_GET_AE_AWB_LOCK_INFO:
		//HM2131MIPI_get_AEAWB_lock(*pFeatureData32, *(pFeatureData32+1));  // by zhangxueping
		break;
	case SENSOR_FEATURE_GET_DELAY_INFO:
		HM2131MIPISENSORDB("SENSOR_FEATURE_GET_DELAY_INFO\n");
		//HM2131MIPI_GetDelayInfo(*pFeatureData32);         // by zhangxueping
		break;
	case SENSOR_FEATURE_AUTOTEST_CMD:
		HM2131MIPISENSORDB("SENSOR_FEATURE_AUTOTEST_CMD\n");
		HM2131MIPI_AutoTestCmd(*feature_data,*(feature_data+1));
		break;
	case SENSOR_FEATURE_INITIALIZE_AF:  
		// HM2131_FOCUS_OVT_AFC_Init();         
		break;
	case SENSOR_FEATURE_MOVE_FOCUS_LENS:
		HM2131_FOCUS_Move_to(*pFeatureData16);
		break;
	case SENSOR_FEATURE_GET_AF_STATUS:
		HM2131_FOCUS_OVT_AFC_Get_AF_Status(pFeatureReturnPara32);            
		*pFeatureParaLen=4;
		break;
	case SENSOR_FEATURE_GET_AF_INF:
		HM2131_FOCUS_Get_AF_Inf(pFeatureReturnPara32);
		*pFeatureParaLen=4;            
		break;
	case SENSOR_FEATURE_GET_AF_MACRO:
		HM2131_FOCUS_Get_AF_Macro(pFeatureReturnPara32);
		*pFeatureParaLen=4;            
		break;
	case SENSOR_FEATURE_CONSTANT_AF:
		//HM2131_FOCUS_OVT_AFC_Constant_Focus();
		break;
	case SENSOR_FEATURE_SET_AF_WINDOW:       
		HM2131_FOCUS_Set_AF_Window(*feature_data);
		break;
	case SENSOR_FEATURE_SINGLE_FOCUS_MODE:
		//HM2131_FOCUS_OVT_AFC_Single_Focus();
		break;  
	case SENSOR_FEATURE_CANCEL_AF:
		HM2131_FOCUS_OVT_AFC_Cancel_Focus();
		break;                  
	case SENSOR_FEATURE_GET_AF_MAX_NUM_FOCUS_AREAS:
		HM2131_FOCUS_Get_AF_Max_Num_Focus_Areas(pFeatureReturnPara32);            
		*pFeatureParaLen=4;
		break;        
	case SENSOR_FEATURE_GET_AE_MAX_NUM_METERING_AREAS:
		HM2131_FOCUS_Get_AE_Max_Num_Metering_Areas(pFeatureReturnPara32);            
		*pFeatureParaLen=4;
		break;        
	case SENSOR_FEATURE_SET_AE_WINDOW:
		//	            HM2131MIPISENSORDB("AE zone addr = 0x%x\n",*feature_data);            
		HM2131_FOCUS_Set_AE_Window(*pFeatureData32);
		break; 
	#endif

	default:
		HM2131MIPISENSORDB("HM2131MIPIFeatureControl:default \n");
		break;          
	}
	HM2131MIPISENSORDB("[HM2131MIPI]exit HM2131MIPIFeatureControl function:\n ");
	return ERROR_NONE;
}   /* HM2131MIPIFeatureControl() */

SENSOR_FUNCTION_STRUCT  SensorFuncHM2131MIPI=
{
	HM2131MIPIOpen,
	HM2131MIPIGetInfo,
	HM2131MIPIGetResolution,
	HM2131MIPIFeatureControl,
	HM2131MIPIControl,
	HM2131MIPIClose
};

UINT32 HM2131_MIPI_YUV_SensorInit(PSENSOR_FUNCTION_STRUCT *pfFunc)
{
	/* To Do : Check Sensor status here */
	if (pfFunc!=NULL)
		*pfFunc=&SensorFuncHM2131MIPI;
	return ERROR_NONE;
}/* SensorInit() */

