/*
 * Copyright (C) 2016 MediaTek Inc.

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See http://www.gnu.org/licenses/gpl-2.0.html for more details.
 */

#include <linux/kernel.h>
#include <linux/module.h>

#include <mach/upmu_sw.h>
#include <mach/upmu_hw.h>
#include <mt-plat/upmu_common.h>

unsigned int mt6353_upmu_get_usbdl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON0),
				  (&val),
				  (unsigned int)(PMIC_USBDL_MASK),
				  (unsigned int)(PMIC_USBDL_SHIFT));


	return val;
}

unsigned int mt6353_upmu_get_vtcxo_config(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON0),
				  (&val),
				  (unsigned int)(PMIC_VTCXO_CONFIG_MASK),
				  (unsigned int)(PMIC_VTCXO_CONFIG_SHIFT));


	return val;
}

void mt6353_upmu_set_rg_thr_det_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THR_DET_DIS_MASK),
				    (unsigned int)(PMIC_RG_THR_DET_DIS_SHIFT));

}

unsigned int mt6353_upmu_get_rg_thr_det_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_THR_DET_DIS_MASK),
				  (unsigned int)(PMIC_RG_THR_DET_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_thr_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THR_TEST_MASK),
				    (unsigned int)(PMIC_RG_THR_TEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_thr_test(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_THR_TEST_MASK),
				  (unsigned int)(PMIC_RG_THR_TEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_ther_deb_rmax(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_RMAX_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_RMAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_ther_deb_rmax(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_THER_DEB_RMAX_MASK),
				  (unsigned int)(PMIC_RG_STRUP_THER_DEB_RMAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_ther_deb_fmax(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_FMAX_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THER_DEB_FMAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_ther_deb_fmax(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_THER_DEB_FMAX_MASK),
				  (unsigned int)(PMIC_RG_STRUP_THER_DEB_FMAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dduvlo_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DDUVLO_DEB_EN_MASK),
				    (unsigned int)(PMIC_DDUVLO_DEB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dduvlo_deb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_DDUVLO_DEB_EN_MASK),
				  (unsigned int)(PMIC_DDUVLO_DEB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pwrbb_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRBB_DEB_EN_MASK),
				    (unsigned int)(PMIC_RG_PWRBB_DEB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pwrbb_deb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_PWRBB_DEB_EN_MASK),
				  (unsigned int)(PMIC_RG_PWRBB_DEB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_osc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_osc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_OSC_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_OSC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_osc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_OSC_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_osc_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_OSC_EN_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_OSC_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_ft_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_FT_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_FT_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_ft_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_FT_CTRL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_FT_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_pwron_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_FORCE_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_FORCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_pwron_force(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_PWRON_FORCE_MASK),
				  (unsigned int)(PMIC_RG_STRUP_PWRON_FORCE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_biasgen_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIASGEN_FORCE_MASK),
				    (unsigned int)(PMIC_RG_BIASGEN_FORCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_biasgen_force(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_BIASGEN_FORCE_MASK),
				  (unsigned int)(PMIC_RG_BIASGEN_FORCE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_pwron(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_pwron(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_PWRON_MASK),
				  (unsigned int)(PMIC_RG_STRUP_PWRON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_pwron_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRON_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_pwron_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_PWRON_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_PWRON_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_biasgen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIASGEN_MASK),
				    (unsigned int)(PMIC_RG_BIASGEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_biasgen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_BIASGEN_MASK),
				  (unsigned int)(PMIC_RG_BIASGEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_biasgen_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIASGEN_SEL_MASK),
				    (unsigned int)(PMIC_RG_BIASGEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_biasgen_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_BIASGEN_SEL_MASK),
				  (unsigned int)(PMIC_RG_BIASGEN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rtc_xosc32_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_MASK),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rtc_xosc32_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_MASK),
				  (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rtc_xosc32_enb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SEL_MASK),
				    (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rtc_xosc32_enb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SEL_MASK),
				  (unsigned int)(PMIC_RG_RTC_XOSC32_ENB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_strup_dig_io_pg_force(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_DIG_IO_PG_FORCE_MASK),
				    (unsigned int)(PMIC_STRUP_DIG_IO_PG_FORCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_strup_dig_io_pg_force(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON3),
				  (&val),
				  (unsigned int)(PMIC_STRUP_DIG_IO_PG_FORCE_MASK),
				  (unsigned int)(PMIC_STRUP_DIG_IO_PG_FORCE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clr_just_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLR_JUST_RST_MASK),
				    (unsigned int)(PMIC_CLR_JUST_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clr_just_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON4),
				  (&val),
				  (unsigned int)(PMIC_CLR_JUST_RST_MASK),
				  (unsigned int)(PMIC_CLR_JUST_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_uvlo_l2h_deb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_UVLO_L2H_DEB_EN_MASK),
				    (unsigned int)(PMIC_UVLO_L2H_DEB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_uvlo_l2h_deb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON4),
				  (&val),
				  (unsigned int)(PMIC_UVLO_L2H_DEB_EN_MASK),
				  (unsigned int)(PMIC_UVLO_L2H_DEB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_just_pwrkey_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON4),
				  (&val),
				  (unsigned int)(PMIC_JUST_PWRKEY_RST_MASK),
				  (unsigned int)(PMIC_JUST_PWRKEY_RST_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_osc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_OSC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_OSC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_ext_pmic_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_ext_pmic_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_ext_pmic_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_ext_pmic_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_EXT_PMIC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_strup_con8_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_CON8_RSV0_MASK),
				    (unsigned int)(PMIC_STRUP_CON8_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_strup_con8_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON5),
				  (&val),
				  (unsigned int)(PMIC_STRUP_CON8_RSV0_MASK),
				  (unsigned int)(PMIC_STRUP_CON8_RSV0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_ext_pmic_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON5),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_EXT_PMIC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_EXT_PMIC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_auxadc_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SW_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_auxadc_start_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SW_MASK),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_auxadc_rstb_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SW_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_auxadc_rstb_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SW_MASK),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_auxadc_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_auxadc_start_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_START_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_auxadc_rstb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_auxadc_rstb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_RSTB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_auxadc_rpcnt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RPCNT_MAX_MASK),
				    (unsigned int)(PMIC_RG_STRUP_AUXADC_RPCNT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_auxadc_rpcnt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_RPCNT_MAX_MASK),
				  (unsigned int)(PMIC_RG_STRUP_AUXADC_RPCNT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_strup_pwroff_seq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_PWROFF_SEQ_EN_MASK),
				    (unsigned int)(PMIC_STRUP_PWROFF_SEQ_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_strup_pwroff_seq_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON7),
				  (&val),
				  (unsigned int)(PMIC_STRUP_PWROFF_SEQ_EN_MASK),
				  (unsigned int)(PMIC_STRUP_PWROFF_SEQ_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_strup_pwroff_preoff_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_PWROFF_PREOFF_EN_MASK),
				    (unsigned int)(PMIC_STRUP_PWROFF_PREOFF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_strup_pwroff_preoff_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON7),
				  (&val),
				  (unsigned int)(PMIC_STRUP_PWROFF_PREOFF_EN_MASK),
				  (unsigned int)(PMIC_STRUP_PWROFF_PREOFF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_strup_dig0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_DIG0_RSV0_MASK),
				    (unsigned int)(PMIC_STRUP_DIG0_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_strup_dig0_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON8),
				  (&val),
				  (unsigned int)(PMIC_STRUP_DIG0_RSV0_MASK),
				  (unsigned int)(PMIC_STRUP_DIG0_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_strup_dig1_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STRUP_DIG1_RSV0_MASK),
				    (unsigned int)(PMIC_STRUP_DIG1_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_strup_dig1_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON8),
				  (&val),
				  (unsigned int)(PMIC_STRUP_DIG1_RSV0_MASK),
				  (unsigned int)(PMIC_STRUP_DIG1_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rsv_swreg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RSV_SWREG_MASK),
				    (unsigned int)(PMIC_RG_RSV_SWREG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rsv_swreg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_RSV_SWREG_MASK),
				  (unsigned int)(PMIC_RG_RSV_SWREG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_uvlo_u1u2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_uvlo_u1u2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_uvlo_u1u2_sel_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SWCTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_uvlo_u1u2_sel_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SWCTRL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_UVLO_U1U2_SEL_SWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_thr_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THR_CLR_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THR_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_thr_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON11),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_THR_CLR_MASK),
				  (unsigned int)(PMIC_RG_STRUP_THR_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_ext_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_ext_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_ext_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_TD_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_ext_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_TD_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_ext_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_ext_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_ext_chr_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_CHR_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_CHR_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_ext_chr_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_CHR_CTRL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_CHR_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_ext_pwrkey_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRKEY_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRKEY_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_ext_pwrkey_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRKEY_CTRL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRKEY_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_ext_pwrbb_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRBB_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRBB_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_ext_pwrbb_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRBB_CTRL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_EXT_PWRBB_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_envtem(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_MASK),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_envtem(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_ENVTEM_MASK),
				  (unsigned int)(PMIC_RG_STRUP_ENVTEM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_envtem_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_CTRL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_ENVTEM_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_envtem_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_ENVTEM_CTRL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_ENVTEM_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_pwrkey_count_reset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_PWRKEY_COUNT_RESET_MASK),
				    (unsigned int)(PMIC_RG_STRUP_PWRKEY_COUNT_RESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_pwrkey_count_reset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_PWRKEY_COUNT_RESET_MASK),
				  (unsigned int)(PMIC_RG_STRUP_PWRKEY_COUNT_RESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vcore2_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vcore2_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vmch_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMCH_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMCH_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vmch_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VMCH_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VMCH_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vmc_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMC_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMC_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vmc_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VMC_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VMC_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vusb33_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vusb33_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vsram_proc_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vsram_proc_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vproc_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VPROC_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VPROC_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vproc_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VPROC_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VPROC_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vdram_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vdram_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vaud28_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vaud28_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vemc_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vemc_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VEMC_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VEMC_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vs1_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vs1_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VS1_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VS1_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vcore_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vcore_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VCORE_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VCORE_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vaux18_pg_h2l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_H2L_EN_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_H2L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vaux18_pg_h2l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_H2L_EN_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_H2L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vcore2_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vcore2_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VCORE2_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vmch_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMCH_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMCH_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vmch_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VMCH_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VMCH_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vmc_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VMC_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VMC_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vmc_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VMC_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VMC_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vxo22_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VXO22_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VXO22_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vxo22_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VXO22_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VXO22_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vtcxo_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VTCXO_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VTCXO_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vtcxo_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VTCXO_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VTCXO_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vusb33_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vusb33_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VUSB33_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vsram_proc_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vsram_proc_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VSRAM_PROC_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vproc_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VPROC_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VPROC_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vproc_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VPROC_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VPROC_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vdram_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vdram_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VDRAM_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vaud28_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vaud28_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VAUD28_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vio28_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VIO28_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VIO28_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vio28_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VIO28_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VIO28_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vemc_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VEMC_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vemc_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VEMC_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VEMC_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vio18_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VIO18_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VIO18_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vio18_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VIO18_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VIO18_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vs1_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS1_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vs1_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VS1_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VS1_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vcore_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vcore_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VCORE_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VCORE_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vaux18_pg_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vaux18_pg_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VAUX18_PG_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vcore2_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE2_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE2_OC_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vcore2_oc_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VCORE2_OC_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VCORE2_OC_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vproc_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VPROC_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VPROC_OC_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vproc_oc_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VPROC_OC_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VPROC_OC_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vs1_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VS1_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VS1_OC_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vs1_oc_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VS1_OC_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VS1_OC_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_vcore_oc_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_OC_ENB_MASK),
				    (unsigned int)(PMIC_RG_STRUP_VCORE_OC_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_vcore_oc_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_VCORE_OC_ENB_MASK),
				  (unsigned int)(PMIC_RG_STRUP_VCORE_OC_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_reset_extend(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RESET_EXTEND_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RESET_EXTEND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_reset_extend(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_CON17),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RESET_EXTEND_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RESET_EXTEND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_thrdet_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THRDET_SEL_MASK),
				    (unsigned int)(PMIC_RG_THRDET_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_thrdet_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_THRDET_SEL_MASK),
				  (unsigned int)(PMIC_RG_THRDET_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_thr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_THR_SEL_MASK),
				    (unsigned int)(PMIC_RG_STRUP_THR_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_thr_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_THR_SEL_MASK),
				  (unsigned int)(PMIC_RG_STRUP_THR_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_thr_tmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_THR_TMODE_MASK),
				    (unsigned int)(PMIC_RG_THR_TMODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_thr_tmode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_THR_TMODE_MASK),
				  (unsigned int)(PMIC_RG_THR_TMODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vref_bg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VREF_BG_MASK),
				    (unsigned int)(PMIC_RG_VREF_BG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vref_bg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VREF_BG_MASK),
				  (unsigned int)(PMIC_RG_VREF_BG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_iref_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_IREF_TRIM_MASK),
				    (unsigned int)(PMIC_RG_STRUP_IREF_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_iref_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_IREF_TRIM_MASK),
				  (unsigned int)(PMIC_RG_STRUP_IREF_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rst_drvsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RST_DRVSEL_MASK),
				    (unsigned int)(PMIC_RG_RST_DRVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rst_drvsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_RST_DRVSEL_MASK),
				  (unsigned int)(PMIC_RG_RST_DRVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_en_drvsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EN_DRVSEL_MASK),
				    (unsigned int)(PMIC_RG_EN_DRVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_en_drvsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_EN_DRVSEL_MASK),
				  (unsigned int)(PMIC_RG_EN_DRVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fchr_keydet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FCHR_KEYDET_EN_MASK),
				    (unsigned int)(PMIC_RG_FCHR_KEYDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fchr_keydet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_FCHR_KEYDET_EN_MASK),
				  (unsigned int)(PMIC_RG_FCHR_KEYDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fchr_pu_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FCHR_PU_EN_MASK),
				    (unsigned int)(PMIC_RG_FCHR_PU_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fchr_pu_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_FCHR_PU_EN_MASK),
				  (unsigned int)(PMIC_RG_FCHR_PU_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pmu_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_STRUP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU_RSV_MASK),
				    (unsigned int)(PMIC_RG_PMU_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pmu_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_STRUP_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_PMU_RSV_MASK),
				  (unsigned int)(PMIC_RG_PMU_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_phy_rg_cc_rp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_PHY_RG_CC_RP_SEL_MASK),
				    (unsigned int)(PMIC_TYPE_C_PHY_RG_CC_RP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_phy_rg_cc_rp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_PHY_RG_CC_RP_SEL_MASK),
				  (unsigned int)(PMIC_TYPE_C_PHY_RG_CC_RP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_pd_tx_slew_calen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TX_SLEW_CALEN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TX_SLEW_CALEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_pd_tx_slew_calen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TX_SLEW_CALEN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TX_SLEW_CALEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_pd_txslew_i(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TXSLEW_I_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TXSLEW_I_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_pd_txslew_i(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TXSLEW_I_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_PD_TXSLEW_I_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc_mpx_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_MPX_SEL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_MPX_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc_mpx_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_MPX_SEL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_MPX_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc_reserve(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC_RESERVE_CSR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_RESERVE_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_RESERVE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc_reserve(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC_RESERVE_CSR),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_RESERVE_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC_RESERVE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_vcmp_cc2_sw_sel_st_cnt_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_VCMP_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_VCMP_CC2_SW_SEL_ST_CNT_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_VCMP_CC2_SW_SEL_ST_CNT_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_vcmp_cc2_sw_sel_st_cnt_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_VCMP_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_VCMP_CC2_SW_SEL_ST_CNT_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_VCMP_CC2_SW_SEL_ST_CNT_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_vcmp_bias_en_st_cnt_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_VCMP_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_VCMP_BIAS_EN_ST_CNT_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_VCMP_BIAS_EN_ST_CNT_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_vcmp_bias_en_st_cnt_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_VCMP_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_VCMP_BIAS_EN_ST_CNT_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_VCMP_BIAS_EN_ST_CNT_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_vcmp_dac_en_st_cnt_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_VCMP_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_VCMP_DAC_EN_ST_CNT_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_VCMP_DAC_EN_ST_CNT_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_vcmp_dac_en_st_cnt_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_VCMP_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_VCMP_DAC_EN_ST_CNT_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_VCMP_DAC_EN_ST_CNT_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_port_support_role(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PORT_SUPPORT_ROLE_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PORT_SUPPORT_ROLE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_port_support_role(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PORT_SUPPORT_ROLE_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PORT_SUPPORT_ROLE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_adc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_ADC_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_ADC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_adc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_ADC_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_ADC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_acc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_ACC_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_ACC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_acc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_ACC_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_ACC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_audio_acc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_AUDIO_ACC_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_AUDIO_ACC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_audio_acc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_AUDIO_ACC_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_AUDIO_ACC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_debug_acc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DEBUG_ACC_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DEBUG_ACC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_debug_acc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DEBUG_ACC_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DEBUG_ACC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_try_src_st_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_TRY_SRC_ST_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_TRY_SRC_ST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_try_src_st_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_TRY_SRC_ST_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_TRY_SRC_ST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_attach_src_2_try_wait_snk_st_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_ATTACH_SRC_2_TRY_WAIT_SNK_ST_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_ATTACH_SRC_2_TRY_WAIT_SNK_ST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_attach_src_2_try_wait_snk_st_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_ATTACH_SRC_2_TRY_WAIT_SNK_ST_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_ATTACH_SRC_2_TRY_WAIT_SNK_ST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_pd2cc_det_disable_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PD2CC_DET_DISABLE_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PD2CC_DET_DISABLE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_pd2cc_det_disable_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PD2CC_DET_DISABLE_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PD2CC_DET_DISABLE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_attach_src_open_pddebounce_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_ATTACH_SRC_OPEN_PDDEBOUNCE_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_ATTACH_SRC_OPEN_PDDEBOUNCE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_attach_src_open_pddebounce_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_ATTACH_SRC_OPEN_PDDEBOUNCE_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_ATTACH_SRC_OPEN_PDDEBOUNCE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_disable_st_rd_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DISABLE_ST_RD_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DISABLE_ST_RD_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_disable_st_rd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DISABLE_ST_RD_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DISABLE_ST_RD_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_sw_vbus_present(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_SW_VBUS_PRESENT_MASK),
				    (unsigned int)(PMIC_TYPE_C_SW_VBUS_PRESENT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_sw_vbus_present(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_SW_VBUS_PRESENT_MASK),
				  (unsigned int)(PMIC_TYPE_C_SW_VBUS_PRESENT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_sw_da_drive_vconn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_SW_DA_DRIVE_VCONN_EN_MASK),
				    (unsigned int)(PMIC_TYPE_C_SW_DA_DRIVE_VCONN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_sw_da_drive_vconn_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_SW_DA_DRIVE_VCONN_EN_MASK),
				  (unsigned int)(PMIC_TYPE_C_SW_DA_DRIVE_VCONN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_sw_vbus_det_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_SW_VBUS_DET_DIS_MASK),
				    (unsigned int)(PMIC_TYPE_C_SW_VBUS_DET_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_sw_vbus_det_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_SW_VBUS_DET_DIS_MASK),
				  (unsigned int)(PMIC_TYPE_C_SW_VBUS_DET_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_sw_cc_det_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_SW_CC_DET_DIS_MASK),
				    (unsigned int)(PMIC_TYPE_C_SW_CC_DET_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_sw_cc_det_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_SW_CC_DET_DIS_MASK),
				  (unsigned int)(PMIC_TYPE_C_SW_CC_DET_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_sw_pd_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_SW_PD_EN_MASK),
				    (unsigned int)(PMIC_TYPE_C_SW_PD_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_sw_pd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_CTRL),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_SW_PD_EN_MASK),
				  (unsigned int)(PMIC_TYPE_C_SW_PD_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_vol_periodic_meas_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_VOL_PERIODIC_MEAS_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PERIODIC_MEAS_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PERIODIC_MEAS_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_vol_periodic_meas_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_VOL_PERIODIC_MEAS_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PERIODIC_MEAS_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PERIODIC_MEAS_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_vol_cc_debounce_cnt_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_VOL_DEBOUCE_CNT_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_CC_DEBOUNCE_CNT_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_CC_DEBOUNCE_CNT_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_vol_cc_debounce_cnt_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_VOL_DEBOUCE_CNT_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_CC_DEBOUNCE_CNT_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_CC_DEBOUNCE_CNT_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_vol_pd_debounce_cnt_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_VOL_DEBOUCE_CNT_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PD_DEBOUNCE_CNT_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PD_DEBOUNCE_CNT_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_vol_pd_debounce_cnt_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_VOL_DEBOUCE_CNT_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PD_DEBOUNCE_CNT_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_VOL_PD_DEBOUNCE_CNT_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_drp_src_cnt_val_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DRP_SRC_CNT_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_SRC_CNT_VAL_0_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_SRC_CNT_VAL_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_drp_src_cnt_val_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DRP_SRC_CNT_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_SRC_CNT_VAL_0_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_SRC_CNT_VAL_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_drp_snk_cnt_val_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DRP_SNK_CNT_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_SNK_CNT_VAL_0_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_SNK_CNT_VAL_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_drp_snk_cnt_val_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DRP_SNK_CNT_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_SNK_CNT_VAL_0_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_SNK_CNT_VAL_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_drp_try_cnt_val_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DRP_TRY_CNT_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_CNT_VAL_0_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_CNT_VAL_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_drp_try_cnt_val_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DRP_TRY_CNT_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_CNT_VAL_0_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_CNT_VAL_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_drp_try_wait_cnt_val_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DRP_TRY_WAIT_CNT_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_0_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_drp_try_wait_cnt_val_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DRP_TRY_WAIT_CNT_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_0_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_drp_try_wait_cnt_val_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DRP_TRY_WAIT_CNT_VAL_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_1_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_drp_try_wait_cnt_val_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DRP_TRY_WAIT_CNT_VAL_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_1_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DRP_TRY_WAIT_CNT_VAL_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_src_vopen_default_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_DEFAULT_DAC_VAL),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_DEFAULT_DAC_VAL_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_DEFAULT_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_src_vopen_default_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_DEFAULT_DAC_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_DEFAULT_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_DEFAULT_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_src_vrd_default_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_DEFAULT_DAC_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_DEFAULT_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_DEFAULT_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_src_vrd_default_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_DEFAULT_DAC_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_DEFAULT_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_DEFAULT_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_src_vopen_15_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_15_DAC_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_15_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_15_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_src_vopen_15_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_15_DAC_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_15_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_15_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_src_vrd_15_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_15_DAC_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_15_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_15_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_src_vrd_15_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_15_DAC_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_15_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_15_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_src_vopen_30_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_30_DAC_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_30_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_30_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_src_vopen_30_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_30_DAC_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_30_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VOPEN_30_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_src_vrd_30_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_30_DAC_VAL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_30_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_30_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_src_vrd_30_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SRC_30_DAC_VAL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_30_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SRC_VRD_30_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_snk_vrp30_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SNK_DAC_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP30_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP30_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_snk_vrp30_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SNK_DAC_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP30_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP30_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_snk_vrp15_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SNK_DAC_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP15_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP15_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_snk_vrp15_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SNK_DAC_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP15_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRP15_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_snk_vrpusb_dac_val(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SNK_DAC_VAL_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRPUSB_DAC_VAL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRPUSB_DAC_VAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_snk_vrpusb_dac_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SNK_DAC_VAL_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRPUSB_DAC_VAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_SNK_VRPUSB_DAC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_attach_src_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SRC_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SRC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_attach_src_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SRC_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SRC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_attach_snk_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SNK_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SNK_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_attach_snk_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SNK_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_SNK_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_audio_acc_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_AUDIO_ACC_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_AUDIO_ACC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_audio_acc_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_AUDIO_ACC_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_AUDIO_ACC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_dbg_acc_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DBG_ACC_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DBG_ACC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_dbg_acc_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DBG_ACC_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DBG_ACC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_disable_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DISABLE_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DISABLE_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_disable_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DISABLE_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_DISABLE_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_unattach_src_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SRC_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SRC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_unattach_src_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SRC_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SRC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_unattach_snk_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SNK_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SNK_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_unattach_snk_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SNK_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_SNK_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_attach_wait_src_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SRC_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SRC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_attach_wait_src_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SRC_INTR_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SRC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_attach_wait_snk_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SNK_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SNK_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_attach_wait_snk_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SNK_INTR_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_SNK_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_try_src_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_TRY_SRC_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_TRY_SRC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_try_src_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_TRY_SRC_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_TRY_SRC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_try_wait_snk_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_TRY_WAIT_SNK_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_TRY_WAIT_SNK_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_try_wait_snk_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_TRY_WAIT_SNK_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_TRY_WAIT_SNK_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_unattach_acc_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_ACC_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_ACC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_unattach_acc_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_ACC_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_UNATTACH_ACC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_attach_wait_acc_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_ACC_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_ACC_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_attach_wait_acc_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_0),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_ACC_INTR_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_ATTACH_WAIT_ACC_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_snk_pwr_idle_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_IDLE_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_IDLE_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_snk_pwr_idle_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_IDLE_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_IDLE_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_snk_pwr_default_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_DEFAULT_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_DEFAULT_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_snk_pwr_default_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_DEFAULT_INTR_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_DEFAULT_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_snk_pwr_15_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_15_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_15_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_snk_pwr_15_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_15_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_15_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_snk_pwr_30_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_30_INTR_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_30_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_snk_pwr_30_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_30_INTR_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_30_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_cc_ent_snk_pwr_redetect_intr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_REDETECT_INTR_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_REDETECT_INTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_cc_ent_snk_pwr_redetect_intr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_INTR_EN_2),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_REDETECT_INTR_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_CC_ENT_SNK_PWR_REDETECT_INTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc1_rpde(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RPDE_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RPDE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc1_rpde(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RPDE_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RPDE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc1_rp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP15_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc1_rp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP15_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc1_rp3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP3_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc1_rp3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP3_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RP3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc1_rd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RD_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc1_rd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC1_RESISTENCE_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RD_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC1_RD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc2_rpde(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RPDE_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RPDE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc2_rpde(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RPDE_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RPDE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc2_rp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP15_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc2_rp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP15_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc2_rp3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP3_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc2_rp3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP3_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RP3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_phy_rg_cc2_rd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RD_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_phy_rg_cc2_rd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_PHY_RG_CC2_RESISTENCE_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RD_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_PHY_RG_CC2_RD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_rcc1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC1_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_rcc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC1_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_rcc2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC2_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_rcc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC2_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_RCC2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_lev_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LEV_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LEV_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_lev_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LEV_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LEV_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_sw_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SW_SEL_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SW_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_sw_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SW_SEL_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SW_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_BIAS_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_BIAS_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_lpf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LPF_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LPF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_lpf_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LPF_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_LPF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_adcsw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_ADCSW_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_ADCSW_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_adcsw_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_ADCSW_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_ADCSW_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_sasw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SASW_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SASW_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_sasw_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SASW_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SASW_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_dac_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_dac_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_EN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_saclk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SACLK_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SACLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_saclk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SACLK_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_SACLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_dac_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_IN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_dac_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_IN_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_dac_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_CAL_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_dac_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_CAL_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_en_da_cc_dac_gain_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_GAIN_CAL_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_GAIN_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_en_da_cc_dac_gain_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_ENABLE),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_GAIN_CAL_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_EN_DA_CC_DAC_GAIN_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_rpcc1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC1_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_rpcc1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC1_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_rdcc1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC1_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_rdcc1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC1_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_racc1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC1_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_racc1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC1_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_rpcc2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC2_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_rpcc2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC2_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RPCC2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_rdcc2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC2_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_rdcc2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC2_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RDCC2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_racc2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC2_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_racc2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC2_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_RACC2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_lev_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LEV_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LEV_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_lev_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LEV_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LEV_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_sw_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SW_SEL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SW_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_sw_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SW_SEL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SW_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_BIAS_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_BIAS_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_lpf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LPF_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LPF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_lpf_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LPF_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_LPF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_adcsw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_ADCSW_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_ADCSW_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_adcsw_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_ADCSW_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_ADCSW_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_sasw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SASW_EN_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SASW_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_sasw_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SASW_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SASW_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_dac_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_EN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_dac_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_EN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_saclk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SACLK_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SACLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_saclk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SACLK_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_SACLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_dac_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_IN_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_dac_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_IN_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_dac_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_1),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_CAL_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_dac_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_CAL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_sw_force_mode_da_cc_dac_gain_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_1),
				    (unsigned int)(val),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_GAIN_CAL_MASK),
				    (unsigned
				     int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_GAIN_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_sw_force_mode_da_cc_dac_gain_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_SW_FORCE_MODE_VAL_1),
				  (&val),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_GAIN_CAL_MASK),
				  (unsigned
				   int)(PMIC_REG_TYPE_C_SW_FORCE_MODE_DA_CC_DAC_GAIN_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_type_c_dac_cal_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_DAC_CALI_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TYPE_C_DAC_CAL_START_MASK),
				    (unsigned int)(PMIC_TYPE_C_DAC_CAL_START_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_type_c_dac_cal_start(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_DAC_CALI_CTRL),
				  (&val),
				  (unsigned int)(PMIC_TYPE_C_DAC_CAL_START_MASK),
				  (unsigned int)(PMIC_TYPE_C_DAC_CAL_START_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_dac_cal_stage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_CC_DAC_CALI_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DAC_CAL_STAGE_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DAC_CAL_STAGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_dac_cal_stage(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_CC_DAC_CALI_CTRL),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DAC_CAL_STAGE_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DAC_CAL_STAGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_dbg_port_sel_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DEBUG_PORT_SELECT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_0_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_dbg_port_sel_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DEBUG_PORT_SELECT_0),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_0_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_dbg_port_sel_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DEBUG_PORT_SELECT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_1_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_dbg_port_sel_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DEBUG_PORT_SELECT_1),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_1_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DBG_PORT_SEL_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_reg_type_c_dbg_mod_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TYPE_C_DEBUG_MODE_SELECT),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_REG_TYPE_C_DBG_MOD_SEL_MASK),
				    (unsigned int)(PMIC_REG_TYPE_C_DBG_MOD_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_reg_type_c_dbg_mod_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TYPE_C_DEBUG_MODE_SELECT),
				  (&val),
				  (unsigned int)(PMIC_REG_TYPE_C_DBG_MOD_SEL_MASK),
				  (unsigned int)(PMIC_REG_TYPE_C_DBG_MOD_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_hwcid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_HWCID),
				  (&val),
				  (unsigned int)(PMIC_HWCID_MASK), (unsigned int)(PMIC_HWCID_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_swcid(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SWCID),
				  (&val),
				  (unsigned int)(PMIC_SWCID_MASK), (unsigned int)(PMIC_SWCID_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_srclken_in0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_srclken_in0_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN0_EN_MASK),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN0_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_srclken_in1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_srclken_in1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN1_EN_MASK),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_osc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_osc_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_OSC_SEL_MASK),
				  (unsigned int)(PMIC_RG_OSC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_srclken_in2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_srclken_in2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_MASK),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_srclken_in0_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN0_HW_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_srclken_in0_hw_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN0_HW_MODE_MASK),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN0_HW_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_srclken_in1_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN1_HW_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_srclken_in1_hw_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN1_HW_MODE_MASK),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN1_HW_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_osc_sel_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_SEL_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_OSC_SEL_HW_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_osc_sel_hw_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_OSC_SEL_HW_MODE_MASK),
				  (unsigned int)(PMIC_RG_OSC_SEL_HW_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_srclken_in_sync_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN_SYNC_EN_MASK),
				    (unsigned int)(PMIC_RG_SRCLKEN_IN_SYNC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_srclken_in_sync_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN_SYNC_EN_MASK),
				  (unsigned int)(PMIC_RG_SRCLKEN_IN_SYNC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_osc_en_auto_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_EN_AUTO_OFF_MASK),
				    (unsigned int)(PMIC_RG_OSC_EN_AUTO_OFF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_osc_en_auto_off(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_OSC_EN_AUTO_OFF_MASK),
				  (unsigned int)(PMIC_RG_OSC_EN_AUTO_OFF_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_test_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_OUT),
				  (&val),
				  (unsigned int)(PMIC_TEST_OUT_MASK),
				  (unsigned int)(PMIC_TEST_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_mon_flag_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_MON_FLAG_SEL_MASK),
				    (unsigned int)(PMIC_RG_MON_FLAG_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_mon_flag_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_MON_FLAG_SEL_MASK),
				  (unsigned int)(PMIC_RG_MON_FLAG_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_mon_grp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TEST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_MON_GRP_SEL_MASK),
				    (unsigned int)(PMIC_RG_MON_GRP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_mon_grp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_MON_GRP_SEL_MASK),
				  (unsigned int)(PMIC_RG_MON_GRP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nandtree_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NANDTREE_MODE_MASK),
				    (unsigned int)(PMIC_RG_NANDTREE_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nandtree_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_NANDTREE_MODE_MASK),
				  (unsigned int)(PMIC_RG_NANDTREE_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_test_auxadc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TEST_AUXADC_MASK),
				    (unsigned int)(PMIC_RG_TEST_AUXADC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_test_auxadc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_TEST_AUXADC_MASK),
				  (unsigned int)(PMIC_RG_TEST_AUXADC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_efuse_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EFUSE_MODE_MASK),
				    (unsigned int)(PMIC_RG_EFUSE_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_efuse_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_EFUSE_MODE_MASK),
				  (unsigned int)(PMIC_RG_EFUSE_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_test_strup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TEST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TEST_STRUP_MASK),
				    (unsigned int)(PMIC_RG_TEST_STRUP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_test_strup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TEST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_TEST_STRUP_MASK),
				  (unsigned int)(PMIC_RG_TEST_STRUP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_testmode_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TESTMODE_SW),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TESTMODE_SW_MASK),
				    (unsigned int)(PMIC_TESTMODE_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_testmode_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TESTMODE_SW),
				  (&val),
				  (unsigned int)(PMIC_TESTMODE_SW_MASK),
				  (unsigned int)(PMIC_TESTMODE_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vdram(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VDRAM_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VDRAM_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vsram_proc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VSRAM_PROC_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VSRAM_PROC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vaud28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VAUD28_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VAUD28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vaux18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VAUX18_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VAUX18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcamd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCAMD_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCAMD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vldo28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VLDO28_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VLDO28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcamio(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCAMIO_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCAMIO_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcama(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCAMA_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCAMA_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcn18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCN18_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCN18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcn28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCN28_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCN28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcn33(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCN33_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCN33_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vrf12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VRF12_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VRF12_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vrf18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VRF18_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VRF18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vxo22(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VXO22_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VXO22_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vtcxo24(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VTCXO24_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VTCXO24_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vtcxo28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VTCXO28_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VTCXO28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vs1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VS1_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VS1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vcore(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VCORE_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VCORE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vproc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VPROC_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VPROC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vpa(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VPA_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VPA_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vrtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VRTC_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VRTC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_tref(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_TREF_MASK),
				  (unsigned int)(PMIC_EN_STATUS_TREF_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vibr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VIBR_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VIBR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vio18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VIO18_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VIO18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vemc33(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VEMC33_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VEMC33_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vusb33(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VUSB33_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VUSB33_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vmch(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VMCH_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VMCH_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vmc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VMC_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VMC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vio28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VIO28_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VIO28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vsim2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VSIM2_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VSIM2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_en_status_vsim1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EN_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_EN_STATUS_VSIM1_MASK),
				  (unsigned int)(PMIC_EN_STATUS_VSIM1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vdram(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VDRAM_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VDRAM_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vsram_proc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VSRAM_PROC_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VSRAM_PROC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vaud28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VAUD28_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VAUD28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vaux18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VAUX18_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VAUX18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcamd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCAMD_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCAMD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vldo28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VLDO28_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VLDO28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcamio(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCAMIO_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCAMIO_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcama(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCAMA_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCAMA_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcn18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCN18_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCN18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcn28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCN28_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCN28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcn33(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCN33_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCN33_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vrf12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VRF12_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VRF12_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vrf18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VRF18_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VRF18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vxo22(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VXO22_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VXO22_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vtcxo24(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VTCXO24_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VTCXO24_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vtcxo28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS1),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VTCXO28_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VTCXO28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vs1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VS1_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VS1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vcore(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VCORE_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VCORE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vproc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VPROC_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VPROC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vpa(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VPA_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VPA_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_tref(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_TREF_MASK),
				  (unsigned int)(PMIC_OC_STATUS_TREF_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vibr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VIBR_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VIBR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vio18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VIO18_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VIO18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vemc33(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VEMC33_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VEMC33_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vusb33(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VUSB33_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VUSB33_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vmch(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VMCH_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VMCH_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vmc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VMC_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VMC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vio28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VIO28_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VIO28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vsim2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VSIM2_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VSIM2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_oc_status_vsim1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OCSTATUS2),
				  (&val),
				  (unsigned int)(PMIC_OC_STATUS_VSIM1_MASK),
				  (unsigned int)(PMIC_OC_STATUS_VSIM1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vcore2_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VCORE2_PG_DEB_MASK),
				  (unsigned int)(PMIC_VCORE2_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vs1_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VS1_PG_DEB_MASK),
				  (unsigned int)(PMIC_VS1_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vcore_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VCORE_PG_DEB_MASK),
				  (unsigned int)(PMIC_VCORE_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vproc_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VPROC_PG_DEB_MASK),
				  (unsigned int)(PMIC_VPROC_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vio18_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VIO18_PG_DEB_MASK),
				  (unsigned int)(PMIC_VIO18_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vemc33_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VEMC33_PG_DEB_MASK),
				  (unsigned int)(PMIC_VEMC33_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vusb33_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VUSB33_PG_DEB_MASK),
				  (unsigned int)(PMIC_VUSB33_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vmch_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VMCH_PG_DEB_MASK),
				  (unsigned int)(PMIC_VMCH_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vmc_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VMC_PG_DEB_MASK),
				  (unsigned int)(PMIC_VMC_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vio28_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VIO28_PG_DEB_MASK),
				  (unsigned int)(PMIC_VIO28_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vdram_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VDRAM_PG_DEB_MASK),
				  (unsigned int)(PMIC_VDRAM_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vsram_proc_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_PROC_PG_DEB_MASK),
				  (unsigned int)(PMIC_VSRAM_PROC_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vaud28_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VAUD28_PG_DEB_MASK),
				  (unsigned int)(PMIC_VAUD28_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vaux18_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VAUX18_PG_DEB_MASK),
				  (unsigned int)(PMIC_VAUX18_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vxo22_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VXO22_PG_DEB_MASK),
				  (unsigned int)(PMIC_VXO22_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vtcxo24_pg_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGDEBSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_VTCXO24_PG_DEB_MASK),
				  (unsigned int)(PMIC_VTCXO24_PG_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vmch_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VMCH_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VMCH_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vmc_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VMC_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VMC_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vxo22_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VXO22_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VXO22_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vtcxo24_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VTCXO24_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VTCXO24_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vusb33_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VUSB33_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VUSB33_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vsram_proc_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VSRAM_PROC_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VSRAM_PROC_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vproc_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VPROC_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VPROC_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vdram_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VDRAM_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VDRAM_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vaud28_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VAUD28_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VAUD28_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vio28_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VIO28_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VIO28_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vemc33_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VEMC33_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VEMC33_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vio18_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VIO18_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VIO18_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vs1_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VS1_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VS1_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vcore_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VCORE_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VCORE_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vaux18_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VAUX18_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VAUX18_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_vcore2_pg_status_gated(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_PGSTATUS0),
				  (&val),
				  (unsigned int)(PMIC_STRUP_VCORE2_PG_STATUS_GATED_MASK),
				  (unsigned int)(PMIC_STRUP_VCORE2_PG_STATUS_GATED_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_pmu_thermal_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_THERMALSTATUS),
				  (&val),
				  (unsigned int)(PMIC_PMU_THERMAL_DEB_MASK),
				  (unsigned int)(PMIC_PMU_THERMAL_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_strup_thermal_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_THERMALSTATUS),
				  (&val),
				  (unsigned int)(PMIC_STRUP_THERMAL_STATUS_MASK),
				  (unsigned int)(PMIC_STRUP_THERMAL_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_pmu_test_mode_scan(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_PMU_TEST_MODE_SCAN_MASK),
				  (unsigned int)(PMIC_PMU_TEST_MODE_SCAN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_pwrkey_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_PWRKEY_DEB_MASK),
				  (unsigned int)(PMIC_PWRKEY_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_homekey_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_HOMEKEY_DEB_MASK),
				  (unsigned int)(PMIC_HOMEKEY_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rtc_xtal_det_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_RTC_XTAL_DET_DONE_MASK),
				  (unsigned int)(PMIC_RTC_XTAL_DET_DONE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_xosc32_enb_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_XOSC32_ENB_DET_MASK),
				  (unsigned int)(PMIC_XOSC32_ENB_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rtc_xtal_det_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOPSTATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RTC_XTAL_DET_RSV_MASK),
				    (unsigned int)(PMIC_RTC_XTAL_DET_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rtc_xtal_det_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOPSTATUS),
				  (&val),
				  (unsigned int)(PMIC_RTC_XTAL_DET_RSV_MASK),
				  (unsigned int)(PMIC_RTC_XTAL_DET_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pmu_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_PMU_TDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pmu_tdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_PMU_TDSEL_MASK),
				  (unsigned int)(PMIC_RG_PMU_TDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spi_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_SPI_TDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spi_tdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SPI_TDSEL_MASK),
				  (unsigned int)(PMIC_RG_SPI_TDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aud_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUD_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_AUD_TDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aud_tdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_AUD_TDSEL_MASK),
				  (unsigned int)(PMIC_RG_AUD_TDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_e32cal_tdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_E32CAL_TDSEL_MASK),
				    (unsigned int)(PMIC_RG_E32CAL_TDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_e32cal_tdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_E32CAL_TDSEL_MASK),
				  (unsigned int)(PMIC_RG_E32CAL_TDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pmu_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PMU_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_PMU_RDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pmu_rdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_PMU_RDSEL_MASK),
				  (unsigned int)(PMIC_RG_PMU_RDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spi_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_SPI_RDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spi_rdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SPI_RDSEL_MASK),
				  (unsigned int)(PMIC_RG_SPI_RDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aud_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUD_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_AUD_RDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aud_rdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_AUD_RDSEL_MASK),
				  (unsigned int)(PMIC_RG_AUD_RDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_e32cal_rdsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RDSEL_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_E32CAL_RDSEL_MASK),
				    (unsigned int)(PMIC_RG_E32CAL_RDSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_e32cal_rdsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RDSEL_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_E32CAL_RDSEL_MASK),
				  (unsigned int)(PMIC_RG_E32CAL_RDSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_wdtrstb_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_WDTRSTB_IN_MASK),
				    (unsigned int)(PMIC_RG_SMT_WDTRSTB_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_wdtrstb_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_WDTRSTB_IN_MASK),
				  (unsigned int)(PMIC_RG_SMT_WDTRSTB_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_SMT_HOMEKEY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_homekey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_HOMEKEY_MASK),
				  (unsigned int)(PMIC_RG_SMT_HOMEKEY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_srclken_in0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN0_MASK),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_srclken_in0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN0_MASK),
				  (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_srclken_in1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN1_MASK),
				    (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_srclken_in1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN1_MASK),
				  (unsigned int)(PMIC_RG_SMT_SRCLKEN_IN1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_rtc_32k1v8_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_0_MASK),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_rtc_32k1v8_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_0_MASK),
				  (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_rtc_32k1v8_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_1_MASK),
				    (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_rtc_32k1v8_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_1_MASK),
				  (unsigned int)(PMIC_RG_SMT_RTC_32K1V8_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_spi_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_CLK_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_CLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_spi_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_SPI_CLK_MASK),
				  (unsigned int)(PMIC_RG_SMT_SPI_CLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_spi_csn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_CSN_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_CSN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_spi_csn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_SPI_CSN_MASK),
				  (unsigned int)(PMIC_RG_SMT_SPI_CSN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_spi_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_MOSI_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_MOSI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_spi_mosi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_SPI_MOSI_MASK),
				  (unsigned int)(PMIC_RG_SMT_SPI_MOSI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_spi_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_SPI_MISO_MASK),
				    (unsigned int)(PMIC_RG_SMT_SPI_MISO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_spi_miso(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_SPI_MISO_MASK),
				  (unsigned int)(PMIC_RG_SMT_SPI_MISO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_aud_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_AUD_CLK_MASK),
				    (unsigned int)(PMIC_RG_SMT_AUD_CLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_aud_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_AUD_CLK_MASK),
				  (unsigned int)(PMIC_RG_SMT_AUD_CLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_aud_dat_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_AUD_DAT_MOSI_MASK),
				    (unsigned int)(PMIC_RG_SMT_AUD_DAT_MOSI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_aud_dat_mosi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_AUD_DAT_MOSI_MASK),
				  (unsigned int)(PMIC_RG_SMT_AUD_DAT_MOSI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_aud_dat_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_AUD_DAT_MISO_MASK),
				    (unsigned int)(PMIC_RG_SMT_AUD_DAT_MISO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_aud_dat_miso(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_AUD_DAT_MISO_MASK),
				  (unsigned int)(PMIC_RG_SMT_AUD_DAT_MISO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_anc_dat_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_ANC_DAT_MOSI_MASK),
				    (unsigned int)(PMIC_RG_SMT_ANC_DAT_MOSI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_anc_dat_mosi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_ANC_DAT_MOSI_MASK),
				  (unsigned int)(PMIC_RG_SMT_ANC_DAT_MOSI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_vow_clk_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_VOW_CLK_MISO_MASK),
				    (unsigned int)(PMIC_RG_SMT_VOW_CLK_MISO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_vow_clk_miso(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_VOW_CLK_MISO_MASK),
				  (unsigned int)(PMIC_RG_SMT_VOW_CLK_MISO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_enbb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_ENBB_MASK),
				    (unsigned int)(PMIC_RG_SMT_ENBB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_enbb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_ENBB_MASK),
				  (unsigned int)(PMIC_RG_SMT_ENBB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smt_xosc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMT_XOSC_EN_MASK),
				    (unsigned int)(PMIC_RG_SMT_XOSC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smt_xosc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SMT_XOSC_EN_MASK),
				  (unsigned int)(PMIC_RG_SMT_XOSC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_srclken_in0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN0_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_srclken_in0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN0_MASK),
				  (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_srclken_in1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN1_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_srclken_in1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN1_MASK),
				  (unsigned int)(PMIC_RG_OCTL_SRCLKEN_IN1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_rtc_32k1v8_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_0_MASK),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_rtc_32k1v8_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_0_MASK),
				  (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_rtc_32k1v8_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_1_MASK),
				    (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_rtc_32k1v8_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_1_MASK),
				  (unsigned int)(PMIC_RG_OCTL_RTC_32K1V8_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_spi_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CLK_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_spi_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_SPI_CLK_MASK),
				  (unsigned int)(PMIC_RG_OCTL_SPI_CLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_spi_csn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CSN_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_CSN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_spi_csn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_SPI_CSN_MASK),
				  (unsigned int)(PMIC_RG_OCTL_SPI_CSN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_spi_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MOSI_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MOSI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_spi_mosi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_SPI_MOSI_MASK),
				  (unsigned int)(PMIC_RG_OCTL_SPI_MOSI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_spi_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MISO_MASK),
				    (unsigned int)(PMIC_RG_OCTL_SPI_MISO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_spi_miso(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_SPI_MISO_MASK),
				  (unsigned int)(PMIC_RG_OCTL_SPI_MISO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_aud_dat_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MOSI_MASK),
				    (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MOSI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_aud_dat_mosi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MOSI_MASK),
				  (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MOSI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_aud_dat_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MISO_MASK),
				    (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MISO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_aud_dat_miso(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MISO_MASK),
				  (unsigned int)(PMIC_RG_OCTL_AUD_DAT_MISO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_aud_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_AUD_CLK_MASK),
				    (unsigned int)(PMIC_RG_OCTL_AUD_CLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_aud_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_AUD_CLK_MASK),
				  (unsigned int)(PMIC_RG_OCTL_AUD_CLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_anc_dat_mosi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_ANC_DAT_MOSI_MASK),
				    (unsigned int)(PMIC_RG_OCTL_ANC_DAT_MOSI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_anc_dat_mosi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_ANC_DAT_MOSI_MASK),
				  (unsigned int)(PMIC_RG_OCTL_ANC_DAT_MOSI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_OCTL_HOMEKEY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_homekey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_HOMEKEY_MASK),
				  (unsigned int)(PMIC_RG_OCTL_HOMEKEY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_enbb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_ENBB_MASK),
				    (unsigned int)(PMIC_RG_OCTL_ENBB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_enbb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_ENBB_MASK),
				  (unsigned int)(PMIC_RG_OCTL_ENBB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_xosc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_XOSC_EN_MASK),
				    (unsigned int)(PMIC_RG_OCTL_XOSC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_xosc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_XOSC_EN_MASK),
				  (unsigned int)(PMIC_RG_OCTL_XOSC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_octl_vow_clk_miso(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DRV_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OCTL_VOW_CLK_MISO_MASK),
				    (unsigned int)(PMIC_RG_OCTL_VOW_CLK_MISO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_octl_vow_clk_miso(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DRV_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_OCTL_VOW_CLK_MISO_MASK),
				  (unsigned int)(PMIC_RG_OCTL_VOW_CLK_MISO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_STATUS_MASK),
				    (unsigned int)(PMIC_TOP_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_STATUS),
				  (&val),
				  (unsigned int)(PMIC_TOP_STATUS_MASK),
				  (unsigned int)(PMIC_TOP_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rsv_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RSV_CON0_RSV_MASK),
				    (unsigned int)(PMIC_CLK_RSV_CON0_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rsv_con0_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_RSV_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RSV_CON0_RSV_MASK),
				  (unsigned int)(PMIC_CLK_RSV_CON0_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dcxo_pwrkey_rstb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DCXO_PWRKEY_RSTB_SEL_MASK),
				    (unsigned int)(PMIC_RG_DCXO_PWRKEY_RSTB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dcxo_pwrkey_rstb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_RSV_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_DCXO_PWRKEY_RSTB_SEL_MASK),
				  (unsigned int)(PMIC_RG_DCXO_PWRKEY_RSTB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_srcvolten_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SRCVOLTEN_SW_MASK),
				    (unsigned int)(PMIC_CLK_SRCVOLTEN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_srcvolten_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SRCVOLTEN_SW_MASK),
				  (unsigned int)(PMIC_CLK_SRCVOLTEN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_vowen_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_VOWEN_SW_MASK),
				    (unsigned int)(PMIC_CLK_VOWEN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_vowen_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_VOWEN_SW_MASK),
				  (unsigned int)(PMIC_CLK_VOWEN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_srcvolten_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SRCVOLTEN_MODE_MASK),
				    (unsigned int)(PMIC_CLK_SRCVOLTEN_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_srcvolten_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SRCVOLTEN_MODE_MASK),
				  (unsigned int)(PMIC_CLK_SRCVOLTEN_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_vowen_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_VOWEN_MODE_MASK),
				    (unsigned int)(PMIC_CLK_VOWEN_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_vowen_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_VOWEN_MODE_MASK),
				  (unsigned int)(PMIC_CLK_VOWEN_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_top_cksel_con2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TOP_CKSEL_CON2_RSV_MASK),
				    (unsigned int)(PMIC_RG_TOP_CKSEL_CON2_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_top_cksel_con2_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_TOP_CKSEL_CON2_RSV_MASK),
				  (unsigned int)(PMIC_RG_TOP_CKSEL_CON2_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_CON0_RSV_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_CON0_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_con0_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_CON0_RSV_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_CON0_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore2_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore2_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vproc_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vproc_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vpa_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vpa_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vs1_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vs1_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ldo_vsram_proc_osc_sel_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_SW_MASK),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ldo_vsram_proc_osc_sel_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_SW_MASK),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore2_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore2_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vproc_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vproc_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vpa_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vpa_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vs1_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vs1_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ldo_vsram_proc_osc_sel_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_MODE_MASK),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ldo_vsram_proc_osc_sel_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_MODE_MASK),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_OSC_SEL_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_CON1_RSV_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_CON1_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_con1_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_BUCK_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_CON1_RSV_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_CON1_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aud(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUD_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aud(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUD_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_fqr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_FQR_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_FQR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_fqr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_FQR_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_FQR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aux_ap(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aux_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aux_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aux_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aux_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_GPS_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_GPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aux_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_GPS_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_GPS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aux_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_RSV_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aux_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_RSV_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aux_ap_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MODE_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aux_ap_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MODE_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_AP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_en_aux_md_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MODE_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_en_aux_md_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MODE_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_EN_AUX_MD_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_in_sel_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_in_sel_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_in_sel_va18_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SWCTRL_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_in_sel_va18_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SWCTRL_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_IN_SEL_VA18_SWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_clksq_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CLKSQ_RSV_MASK),
				    (unsigned int)(PMIC_TOP_CLKSQ_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_clksq_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_TOP_CLKSQ_RSV_MASK),
				  (unsigned int)(PMIC_TOP_CLKSQ_RSV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_clksq_en_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ),
				  (&val),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VA28_MASK),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_rtc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_rtc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clksq_rtc_en_hw_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_HW_MODE_MASK),
				    (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_HW_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clksq_rtc_en_hw_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_HW_MODE_MASK),
				  (unsigned int)(PMIC_RG_CLKSQ_RTC_EN_HW_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_clksq_rtc_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV0_MASK),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_clksq_rtc_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV0_MASK),
				  (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_enbb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ENBB_SEL_MASK),
				    (unsigned int)(PMIC_RG_ENBB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_enbb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_RG_ENBB_SEL_MASK),
				  (unsigned int)(PMIC_RG_ENBB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xosc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XOSC_EN_SEL_MASK),
				    (unsigned int)(PMIC_RG_XOSC_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xosc_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_RG_XOSC_EN_SEL_MASK),
				  (unsigned int)(PMIC_RG_XOSC_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_clksq_rtc_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV1_MASK),
				    (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_clksq_rtc_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV1_MASK),
				  (unsigned int)(PMIC_TOP_CLKSQ_RTC_RSV1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_clksq_en_vdig18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLKSQ_RTC),
				  (&val),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VDIG18_MASK),
				  (unsigned int)(PMIC_DA_CLKSQ_EN_VDIG18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_osc_75k_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_OSC_75K_TRIM_MASK),
				    (unsigned int)(PMIC_OSC_75K_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_osc_75k_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				  (&val),
				  (unsigned int)(PMIC_OSC_75K_TRIM_MASK),
				  (unsigned int)(PMIC_OSC_75K_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_osc_75k_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_osc_75k_trim_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				  (&val),
				  (unsigned int)(PMIC_RG_OSC_75K_TRIM_EN_MASK),
				  (unsigned int)(PMIC_RG_OSC_75K_TRIM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_osc_75k_trim_rate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_RATE_MASK),
				    (unsigned int)(PMIC_RG_OSC_75K_TRIM_RATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_osc_75k_trim_rate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				  (&val),
				  (unsigned int)(PMIC_RG_OSC_75K_TRIM_RATE_MASK),
				  (unsigned int)(PMIC_RG_OSC_75K_TRIM_RATE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_osc_75k_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_CLK_TRIM),
				  (&val),
				  (unsigned int)(PMIC_DA_OSC_75K_TRIM_MASK),
				  (unsigned int)(PMIC_DA_OSC_75K_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pmu75k_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PMU75K_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_PMU75K_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pmu75k_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_PMU75K_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_PMU75K_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_smps_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SMPS_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_SMPS_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_smps_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SMPS_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_SMPS_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_aud26m_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUD26M_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_AUD26M_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_aud26m_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUD26M_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_AUD26M_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_vow12m_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_VOW12M_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_VOW12M_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_vow12m_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_VOW12M_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_VOW12M_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc32k_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC32K_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_RTC32K_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc32k_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC32K_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_RTC32K_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc26m_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC26M_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_RTC26M_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc26m_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC26M_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_RTC26M_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fg_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FG_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_FG_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fg_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_FG_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_FG_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spk_ck_tst_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPK_CK_TST_DIS_MASK),
				    (unsigned int)(PMIC_CLK_SPK_CK_TST_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spk_ck_tst_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPK_CK_TST_DIS_MASK),
				  (unsigned int)(PMIC_CLK_SPK_CK_TST_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ckroottst_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_CKROOTTST_CON0_RSV_MASK),
				    (unsigned int)(PMIC_CLK_CKROOTTST_CON0_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ckroottst_con0_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_CKROOTTST_CON0_RSV_MASK),
				  (unsigned int)(PMIC_CLK_CKROOTTST_CON0_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_ana_auto_off_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_ANA_AUTO_OFF_DIS_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_ANA_AUTO_OFF_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_ana_auto_off_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_ANA_AUTO_OFF_DIS_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_ANA_AUTO_OFF_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pmu75k_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PMU75K_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_PMU75K_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pmu75k_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_PMU75K_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_PMU75K_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_smps_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SMPS_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_SMPS_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_smps_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_SMPS_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_SMPS_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_aud26m_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUD26M_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUD26M_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_aud26m_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUD26M_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUD26M_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_vow12m_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_VOW12M_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_VOW12M_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_vow12m_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_VOW12M_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_VOW12M_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc32k_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC32K_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_RTC32K_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc32k_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC32K_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_RTC32K_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc26m_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC26M_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_RTC26M_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc26m_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC26M_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_RTC26M_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fg_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FG_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_FG_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fg_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_FG_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_FG_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spk_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPK_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_SPK_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spk_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPK_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_SPK_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ckroottst_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_CKROOTTST_CON1_RSV_MASK),
				    (unsigned int)(PMIC_CLK_CKROOTTST_CON1_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ckroottst_con1_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKROOTTST_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_CKROOTTST_CON1_RSV_MASK),
				  (unsigned int)(PMIC_CLK_CKROOTTST_CON1_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc32k_1v8_0_o_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC32K_1V8_0_O_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC32K_1V8_0_O_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc32k_1v8_0_o_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC32K_1V8_0_O_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC32K_1V8_0_O_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc32k_1v8_1_o_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC32K_1V8_1_O_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC32K_1V8_1_O_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc32k_1v8_1_o_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC32K_1V8_1_O_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC32K_1V8_1_O_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_2sec_off_det_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_2SEC_OFF_DET_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_2SEC_OFF_DET_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_2sec_off_det_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_2SEC_OFF_DET_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_2SEC_OFF_DET_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pdn_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PDN_CON0_RSV_MASK),
				    (unsigned int)(PMIC_CLK_PDN_CON0_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pdn_con0_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_PDN_CON0_RSV_MASK),
				  (unsigned int)(PMIC_CLK_PDN_CON0_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_zcd13m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_ZCD13M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_ZCD13M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_zcd13m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_ZCD13M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_ZCD13M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_smps_ck_div_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SMPS_CK_DIV_PDN_MASK),
				    (unsigned int)(PMIC_CLK_SMPS_CK_DIV_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_smps_ck_div_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_SMPS_CK_DIV_PDN_MASK),
				  (unsigned int)(PMIC_CLK_SMPS_CK_DIV_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_ana_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_ANA_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_ANA_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_ana_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_ANA_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_ANA_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pdn_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PDN_CON1_RSV_MASK),
				    (unsigned int)(PMIC_CLK_PDN_CON1_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pdn_con1_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_PDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_PDN_CON1_RSV_MASK),
				  (unsigned int)(PMIC_CLK_PDN_CON1_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_osc_sel_hw_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_OSC_SEL_HW_SRC_SEL_MASK),
				    (unsigned int)(PMIC_CLK_OSC_SEL_HW_SRC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_osc_sel_hw_src_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_OSC_SEL_HW_SRC_SEL_MASK),
				  (unsigned int)(PMIC_CLK_OSC_SEL_HW_SRC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_srclken_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SRCLKEN_SRC_SEL_MASK),
				    (unsigned int)(PMIC_CLK_SRCLKEN_SRC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_srclken_src_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SRCLKEN_SRC_SEL_MASK),
				  (unsigned int)(PMIC_CLK_SRCLKEN_SRC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_sel_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SEL_CON0_RSV_MASK),
				    (unsigned int)(PMIC_CLK_SEL_CON0_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_sel_con0_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SEL_CON0_RSV_MASK),
				  (unsigned int)(PMIC_CLK_SEL_CON0_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_ck_cksel_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_ck_cksel_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_75k_32k_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_75K_32K_SEL_MASK),
				    (unsigned int)(PMIC_CLK_75K_32K_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_75k_32k_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_75K_32K_SEL_MASK),
				  (unsigned int)(PMIC_CLK_75K_32K_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_sel_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SEL_CON1_RSV_MASK),
				    (unsigned int)(PMIC_CLK_SEL_CON1_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_sel_con1_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_SEL_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_SEL_CON1_RSV_MASK),
				  (unsigned int)(PMIC_CLK_SEL_CON1_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_g_smps_pd_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_g_smps_pd_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_g_smps_aud_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_g_smps_aud_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_g_smps_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_G_SMPS_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_G_SMPS_TEST_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_g_smps_test_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_G_SMPS_TEST_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_G_SMPS_TEST_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_accdet_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_ACCDET_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_ACCDET_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_accdet_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_ACCDET_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_ACCDET_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_audif_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUDIF_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUDIF_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_audif_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUDIF_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUDIF_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_aud_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUD_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUD_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_aud_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUD_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUD_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_audncp_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUDNCP_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUDNCP_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_audncp_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUDNCP_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUDNCP_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_1M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_1m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_1M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_1M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_smps_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_smps_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_rng_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_RNG_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_RNG_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_rng_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_RNG_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_RNG_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_26m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_26m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_isink0_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_ISINK0_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_DRV_ISINK0_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_isink0_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_ISINK0_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_DRV_ISINK0_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_isink1_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_ISINK1_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_DRV_ISINK1_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_isink1_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_ISINK1_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_DRV_ISINK1_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_isink2_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_ISINK2_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_DRV_ISINK2_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_isink2_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_ISINK2_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_DRV_ISINK2_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_isink3_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_ISINK3_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_DRV_ISINK3_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_isink3_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_ISINK3_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_DRV_ISINK3_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_chrind_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_chrind_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_DRV_32K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_32k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_32K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_DRV_32K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_1m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_32K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_32k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_32K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_32K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pwmoc_6m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PWMOC_6M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_PWMOC_6M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pwmoc_6m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_PWMOC_6M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_PWMOC_6M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vproc_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vproc_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore2_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore2_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vpa_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vpa_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vs1_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vs1_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fqmtr_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FQMTR_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_FQMTR_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fqmtr_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_FQMTR_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_FQMTR_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fqmtr_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FQMTR_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_FQMTR_32K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fqmtr_32k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_FQMTR_32K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_FQMTR_32K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_intrp_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_INTRP_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_INTRP_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_intrp_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_INTRP_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_INTRP_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_intrp_pre_oc_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_INTRP_PRE_OC_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_INTRP_PRE_OC_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_intrp_pre_oc_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_INTRP_PRE_OC_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_INTRP_PRE_OC_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_stb_1m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_stb_1m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON1),
				  (&val),
				  (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ldo_cali_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_LDO_CALI_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_LDO_CALI_75K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ldo_cali_75k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_LDO_CALI_75K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_LDO_CALI_75K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ldo_vsram_proc_9m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ldo_vsram_proc_9m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_26m_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_26m_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_32K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_32k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_32K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_32K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_mclk_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_MCLK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_MCLK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_mclk_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_MCLK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_MCLK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_75K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_75k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_75K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_75K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtcdet_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTCDET_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTCDET_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtcdet_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTCDET_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTCDET_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_eosc32_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_eosc32_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_eosc_cali_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_eosc_cali_test_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fgadc_ana_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FGADC_ANA_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_FGADC_ANA_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fgadc_ana_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_FGADC_ANA_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_FGADC_ANA_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fgadc_dig_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FGADC_DIG_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_FGADC_DIG_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fgadc_dig_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_FGADC_DIG_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_FGADC_DIG_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fgadc_ft_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FGADC_FT_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_FGADC_FT_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fgadc_ft_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_FGADC_FT_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_FGADC_FT_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_trim_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_TRIM_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_TRIM_75K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_trim_75k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_TRIM_75K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_TRIM_75K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_efuse_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_efuse_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_strup_75k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_STRUP_75K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_STRUP_75K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_strup_75k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_STRUP_75K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_STRUP_75K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_strup_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_STRUP_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_STRUP_32K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_strup_32k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON2),
				  (&val),
				  (unsigned int)(PMIC_CLK_STRUP_32K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_STRUP_32K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pchr_32k_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PCHR_32K_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_PCHR_32K_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pchr_32k_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_PCHR_32K_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_PCHR_32K_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pchr_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PCHR_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_PCHR_TEST_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pchr_test_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_PCHR_TEST_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_PCHR_TEST_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spi_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPI_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_SPI_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spi_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPI_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_SPI_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_bgr_test_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BGR_TEST_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_BGR_TEST_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_bgr_test_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_BGR_TEST_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_BGR_TEST_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_type_c_cc_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_TYPE_C_CC_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_TYPE_C_CC_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_type_c_cc_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_TYPE_C_CC_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_TYPE_C_CC_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_type_c_csr_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_TYPE_C_CSR_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_TYPE_C_CSR_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_type_c_csr_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_TYPE_C_CSR_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_TYPE_C_CSR_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spk_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPK_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_SPK_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spk_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPK_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_SPK_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spk_pwm_ck_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPK_PWM_CK_PDN_MASK),
				    (unsigned int)(PMIC_CLK_SPK_PWM_CK_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spk_pwm_ck_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPK_PWM_CK_PDN_MASK),
				  (unsigned int)(PMIC_CLK_SPK_PWM_CK_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rsv_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RSV_PDN_MASK),
				    (unsigned int)(PMIC_CLK_RSV_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rsv_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_CON3),
				  (&val),
				  (unsigned int)(PMIC_CLK_RSV_PDN_MASK),
				  (unsigned int)(PMIC_CLK_RSV_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_g_smps_pd_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_g_smps_pd_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_G_SMPS_PD_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_g_smps_aud_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_g_smps_aud_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_G_SMPS_AUD_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_smps_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_smps_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_26m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_26m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_1m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_1m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_1M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vproc_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vproc_9m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPROC_9M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore_9m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE_9M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vcore2_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vcore2_9m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VCORE2_9M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vpa_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vpa_9m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VPA_9M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_vs1_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_vs1_9m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_VS1_9M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_stb_1m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_stb_1m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_STB_1M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_ldo_vsram_proc_9m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_ldo_vsram_proc_9m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_LDO_VSRAM_PROC_9M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_26m_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_26m_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_RTC_26M_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rsv_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RSV_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_RSV_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rsv_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKPDN_HWEN_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RSV_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_RSV_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_audif_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUDIF_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUDIF_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_audif_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUDIF_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUDIF_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_aud_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUD_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUD_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_aud_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUD_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUD_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fqmtr_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FQMTR_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_FQMTR_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fqmtr_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_FQMTR_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_FQMTR_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fgadc_ana_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FGADC_ANA_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_FGADC_ANA_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fgadc_ana_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_FGADC_ANA_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_FGADC_ANA_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pchr_test_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PCHR_TEST_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_PCHR_TEST_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pchr_test_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_PCHR_TEST_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_PCHR_TEST_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_bgr_test_ck_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BGR_TEST_CK_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_BGR_TEST_CK_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_bgr_test_ck_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BGR_TEST_CK_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_BGR_TEST_CK_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_efuse_ck_pdn_hwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_HWEN_MASK),
				    (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_HWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_efuse_ck_pdn_hwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_HWEN_MASK),
				  (unsigned int)(PMIC_CLK_EFUSE_CK_PDN_HWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rsv_cksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RSV_CKSEL_MASK),
				    (unsigned int)(PMIC_CLK_RSV_CKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rsv_cksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RSV_CKSEL_MASK),
				  (unsigned int)(PMIC_CLK_RSV_CKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_smps_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_smps_ck_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_26m_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_26m_ck_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_buck_9m_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BUCK_9M_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_BUCK_9M_CK_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_buck_9m_ck_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BUCK_9M_CK_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_BUCK_9M_CK_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_reg_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_REG_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_REG_CK_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_reg_ck_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_REG_CK_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_REG_CK_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spk_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPK_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_SPK_CK_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spk_ck_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPK_CK_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_SPK_CK_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_spk_pwm_ck_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_SPK_PWM_CK_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_SPK_PWM_CK_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_spk_pwm_ck_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_SPK_PWM_CK_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_SPK_PWM_CK_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rsv_divsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RSV_DIVSEL_MASK),
				    (unsigned int)(PMIC_CLK_RSV_DIVSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rsv_divsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKDIVSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RSV_DIVSEL_MASK),
				  (unsigned int)(PMIC_CLK_RSV_DIVSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_audif_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUDIF_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUDIF_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_audif_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUDIF_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUDIF_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_aud_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUD_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUD_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_aud_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUD_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUD_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_smps_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_smps_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_SMPS_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_26m_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_26M_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_26m_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_26M_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_auxadc_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_AUXADC_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_auxadc_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_AUXADC_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_drv_chrind_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_drv_chrind_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_DRV_CHRIND_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fqmtr_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FQMTR_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_FQMTR_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fqmtr_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_FQMTR_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_FQMTR_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtcdet_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTCDET_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_RTCDET_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtcdet_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTCDET_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_RTCDET_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rtc_eosc32_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rtc_eosc32_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_RTC_EOSC32_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_eosc_cali_test_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_eosc_cali_test_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_EOSC_CALI_TEST_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_fgadc_ana_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_FGADC_ANA_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_FGADC_ANA_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_fgadc_ana_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_FGADC_ANA_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_FGADC_ANA_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_pchr_test_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_PCHR_TEST_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_PCHR_TEST_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_pchr_test_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_PCHR_TEST_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_PCHR_TEST_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_bgr_test_ck_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_BGR_TEST_CK_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_BGR_TEST_CK_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_bgr_test_ck_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_BGR_TEST_CK_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_BGR_TEST_CK_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_clk_rsv_tstsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CLK_RSV_TSTSEL_MASK),
				    (unsigned int)(PMIC_CLK_RSV_TSTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_clk_rsv_tstsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CLK_CKTSTSEL_CON0),
				  (&val),
				  (unsigned int)(PMIC_CLK_RSV_TSTSEL_MASK),
				  (unsigned int)(PMIC_CLK_RSV_TSTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_efuse_man_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EFUSE_MAN_RST_MASK),
				    (unsigned int)(PMIC_RG_EFUSE_MAN_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_efuse_man_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_EFUSE_MAN_RST_MASK),
				  (unsigned int)(PMIC_RG_EFUSE_MAN_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auxadc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_RST_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auxadc_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUXADC_RST_MASK),
				  (unsigned int)(PMIC_RG_AUXADC_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auxadc_reg_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_REG_RST_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_REG_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auxadc_reg_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUXADC_REG_RST_MASK),
				  (unsigned int)(PMIC_RG_AUXADC_REG_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audio_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIO_RST_MASK),
				    (unsigned int)(PMIC_RG_AUDIO_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audio_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIO_RST_MASK),
				  (unsigned int)(PMIC_RG_AUDIO_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_accdet_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ACCDET_RST_MASK),
				    (unsigned int)(PMIC_RG_ACCDET_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_accdet_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_ACCDET_RST_MASK),
				  (unsigned int)(PMIC_RG_ACCDET_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bif_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BIF_RST_MASK),
				    (unsigned int)(PMIC_RG_BIF_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bif_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BIF_RST_MASK),
				  (unsigned int)(PMIC_RG_BIF_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_driver_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DRIVER_RST_MASK),
				    (unsigned int)(PMIC_RG_DRIVER_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_driver_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_DRIVER_RST_MASK),
				  (unsigned int)(PMIC_RG_DRIVER_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fgadc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGADC_RST_MASK),
				    (unsigned int)(PMIC_RG_FGADC_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fgadc_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_FGADC_RST_MASK),
				  (unsigned int)(PMIC_RG_FGADC_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fqmtr_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FQMTR_RST_MASK),
				    (unsigned int)(PMIC_RG_FQMTR_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fqmtr_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_FQMTR_RST_MASK),
				  (unsigned int)(PMIC_RG_FQMTR_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rtc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RTC_RST_MASK),
				    (unsigned int)(PMIC_RG_RTC_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rtc_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_RTC_RST_MASK),
				  (unsigned int)(PMIC_RG_RTC_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_type_c_cc_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TYPE_C_CC_RST_MASK),
				    (unsigned int)(PMIC_RG_TYPE_C_CC_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_type_c_cc_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_TYPE_C_CC_RST_MASK),
				  (unsigned int)(PMIC_RG_TYPE_C_CC_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_RST_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_RST_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_zcd_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ZCD_RST_MASK),
				    (unsigned int)(PMIC_RG_ZCD_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_zcd_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_ZCD_RST_MASK),
				  (unsigned int)(PMIC_RG_ZCD_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audncp_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDNCP_RST_MASK),
				    (unsigned int)(PMIC_RG_AUDNCP_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audncp_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDNCP_RST_MASK),
				  (unsigned int)(PMIC_RG_AUDNCP_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_clk_trim_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CLK_TRIM_RST_MASK),
				    (unsigned int)(PMIC_RG_CLK_TRIM_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_clk_trim_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_CLK_TRIM_RST_MASK),
				  (unsigned int)(PMIC_RG_CLK_TRIM_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_buck_srclken_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_SRCLKEN_RST_MASK),
				    (unsigned int)(PMIC_RG_BUCK_SRCLKEN_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_buck_srclken_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_SRCLKEN_RST_MASK),
				  (unsigned int)(PMIC_RG_BUCK_SRCLKEN_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_strup_long_press_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RST_MASK),
				    (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_strup_long_press_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RST_MASK),
				  (unsigned int)(PMIC_RG_STRUP_LONG_PRESS_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_buck_prot_pmpp_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BUCK_PROT_PMPP_RST_MASK),
				    (unsigned int)(PMIC_RG_BUCK_PROT_PMPP_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_buck_prot_pmpp_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_BUCK_PROT_PMPP_RST_MASK),
				  (unsigned int)(PMIC_RG_BUCK_PROT_PMPP_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_RST_MASK),
				    (unsigned int)(PMIC_RG_SPK_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_RST_MASK),
				  (unsigned int)(PMIC_RG_SPK_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_rst_con1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_CON1_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_CON1_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_rst_con1_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON1),
				  (&val),
				  (unsigned int)(PMIC_TOP_RST_CON1_RSV_MASK),
				  (unsigned int)(PMIC_TOP_RST_CON1_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chr_ldo_det_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_MODE_MASK),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chr_ldo_det_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_CHR_LDO_DET_MODE_MASK),
				  (unsigned int)(PMIC_RG_CHR_LDO_DET_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chr_ldo_det_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_SW_MASK),
				    (unsigned int)(PMIC_RG_CHR_LDO_DET_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chr_ldo_det_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_CHR_LDO_DET_SW_MASK),
				  (unsigned int)(PMIC_RG_CHR_LDO_DET_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_flag_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_MODE_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_flag_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_FLAG_MODE_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_FLAG_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_flag_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_SW_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_flag_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_FLAG_SW_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_FLAG_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_rst_con2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_CON2_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_CON2_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_rst_con2_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_CON2),
				  (&val),
				  (unsigned int)(PMIC_TOP_RST_CON2_RSV_MASK),
				  (unsigned int)(PMIC_TOP_RST_CON2_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_wdtrstb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_EN_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_wdtrstb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_WDTRSTB_EN_MASK),
				  (unsigned int)(PMIC_RG_WDTRSTB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_wdtrstb_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_MODE_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_wdtrstb_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_WDTRSTB_MODE_MASK),
				  (unsigned int)(PMIC_RG_WDTRSTB_MODE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_wdtrstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_WDTRSTB_STATUS_MASK),
				  (unsigned int)(PMIC_WDTRSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_wdtrstb_status_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_WDTRSTB_STATUS_CLR_MASK),
				    (unsigned int)(PMIC_WDTRSTB_STATUS_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_wdtrstb_status_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_WDTRSTB_STATUS_CLR_MASK),
				  (unsigned int)(PMIC_WDTRSTB_STATUS_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_wdtrstb_fb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_FB_EN_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_FB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_wdtrstb_fb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_WDTRSTB_FB_EN_MASK),
				  (unsigned int)(PMIC_RG_WDTRSTB_FB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_wdtrstb_deb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_WDTRSTB_DEB_MASK),
				    (unsigned int)(PMIC_RG_WDTRSTB_DEB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_wdtrstb_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_WDTRSTB_DEB_MASK),
				  (unsigned int)(PMIC_RG_WDTRSTB_DEB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_homekey_rst_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HOMEKEY_RST_EN_MASK),
				    (unsigned int)(PMIC_RG_HOMEKEY_RST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_homekey_rst_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_HOMEKEY_RST_EN_MASK),
				  (unsigned int)(PMIC_RG_HOMEKEY_RST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pwrkey_rst_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_EN_MASK),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pwrkey_rst_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_PWRKEY_RST_EN_MASK),
				  (unsigned int)(PMIC_RG_PWRKEY_RST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pwrrst_tmr_dis(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRRST_TMR_DIS_MASK),
				    (unsigned int)(PMIC_RG_PWRRST_TMR_DIS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pwrrst_tmr_dis(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_PWRRST_TMR_DIS_MASK),
				  (unsigned int)(PMIC_RG_PWRRST_TMR_DIS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pwrkey_rst_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_TD_MASK),
				    (unsigned int)(PMIC_RG_PWRKEY_RST_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pwrkey_rst_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_RG_PWRKEY_RST_TD_MASK),
				  (unsigned int)(PMIC_RG_PWRKEY_RST_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_rst_misc_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_MISC),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_MISC_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_MISC_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_rst_misc_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_MISC),
				  (&val),
				  (unsigned int)(PMIC_TOP_RST_MISC_RSV_MASK),
				  (unsigned int)(PMIC_TOP_RST_MISC_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_vpwrin_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VPWRIN_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_VPWRIN_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_vpwrin_rstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_VPWRIN_RSTB_STATUS_MASK),
				  (unsigned int)(PMIC_VPWRIN_RSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ddlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DDLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_DDLO_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ddlo_rstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_DDLO_RSTB_STATUS_MASK),
				  (unsigned int)(PMIC_DDLO_RSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_uvlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_UVLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_UVLO_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_uvlo_rstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_UVLO_RSTB_STATUS_MASK),
				  (unsigned int)(PMIC_UVLO_RSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rtc_ddlo_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RTC_DDLO_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_RTC_DDLO_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rtc_ddlo_rstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_RTC_DDLO_RSTB_STATUS_MASK),
				  (unsigned int)(PMIC_RTC_DDLO_RSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrwdt_reg_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRWDT_REG_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_CHRWDT_REG_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrwdt_reg_rstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_CHRWDT_REG_RSTB_STATUS_MASK),
				  (unsigned int)(PMIC_CHRWDT_REG_RSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrdet_reg_rstb_status(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRDET_REG_RSTB_STATUS_MASK),
				    (unsigned int)(PMIC_CHRDET_REG_RSTB_STATUS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrdet_reg_rstb_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_CHRDET_REG_RSTB_STATUS_MASK),
				  (unsigned int)(PMIC_CHRDET_REG_RSTB_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_rst_status_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_STATUS_RSV_MASK),
				    (unsigned int)(PMIC_TOP_RST_STATUS_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_rst_status_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_STATUS),
				  (&val),
				  (unsigned int)(PMIC_TOP_RST_STATUS_RSV_MASK),
				  (unsigned int)(PMIC_TOP_RST_STATUS_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_rst_rsv_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON0_MASK),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_rst_rsv_con0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_RSV_CON0),
				  (&val),
				  (unsigned int)(PMIC_TOP_RST_RSV_CON0_MASK),
				  (unsigned int)(PMIC_TOP_RST_RSV_CON0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_top_rst_rsv_con1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_TOP_RST_RSV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON1_MASK),
				    (unsigned int)(PMIC_TOP_RST_RSV_CON1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_top_rst_rsv_con1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_TOP_RST_RSV_CON1),
				  (&val),
				  (unsigned int)(PMIC_TOP_RST_RSV_CON1_MASK),
				  (unsigned int)(PMIC_TOP_RST_RSV_CON1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_pwrkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_pwrkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_PWRKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_PWRKEY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_homekey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_homekey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_pwrkey_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_R_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_PWRKEY_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_pwrkey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_PWRKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_PWRKEY_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_homekey_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_R_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_homekey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_HOMEKEY_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_thr_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_THR_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_THR_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_thr_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_THR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_THR_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_thr_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_THR_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_THR_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_thr_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_THR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_THR_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_bat_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_bat_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_BAT_H_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_BAT_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_bat_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BAT_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_bat_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_BAT_L_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_BAT_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_rtc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_RTC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_RTC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_rtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_RTC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_RTC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_audio(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_AUDIO_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_AUDIO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_audio(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_AUDIO_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_AUDIO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_accdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_ACCDET_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_ACCDET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_accdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_ACCDET_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_ACCDET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_accdet_eint(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_ACCDET_EINT_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_ACCDET_EINT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_accdet_eint(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_ACCDET_EINT_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_ACCDET_EINT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_accdet_negv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_ACCDET_NEGV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_ACCDET_NEGV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_accdet_negv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_ACCDET_NEGV_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_ACCDET_NEGV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_ni_lbat_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_NI_LBAT_INT_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_NI_LBAT_INT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_ni_lbat_int(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_NI_LBAT_INT_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_NI_LBAT_INT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_vcore_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VCORE_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VCORE_OC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_vcore_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_VCORE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_VCORE_OC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_vproc_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VPROC_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VPROC_OC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_vproc_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_VPROC_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_VPROC_OC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_vs1_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VS1_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VS1_OC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_vs1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_VS1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_VS1_OC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_vpa_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VPA_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VPA_OC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_vpa_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_VPA_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_VPA_OC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_spkl_d(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_SPKL_D_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_SPKL_D_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_spkl_d(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_SPKL_D_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_SPKL_D_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_spkl_ab(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_SPKL_AB_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_SPKL_AB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_spkl_ab(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_SPKL_AB_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_SPKL_AB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_ldo_oc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_LDO_OC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_LDO_OC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_ldo_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_LDO_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_LDO_OC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_type_c_l_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MIN_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_type_c_l_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MIN_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_type_c_l_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MAX_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_type_c_l_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MAX_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_L_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_type_c_h_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MIN_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_type_c_h_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MIN_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_type_c_h_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MAX_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_type_c_h_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MAX_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_H_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_auxadc_imp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_AUXADC_IMP_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_AUXADC_IMP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_auxadc_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_AUXADC_IMP_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_AUXADC_IMP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_nag_c_dltv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_NAG_C_DLTV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_NAG_C_DLTV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_nag_c_dltv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_NAG_C_DLTV_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_NAG_C_DLTV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_type_c_cc_irq(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_CC_IRQ_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_TYPE_C_CC_IRQ_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_type_c_cc_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_CC_IRQ_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_TYPE_C_CC_IRQ_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_chrdet_edge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_EDGE_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_EDGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_chrdet_edge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_CHRDET_EDGE_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_CHRDET_EDGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_ov(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_OV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_OV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_ov(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_OV_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_OV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_bvalid_det(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_BVALID_DET_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_BVALID_DET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_bvalid_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_BVALID_DET_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_BVALID_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_rgs_baton_hv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_RGS_BATON_HV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_RGS_BATON_HV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_rgs_baton_hv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_RGS_BATON_HV_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_RGS_BATON_HV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_vbaton_undet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_VBATON_UNDET_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_VBATON_UNDET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_vbaton_undet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_VBATON_UNDET_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_VBATON_UNDET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_watchdog(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_WATCHDOG_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_WATCHDOG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_watchdog(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_WATCHDOG_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_WATCHDOG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_pchr_cm_vdec(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VDEC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VDEC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_pchr_cm_vdec(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VDEC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VDEC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_chrdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_CHRDET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_chrdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_CHRDET_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_CHRDET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_pchr_cm_vinc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VINC_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VINC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_pchr_cm_vinc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VINC_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_PCHR_CM_VINC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_fg_bat_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_fg_bat_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_FG_BAT_H_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_FG_BAT_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_fg_bat_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_BAT_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_fg_bat_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_FG_BAT_L_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_FG_BAT_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_fg_cur_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_H_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_fg_cur_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_FG_CUR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_FG_CUR_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_fg_cur_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_L_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_CUR_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_fg_cur_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_FG_CUR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_FG_CUR_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_int_en_fg_zcv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INT_EN_FG_ZCV_MASK),
				    (unsigned int)(PMIC_RG_INT_EN_FG_ZCV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_int_en_fg_zcv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_EN_FG_ZCV_MASK),
				  (unsigned int)(PMIC_RG_INT_EN_FG_ZCV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_polarity(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_POLARITY_MASK),
				    (unsigned int)(PMIC_POLARITY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_polarity(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_MISC_CON),
				  (&val),
				  (unsigned int)(PMIC_POLARITY_MASK),
				  (unsigned int)(PMIC_POLARITY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_homekey_int_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HOMEKEY_INT_SEL_MASK),
				    (unsigned int)(PMIC_RG_HOMEKEY_INT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_homekey_int_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_MISC_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_HOMEKEY_INT_SEL_MASK),
				  (unsigned int)(PMIC_RG_HOMEKEY_INT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pwrkey_int_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PWRKEY_INT_SEL_MASK),
				    (unsigned int)(PMIC_RG_PWRKEY_INT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pwrkey_int_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_MISC_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_PWRKEY_INT_SEL_MASK),
				  (unsigned int)(PMIC_RG_PWRKEY_INT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrdet_int_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRDET_INT_SEL_MASK),
				    (unsigned int)(PMIC_RG_CHRDET_INT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrdet_int_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_MISC_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRDET_INT_SEL_MASK),
				  (unsigned int)(PMIC_RG_CHRDET_INT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_cm_vinc_polarity_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_CM_VINC_POLARITY_RSV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_CM_VINC_POLARITY_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_cm_vinc_polarity_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_MISC_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_CM_VINC_POLARITY_RSV_MASK),
				  (unsigned int)(PMIC_RG_PCHR_CM_VINC_POLARITY_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_cm_vdec_polarity_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_MISC_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_CM_VDEC_POLARITY_RSV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_CM_VDEC_POLARITY_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_cm_vdec_polarity_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_MISC_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_CM_VDEC_POLARITY_RSV_MASK),
				  (unsigned int)(PMIC_RG_PCHR_CM_VDEC_POLARITY_RSV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_pwrkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_homekey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_pwrkey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_PWRKEY_R_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_homekey_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_R_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_HOMEKEY_R_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_thr_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_thr_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_THR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_bat_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_bat_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BAT_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_rtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_RTC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_RTC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_audio(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_AUDIO_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_AUDIO_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_accdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_ACCDET_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_ACCDET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_accdet_eint(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_ACCDET_EINT_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_ACCDET_EINT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_accdet_negv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_ACCDET_NEGV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_ACCDET_NEGV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_ni_lbat_int(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS0),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_NI_LBAT_INT_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_NI_LBAT_INT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_vcore_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCORE_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VCORE_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_vproc_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPROC_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPROC_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_vs1_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VS1_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VS1_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_vpa_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPA_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VPA_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_spkl_d(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_SPKL_D_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_SPKL_D_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_spkl_ab(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_SPKL_AB_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_SPKL_AB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_ldo_oc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS1),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_LDO_OC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_LDO_OC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_type_c_l_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_L_MIN_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_L_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_type_c_l_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_L_MAX_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_L_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_type_c_h_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_H_MIN_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_H_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_type_c_h_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_H_MAX_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_H_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_auxadc_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_AUXADC_IMP_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_AUXADC_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_nag_c_dltv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_NAG_C_DLTV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_NAG_C_DLTV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_type_c_cc_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_CC_IRQ_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_TYPE_C_CC_IRQ_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_chrdet_edge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_EDGE_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_EDGE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_ov(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_OV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_OV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_bvalid_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_BVALID_DET_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_BVALID_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_rgs_baton_hv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_RGS_BATON_HV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_RGS_BATON_HV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_vbaton_undet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_VBATON_UNDET_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_VBATON_UNDET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_watchdog(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_WATCHDOG_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_WATCHDOG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_pchr_cm_vdec(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_PCHR_CM_VDEC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_PCHR_CM_VDEC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_chrdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_CHRDET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_pchr_cm_vinc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS2),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_PCHR_CM_VINC_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_PCHR_CM_VINC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_fg_bat_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_fg_bat_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_BAT_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_fg_cur_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_H_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_fg_cur_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_L_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_CUR_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_int_status_fg_zcv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STATUS3),
				  (&val),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_ZCV_MASK),
				  (unsigned int)(PMIC_RG_INT_STATUS_FG_ZCV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_oc_gear_ldo(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OC_GEAR_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_OC_GEAR_LDO_MASK),
				    (unsigned int)(PMIC_OC_GEAR_LDO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_oc_gear_ldo(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OC_GEAR_0),
				  (&val),
				  (unsigned int)(PMIC_OC_GEAR_LDO_MASK),
				  (unsigned int)(PMIC_OC_GEAR_LDO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_EN_L_MASK),
				    (unsigned int)(PMIC_SPK_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_SPK_EN_L_MASK),
				  (unsigned int)(PMIC_SPK_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spkmode_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPKMODE_L_MASK),
				    (unsigned int)(PMIC_SPKMODE_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spkmode_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_SPKMODE_L_MASK),
				  (unsigned int)(PMIC_SPKMODE_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_EN_L_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_EN_L_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_oc_shdn_dl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OC_SHDN_DL_MASK),
				    (unsigned int)(PMIC_SPK_OC_SHDN_DL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_oc_shdn_dl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_SPK_OC_SHDN_DL_MASK),
				  (unsigned int)(PMIC_SPK_OC_SHDN_DL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_ther_shdn_l_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_THER_SHDN_L_EN_MASK),
				    (unsigned int)(PMIC_SPK_THER_SHDN_L_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_ther_shdn_l_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_SPK_THER_SHDN_L_EN_MASK),
				  (unsigned int)(PMIC_SPK_THER_SHDN_L_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_out_stage_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OUT_STAGE_SEL_MASK),
				    (unsigned int)(PMIC_SPK_OUT_STAGE_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_out_stage_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_SPK_OUT_STAGE_SEL_MASK),
				  (unsigned int)(PMIC_SPK_OUT_STAGE_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_gainl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_GAINL_MASK),
				    (unsigned int)(PMIC_RG_SPK_GAINL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_gainl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_GAINL_MASK),
				  (unsigned int)(PMIC_RG_SPK_GAINL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_spk_offset_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_SPK_OFFSET_L_MASK),
				  (unsigned int)(PMIC_DA_SPK_OFFSET_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_spk_lead_dglh_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_SPK_LEAD_DGLH_L_MASK),
				  (unsigned int)(PMIC_DA_SPK_LEAD_DGLH_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_ni_spk_lead_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_SPK_LEAD_L_MASK),
				  (unsigned int)(PMIC_AD_NI_SPK_LEAD_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_offset_l_ov(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_SPK_OFFSET_L_OV_MASK),
				  (unsigned int)(PMIC_SPK_OFFSET_L_OV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_offset_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OFFSET_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_OFFSET_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_offset_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_SPK_OFFSET_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_OFFSET_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_lead_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_LEAD_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_LEAD_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_lead_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_SPK_LEAD_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_LEAD_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_offset_l_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OFFSET_L_MODE_MASK),
				    (unsigned int)(PMIC_SPK_OFFSET_L_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_offset_l_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_SPK_OFFSET_L_MODE_MASK),
				  (unsigned int)(PMIC_SPK_OFFSET_L_MODE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_trim_done_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON1),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_DONE_L_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_DONE_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_intg_rst_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_INTG_RST_L_MASK),
				    (unsigned int)(PMIC_RG_SPK_INTG_RST_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_intg_rst_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_INTG_RST_L_MASK),
				  (unsigned int)(PMIC_RG_SPK_INTG_RST_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_force_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_FORCE_EN_L_MASK),
				    (unsigned int)(PMIC_RG_SPK_FORCE_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_force_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_FORCE_EN_L_MASK),
				  (unsigned int)(PMIC_RG_SPK_FORCE_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_slew_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_SLEW_L_MASK),
				    (unsigned int)(PMIC_RG_SPK_SLEW_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_slew_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_SLEW_L_MASK),
				  (unsigned int)(PMIC_RG_SPK_SLEW_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkab_obias_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKAB_OBIAS_L_MASK),
				    (unsigned int)(PMIC_RG_SPKAB_OBIAS_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkab_obias_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKAB_OBIAS_L_MASK),
				  (unsigned int)(PMIC_RG_SPKAB_OBIAS_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkrcv_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKRCV_EN_L_MASK),
				    (unsigned int)(PMIC_RG_SPKRCV_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkrcv_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKRCV_EN_L_MASK),
				  (unsigned int)(PMIC_RG_SPKRCV_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_drc_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_DRC_EN_L_MASK),
				    (unsigned int)(PMIC_RG_SPK_DRC_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_drc_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_DRC_EN_L_MASK),
				  (unsigned int)(PMIC_RG_SPK_DRC_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_test_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_TEST_EN_L_MASK),
				    (unsigned int)(PMIC_RG_SPK_TEST_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_test_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_TEST_EN_L_MASK),
				  (unsigned int)(PMIC_RG_SPK_TEST_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkab_oc_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKAB_OC_EN_L_MASK),
				    (unsigned int)(PMIC_RG_SPKAB_OC_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkab_oc_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKAB_OC_EN_L_MASK),
				  (unsigned int)(PMIC_RG_SPKAB_OC_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_oc_en_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_OC_EN_L_MASK),
				    (unsigned int)(PMIC_RG_SPK_OC_EN_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_oc_en_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_OC_EN_L_MASK),
				  (unsigned int)(PMIC_RG_SPK_OC_EN_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_EN_R_MASK),
				    (unsigned int)(PMIC_SPK_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON3),
				  (&val),
				  (unsigned int)(PMIC_SPK_EN_R_MASK),
				  (unsigned int)(PMIC_SPK_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spkmode_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPKMODE_R_MASK),
				    (unsigned int)(PMIC_SPKMODE_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spkmode_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON3),
				  (&val),
				  (unsigned int)(PMIC_SPKMODE_R_MASK),
				  (unsigned int)(PMIC_SPKMODE_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_EN_R_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON3),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_EN_R_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_oc_shdn_dr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OC_SHDN_DR_MASK),
				    (unsigned int)(PMIC_SPK_OC_SHDN_DR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_oc_shdn_dr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON3),
				  (&val),
				  (unsigned int)(PMIC_SPK_OC_SHDN_DR_MASK),
				  (unsigned int)(PMIC_SPK_OC_SHDN_DR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_ther_shdn_r_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_THER_SHDN_R_EN_MASK),
				    (unsigned int)(PMIC_SPK_THER_SHDN_R_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_ther_shdn_r_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON3),
				  (&val),
				  (unsigned int)(PMIC_SPK_THER_SHDN_R_EN_MASK),
				  (unsigned int)(PMIC_SPK_THER_SHDN_R_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_gainr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_GAINR_MASK),
				    (unsigned int)(PMIC_RG_SPK_GAINR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_gainr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_GAINR_MASK),
				  (unsigned int)(PMIC_RG_SPK_GAINR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_spk_offset_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_SPK_OFFSET_R_MASK),
				  (unsigned int)(PMIC_DA_SPK_OFFSET_R_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_spk_lead_dglh_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_DA_SPK_LEAD_DGLH_R_MASK),
				  (unsigned int)(PMIC_DA_SPK_LEAD_DGLH_R_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ni_spk_lead_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_NI_SPK_LEAD_R_MASK),
				  (unsigned int)(PMIC_NI_SPK_LEAD_R_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_offset_r_ov(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_SPK_OFFSET_R_OV_MASK),
				  (unsigned int)(PMIC_SPK_OFFSET_R_OV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_offset_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OFFSET_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_OFFSET_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_offset_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_SPK_OFFSET_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_OFFSET_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_lead_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_LEAD_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_LEAD_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_lead_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_SPK_LEAD_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_LEAD_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_offset_r_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OFFSET_R_MODE_MASK),
				    (unsigned int)(PMIC_SPK_OFFSET_R_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_offset_r_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_SPK_OFFSET_R_MODE_MASK),
				  (unsigned int)(PMIC_SPK_OFFSET_R_MODE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_trim_done_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON4),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_DONE_R_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_DONE_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_intg_rst_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_INTG_RST_R_MASK),
				    (unsigned int)(PMIC_RG_SPK_INTG_RST_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_intg_rst_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_INTG_RST_R_MASK),
				  (unsigned int)(PMIC_RG_SPK_INTG_RST_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_force_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_FORCE_EN_R_MASK),
				    (unsigned int)(PMIC_RG_SPK_FORCE_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_force_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_FORCE_EN_R_MASK),
				  (unsigned int)(PMIC_RG_SPK_FORCE_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_slew_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_SLEW_R_MASK),
				    (unsigned int)(PMIC_RG_SPK_SLEW_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_slew_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_SLEW_R_MASK),
				  (unsigned int)(PMIC_RG_SPK_SLEW_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkab_obias_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKAB_OBIAS_R_MASK),
				    (unsigned int)(PMIC_RG_SPKAB_OBIAS_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkab_obias_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKAB_OBIAS_R_MASK),
				  (unsigned int)(PMIC_RG_SPKAB_OBIAS_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkrcv_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKRCV_EN_R_MASK),
				    (unsigned int)(PMIC_RG_SPKRCV_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkrcv_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKRCV_EN_R_MASK),
				  (unsigned int)(PMIC_RG_SPKRCV_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_drc_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_DRC_EN_R_MASK),
				    (unsigned int)(PMIC_RG_SPK_DRC_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_drc_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_DRC_EN_R_MASK),
				  (unsigned int)(PMIC_RG_SPK_DRC_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_test_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_TEST_EN_R_MASK),
				    (unsigned int)(PMIC_RG_SPK_TEST_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_test_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_TEST_EN_R_MASK),
				  (unsigned int)(PMIC_RG_SPK_TEST_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkab_oc_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKAB_OC_EN_R_MASK),
				    (unsigned int)(PMIC_RG_SPKAB_OC_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkab_oc_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKAB_OC_EN_R_MASK),
				  (unsigned int)(PMIC_RG_SPKAB_OC_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_oc_en_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_OC_EN_R_MASK),
				    (unsigned int)(PMIC_RG_SPK_OC_EN_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_oc_en_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_OC_EN_R_MASK),
				  (unsigned int)(PMIC_RG_SPK_OC_EN_R_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkpga_gainr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKPGA_GAINR_MASK),
				    (unsigned int)(PMIC_RG_SPKPGA_GAINR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkpga_gainr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKPGA_GAINR_MASK),
				  (unsigned int)(PMIC_RG_SPKPGA_GAINR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_WND_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_WND_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_THD_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_THD_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_THD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OC_WND_MASK),
				    (unsigned int)(PMIC_SPK_OC_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_oc_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_OC_WND_MASK),
				  (unsigned int)(PMIC_SPK_OC_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OC_THD_MASK),
				    (unsigned int)(PMIC_SPK_OC_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_oc_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_OC_THD_MASK),
				  (unsigned int)(PMIC_SPK_OC_THD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_d_oc_r_deg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_D_OC_R_DEG_MASK),
				  (unsigned int)(PMIC_SPK_D_OC_R_DEG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_ab_oc_r_deg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_AB_OC_R_DEG_MASK),
				  (unsigned int)(PMIC_SPK_AB_OC_R_DEG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_d_oc_l_deg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_D_OC_L_DEG_MASK),
				  (unsigned int)(PMIC_SPK_D_OC_L_DEG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_spk_ab_oc_l_deg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON6),
				  (&val),
				  (unsigned int)(PMIC_SPK_AB_OC_L_DEG_MASK),
				  (unsigned int)(PMIC_SPK_AB_OC_L_DEG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_td1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TD1_MASK),
				    (unsigned int)(PMIC_SPK_TD1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_td1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON7),
				  (&val),
				  (unsigned int)(PMIC_SPK_TD1_MASK),
				  (unsigned int)(PMIC_SPK_TD1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_td2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TD2_MASK),
				    (unsigned int)(PMIC_SPK_TD2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_td2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON7),
				  (&val),
				  (unsigned int)(PMIC_SPK_TD2_MASK),
				  (unsigned int)(PMIC_SPK_TD2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_td3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TD3_MASK),
				    (unsigned int)(PMIC_SPK_TD3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_td3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON7),
				  (&val),
				  (unsigned int)(PMIC_SPK_TD3_MASK),
				  (unsigned int)(PMIC_SPK_TD3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_div(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_DIV_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_DIV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_div(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON7),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_DIV_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_DIV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_btl_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BTL_SET_MASK),
				    (unsigned int)(PMIC_RG_BTL_SET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_btl_set(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_BTL_SET_MASK),
				  (unsigned int)(PMIC_RG_BTL_SET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_ibias_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_IBIAS_SEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_IBIAS_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_ibias_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_IBIAS_SEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_IBIAS_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_ccode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_CCODE_MASK),
				    (unsigned int)(PMIC_RG_SPK_CCODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_ccode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_CCODE_MASK),
				  (unsigned int)(PMIC_RG_SPK_CCODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_en_view_vcm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_EN_VIEW_VCM_MASK),
				    (unsigned int)(PMIC_RG_SPK_EN_VIEW_VCM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_en_view_vcm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_EN_VIEW_VCM_MASK),
				  (unsigned int)(PMIC_RG_SPK_EN_VIEW_VCM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_en_view_clk(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_EN_VIEW_CLK_MASK),
				    (unsigned int)(PMIC_RG_SPK_EN_VIEW_CLK_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_en_view_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_EN_VIEW_CLK_MASK),
				  (unsigned int)(PMIC_RG_SPK_EN_VIEW_CLK_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_vcm_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_VCM_SEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_VCM_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_vcm_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_VCM_SEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_VCM_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_vcm_ibsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_VCM_IBSEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_VCM_IBSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_vcm_ibsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_VCM_IBSEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_VCM_IBSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_fbrc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_FBRC_EN_MASK),
				    (unsigned int)(PMIC_RG_SPK_FBRC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_fbrc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_FBRC_EN_MASK),
				  (unsigned int)(PMIC_RG_SPK_FBRC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkab_ovdrv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKAB_OVDRV_MASK),
				    (unsigned int)(PMIC_RG_SPKAB_OVDRV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkab_ovdrv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKAB_OVDRV_MASK),
				  (unsigned int)(PMIC_RG_SPKAB_OVDRV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_octh_d(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_OCTH_D_MASK),
				    (unsigned int)(PMIC_RG_SPK_OCTH_D_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_octh_d(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_OCTH_D_MASK),
				  (unsigned int)(PMIC_RG_SPK_OCTH_D_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkpga_gainl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKPGA_GAINL_MASK),
				    (unsigned int)(PMIC_RG_SPKPGA_GAINL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkpga_gainl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKPGA_GAINL_MASK),
				  (unsigned int)(PMIC_RG_SPKPGA_GAINL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_RSV0_MASK),
				    (unsigned int)(PMIC_SPK_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON9),
				  (&val),
				  (unsigned int)(PMIC_SPK_RSV0_MASK),
				  (unsigned int)(PMIC_SPK_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_vcm_fast_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_VCM_FAST_EN_MASK),
				    (unsigned int)(PMIC_SPK_VCM_FAST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_vcm_fast_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON9),
				  (&val),
				  (unsigned int)(PMIC_SPK_VCM_FAST_EN_MASK),
				  (unsigned int)(PMIC_SPK_VCM_FAST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_test_mode0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TEST_MODE0_MASK),
				    (unsigned int)(PMIC_SPK_TEST_MODE0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_test_mode0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON9),
				  (&val),
				  (unsigned int)(PMIC_SPK_TEST_MODE0_MASK),
				  (unsigned int)(PMIC_SPK_TEST_MODE0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_test_mode1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TEST_MODE1_MASK),
				    (unsigned int)(PMIC_SPK_TEST_MODE1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_test_mode1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON9),
				  (&val),
				  (unsigned int)(PMIC_SPK_TEST_MODE1_MASK),
				  (unsigned int)(PMIC_SPK_TEST_MODE1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_td_wait(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TD_WAIT_MASK),
				    (unsigned int)(PMIC_SPK_TD_WAIT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_td_wait(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON10),
				  (&val),
				  (unsigned int)(PMIC_SPK_TD_WAIT_MASK),
				  (unsigned int)(PMIC_SPK_TD_WAIT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_td_done(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TD_DONE_MASK),
				    (unsigned int)(PMIC_SPK_TD_DONE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_td_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON10),
				  (&val),
				  (unsigned int)(PMIC_SPK_TD_DONE_MASK),
				  (unsigned int)(PMIC_SPK_TD_DONE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_en_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_EN_MODE_MASK),
				    (unsigned int)(PMIC_SPK_EN_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_en_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_EN_MODE_MASK),
				  (unsigned int)(PMIC_SPK_EN_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_vcm_fast_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_VCM_FAST_SW_MASK),
				    (unsigned int)(PMIC_SPK_VCM_FAST_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_vcm_fast_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_VCM_FAST_SW_MASK),
				  (unsigned int)(PMIC_SPK_VCM_FAST_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_rst_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_RST_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_RST_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_rst_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_RST_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_RST_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_rst_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_RST_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_RST_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_rst_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_RST_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_RST_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spkmode_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPKMODE_R_SW_MASK),
				    (unsigned int)(PMIC_SPKMODE_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spkmode_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPKMODE_R_SW_MASK),
				  (unsigned int)(PMIC_SPKMODE_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spkmode_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPKMODE_L_SW_MASK),
				    (unsigned int)(PMIC_SPKMODE_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spkmode_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPKMODE_L_SW_MASK),
				  (unsigned int)(PMIC_SPKMODE_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_depop_en_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_DEPOP_EN_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_DEPOP_EN_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_depop_en_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_DEPOP_EN_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_DEPOP_EN_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_depop_en_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_DEPOP_EN_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_DEPOP_EN_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_depop_en_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_DEPOP_EN_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_DEPOP_EN_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_en_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_EN_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_EN_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_en_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_EN_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_EN_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_en_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_EN_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_EN_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_en_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_EN_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_EN_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_outstg_en_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OUTSTG_EN_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_OUTSTG_EN_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_outstg_en_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_OUTSTG_EN_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_OUTSTG_EN_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_outstg_en_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_OUTSTG_EN_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_OUTSTG_EN_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_outstg_en_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_OUTSTG_EN_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_OUTSTG_EN_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_en_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_EN_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_EN_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_en_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_EN_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_EN_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_en_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_EN_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_EN_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_en_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_EN_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_EN_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_stop_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_STOP_R_SW_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_STOP_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_stop_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_STOP_R_SW_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_STOP_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_spk_trim_stop_l_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SPK_TRIM_STOP_L_SW_MASK),
				    (unsigned int)(PMIC_SPK_TRIM_STOP_L_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_spk_trim_stop_l_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON11),
				  (&val),
				  (unsigned int)(PMIC_SPK_TRIM_STOP_L_SW_MASK),
				  (unsigned int)(PMIC_SPK_TRIM_STOP_L_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_isense_test_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_TEST_EN_MASK),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_TEST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_isense_test_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_TEST_EN_MASK),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_TEST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_isense_refsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_REFSEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_REFSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_isense_refsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_REFSEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_REFSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_isense_gainsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_GAINSEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_GAINSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_isense_gainsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_GAINSEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_GAINSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_isense_pdreset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_PDRESET_MASK),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_PDRESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_isense_pdreset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_PDRESET_MASK),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_PDRESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_isense_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_EN_MASK),
				    (unsigned int)(PMIC_RG_SPK_ISENSE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_isense_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_EN_MASK),
				  (unsigned int)(PMIC_RG_SPK_ISENSE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_RSV1_MASK),
				    (unsigned int)(PMIC_RG_SPK_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_RSV1_MASK),
				  (unsigned int)(PMIC_RG_SPK_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_RSV0_MASK),
				    (unsigned int)(PMIC_RG_SPK_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_RSV0_MASK),
				  (unsigned int)(PMIC_RG_SPK_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_abd_volsen_gain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_GAIN_MASK),
				    (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_GAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_abd_volsen_gain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_GAIN_MASK),
				  (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_GAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_abd_volsen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_EN_MASK),
				    (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_abd_volsen_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_EN_MASK),
				  (unsigned int)(PMIC_RG_SPK_ABD_VOLSEN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_abd_cursen_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_ABD_CURSEN_SEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_ABD_CURSEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_abd_cursen_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_ABD_CURSEN_SEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_ABD_CURSEN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_RSV2_MASK),
				    (unsigned int)(PMIC_RG_SPK_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_RSV2_MASK),
				  (unsigned int)(PMIC_RG_SPK_RSV2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_trim2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_TRIM2_MASK),
				    (unsigned int)(PMIC_RG_SPK_TRIM2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_trim2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_TRIM2_MASK),
				  (unsigned int)(PMIC_RG_SPK_TRIM2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_trim1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_TRIM1_MASK),
				    (unsigned int)(PMIC_RG_SPK_TRIM1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_trim1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_TRIM1_MASK),
				  (unsigned int)(PMIC_RG_SPK_TRIM1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_d_cursen_rsetsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_D_CURSEN_RSETSEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_D_CURSEN_RSETSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_d_cursen_rsetsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_D_CURSEN_RSETSEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_D_CURSEN_RSETSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_d_cursen_gain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_D_CURSEN_GAIN_MASK),
				    (unsigned int)(PMIC_RG_SPK_D_CURSEN_GAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_d_cursen_gain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_D_CURSEN_GAIN_MASK),
				  (unsigned int)(PMIC_RG_SPK_D_CURSEN_GAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_d_cursen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_D_CURSEN_EN_MASK),
				    (unsigned int)(PMIC_RG_SPK_D_CURSEN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_d_cursen_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_D_CURSEN_EN_MASK),
				  (unsigned int)(PMIC_RG_SPK_D_CURSEN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_ab_cursen_rsetsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_AB_CURSEN_RSETSEL_MASK),
				    (unsigned int)(PMIC_RG_SPK_AB_CURSEN_RSETSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_ab_cursen_rsetsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_AB_CURSEN_RSETSEL_MASK),
				  (unsigned int)(PMIC_RG_SPK_AB_CURSEN_RSETSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_ab_cursen_gain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_AB_CURSEN_GAIN_MASK),
				    (unsigned int)(PMIC_RG_SPK_AB_CURSEN_GAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_ab_cursen_gain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_AB_CURSEN_GAIN_MASK),
				  (unsigned int)(PMIC_RG_SPK_AB_CURSEN_GAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_ab_cursen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_AB_CURSEN_EN_MASK),
				    (unsigned int)(PMIC_RG_SPK_AB_CURSEN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_ab_cursen_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_AB_CURSEN_EN_MASK),
				  (unsigned int)(PMIC_RG_SPK_AB_CURSEN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spkpga_gain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPKPGA_GAIN_MASK),
				    (unsigned int)(PMIC_RG_SPKPGA_GAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spkpga_gain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SPKPGA_GAIN_MASK),
				  (unsigned int)(PMIC_RG_SPKPGA_GAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spk_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPK_RSV_MASK),
				    (unsigned int)(PMIC_RG_SPK_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spk_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_SPK_RSV_MASK),
				  (unsigned int)(PMIC_RG_SPK_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_isense_pd_reset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ISENSE_PD_RESET_MASK),
				    (unsigned int)(PMIC_RG_ISENSE_PD_RESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_isense_pd_reset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_ISENSE_PD_RESET_MASK),
				  (unsigned int)(PMIC_RG_ISENSE_PD_RESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audivlpwrup_vaudp12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIVLPWRUP_VAUDP12_MASK),
				    (unsigned int)(PMIC_RG_AUDIVLPWRUP_VAUDP12_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audivlpwrup_vaudp12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIVLPWRUP_VAUDP12_MASK),
				  (unsigned int)(PMIC_RG_AUDIVLPWRUP_VAUDP12_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audivlstartup_vaudp12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIVLSTARTUP_VAUDP12_MASK),
				    (unsigned int)(PMIC_RG_AUDIVLSTARTUP_VAUDP12_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audivlstartup_vaudp12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIVLSTARTUP_VAUDP12_MASK),
				  (unsigned int)(PMIC_RG_AUDIVLSTARTUP_VAUDP12_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audivlmuxsel_vaudp12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIVLMUXSEL_VAUDP12_MASK),
				    (unsigned int)(PMIC_RG_AUDIVLMUXSEL_VAUDP12_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audivlmuxsel_vaudp12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIVLMUXSEL_VAUDP12_MASK),
				  (unsigned int)(PMIC_RG_AUDIVLMUXSEL_VAUDP12_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audivlmute_vaudp12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIVLMUTE_VAUDP12_MASK),
				    (unsigned int)(PMIC_RG_AUDIVLMUTE_VAUDP12_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audivlmute_vaudp12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SPK_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIVLMUTE_VAUDP12_MASK),
				  (unsigned int)(PMIC_RG_AUDIVLMUTE_VAUDP12_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fqmtr_tcksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FQMTR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_TCKSEL_MASK),
				    (unsigned int)(PMIC_FQMTR_TCKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fqmtr_tcksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FQMTR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_TCKSEL_MASK),
				  (unsigned int)(PMIC_FQMTR_TCKSEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fqmtr_busy(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FQMTR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_BUSY_MASK),
				  (unsigned int)(PMIC_FQMTR_BUSY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fqmtr_dcxo26m_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FQMTR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_DCXO26M_EN_MASK),
				    (unsigned int)(PMIC_FQMTR_DCXO26M_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fqmtr_dcxo26m_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FQMTR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_DCXO26M_EN_MASK),
				  (unsigned int)(PMIC_FQMTR_DCXO26M_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fqmtr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FQMTR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_EN_MASK),
				    (unsigned int)(PMIC_FQMTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fqmtr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FQMTR_CON0),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_EN_MASK),
				  (unsigned int)(PMIC_FQMTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fqmtr_winset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FQMTR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FQMTR_WINSET_MASK),
				    (unsigned int)(PMIC_FQMTR_WINSET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fqmtr_winset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FQMTR_CON1),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_WINSET_MASK),
				  (unsigned int)(PMIC_FQMTR_WINSET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fqmtr_data(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FQMTR_CON2),
				  (&val),
				  (unsigned int)(PMIC_FQMTR_DATA_MASK),
				  (unsigned int)(PMIC_FQMTR_DATA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_TRIM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_trim_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_TRIM_EN_MASK),
				  (unsigned int)(PMIC_RG_TRIM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_trim_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TRIM_SEL_MASK),
				    (unsigned int)(PMIC_RG_TRIM_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_trim_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_TRIM_SEL_MASK),
				  (unsigned int)(PMIC_RG_TRIM_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_isinks_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ISINKS_RSV_MASK),
				    (unsigned int)(PMIC_RG_ISINKS_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_isinks_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_ISINKS_RSV_MASK),
				  (unsigned int)(PMIC_RG_ISINKS_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_isink0_double_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ISINK0_DOUBLE_EN_MASK),
				    (unsigned int)(PMIC_RG_ISINK0_DOUBLE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_isink0_double_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_ISINK0_DOUBLE_EN_MASK),
				  (unsigned int)(PMIC_RG_ISINK0_DOUBLE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_isink1_double_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ISINK1_DOUBLE_EN_MASK),
				    (unsigned int)(PMIC_RG_ISINK1_DOUBLE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_isink1_double_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_ISINK1_DOUBLE_EN_MASK),
				  (unsigned int)(PMIC_RG_ISINK1_DOUBLE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_isink2_double_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ISINK2_DOUBLE_EN_MASK),
				    (unsigned int)(PMIC_RG_ISINK2_DOUBLE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_isink2_double_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_ISINK2_DOUBLE_EN_MASK),
				  (unsigned int)(PMIC_RG_ISINK2_DOUBLE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_isink3_double_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ISINK3_DOUBLE_EN_MASK),
				    (unsigned int)(PMIC_RG_ISINK3_DOUBLE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_isink3_double_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON_0),
				  (&val),
				  (unsigned int)(PMIC_RG_ISINK3_DOUBLE_EN_MASK),
				  (unsigned int)(PMIC_RG_ISINK3_DOUBLE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_dim0_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM0_FSEL_MASK),
				    (unsigned int)(PMIC_ISINK_DIM0_FSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_dim0_fsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON0),
				  (&val),
				  (unsigned int)(PMIC_ISINK_DIM0_FSEL_MASK),
				  (unsigned int)(PMIC_ISINK_DIM0_FSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink0_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK0_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK0_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink0_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK0_RSV1_MASK),
				  (unsigned int)(PMIC_ISINK0_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK0_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK0_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink0_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK0_RSV0_MASK),
				  (unsigned int)(PMIC_ISINK0_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_dim0_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM0_DUTY_MASK),
				    (unsigned int)(PMIC_ISINK_DIM0_DUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_dim0_duty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK_DIM0_DUTY_MASK),
				  (unsigned int)(PMIC_ISINK_DIM0_DUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch0_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_STEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch0_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH0_STEP_MASK),
				  (unsigned int)(PMIC_ISINK_CH0_STEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath0_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath0_tf2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH0_TF2_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH0_TF2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath0_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TF1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath0_tf1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH0_TF1_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH0_TF1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath0_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath0_tr2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH0_TR2_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH0_TR2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath0_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TR1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath0_tr1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH0_TR1_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH0_TR1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath0_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TOFF_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath0_toff_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON3),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH0_TOFF_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH0_TOFF_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath0_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK0_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH0_TON_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH0_TON_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath0_ton_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK0_CON3),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH0_TON_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH0_TON_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_dim1_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM1_FSEL_MASK),
				    (unsigned int)(PMIC_ISINK_DIM1_FSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_dim1_fsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON0),
				  (&val),
				  (unsigned int)(PMIC_ISINK_DIM1_FSEL_MASK),
				  (unsigned int)(PMIC_ISINK_DIM1_FSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink1_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK1_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK1_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink1_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK1_RSV1_MASK),
				  (unsigned int)(PMIC_ISINK1_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink1_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK1_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK1_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink1_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK1_RSV0_MASK),
				  (unsigned int)(PMIC_ISINK1_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_dim1_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_DIM1_DUTY_MASK),
				    (unsigned int)(PMIC_ISINK_DIM1_DUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_dim1_duty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK_DIM1_DUTY_MASK),
				  (unsigned int)(PMIC_ISINK_DIM1_DUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch1_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_STEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch1_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH1_STEP_MASK),
				  (unsigned int)(PMIC_ISINK_CH1_STEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath1_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath1_tf2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH1_TF2_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH1_TF2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath1_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TF1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath1_tf1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH1_TF1_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH1_TF1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath1_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR2_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath1_tr2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH1_TR2_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH1_TR2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath1_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR1_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TR1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath1_tr1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON2),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH1_TR1_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH1_TR1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath1_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TOFF_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath1_toff_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON3),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH1_TOFF_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH1_TOFF_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_breath1_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK1_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_BREATH1_TON_SEL_MASK),
				    (unsigned int)(PMIC_ISINK_BREATH1_TON_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_breath1_ton_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK1_CON3),
				  (&val),
				  (unsigned int)(PMIC_ISINK_BREATH1_TON_SEL_MASK),
				  (unsigned int)(PMIC_ISINK_BREATH1_TON_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_ni_isink3_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_ISINK3_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_ISINK3_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_ni_isink2_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_ISINK2_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_ISINK2_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_ni_isink1_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_ISINK1_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_ISINK1_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_ni_isink0_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA1),
				  (&val),
				  (unsigned int)(PMIC_AD_NI_ISINK0_STATUS_MASK),
				  (unsigned int)(PMIC_AD_NI_ISINK0_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_phase0_dly_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE0_DLY_EN_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE0_DLY_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_phase0_dly_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				  (&val),
				  (unsigned int)(PMIC_ISINK_PHASE0_DLY_EN_MASK),
				  (unsigned int)(PMIC_ISINK_PHASE0_DLY_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_phase1_dly_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE1_DLY_EN_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE1_DLY_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_phase1_dly_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				  (&val),
				  (unsigned int)(PMIC_ISINK_PHASE1_DLY_EN_MASK),
				  (unsigned int)(PMIC_ISINK_PHASE1_DLY_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_phase_dly_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_PHASE_DLY_TC_MASK),
				    (unsigned int)(PMIC_ISINK_PHASE_DLY_TC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_phase_dly_tc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				  (&val),
				  (unsigned int)(PMIC_ISINK_PHASE_DLY_TC_MASK),
				  (unsigned int)(PMIC_ISINK_PHASE_DLY_TC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop0_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP0_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP0_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop0_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP0_SW_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP0_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop1_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP1_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP1_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop1_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP1_SW_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP1_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_sfstr1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR1_EN_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_sfstr1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_SFSTR),
				  (&val),
				  (unsigned int)(PMIC_ISINK_SFSTR1_EN_MASK),
				  (unsigned int)(PMIC_ISINK_SFSTR1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_sfstr1_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR1_TC_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR1_TC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_sfstr1_tc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_SFSTR),
				  (&val),
				  (unsigned int)(PMIC_ISINK_SFSTR1_TC_MASK),
				  (unsigned int)(PMIC_ISINK_SFSTR1_TC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_sfstr0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR0_EN_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR0_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_sfstr0_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_SFSTR),
				  (&val),
				  (unsigned int)(PMIC_ISINK_SFSTR0_EN_MASK),
				  (unsigned int)(PMIC_ISINK_SFSTR0_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_sfstr0_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_SFSTR),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_SFSTR0_TC_MASK),
				    (unsigned int)(PMIC_ISINK_SFSTR0_TC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_sfstr0_tc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_SFSTR),
				  (&val),
				  (unsigned int)(PMIC_ISINK_SFSTR0_TC_MASK),
				  (unsigned int)(PMIC_ISINK_SFSTR0_TC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch0_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH0_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH0_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH1_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop0_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP0_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP0_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop0_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP0_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP0_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP1_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP1_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch0_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch0_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH0_BIAS_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH0_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch1_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch1_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH1_BIAS_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH1_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_RSV_MASK),
				    (unsigned int)(PMIC_ISINK_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_MODE_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_RSV_MASK),
				  (unsigned int)(PMIC_ISINK_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch1_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH1_MODE_MASK),
				    (unsigned int)(PMIC_ISINK_CH1_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_MODE_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH1_MODE_MASK),
				  (unsigned int)(PMIC_ISINK_CH1_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch0_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_MODE_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH0_MODE_MASK),
				    (unsigned int)(PMIC_ISINK_CH0_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch0_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_MODE_CTRL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH0_MODE_MASK),
				  (unsigned int)(PMIC_ISINK_CH0_MODE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_isinks_ch3_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH3_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH3_STEP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_isinks_ch2_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH2_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH2_STEP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_isinks_ch1_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH1_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH1_STEP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_isinks_ch0_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH0_STEP_MASK),
				  (unsigned int)(PMIC_DA_QI_ISINKS_CH0_STEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink2_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK2_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK2_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink2_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK2_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK2_RSV1_MASK),
				  (unsigned int)(PMIC_ISINK2_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink2_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK2_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK2_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink2_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK2_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK2_RSV0_MASK),
				  (unsigned int)(PMIC_ISINK2_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch2_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK2_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_STEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch2_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK2_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH2_STEP_MASK),
				  (unsigned int)(PMIC_ISINK_CH2_STEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink3_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK3_RSV1_MASK),
				    (unsigned int)(PMIC_ISINK3_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink3_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK3_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK3_RSV1_MASK),
				  (unsigned int)(PMIC_ISINK3_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink3_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK3_RSV0_MASK),
				    (unsigned int)(PMIC_ISINK3_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink3_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK3_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK3_RSV0_MASK),
				  (unsigned int)(PMIC_ISINK3_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch3_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK3_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_STEP_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_STEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch3_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK3_CON1),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH3_STEP_MASK),
				  (unsigned int)(PMIC_ISINK_CH3_STEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop3_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP3_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP3_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop3_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP3_SW_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP3_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop2_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_PHASE_DLY_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP2_SW_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP2_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop2_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_PHASE_DLY_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP2_SW_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP2_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch3_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch3_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH3_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH3_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH2_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop3_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP3_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP3_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop3_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP3_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP3_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_chop2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CHOP2_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CHOP2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_chop2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CHOP2_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CHOP2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch3_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH3_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH3_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch3_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH3_BIAS_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH3_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_isink_ch2_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ISINK_CH2_BIAS_EN_MASK),
				    (unsigned int)(PMIC_ISINK_CH2_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_isink_ch2_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ISINK_EN_CTRL_SMPL),
				  (&val),
				  (unsigned int)(PMIC_ISINK_CH2_BIAS_EN_MASK),
				  (unsigned int)(PMIC_ISINK_CH2_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_dim_fsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_DIM_FSEL_MASK),
				    (unsigned int)(PMIC_CHRIND_DIM_FSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_dim_fsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON0),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_DIM_FSEL_MASK),
				  (unsigned int)(PMIC_CHRIND_DIM_FSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_RSV1_MASK),
				    (unsigned int)(PMIC_CHRIND_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON1),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_RSV1_MASK),
				  (unsigned int)(PMIC_CHRIND_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_RSV0_MASK),
				    (unsigned int)(PMIC_CHRIND_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON1),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_RSV0_MASK),
				  (unsigned int)(PMIC_CHRIND_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_dim_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_DIM_DUTY_MASK),
				    (unsigned int)(PMIC_CHRIND_DIM_DUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_dim_duty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON1),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_DIM_DUTY_MASK),
				  (unsigned int)(PMIC_CHRIND_DIM_DUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_step(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_STEP_MASK),
				    (unsigned int)(PMIC_CHRIND_STEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_step(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON1),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_STEP_MASK),
				  (unsigned int)(PMIC_CHRIND_STEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_breath_tf2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BREATH_TF2_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_BREATH_TF2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_breath_tf2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON2),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BREATH_TF2_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_BREATH_TF2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_breath_tf1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BREATH_TF1_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_BREATH_TF1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_breath_tf1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON2),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BREATH_TF1_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_BREATH_TF1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_breath_tr2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BREATH_TR2_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_BREATH_TR2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_breath_tr2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON2),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BREATH_TR2_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_BREATH_TR2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_breath_tr1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BREATH_TR1_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_BREATH_TR1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_breath_tr1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON2),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BREATH_TR1_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_BREATH_TR1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_breath_toff_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BREATH_TOFF_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_BREATH_TOFF_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_breath_toff_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON3),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BREATH_TOFF_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_BREATH_TOFF_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_breath_ton_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BREATH_TON_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_BREATH_TON_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_breath_ton_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_CON3),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BREATH_TON_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_BREATH_TON_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_sfstr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_SFSTR_EN_MASK),
				    (unsigned int)(PMIC_CHRIND_SFSTR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_sfstr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_SFSTR_EN_MASK),
				  (unsigned int)(PMIC_CHRIND_SFSTR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_sfstr_tc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_SFSTR_TC_MASK),
				    (unsigned int)(PMIC_CHRIND_SFSTR_TC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_sfstr_tc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_SFSTR_TC_MASK),
				  (unsigned int)(PMIC_CHRIND_SFSTR_TC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_EN_SEL_MASK),
				    (unsigned int)(PMIC_CHRIND_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_EN_SEL_MASK),
				  (unsigned int)(PMIC_CHRIND_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_EN_MASK),
				    (unsigned int)(PMIC_CHRIND_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_EN_MASK),
				  (unsigned int)(PMIC_CHRIND_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_chop_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_CHOP_EN_MASK),
				    (unsigned int)(PMIC_CHRIND_CHOP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_chop_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_CHOP_EN_MASK),
				  (unsigned int)(PMIC_CHRIND_CHOP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_MODE_MASK),
				    (unsigned int)(PMIC_CHRIND_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_MODE_MASK),
				  (unsigned int)(PMIC_CHRIND_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_chop_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_CHOP_SW_MASK),
				    (unsigned int)(PMIC_CHRIND_CHOP_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_chop_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_CHOP_SW_MASK),
				  (unsigned int)(PMIC_CHRIND_CHOP_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_chrind_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_CHRIND_BIAS_EN_MASK),
				    (unsigned int)(PMIC_CHRIND_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_chrind_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHRIND_EN_CTRL),
				  (&val),
				  (unsigned int)(PMIC_CHRIND_BIAS_EN_MASK),
				  (unsigned int)(PMIC_CHRIND_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_slp_rw_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RG_SPI_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLP_RW_EN_MASK),
				    (unsigned int)(PMIC_RG_SLP_RW_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_slp_rw_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RG_SPI_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SLP_RW_EN_MASK),
				  (unsigned int)(PMIC_RG_SLP_RW_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spi_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RG_SPI_CON),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPI_RSV_MASK),
				    (unsigned int)(PMIC_RG_SPI_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spi_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RG_SPI_CON),
				  (&val),
				  (unsigned int)(PMIC_RG_SPI_RSV_MASK),
				  (unsigned int)(PMIC_RG_SPI_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_dio_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_DIO_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_DIO_EN_MASK),
				    (unsigned int)(PMIC_DEW_DIO_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_dio_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_DIO_EN),
				  (&val),
				  (unsigned int)(PMIC_DEW_DIO_EN_MASK),
				  (unsigned int)(PMIC_DEW_DIO_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_dew_read_test(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_READ_TEST),
				  (&val),
				  (unsigned int)(PMIC_DEW_READ_TEST_MASK),
				  (unsigned int)(PMIC_DEW_READ_TEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_write_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_WRITE_TEST),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_WRITE_TEST_MASK),
				    (unsigned int)(PMIC_DEW_WRITE_TEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_write_test(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_WRITE_TEST),
				  (&val),
				  (unsigned int)(PMIC_DEW_WRITE_TEST_MASK),
				  (unsigned int)(PMIC_DEW_WRITE_TEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_crc_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CRC_SWRST),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CRC_SWRST_MASK),
				    (unsigned int)(PMIC_DEW_CRC_SWRST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_crc_swrst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CRC_SWRST),
				  (&val),
				  (unsigned int)(PMIC_DEW_CRC_SWRST_MASK),
				  (unsigned int)(PMIC_DEW_CRC_SWRST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_crc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CRC_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CRC_EN_MASK),
				    (unsigned int)(PMIC_DEW_CRC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_crc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CRC_EN),
				  (&val),
				  (unsigned int)(PMIC_DEW_CRC_EN_MASK),
				  (unsigned int)(PMIC_DEW_CRC_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_dew_crc_val(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CRC_VAL),
				  (&val),
				  (unsigned int)(PMIC_DEW_CRC_VAL_MASK),
				  (unsigned int)(PMIC_DEW_CRC_VAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_dbg_mon_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_DBG_MON_SEL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_DBG_MON_SEL_MASK),
				    (unsigned int)(PMIC_DEW_DBG_MON_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_dbg_mon_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_DBG_MON_SEL),
				  (&val),
				  (unsigned int)(PMIC_DEW_DBG_MON_SEL_MASK),
				  (unsigned int)(PMIC_DEW_DBG_MON_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_cipher_key_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CIPHER_KEY_SEL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_KEY_SEL_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_KEY_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_cipher_key_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CIPHER_KEY_SEL),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_KEY_SEL_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_KEY_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_cipher_iv_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CIPHER_IV_SEL),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_IV_SEL_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_IV_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_cipher_iv_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CIPHER_IV_SEL),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_IV_SEL_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_IV_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_cipher_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CIPHER_EN),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_EN_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_cipher_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CIPHER_EN),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_EN_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_dew_cipher_rdy(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CIPHER_RDY),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_RDY_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_RDY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_cipher_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CIPHER_MODE),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_MODE_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_cipher_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CIPHER_MODE),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_MODE_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_cipher_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_CIPHER_SWRST),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_CIPHER_SWRST_MASK),
				    (unsigned int)(PMIC_DEW_CIPHER_SWRST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_cipher_swrst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_CIPHER_SWRST),
				  (&val),
				  (unsigned int)(PMIC_DEW_CIPHER_SWRST_MASK),
				  (unsigned int)(PMIC_DEW_CIPHER_SWRST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_dew_rddmy_no(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DEW_RDDMY_NO),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DEW_RDDMY_NO_MASK),
				    (unsigned int)(PMIC_DEW_RDDMY_NO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_dew_rddmy_no(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DEW_RDDMY_NO),
				  (&val),
				  (unsigned int)(PMIC_DEW_RDDMY_NO_MASK),
				  (unsigned int)(PMIC_DEW_RDDMY_NO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_int_type_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_TYPE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON0_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_int_type_con0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_TYPE_CON0),
				  (&val),
				  (unsigned int)(PMIC_INT_TYPE_CON0_MASK),
				  (unsigned int)(PMIC_INT_TYPE_CON0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_int_type_con1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_TYPE_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON1_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_int_type_con1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_TYPE_CON1),
				  (&val),
				  (unsigned int)(PMIC_INT_TYPE_CON1_MASK),
				  (unsigned int)(PMIC_INT_TYPE_CON1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_int_type_con2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_TYPE_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON2_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_int_type_con2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_TYPE_CON2),
				  (&val),
				  (unsigned int)(PMIC_INT_TYPE_CON2_MASK),
				  (unsigned int)(PMIC_INT_TYPE_CON2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_int_type_con3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_INT_TYPE_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_INT_TYPE_CON3_MASK),
				    (unsigned int)(PMIC_INT_TYPE_CON3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_int_type_con3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_TYPE_CON3),
				  (&val),
				  (unsigned int)(PMIC_INT_TYPE_CON3_MASK),
				  (unsigned int)(PMIC_INT_TYPE_CON3_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_cpu_int_sta(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STA),
				  (&val),
				  (unsigned int)(PMIC_CPU_INT_STA_MASK),
				  (unsigned int)(PMIC_CPU_INT_STA_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_md32_int_sta(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_INT_STA),
				  (&val),
				  (unsigned int)(PMIC_MD32_INT_STA_MASK),
				  (unsigned int)(PMIC_MD32_INT_STA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_ldo_ft_testmode_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_LDO_FT_TESTMODE_EN_MASK),
				    (unsigned int)(PMIC_BUCK_LDO_FT_TESTMODE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_ldo_ft_testmode_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_LDO_FT_TESTMODE_EN_MASK),
				  (unsigned int)(PMIC_BUCK_LDO_FT_TESTMODE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_vosel_limit(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_VOSEL_LIMIT_MASK),
				    (unsigned int)(PMIC_EFUSE_VOSEL_LIMIT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_vosel_limit(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_VOSEL_LIMIT_MASK),
				  (unsigned int)(PMIC_EFUSE_VOSEL_LIMIT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_oc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OC_EN_SEL_MASK),
				    (unsigned int)(PMIC_EFUSE_OC_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_oc_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_OC_EN_SEL_MASK),
				  (unsigned int)(PMIC_EFUSE_OC_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_oc_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OC_SDN_EN_MASK),
				    (unsigned int)(PMIC_EFUSE_OC_SDN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_oc_sdn_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_OC_SDN_EN_MASK),
				  (unsigned int)(PMIC_EFUSE_OC_SDN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_for_ldo_osc_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_FOR_LDO_OSC_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_FOR_LDO_OSC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_for_ldo_osc_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_FOR_LDO_OSC_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_FOR_LDO_OSC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_all_con0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_ALL_CON0_RSV0_MASK),
				    (unsigned int)(PMIC_BUCK_ALL_CON0_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_all_con0_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_ALL_CON0_RSV0_MASK),
				  (unsigned int)(PMIC_BUCK_ALL_CON0_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_buck_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_BUCK_RSV_MASK),
				    (unsigned int)(PMIC_BUCK_BUCK_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_buck_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_BUCK_RSV_MASK),
				  (unsigned int)(PMIC_BUCK_BUCK_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel_ctrl_prot(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel_ctrl_prot(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel_ctrl_prot_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel_ctrl_prot_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_PROT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_all_con2_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_ALL_CON2_RSV0_MASK),
				    (unsigned int)(PMIC_BUCK_ALL_CON2_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_all_con2_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_ALL_CON2_RSV0_MASK),
				  (unsigned int)(PMIC_BUCK_ALL_CON2_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsleep_src0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSLEEP_SRC0_MASK),
				    (unsigned int)(PMIC_BUCK_VSLEEP_SRC0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsleep_src0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSLEEP_SRC0_MASK),
				  (unsigned int)(PMIC_BUCK_VSLEEP_SRC0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsleep_src1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSLEEP_SRC1_MASK),
				    (unsigned int)(PMIC_BUCK_VSLEEP_SRC1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsleep_src1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSLEEP_SRC1_MASK),
				  (unsigned int)(PMIC_BUCK_VSLEEP_SRC1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_r2r_src0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_R2R_SRC0_MASK),
				    (unsigned int)(PMIC_BUCK_R2R_SRC0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_r2r_src0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_R2R_SRC0_MASK),
				  (unsigned int)(PMIC_BUCK_R2R_SRC0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_r2r_src1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_R2R_SRC1_MASK),
				    (unsigned int)(PMIC_BUCK_R2R_SRC1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_r2r_src1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_R2R_SRC1_MASK),
				  (unsigned int)(PMIC_BUCK_R2R_SRC1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_buck_osc_sel_src0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_BUCK_OSC_SEL_SRC0_MASK),
				    (unsigned int)(PMIC_BUCK_BUCK_OSC_SEL_SRC0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_buck_osc_sel_src0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON5),
				  (&val),
				  (unsigned int)(PMIC_BUCK_BUCK_OSC_SEL_SRC0_MASK),
				  (unsigned int)(PMIC_BUCK_BUCK_OSC_SEL_SRC0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_srclken_dly_src1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ALL_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_SRCLKEN_DLY_SRC1_MASK),
				    (unsigned int)(PMIC_BUCK_SRCLKEN_DLY_SRC1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_srclken_dly_src1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ALL_CON5),
				  (&val),
				  (unsigned int)(PMIC_BUCK_SRCLKEN_DLY_SRC1_MASK),
				  (unsigned int)(PMIC_BUCK_SRCLKEN_DLY_SRC1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_vosel_dlc011(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC011_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC011_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_vosel_dlc011(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC011_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC011_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_vosel_dlc111(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC111_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC111_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_vosel_dlc111(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC111_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC111_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_dlc_map_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_DLC_MAP_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_DLC_MAP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_dlc_map_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_DLC_MAP_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_DLC_MAP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_vosel_dlc001(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC001_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC001_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_vosel_dlc001(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC001_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_DLC001_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_DLC_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_DLC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_DLC_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_DLC_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vpa_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_DLC_VPA_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA_DLC_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA_DLC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_track_sleep_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_SLEEP_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_SLEEP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_track_sleep_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_SLEEP_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_SLEEP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_track_on_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_ON_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_ON_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_track_on_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_ON_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_TRACK_ON_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_track_on_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_TRACK_ON_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_TRACK_ON_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_track_on_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_TRACK_ON_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_TRACK_ON_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_vosel_delta(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_DELTA_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_DELTA_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_vosel_delta(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_DELTA_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_DELTA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_vosel_offset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_OFFSET_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_OFFSET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_vosel_offset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_OFFSET_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_OFFSET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_vosel_on_lb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_LB_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_LB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_vosel_on_lb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_LB_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_LB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_vosel_on_hb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_HB_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_HB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_vosel_on_hb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_HB_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_ON_HB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vsram_proc_vosel_sleep_lb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_TRACKING_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_SLEEP_LB_MASK),
				    (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_SLEEP_LB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vsram_proc_vosel_sleep_lb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_TRACKING_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_SLEEP_LB_MASK),
				  (unsigned int)(PMIC_BUCK_VSRAM_PROC_VOSEL_SLEEP_LB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vcore_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON0),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VCORE_OC_STATUS_MASK),
				  (unsigned int)(PMIC_AD_QI_VCORE_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vproc_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON0),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VPROC_OC_STATUS_MASK),
				  (unsigned int)(PMIC_AD_QI_VPROC_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vs1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON0),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VS1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_AD_QI_VS1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vpa_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON0),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VPA_OC_STATUS_MASK),
				  (unsigned int)(PMIC_AD_QI_VPA_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_buck_ana_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_ANA_STATUS_MASK),
				  (unsigned int)(PMIC_BUCK_ANA_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vcore_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON1),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VCORE_DIG_MON_MASK),
				  (unsigned int)(PMIC_AD_QI_VCORE_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vproc_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON1),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VPROC_DIG_MON_MASK),
				  (unsigned int)(PMIC_AD_QI_VPROC_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_qi_vs1_dig_mon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_MON_CON1),
				  (&val),
				  (unsigned int)(PMIC_AD_QI_VS1_DIG_MON_MASK),
				  (unsigned int)(PMIC_AD_QI_VS1_DIG_MON_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_buck_vcore_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_STATUS_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_buck_vcore2_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_STATUS_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_buck_vproc_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_STATUS_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_buck_vs1_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_STATUS_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_STATUS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_buck_vpa_oc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_STATUS_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_oc_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_INT_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_oc_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_INT_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_oc_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_INT_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_oc_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_INT_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_oc_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_INT_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_oc_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_INT_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_oc_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_OC_INT_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_OC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_oc_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_INT_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_oc_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_OC_INT_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_OC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_oc_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_INT_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_en_oc_sdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_OC_SDN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_OC_SDN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_en_oc_sdn_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_OC_SDN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_OC_SDN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_en_oc_sdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_OC_SDN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_OC_SDN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_en_oc_sdn_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_OC_SDN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_OC_SDN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_en_oc_sdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_OC_SDN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_OC_SDN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_en_oc_sdn_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_OC_SDN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_OC_SDN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_en_oc_sdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_EN_OC_SDN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_EN_OC_SDN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_en_oc_sdn_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_EN_OC_SDN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_EN_OC_SDN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_en_oc_sdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_EN_OC_SDN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_EN_OC_SDN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_en_oc_sdn_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_EN_OC_SDN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_EN_OC_SDN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_oc_flag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_oc_flag_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_oc_flag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_oc_flag_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_oc_flag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_oc_flag_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_oc_flag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_oc_flag_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_oc_flag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_oc_flag_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_oc_flag_clr_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_FLAG_CLR_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_oc_flag_clr_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_FLAG_CLR_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_oc_flag_clr_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_FLAG_CLR_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_oc_flag_clr_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_FLAG_CLR_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_oc_flag_clr_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_oc_flag_clr_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_CON4),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_FLAG_CLR_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_DEG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_oc_deg_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VCORE_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_DEG_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_DEG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_WND_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_oc_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VCORE_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_WND_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VCORE_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_THD_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_OC_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_oc_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VCORE_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_THD_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_OC_THD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VCORE2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_DEG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_oc_deg_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VCORE2_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_DEG_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_DEG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VCORE2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_WND_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_oc_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VCORE2_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_WND_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VCORE2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_THD_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_OC_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_oc_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VCORE2_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_THD_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_OC_THD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VPROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_DEG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_oc_deg_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VPROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_DEG_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_DEG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VPROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_WND_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_oc_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VPROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_WND_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VPROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_THD_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_OC_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_oc_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VPROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_THD_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_OC_THD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_OC_DEG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_oc_deg_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VS1_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_DEG_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_DEG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_OC_WND_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_OC_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_oc_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VS1_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_WND_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VS1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_OC_THD_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_OC_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_oc_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VS1_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_OC_THD_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_OC_THD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_oc_deg_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VPA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_OC_DEG_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_OC_DEG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_oc_deg_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VPA_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_DEG_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_DEG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_oc_wnd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VPA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_OC_WND_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_OC_WND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_oc_wnd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VPA_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_WND_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_WND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_oc_thd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_OC_VPA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_OC_THD_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_OC_THD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_oc_thd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_OC_VPA_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_OC_THD_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_OC_THD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_smps_testmode_b(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SMPS_TESTMODE_B_MASK),
				    (unsigned int)(PMIC_RG_SMPS_TESTMODE_B_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_smps_testmode_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_SMPS_TESTMODE_B_MASK),
				  (unsigned int)(PMIC_RG_SMPS_TESTMODE_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_TRIMH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_trimh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_TRIMH_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_TRIMH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_TRIML_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_triml(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_TRIML_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_TRIML_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VPROC_TRIMH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_trimh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_TRIMH_MASK),
				  (unsigned int)(PMIC_RG_VPROC_TRIMH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VPROC_TRIML_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_triml(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_TRIML_MASK),
				  (unsigned int)(PMIC_RG_VPROC_TRIML_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VCORE_TRIMH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_trimh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_TRIMH_MASK),
				  (unsigned int)(PMIC_RG_VCORE_TRIMH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VCORE_TRIML_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_triml(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_TRIML_MASK),
				  (unsigned int)(PMIC_RG_VCORE_TRIML_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_TRIMH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_trimh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_TRIMH_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_TRIMH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_TRIML_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_triml(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_TRIML_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_TRIML_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VS1_TRIMH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_trimh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_TRIMH_MASK),
				  (unsigned int)(PMIC_RG_VS1_TRIMH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VS1_TRIML_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_triml(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_TRIML_MASK),
				  (unsigned int)(PMIC_RG_VS1_TRIML_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_trimh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_TRIMH_MASK),
				    (unsigned int)(PMIC_RG_VPA_TRIMH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_trimh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_TRIMH_MASK),
				  (unsigned int)(PMIC_RG_VPA_TRIMH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_triml(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_TRIML_MASK),
				    (unsigned int)(PMIC_RG_VPA_TRIML_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_triml(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_TRIML_MASK),
				  (unsigned int)(PMIC_RG_VPA_TRIML_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_trim_ref(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_TRIM_REF_MASK),
				    (unsigned int)(PMIC_RG_VPA_TRIM_REF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_trim_ref(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_TRIM_REF_MASK),
				  (unsigned int)(PMIC_RG_VPA_TRIM_REF_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_vsleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VPROC_VSLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_vsleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_VSLEEP_MASK),
				  (unsigned int)(PMIC_RG_VPROC_VSLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VSLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_vsleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_VSLEEP_MASK),
				  (unsigned int)(PMIC_RG_VCORE_VSLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_vsleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_VSLEEP_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_VSLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_vsleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_VSLEEP_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_VSLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_bursth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_BURSTH_MASK),
				    (unsigned int)(PMIC_RG_VPA_BURSTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_bursth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_BURSTH_MASK),
				  (unsigned int)(PMIC_RG_VPA_BURSTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_burstl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_BURSTL_MASK),
				    (unsigned int)(PMIC_RG_VPA_BURSTL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_burstl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_BURSTL_MASK),
				  (unsigned int)(PMIC_RG_VPA_BURSTL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dmy100ma_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DMY100MA_EN_MASK),
				    (unsigned int)(PMIC_RG_DMY100MA_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dmy100ma_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_DMY100MA_EN_MASK),
				  (unsigned int)(PMIC_RG_DMY100MA_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dmy100ma_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DMY100MA_SEL_MASK),
				    (unsigned int)(PMIC_RG_DMY100MA_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dmy100ma_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_DMY100MA_SEL_MASK),
				  (unsigned int)(PMIC_RG_DMY100MA_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_vsleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_VOLTAGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_vsleep_voltage(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_VOLTAGE_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_VSLEEP_VOLTAGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_vsleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_VSLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VPROC_VSLEEP_VOLTAGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_vsleep_voltage(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_VSLEEP_VOLTAGE_MASK),
				  (unsigned int)(PMIC_RG_VPROC_VSLEEP_VOLTAGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_vsleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VSLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VSLEEP_VOLTAGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_vsleep_voltage(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_VSLEEP_VOLTAGE_MASK),
				  (unsigned int)(PMIC_RG_VCORE_VSLEEP_VOLTAGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_vsleep_voltage(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_VSLEEP_VOLTAGE_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_VSLEEP_VOLTAGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_vsleep_voltage(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SMPS_TOP_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_VSLEEP_VOLTAGE_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_VSLEEP_VOLTAGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VPA_RZSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_rzsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_RZSEL_MASK),
				  (unsigned int)(PMIC_RG_VPA_RZSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_cc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_CC_MASK),
				    (unsigned int)(PMIC_RG_VPA_CC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_cc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_CC_MASK),
				  (unsigned int)(PMIC_RG_VPA_CC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_CSR_MASK),
				    (unsigned int)(PMIC_RG_VPA_CSR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_csr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_CSR_MASK),
				  (unsigned int)(PMIC_RG_VPA_CSR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_csmir(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_CSMIR_MASK),
				    (unsigned int)(PMIC_RG_VPA_CSMIR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_csmir(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_CSMIR_MASK),
				  (unsigned int)(PMIC_RG_VPA_CSMIR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_CSL_MASK),
				    (unsigned int)(PMIC_RG_VPA_CSL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_csl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_CSL_MASK),
				  (unsigned int)(PMIC_RG_VPA_CSL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_SLP_MASK),
				    (unsigned int)(PMIC_RG_VPA_SLP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_slp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_SLP_MASK),
				  (unsigned int)(PMIC_RG_VPA_SLP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_zx_os_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_ZX_OS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VPA_ZX_OS_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_zx_os_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_ZX_OS_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VPA_ZX_OS_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_zx_os(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_ZX_OS_MASK),
				    (unsigned int)(PMIC_RG_VPA_ZX_OS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_zx_os(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_ZX_OS_MASK),
				  (unsigned int)(PMIC_RG_VPA_ZX_OS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_hzp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_HZP_MASK),
				    (unsigned int)(PMIC_RG_VPA_HZP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_hzp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_HZP_MASK),
				  (unsigned int)(PMIC_RG_VPA_HZP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_bwex_gat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_BWEX_GAT_MASK),
				    (unsigned int)(PMIC_RG_VPA_BWEX_GAT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_bwex_gat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_BWEX_GAT_MASK),
				  (unsigned int)(PMIC_RG_VPA_BWEX_GAT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VPA_MODESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_modeset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_MODESET_MASK),
				  (unsigned int)(PMIC_RG_VPA_MODESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_slew(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_SLEW_MASK),
				    (unsigned int)(PMIC_RG_VPA_SLEW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_slew(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_SLEW_MASK),
				  (unsigned int)(PMIC_RG_VPA_SLEW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_slew_nmos(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_SLEW_NMOS_MASK),
				    (unsigned int)(PMIC_RG_VPA_SLEW_NMOS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_slew_nmos(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_SLEW_NMOS_MASK),
				  (unsigned int)(PMIC_RG_VPA_SLEW_NMOS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VPA_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VPA_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_min_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_MIN_ON_MASK),
				    (unsigned int)(PMIC_RG_VPA_MIN_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_min_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_MIN_ON_MASK),
				  (unsigned int)(PMIC_RG_VPA_MIN_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_vbat_del(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_VBAT_DEL_MASK),
				    (unsigned int)(PMIC_RG_VPA_VBAT_DEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_vbat_del(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_VBAT_DEL_MASK),
				  (unsigned int)(PMIC_RG_VPA_VBAT_DEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_RSV1_MASK),
				    (unsigned int)(PMIC_RG_VPA_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_RSV1_MASK),
				  (unsigned int)(PMIC_RG_VPA_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vpa_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPA_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPA_RSV2_MASK),
				    (unsigned int)(PMIC_RG_VPA_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vpa_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VPA_RSV2_MASK),
				  (unsigned int)(PMIC_RG_VPA_RSV2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vpa_zx_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPA_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RGS_VPA_ZX_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VPA_ZX_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VCORE_MIN_OFF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_min_off(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_MIN_OFF_MASK),
				  (unsigned int)(PMIC_RG_VCORE_MIN_OFF_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_VRF18_SSTART_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_vrf18_sstart_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_VRF18_SSTART_EN_MASK),
				  (unsigned int)(PMIC_RG_VCORE_VRF18_SSTART_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_1P35UP_SEL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_1p35up_sel_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_1P35UP_SEL_EN_MASK),
				  (unsigned int)(PMIC_RG_VCORE_1P35UP_SEL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_RZSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_rzsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_RZSEL_MASK),
				  (unsigned int)(PMIC_RG_VCORE_RZSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSR_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_csr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_CSR_MASK),
				  (unsigned int)(PMIC_RG_VCORE_CSR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSL_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_csl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_CSL_MASK),
				  (unsigned int)(PMIC_RG_VCORE_CSL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_SLP_MASK),
				    (unsigned int)(PMIC_RG_VCORE_SLP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_slp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_SLP_MASK),
				  (unsigned int)(PMIC_RG_VCORE_SLP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_zx_os(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_ZX_OS_MASK),
				    (unsigned int)(PMIC_RG_VCORE_ZX_OS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_zx_os(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_ZX_OS_MASK),
				  (unsigned int)(PMIC_RG_VCORE_ZX_OS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCORE_ZXOS_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_zxos_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_ZXOS_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VCORE_ZXOS_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VCORE_MODESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_modeset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_MODESET_MASK),
				  (unsigned int)(PMIC_RG_VCORE_MODESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCORE_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_csm_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSM_N_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSM_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_csm_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_CSM_N_MASK),
				  (unsigned int)(PMIC_RG_VCORE_CSM_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_csm_p(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_CSM_P_MASK),
				    (unsigned int)(PMIC_RG_VCORE_CSM_P_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_csm_p(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_CSM_P_MASK),
				  (unsigned int)(PMIC_RG_VCORE_CSM_P_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_RSV_MASK),
				    (unsigned int)(PMIC_RG_VCORE_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_RSV_MASK),
				  (unsigned int)(PMIC_RG_VCORE_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PFM_RIP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_pfm_rip(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_PFM_RIP_MASK),
				  (unsigned int)(PMIC_RG_VCORE_PFM_RIP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VCORE_DTS_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_dts_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_DTS_ENB_MASK),
				  (unsigned int)(PMIC_RG_VCORE_DTS_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCORE_AUTO_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_auto_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_AUTO_MODE_MASK),
				  (unsigned int)(PMIC_RG_VCORE_AUTO_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_pwm_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_PWM_TRIG_MASK),
				    (unsigned int)(PMIC_RG_VCORE_PWM_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_pwm_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_PWM_TRIG_MASK),
				  (unsigned int)(PMIC_RG_VCORE_PWM_TRIG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VCORE_TRAN_BST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore_tran_bst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE_TRAN_BST_MASK),
				  (unsigned int)(PMIC_RG_VCORE_TRAN_BST_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vcore_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCORE_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VCORE_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VPROC_MIN_OFF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_min_off(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_MIN_OFF_MASK),
				  (unsigned int)(PMIC_RG_VPROC_MIN_OFF_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VPROC_VRF18_SSTART_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_vrf18_sstart_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_VRF18_SSTART_EN_MASK),
				  (unsigned int)(PMIC_RG_VPROC_VRF18_SSTART_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VPROC_1P35UP_SEL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_1p35up_sel_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_1P35UP_SEL_EN_MASK),
				  (unsigned int)(PMIC_RG_VPROC_1P35UP_SEL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VPROC_RZSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_rzsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_RZSEL_MASK),
				  (unsigned int)(PMIC_RG_VPROC_RZSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_CSR_MASK),
				    (unsigned int)(PMIC_RG_VPROC_CSR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_csr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_CSR_MASK),
				  (unsigned int)(PMIC_RG_VPROC_CSR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_CSL_MASK),
				    (unsigned int)(PMIC_RG_VPROC_CSL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_csl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_CSL_MASK),
				  (unsigned int)(PMIC_RG_VPROC_CSL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_SLP_MASK),
				    (unsigned int)(PMIC_RG_VPROC_SLP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_slp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_SLP_MASK),
				  (unsigned int)(PMIC_RG_VPROC_SLP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_zx_os(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_ZX_OS_MASK),
				    (unsigned int)(PMIC_RG_VPROC_ZX_OS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_zx_os(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_ZX_OS_MASK),
				  (unsigned int)(PMIC_RG_VPROC_ZX_OS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VPROC_ZXOS_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_zxos_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_ZXOS_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VPROC_ZXOS_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VPROC_MODESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_modeset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_MODESET_MASK),
				  (unsigned int)(PMIC_RG_VPROC_MODESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VPROC_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VPROC_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_csm_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_CSM_N_MASK),
				    (unsigned int)(PMIC_RG_VPROC_CSM_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_csm_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_CSM_N_MASK),
				  (unsigned int)(PMIC_RG_VPROC_CSM_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_csm_p(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_CSM_P_MASK),
				    (unsigned int)(PMIC_RG_VPROC_CSM_P_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_csm_p(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_CSM_P_MASK),
				  (unsigned int)(PMIC_RG_VPROC_CSM_P_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_RSV_MASK),
				    (unsigned int)(PMIC_RG_VPROC_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_RSV_MASK),
				  (unsigned int)(PMIC_RG_VPROC_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VPROC_PFM_RIP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_pfm_rip(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_PFM_RIP_MASK),
				  (unsigned int)(PMIC_RG_VPROC_PFM_RIP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VPROC_DTS_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_dts_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_DTS_ENB_MASK),
				  (unsigned int)(PMIC_RG_VPROC_DTS_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_bw_extend(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_BW_EXTEND_MASK),
				    (unsigned int)(PMIC_RG_VPROC_BW_EXTEND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_bw_extend(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_BW_EXTEND_MASK),
				  (unsigned int)(PMIC_RG_VPROC_BW_EXTEND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_pwm_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_PWM_TRIG_MASK),
				    (unsigned int)(PMIC_RG_VPROC_PWM_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_pwm_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_PWM_TRIG_MASK),
				  (unsigned int)(PMIC_RG_VPROC_PWM_TRIG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vproc_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VPROC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VPROC_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VPROC_TRAN_BST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vproc_tran_bst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VPROC_TRAN_BST_MASK),
				  (unsigned int)(PMIC_RG_VPROC_TRAN_BST_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vproc_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VPROC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RGS_VPROC_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VPROC_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VS1_MIN_OFF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_min_off(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_MIN_OFF_MASK),
				  (unsigned int)(PMIC_RG_VS1_MIN_OFF_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_nvt_buff_off_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_NVT_BUFF_OFF_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_NVT_BUFF_OFF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_nvt_buff_off_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_NVT_BUFF_OFF_EN_MASK),
				  (unsigned int)(PMIC_RG_VS1_NVT_BUFF_OFF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_VRF18_SSTART_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_vrf18_sstart_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_VRF18_SSTART_EN_MASK),
				  (unsigned int)(PMIC_RG_VS1_VRF18_SSTART_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_1P35UP_SEL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_1p35up_sel_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_1P35UP_SEL_EN_MASK),
				  (unsigned int)(PMIC_RG_VS1_1P35UP_SEL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VS1_RZSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_rzsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_RZSEL_MASK),
				  (unsigned int)(PMIC_RG_VS1_RZSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CSR_MASK),
				    (unsigned int)(PMIC_RG_VS1_CSR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_csr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_CSR_MASK),
				  (unsigned int)(PMIC_RG_VS1_CSR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CSL_MASK),
				    (unsigned int)(PMIC_RG_VS1_CSL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_csl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_CSL_MASK),
				  (unsigned int)(PMIC_RG_VS1_CSL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_SLP_MASK),
				    (unsigned int)(PMIC_RG_VS1_SLP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_slp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_SLP_MASK),
				  (unsigned int)(PMIC_RG_VS1_SLP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_zx_os(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_ZX_OS_MASK),
				    (unsigned int)(PMIC_RG_VS1_ZX_OS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_zx_os(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_ZX_OS_MASK),
				  (unsigned int)(PMIC_RG_VS1_ZX_OS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VS1_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VS1_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_csm_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CSM_N_MASK),
				    (unsigned int)(PMIC_RG_VS1_CSM_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_csm_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_CSM_N_MASK),
				  (unsigned int)(PMIC_RG_VS1_CSM_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_csm_p(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_CSM_P_MASK),
				    (unsigned int)(PMIC_RG_VS1_CSM_P_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_csm_p(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_CSM_P_MASK),
				  (unsigned int)(PMIC_RG_VS1_CSM_P_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_RSV_MASK),
				    (unsigned int)(PMIC_RG_VS1_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_RSV_MASK),
				  (unsigned int)(PMIC_RG_VS1_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VS1_ZXOS_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_zxos_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_ZXOS_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VS1_ZXOS_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VS1_MODESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_modeset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_MODESET_MASK),
				  (unsigned int)(PMIC_RG_VS1_MODESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VS1_PFM_RIP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_pfm_rip(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_PFM_RIP_MASK),
				  (unsigned int)(PMIC_RG_VS1_PFM_RIP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VS1_TRAN_BST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_tran_bst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_TRAN_BST_MASK),
				  (unsigned int)(PMIC_RG_VS1_TRAN_BST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VS1_DTS_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_dts_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_DTS_ENB_MASK),
				  (unsigned int)(PMIC_RG_VS1_DTS_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VS1_AUTO_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_auto_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_AUTO_MODE_MASK),
				  (unsigned int)(PMIC_RG_VS1_AUTO_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vs1_pwm_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VS1_PWM_TRIG_MASK),
				    (unsigned int)(PMIC_RG_VS1_PWM_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vs1_pwm_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VS1_PWM_TRIG_MASK),
				  (unsigned int)(PMIC_RG_VS1_PWM_TRIG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vs1_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VS1_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RGS_VS1_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VS1_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vcore_burst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VCORE_BURST_MASK),
				    (unsigned int)(PMIC_DA_QI_VCORE_BURST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vcore_burst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_BURST_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_BURST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vcore2_burst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VCORE2_BURST_MASK),
				    (unsigned int)(PMIC_DA_QI_VCORE2_BURST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vcore2_burst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE2_BURST_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE2_BURST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vs1_burst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VS1_BURST_MASK),
				    (unsigned int)(PMIC_DA_QI_VS1_BURST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vs1_burst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_BURST_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_BURST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vproc_burst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VPROC_BURST_MASK),
				    (unsigned int)(PMIC_DA_QI_VPROC_BURST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vproc_burst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPROC_BURST_MASK),
				  (unsigned int)(PMIC_DA_QI_VPROC_BURST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vcore_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VCORE_DLC_MASK),
				    (unsigned int)(PMIC_DA_QI_VCORE_DLC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vcore_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_DLC_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_DLC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vcore_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VCORE_DLC_N_MASK),
				    (unsigned int)(PMIC_DA_QI_VCORE_DLC_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vcore_dlc_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_DLC_N_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_DLC_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vcore2_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VCORE2_DLC_MASK),
				    (unsigned int)(PMIC_DA_QI_VCORE2_DLC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vcore2_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE2_DLC_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE2_DLC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vcore2_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VCORE2_DLC_N_MASK),
				    (unsigned int)(PMIC_DA_QI_VCORE2_DLC_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vcore2_dlc_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE2_DLC_N_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE2_DLC_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vs1_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VS1_DLC_MASK),
				    (unsigned int)(PMIC_DA_QI_VS1_DLC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vs1_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_DLC_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_DLC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vs1_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VS1_DLC_N_MASK),
				    (unsigned int)(PMIC_DA_QI_VS1_DLC_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vs1_dlc_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_DLC_N_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_DLC_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vproc_dlc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VPROC_DLC_MASK),
				    (unsigned int)(PMIC_DA_QI_VPROC_DLC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vproc_dlc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPROC_DLC_MASK),
				  (unsigned int)(PMIC_DA_QI_VPROC_DLC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_vproc_dlc_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_VPROC_DLC_N_MASK),
				    (unsigned int)(PMIC_DA_QI_VPROC_DLC_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_vproc_dlc_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPROC_DLC_N_MASK),
				  (unsigned int)(PMIC_DA_QI_VPROC_DLC_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_min_off(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_MIN_OFF_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_MIN_OFF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_min_off(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_MIN_OFF_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_MIN_OFF_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_vrf18_sstart_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_VRF18_SSTART_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_VRF18_SSTART_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_vrf18_sstart_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_VRF18_SSTART_EN_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_VRF18_SSTART_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_1p35up_sel_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_1P35UP_SEL_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_1P35UP_SEL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_1p35up_sel_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_1P35UP_SEL_EN_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_1P35UP_SEL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_rzsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_RZSEL_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_RZSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_rzsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_RZSEL_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_RZSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_csr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_CSR_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_CSR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_csr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_CSR_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_CSR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_csl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_CSL_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_CSL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_csl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_CSL_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_CSL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_slp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_SLP_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_SLP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_slp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_SLP_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_SLP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_zx_os(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_ZX_OS_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_ZX_OS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_zx_os(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_ZX_OS_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_ZX_OS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_zxos_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_ZXOS_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_ZXOS_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_zxos_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_ZXOS_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_ZXOS_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_modeset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_MODESET_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_MODESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_modeset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_MODESET_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_MODESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_csm_n(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_CSM_N_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_CSM_N_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_csm_n(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_CSM_N_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_CSM_N_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_csm_p(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_CSM_P_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_CSM_P_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_csm_p(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_CSM_P_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_CSM_P_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_RSV_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_RSV_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_pfm_rip(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_PFM_RIP_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_PFM_RIP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_pfm_rip(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_PFM_RIP_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_PFM_RIP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_dts_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_DTS_ENB_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_DTS_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_dts_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_DTS_ENB_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_DTS_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_auto_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_AUTO_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_AUTO_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_auto_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_AUTO_MODE_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_AUTO_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_pwm_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_PWM_TRIG_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_PWM_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_pwm_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_PWM_TRIG_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_PWM_TRIG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcore2_tran_bst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VCORE2_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCORE2_TRAN_BST_MASK),
				    (unsigned int)(PMIC_RG_VCORE2_TRAN_BST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcore2_tran_bst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCORE2_TRAN_BST_MASK),
				  (unsigned int)(PMIC_RG_VCORE2_TRAN_BST_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vcore2_enpwm_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VCORE2_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCORE2_ENPWM_STATUS_MASK),
				  (unsigned int)(PMIC_RGS_VCORE2_ENPWM_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vosel_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vosel_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vosel_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vosel_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_STBTD_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_STBTD_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_vproc_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_VPROC_STB_MASK),
				  (unsigned int)(PMIC_DA_VPROC_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vproc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPROC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VPROC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_sfchg_frate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_sfchg_fen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FEN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_FEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_RRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_sfchg_rrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_RRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_RRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_SFCHG_REN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_sfchg_ren(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_REN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_SFCHG_REN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vproc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPROC_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VPROC_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vosel_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_ON_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vosel_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_ON_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vosel_sleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_VOL_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SLEEP_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VOSEL_SLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_TRANS_TD_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_TRANS_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_trans_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_TRANS_TD_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_TRANS_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_TRANS_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_trans_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_TRANS_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_TRANS_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_TRANS_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_trans_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_TRANS_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_TRANS_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vproc_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPROC_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VPROC_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vsleep_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vsleep_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_r2r_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_R2R_PDN_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_R2R_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_R2R_PDN_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_R2R_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vproc_vsleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vproc_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPROC_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vproc_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPROC_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VPROC_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vproc_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPROC_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VPROC_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_EN_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_EN_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_ctrl_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_0_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_ctrl_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_0_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_ctrl_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_1_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_ctrl_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_1_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_ctrl_2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_2_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_ctrl_2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_2_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_modeset_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_MODESET_0_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_MODESET_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_modeset_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_MODESET_0_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_MODESET_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_modeset_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_MODESET_1_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_MODESET_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_modeset_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_MODESET_1_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_MODESET_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_modeset_2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_MODESET_2_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_MODESET_2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_modeset_2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_MODESET_2_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_MODESET_2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_vs1_modeset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_VS1_MODESET_MASK),
				  (unsigned int)(PMIC_DA_VS1_MODESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_ctrl_inv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_INV_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_INV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_ctrl_inv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_INV_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_CTRL_INV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_EN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_EN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_STBTD_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_STBTD_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_vs1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_VS1_STB_MASK),
				  (unsigned int)(PMIC_DA_VS1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vs1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_FRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_sfchg_frate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_FRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_FRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_FEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_sfchg_fen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_FEN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_FEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_RRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_sfchg_rrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_RRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_RRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_SFCHG_REN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_sfchg_ren(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_REN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_SFCHG_REN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vs1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_ON_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_ON_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VOSEL_SLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vosel_sleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_VOL_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_SLEEP_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VOSEL_SLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_TRANS_TD_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_TRANS_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_trans_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_TRANS_TD_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_TRANS_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_TRANS_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_trans_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_TRANS_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_TRANS_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_TRANS_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_trans_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_TRANS_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_TRANS_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vs1_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VS1_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VS1_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vsleep_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VSLEEP_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VSLEEP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vsleep_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VSLEEP_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VSLEEP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_r2r_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_R2R_PDN_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_R2R_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_R2R_PDN_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_R2R_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vs1_vsleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VS1_VSLEEP_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VS1_VSLEEP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vs1_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VS1_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VS1_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vs1_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vs1_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VS1_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VS1_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VS1_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_STBTD_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_STBTD_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_vcore_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_VCORE_STB_MASK),
				  (unsigned int)(PMIC_DA_VCORE_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcore_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_sfchg_frate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_sfchg_fen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FEN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_FEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_RRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_sfchg_rrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_RRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_RRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_SFCHG_REN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_sfchg_ren(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_REN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_SFCHG_REN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vcore_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_ON_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_ON_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vosel_sleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_VOL_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SLEEP_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VOSEL_SLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_TRANS_TD_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_TRANS_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_trans_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_TRANS_TD_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_TRANS_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_TRANS_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_trans_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_TRANS_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_TRANS_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_TRANS_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_trans_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_TRANS_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_TRANS_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcore_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vsleep_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vsleep_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_r2r_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_R2R_PDN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_R2R_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_R2R_PDN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_R2R_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore_vsleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vcore_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vcore_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vosel_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vosel_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vosel_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vosel_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_HWM_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_STBTD_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_STBTD_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_vcore2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_VCORE2_STB_MASK),
				  (unsigned int)(PMIC_DA_VCORE2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcore2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_sfchg_frate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_sfchg_fen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FEN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_FEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_RRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_sfchg_rrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_RRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_RRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_REN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_sfchg_ren(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_REN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_SFCHG_REN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vcore2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE2_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE2_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vosel_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_ON_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vosel_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON2),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_ON_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vosel_sleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_VOL_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SLEEP_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VOSEL_SLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_TRANS_TD_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_TRANS_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_trans_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_TRANS_TD_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_TRANS_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_TRANS_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_trans_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_TRANS_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_TRANS_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_TRANS_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_trans_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_TRANS_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_TRANS_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcore2_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCORE2_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCORE2_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vsleep_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vsleep_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_r2r_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_R2R_PDN_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_R2R_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_R2R_PDN_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_R2R_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vcore2_vsleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vcore2_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_VCORE2_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vcore2_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE2_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE2_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vcore2_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VCORE2_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VCORE2_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VCORE2_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_EN_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_EN_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_EN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_STBTD_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_STBTD_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_vpa_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_VPA_STB_MASK),
				  (unsigned int)(PMIC_DA_VPA_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vpa_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_EN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VPA_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VPA_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_FRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_sfchg_frate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_FRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_FRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_FEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_sfchg_fen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_FEN_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_FEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_RRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_sfchg_rrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_RRATE_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_RRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_SFCHG_REN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_sfchg_ren(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_REN_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_SFCHG_REN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vpa_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_VOL_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_VOL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_VOL_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_TRANS_TD_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_TRANS_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_trans_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_TRANS_TD_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_TRANS_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_TRANS_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_trans_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_TRANS_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_TRANS_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_TRANS_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_trans_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_TRANS_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_TRANS_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vpa_dvs_transt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA_DVS_TRANST_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA_DVS_TRANST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_dvs_bw_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_DVS_BW_TD_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_DVS_BW_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_dvs_bw_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_DVS_BW_TD_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_DVS_BW_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_dvs_bw_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_DVS_BW_CTRL_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_DVS_BW_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_dvs_bw_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_DVS_BW_CTRL_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_DVS_BW_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_vpa_dvs_bw_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_VPA_DVS_BW_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_VPA_DVS_BW_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_vpa_dvs_bw_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_VPA_DVS_BW_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_VPA_DVS_BW_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vpa_dvs_bw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_VPA_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VPA_DVS_BW_MASK),
				  (unsigned int)(PMIC_DA_NI_VPA_DVS_BW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_rst_done(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_RST_DONE_MASK),
				    (unsigned int)(PMIC_BUCK_K_RST_DONE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_rst_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_RST_DONE_MASK),
				  (unsigned int)(PMIC_BUCK_K_RST_DONE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_map_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_MAP_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_K_MAP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_map_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_MAP_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_K_MAP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_once_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_ONCE_EN_MASK),
				    (unsigned int)(PMIC_BUCK_K_ONCE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_once_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_ONCE_EN_MASK),
				  (unsigned int)(PMIC_BUCK_K_ONCE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_ONCE_MASK),
				    (unsigned int)(PMIC_BUCK_K_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_ONCE_MASK),
				  (unsigned int)(PMIC_BUCK_K_ONCE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_start_manual(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_START_MANUAL_MASK),
				    (unsigned int)(PMIC_BUCK_K_START_MANUAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_start_manual(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_START_MANUAL_MASK),
				  (unsigned int)(PMIC_BUCK_K_START_MANUAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_SRC_SEL_MASK),
				    (unsigned int)(PMIC_BUCK_K_SRC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_src_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_SRC_SEL_MASK),
				  (unsigned int)(PMIC_BUCK_K_SRC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_auto_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_AUTO_EN_MASK),
				    (unsigned int)(PMIC_BUCK_K_AUTO_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_auto_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_AUTO_EN_MASK),
				  (unsigned int)(PMIC_BUCK_K_AUTO_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_inv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_INV_MASK),
				    (unsigned int)(PMIC_BUCK_K_INV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_inv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON0),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_INV_MASK),
				  (unsigned int)(PMIC_BUCK_K_INV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_control_smps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_CONTROL_SMPS_MASK),
				    (unsigned int)(PMIC_BUCK_K_CONTROL_SMPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_control_smps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON1),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_CONTROL_SMPS_MASK),
				  (unsigned int)(PMIC_BUCK_K_CONTROL_SMPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_k_result(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_K_RESULT_MASK),
				  (unsigned int)(PMIC_K_RESULT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_k_done(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_K_DONE_MASK),
				  (unsigned int)(PMIC_K_DONE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_k_control(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_K_CONTROL_MASK),
				  (unsigned int)(PMIC_K_CONTROL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_smps_osc_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON2),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_SMPS_OSC_CAL_MASK),
				  (unsigned int)(PMIC_DA_QI_SMPS_OSC_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_buck_k_buck_ck_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BUCK_K_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BUCK_K_BUCK_CK_CNT_MASK),
				    (unsigned int)(PMIC_BUCK_K_BUCK_CK_CNT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_buck_k_buck_ck_cnt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BUCK_K_CON3),
				  (&val),
				  (unsigned int)(PMIC_BUCK_K_BUCK_CK_CNT_MASK),
				  (unsigned int)(PMIC_BUCK_K_BUCK_CK_CNT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_wdtdbg_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_WDTDBG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_WDTDBG_CLR_MASK),
				    (unsigned int)(PMIC_WDTDBG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_wdtdbg_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON0),
				  (&val),
				  (unsigned int)(PMIC_WDTDBG_CLR_MASK),
				  (unsigned int)(PMIC_WDTDBG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_wdtdbg_con0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_WDTDBG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_WDTDBG_CON0_RSV0_MASK),
				    (unsigned int)(PMIC_WDTDBG_CON0_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_wdtdbg_con0_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON0),
				  (&val),
				  (unsigned int)(PMIC_WDTDBG_CON0_RSV0_MASK),
				  (unsigned int)(PMIC_WDTDBG_CON0_RSV0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vproc_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON1),
				  (&val),
				  (unsigned int)(PMIC_VPROC_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VPROC_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vcore_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON1),
				  (&val),
				  (unsigned int)(PMIC_VCORE_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VCORE_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vpa_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON2),
				  (&val),
				  (unsigned int)(PMIC_VPA_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VPA_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vs1_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON2),
				  (&val),
				  (unsigned int)(PMIC_VS1_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VS1_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_vsram_proc_vosel_wdtdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_WDTDBG_CON3),
				  (&val),
				  (unsigned int)(PMIC_VSRAM_PROC_VOSEL_WDTDBG_MASK),
				  (unsigned int)(PMIC_VSRAM_PROC_VOSEL_WDTDBG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audzcdenable(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDZCDENABLE_MASK),
				    (unsigned int)(PMIC_RG_AUDZCDENABLE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audzcdenable(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDZCDENABLE_MASK),
				  (unsigned int)(PMIC_RG_AUDZCDENABLE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audzcdgainsteptime(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDZCDGAINSTEPTIME_MASK),
				    (unsigned int)(PMIC_RG_AUDZCDGAINSTEPTIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audzcdgainsteptime(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDZCDGAINSTEPTIME_MASK),
				  (unsigned int)(PMIC_RG_AUDZCDGAINSTEPTIME_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audzcdgainstepsize(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDZCDGAINSTEPSIZE_MASK),
				    (unsigned int)(PMIC_RG_AUDZCDGAINSTEPSIZE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audzcdgainstepsize(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDZCDGAINSTEPSIZE_MASK),
				  (unsigned int)(PMIC_RG_AUDZCDGAINSTEPSIZE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audzcdtimeoutmodesel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDZCDTIMEOUTMODESEL_MASK),
				    (unsigned int)(PMIC_RG_AUDZCDTIMEOUTMODESEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audzcdtimeoutmodesel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDZCDTIMEOUTMODESEL_MASK),
				  (unsigned int)(PMIC_RG_AUDZCDTIMEOUTMODESEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audzcdclksel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDZCDCLKSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDZCDCLKSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audzcdclksel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDZCDCLKSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDZCDCLKSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audzcdmuxsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDZCDMUXSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDZCDMUXSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audzcdmuxsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDZCDMUXSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDZCDMUXSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audlolgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDLOLGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDLOLGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audlolgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDLOLGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDLOLGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audlorgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDLORGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDLORGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audlorgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDLORGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDLORGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhplgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhplgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhsgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHSGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDHSGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhsgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHSGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDHSGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audivlgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIVLGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDIVLGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audivlgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIVLGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDIVLGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audivrgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ZCD_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIVRGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDIVRGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audivrgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIVRGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDIVRGAIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_audintgain1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDINTGAIN1_MASK),
				  (unsigned int)(PMIC_RG_AUDINTGAIN1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_audintgain2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ZCD_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDINTGAIN2_MASK),
				  (unsigned int)(PMIC_RG_AUDINTGAIN2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_ldo_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_LDO_RSV1_MASK),
				    (unsigned int)(PMIC_LDO_LDO_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_ldo_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_RSV_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_LDO_RSV1_MASK),
				  (unsigned int)(PMIC_LDO_LDO_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_ldo_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_RSV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_LDO_RSV0_MASK),
				    (unsigned int)(PMIC_LDO_LDO_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_ldo_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_RSV_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_LDO_RSV0_MASK),
				  (unsigned int)(PMIC_LDO_LDO_RSV0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ldo_ldo_rsv1_ro(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_RSV_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_LDO_RSV1_RO_MASK),
				  (unsigned int)(PMIC_LDO_LDO_RSV1_RO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_ldo_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_RSV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_LDO_RSV2_MASK),
				    (unsigned int)(PMIC_LDO_LDO_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_ldo_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_RSV_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_LDO_RSV2_MASK),
				  (unsigned int)(PMIC_LDO_LDO_RSV2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_auxadc_pwdb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_TOP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_AUXADC_PWDB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_AUXADC_PWDB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_auxadc_pwdb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_TOP_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_AUXADC_PWDB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_AUXADC_PWDB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vibr_ther_sdn_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_TOP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIBR_THER_SDN_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIBR_THER_SDN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vibr_ther_sdn_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_TOP_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIBR_THER_SDN_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIBR_THER_SDN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_top_con0_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_TOP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_TOP_CON0_RSV_MASK),
				    (unsigned int)(PMIC_LDO_TOP_CON0_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_top_con0_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_TOP_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_TOP_CON0_RSV_MASK),
				  (unsigned int)(PMIC_LDO_TOP_CON0_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_switch(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VTCXO24_SW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_SWITCH_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_SWITCH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_switch(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VTCXO24_SW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_SWITCH_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_SWITCH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_switch(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VXO22_SW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_SWITCH_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_SWITCH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_switch(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VXO22_SW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_SWITCH_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_SWITCH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_degtd_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_OCFB0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_DEGTD_SEL_MASK),
				    (unsigned int)(PMIC_LDO_DEGTD_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_degtd_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_OCFB0),
				  (&val),
				  (unsigned int)(PMIC_LDO_DEGTD_SEL_MASK),
				  (unsigned int)(PMIC_LDO_DEGTD_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrtc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VRTC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRTC_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRTC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrtc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRTC_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRTC_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrtc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRTC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRTC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_en_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_EN_BT_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_EN_BT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_en_bt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_EN_BT_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_EN_BT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_en_ctrl_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_BT_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_BT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_en_ctrl_bt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_BT_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_BT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_en_sel_bt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_EN_SEL_BT_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_EN_SEL_BT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_en_sel_bt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_EN_SEL_BT_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_EN_SEL_BT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_en_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_EN_WIFI_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_EN_WIFI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_en_wifi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_EN_WIFI_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_EN_WIFI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_en_ctrl_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_WIFI_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_WIFI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_en_ctrl_wifi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_WIFI_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_EN_CTRL_WIFI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_en_sel_wifi(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_EN_SEL_WIFI_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_EN_SEL_WIFI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_en_sel_wifi(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VCN33_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_EN_SEL_WIFI_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_EN_SEL_WIFI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn33_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn33_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn33_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN33_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN33_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCN33_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCN33_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN33_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN33_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_en_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VLDO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_EN_0_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_EN_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_en_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_EN_0_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_EN_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_en_1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_SHARE_VLDO28_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_EN_1_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_EN_1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_en_1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_SHARE_VLDO28_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_EN_1_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_EN_1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vldo28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VLDO28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VLDO28_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vldo28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VLDO28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VLDO28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vldo28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VLDO28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VLDO28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VLDO28_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vldo28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VLDO28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VLDO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VLDO28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_fast_tran_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_fast_tran_dl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_fast_tran_dl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_fast_tran_dl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_fast_tran_dl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vldo28_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VLDO28_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VLDO28_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_fast_tran_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_fast_tran_cl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_fast_tran_cl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vldo28_fast_tran_cl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vldo28_fast_tran_cl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VLDO28_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vldo28_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VLDO28_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VLDO28_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VLDO28_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vosel_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vosel_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vosel_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_HWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vosel_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_HWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_sfchg_frate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FRATE_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_sfchg_frate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FRATE_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_sfchg_fen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FEN_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_sfchg_fen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FEN_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_FEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_sfchg_rrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_RRATE_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_RRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_sfchg_rrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_RRATE_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_RRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_sfchg_ren(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_REN_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_REN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_sfchg_ren(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_SFCHG_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_REN_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_SFCHG_REN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vsram_proc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_PROC_VOSEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_PROC_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON1),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vosel_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_ON_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vosel_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON2),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_ON_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vosel_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SLEEP_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vosel_sleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_VOL_CON3),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SLEEP_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VOSEL_SLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_trans_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_TD_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_trans_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_TD_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_trans_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_trans_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_trans_once(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_ONCE_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_ONCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_trans_once(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_ONCE_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_TRANS_ONCE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsram_proc_dvs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_DVS_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_DVS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vsleep_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vsleep_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_r2r_pdn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_R2R_PDN_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_R2R_PDN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_R2R_PDN_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_R2R_PDN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_vsleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vsram_proc_r2r_pdn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_PROC_R2R_PDN_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_PROC_R2R_PDN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_vsram_proc_vsleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VSRAM_PROC_LPW_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_VSRAM_PROC_VSLEEP_SEL_MASK),
				  (unsigned int)(PMIC_DA_NI_VSRAM_PROC_VSLEEP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_baton_ht_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_BATON_HT_EN_MASK),
				    (unsigned int)(PMIC_LDO_BATON_HT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_baton_ht_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_BATON_HT_EN_MASK),
				  (unsigned int)(PMIC_LDO_BATON_HT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_baton_ht_en_dly_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_BATON_HT_EN_DLY_TIME_MASK),
				    (unsigned int)(PMIC_LDO_BATON_HT_EN_DLY_TIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_baton_ht_en_dly_time(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_BATON_HT_EN_DLY_TIME_MASK),
				  (unsigned int)(PMIC_LDO_BATON_HT_EN_DLY_TIME_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_baton_ht_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_BATON_HT_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_BATON_HT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_tref_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_TREF_EN_MASK),
				    (unsigned int)(PMIC_LDO_TREF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_tref_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_TREF_EN_MASK),
				  (unsigned int)(PMIC_LDO_TREF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_tref_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_TREF_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_TREF_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_tref_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_TREF_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_TREF_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_tref_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_TREF_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_TREF_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_tref_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_TREF_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_TREF_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_tref_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO2_TREF_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_TREF_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_TREF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_EN_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_EN_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO28_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO28_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_EN_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_EN_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo24_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo24_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo24_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vtcxo24_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VTCXO24_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VTCXO24_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VTCXO24_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vtcxo24_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VTCXO24_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VTCXO24_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vtcxo24_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VTCXO24_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VTCXO24_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_EN_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_EN_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vxo22_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vxo22_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vxo22_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vxo22_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VXO22_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VXO22_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VXO22_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vxo22_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VXO22_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VXO22_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vxo22_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VXO22_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VXO22_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VXO22_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF18_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRF18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRF18_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf12_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf12_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf12_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VRF12_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf12_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VRF12_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_fast_tran_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_fast_tran_dl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_fast_tran_dl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_fast_tran_dl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_fast_tran_dl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf12_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_fast_tran_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_fast_tran_cl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_fast_tran_cl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vrf12_fast_tran_cl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vrf12_fast_tran_cl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VRF12_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vrf12_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VRF12_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VRF12_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VRF12_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN28_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCN28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCN28_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcn18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VCN18_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCN18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCN18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcn18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCN18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCN18_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcn18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VCN18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCN18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCN18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcama_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMA_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VCAMA_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcama_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMA_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VCAMA_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcama_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMA_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCAMA_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcama_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMA_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCAMA_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcama_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcama_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMA_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VCAMA_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcama_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMA_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VCAMA_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcama_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcama_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcama_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMA_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMA_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCAMA_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcama_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMA_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCAMA_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcama_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMA_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMA_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMA_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamio_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMIO_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VCAMIO_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamio_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMIO_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VCAMIO_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamio_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMIO_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCAMIO_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamio_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMIO_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCAMIO_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamio_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamio_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMIO_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VCAMIO_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamio_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMIO_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VCAMIO_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamio_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamio_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamio_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMIO_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMIO_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCAMIO_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamio_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMIO_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCAMIO_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamio_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMIO_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMIO_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamd_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMD_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VCAMD_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamd_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMD_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VCAMD_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamd_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMD_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCAMD_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMD_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCAMD_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamd_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamd_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMD_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VCAMD_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamd_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMD_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VCAMD_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamd_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vcamd_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VCAMD_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VCAMD_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VCAMD_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vcamd_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VCAMD_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VCAMD_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vcamd_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VCAMD_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VCAMD_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VCAMD_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_EN_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_EN_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaux18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUX18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUX18_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaux18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUX18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUX18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaux18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUX18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUX18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaux18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUX18_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUX18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VAUX18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaux18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUX18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VAUX18_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaux18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUX18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUX18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUX18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_EN_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_EN_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaud28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUD28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUD28_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaud28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUD28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUD28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaud28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUD28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUD28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vaud28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VAUD28_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VAUD28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VAUD28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vaud28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VAUD28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VAUD28_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vaud28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VAUD28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VAUD28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VAUD28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsram_proc_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_STBTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_en_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_en_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_EN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsram_proc_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsram_proc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsram_proc_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSRAM_PROC_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsram_proc_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSRAM_PROC_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsram_proc_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO3_VSRAM_PROC_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSRAM_PROC_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_EN_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_EN_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vdram_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vdram_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vdram_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VDRAM_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vdram_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VDRAM_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_fast_tran_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_fast_tran_dl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_fast_tran_dl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_fast_tran_dl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_fast_tran_dl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vdram_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_fast_tran_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_fast_tran_cl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_fast_tran_cl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vdram_fast_tran_cl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vdram_fast_tran_cl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VDRAM_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vdram_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VDRAM_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VDRAM_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VDRAM_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim1_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM1_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VSIM1_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim1_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM1_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VSIM1_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim1_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM1_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSIM1_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM1_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSIM1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim1_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM1_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VSIM1_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim1_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM1_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VSIM1_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim1_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM1_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VSIM1_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim1_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM1_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VSIM1_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim1_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM1_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VSIM1_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim1_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM1_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VSIM1_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim1_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim1_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim1_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM1_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM1_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSIM1_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSIM1_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim1_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM1_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM1_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM1_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim2_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM2_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VSIM2_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim2_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM2_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VSIM2_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim2_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM2_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSIM2_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM2_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSIM2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim2_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM2_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VSIM2_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim2_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM2_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VSIM2_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim2_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM2_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VSIM2_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim2_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM2_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VSIM2_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim2_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM2_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VSIM2_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim2_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM2_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VSIM2_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim2_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim2_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vsim2_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VSIM2_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VSIM2_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VSIM2_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vsim2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VSIM2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VSIM2_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vsim2_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VSIM2_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VSIM2_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VSIM2_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio28_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO28_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VIO28_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio28_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO28_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VIO28_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio28_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO28_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIO28_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO28_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIO28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio28_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO28_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VIO28_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio28_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO28_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VIO28_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio28_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO28_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VIO28_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio28_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO28_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VIO28_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio28_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio28_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO28_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VIO28_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio28_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO28_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VIO28_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio28_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio28_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio28_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO28_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO28_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIO28_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIO28_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio28_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO28_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO28_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO28_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VMC_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VMC_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VMC_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VMC_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VMC_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VMC_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmc_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VMC_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VMC_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmc_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMC_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMC_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMC_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmc_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMC_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_fast_tran_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_fast_tran_dl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_fast_tran_dl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_fast_tran_dl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_fast_tran_dl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmc_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_fast_tran_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_fast_tran_cl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_fast_tran_cl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmc_fast_tran_cl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmc_fast_tran_cl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VMC_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmc_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMC_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMC_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMC_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmch_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmch_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmch_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VMCH_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmch_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VMCH_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_fast_tran_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_fast_tran_dl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_fast_tran_dl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_fast_tran_dl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_fast_tran_dl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmch_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_fast_tran_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_fast_tran_cl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_fast_tran_cl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vmch_fast_tran_cl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vmch_fast_tran_cl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VMCH_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vmch_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VMCH_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VMCH_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VMCH_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vusb33_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VUSB33_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VUSB33_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vusb33_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VUSB33_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VUSB33_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vusb33_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VUSB33_EN_MASK),
				    (unsigned int)(PMIC_LDO_VUSB33_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vusb33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VUSB33_EN_MASK),
				  (unsigned int)(PMIC_LDO_VUSB33_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vusb33_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VUSB33_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VUSB33_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vusb33_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VUSB33_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VUSB33_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vusb33_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VUSB33_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VUSB33_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vusb33_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VUSB33_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VUSB33_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vusb33_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vusb33_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VUSB33_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VUSB33_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vusb33_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VUSB33_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VUSB33_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vusb33_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vusb33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vusb33_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VUSB33_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VUSB33_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VUSB33_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vusb33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VUSB33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VUSB33_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vusb33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VUSB33_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VUSB33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VUSB33_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_EN_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_EN_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vemc33_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC33_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC33_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vemc33_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC33_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC33_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vemc33_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC33_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC33_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VEMC33_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vemc33_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VEMC33_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC33_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC33_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_fast_tran_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_fast_tran_dl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_fast_tran_dl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_fast_tran_dl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_fast_tran_dl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_DL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vemc33_fast_tran_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC33_FAST_TRAN_DL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC33_FAST_TRAN_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_fast_tran_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_EN_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_fast_tran_cl_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_fast_tran_cl_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vemc33_fast_tran_cl_srclken_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vemc33_fast_tran_cl_srclken_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_SRCLKEN_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VEMC33_FAST_TRAN_CL_SRCLKEN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vemc33_fast_tran_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO_VEMC33_FAST_TRAN_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VEMC33_FAST_TRAN_CL_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VEMC33_FAST_TRAN_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio18_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO18_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VIO18_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio18_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO18_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VIO18_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio18_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO18_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIO18_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO18_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIO18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio18_lp_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO18_LP_CTRL_MASK),
				    (unsigned int)(PMIC_LDO_VIO18_LP_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio18_lp_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO18_LP_CTRL_MASK),
				  (unsigned int)(PMIC_LDO_VIO18_LP_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio18_lp_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO18_LP_SEL_MASK),
				    (unsigned int)(PMIC_LDO_VIO18_LP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio18_lp_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO18_LP_SEL_MASK),
				  (unsigned int)(PMIC_LDO_VIO18_LP_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio18_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio18_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO18_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VIO18_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio18_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO18_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VIO18_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio18_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio18_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vio18_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO1_VIO18_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIO18_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIO18_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vio18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIO18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIO18_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vio18_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO1_VIO18_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIO18_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIO18_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vibr_lp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIBR_LP_MODE_MASK),
				    (unsigned int)(PMIC_LDO_VIBR_LP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vibr_lp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIBR_LP_MODE_MASK),
				  (unsigned int)(PMIC_LDO_VIBR_LP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vibr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIBR_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIBR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vibr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIBR_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIBR_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vibr_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_MODE_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vibr_stbtd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIBR_STBTD_MASK),
				    (unsigned int)(PMIC_LDO_VIBR_STBTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vibr_stbtd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIBR_STBTD_MASK),
				  (unsigned int)(PMIC_LDO_VIBR_STBTD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vibr_stb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_STB_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_STB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vibr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_ldo_vibr_ocfb_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_LDO0_VIBR_OCFB_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_LDO_VIBR_OCFB_EN_MASK),
				    (unsigned int)(PMIC_LDO_VIBR_OCFB_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_ldo_vibr_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_LDO_VIBR_OCFB_EN_MASK),
				  (unsigned int)(PMIC_LDO_VIBR_OCFB_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_qi_vibr_ocfb_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_LDO0_VIBR_OCFB_CON0),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_VIBR_OCFB_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_VIBR_OCFB_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vtcxo28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTCXO28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VTCXO28_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vtcxo28_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VTCXO28_CAL_MASK),
				  (unsigned int)(PMIC_RG_VTCXO28_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vtcxo28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTCXO28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VTCXO28_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vtcxo28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VTCXO28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VTCXO28_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vtcxo28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTCXO28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VTCXO28_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vtcxo28_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VTCXO28_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VTCXO28_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vaud28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VAUD28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VAUD28_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vaud28_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VAUD28_CAL_MASK),
				  (unsigned int)(PMIC_RG_VAUD28_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vaud28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VAUD28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VAUD28_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vaud28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VAUD28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VAUD28_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vaud28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VAUD28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VAUD28_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vaud28_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VAUD28_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VAUD28_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCN28_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn28_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN28_CAL_MASK),
				  (unsigned int)(PMIC_RG_VCN28_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCN28_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCN28_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN28_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn28_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN28_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCN28_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vaux18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VAUX18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VAUX18_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vaux18_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VAUX18_CAL_MASK),
				  (unsigned int)(PMIC_RG_VAUX18_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vaux18_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VAUX18_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VAUX18_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vaux18_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VAUX18_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VAUX18_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vaux18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VAUX18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VAUX18_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vaux18_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VAUX18_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VAUX18_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcama_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcama_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMA_CAL_MASK),
				  (unsigned int)(PMIC_RG_VCAMA_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcama_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMA_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcama_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMA_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMA_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcama_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMA_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMA_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcama_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMA_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCAMA_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aldo_rsv_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ALDO_RSV_H_MASK),
				    (unsigned int)(PMIC_RG_ALDO_RSV_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aldo_rsv_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_ALDO_RSV_H_MASK),
				  (unsigned int)(PMIC_RG_ALDO_RSV_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aldo_rsv_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ALDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ALDO_RSV_L_MASK),
				    (unsigned int)(PMIC_RG_ALDO_RSV_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aldo_rsv_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ALDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_ALDO_RSV_L_MASK),
				  (unsigned int)(PMIC_RG_ALDO_RSV_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vxo22_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_CAL_MASK),
				    (unsigned int)(PMIC_RG_VXO22_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vxo22_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VXO22_CAL_MASK),
				  (unsigned int)(PMIC_RG_VXO22_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vxo22_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VXO22_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vxo22_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VXO22_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VXO22_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vxo22_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VXO22_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VXO22_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vxo22_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VXO22_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VXO22_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vtcxo24_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTCXO24_CAL_MASK),
				    (unsigned int)(PMIC_RG_VTCXO24_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vtcxo24_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VTCXO24_CAL_MASK),
				  (unsigned int)(PMIC_RG_VTCXO24_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vtcxo24_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTCXO24_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VTCXO24_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vtcxo24_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VTCXO24_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VTCXO24_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vtcxo24_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VTCXO24_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VTCXO24_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vtcxo24_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VTCXO24_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VTCXO24_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsim1_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_CAL_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsim1_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VSIM1_CAL_MASK),
				  (unsigned int)(PMIC_RG_VSIM1_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsim1_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsim1_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VSIM1_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VSIM1_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsim1_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsim1_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VSIM1_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsim2_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_CAL_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsim2_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VSIM2_CAL_MASK),
				  (unsigned int)(PMIC_RG_VSIM2_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsim2_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsim2_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VSIM2_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VSIM2_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsim2_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsim2_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VSIM2_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn33_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCN33_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn33_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN33_CAL_MASK),
				  (unsigned int)(PMIC_RG_VCN33_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn33_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCN33_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn33_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN33_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCN33_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn33_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN33_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN33_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn33_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN33_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCN33_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vusb33_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_CAL_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vusb33_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VUSB33_CAL_MASK),
				  (unsigned int)(PMIC_RG_VUSB33_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vusb33_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VUSB33_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VUSB33_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vusb33_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VUSB33_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VUSB33_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_CAL_MASK),
				    (unsigned int)(PMIC_RG_VMCH_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_CAL_MASK),
				  (unsigned int)(PMIC_RG_VMCH_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VMCH_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VMCH_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VMCH_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VMCH_OC_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_oc_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_OC_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VMCH_OC_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VMCH_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_RG_VMCH_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_DL_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_DL_EN_MASK),
				  (unsigned int)(PMIC_RG_VMCH_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_CL_EN_MASK),
				    (unsigned int)(PMIC_RG_VMCH_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_CL_EN_MASK),
				  (unsigned int)(PMIC_RG_VMCH_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmch_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMCH_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VMCH_STB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmch_stb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VMCH_STB_SEL_MASK),
				  (unsigned int)(PMIC_RG_VMCH_STB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_CAL_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_CAL_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_oc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_OC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_OC_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_oc_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_OC_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_OC_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_DL_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_DL_EN_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_CL_EN_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_CL_EN_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vemc33_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VEMC33_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VEMC33_STB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vemc33_stb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_VEMC33_STB_SEL_MASK),
				  (unsigned int)(PMIC_RG_VEMC33_STB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vio28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VIO28_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vio28_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_VIO28_CAL_MASK),
				  (unsigned int)(PMIC_RG_VIO28_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vio28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO28_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vio28_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_VIO28_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VIO28_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vibr_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_CAL_MASK),
				    (unsigned int)(PMIC_RG_VIBR_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vibr_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON11),
				  (&val),
				  (unsigned int)(PMIC_RG_VIBR_CAL_MASK),
				  (unsigned int)(PMIC_RG_VIBR_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vibr_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VIBR_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vibr_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON11),
				  (&val),
				  (unsigned int)(PMIC_RG_VIBR_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VIBR_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vibr_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIBR_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VIBR_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vibr_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON11),
				  (&val),
				  (unsigned int)(PMIC_RG_VIBR_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VIBR_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vldo28_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VLDO28_CAL_MASK),
				    (unsigned int)(PMIC_RG_VLDO28_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vldo28_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VLDO28_CAL_MASK),
				  (unsigned int)(PMIC_RG_VLDO28_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vldo28_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VLDO28_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VLDO28_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vldo28_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VLDO28_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VLDO28_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vldo28_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VLDO28_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VLDO28_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vldo28_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VLDO28_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VLDO28_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vldo28_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VLDO28_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VLDO28_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vldo28_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_VLDO28_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_RG_VLDO28_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vldo28_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VLDO28_DL_EN_MASK),
				    (unsigned int)(PMIC_RG_VLDO28_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vldo28_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_VLDO28_DL_EN_MASK),
				  (unsigned int)(PMIC_RG_VLDO28_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vldo28_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VLDO28_CL_EN_MASK),
				    (unsigned int)(PMIC_RG_VLDO28_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vldo28_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_VLDO28_CL_EN_MASK),
				  (unsigned int)(PMIC_RG_VLDO28_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmc_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_CAL_MASK),
				    (unsigned int)(PMIC_RG_VMC_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmc_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_VMC_CAL_MASK),
				  (unsigned int)(PMIC_RG_VMC_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmc_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VMC_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_VMC_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VMC_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmc_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmc_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_VMC_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VMC_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmc_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VMC_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmc_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_VMC_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_RG_VMC_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmc_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_DL_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmc_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_VMC_DL_EN_MASK),
				  (unsigned int)(PMIC_RG_VMC_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vmc_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VMC_CL_EN_MASK),
				    (unsigned int)(PMIC_RG_VMC_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vmc_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_VMC_CL_EN_MASK),
				  (unsigned int)(PMIC_RG_VMC_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dldo_rsv_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DLDO_RSV_H_MASK),
				    (unsigned int)(PMIC_RG_DLDO_RSV_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dldo_rsv_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_DLDO_RSV_H_MASK),
				  (unsigned int)(PMIC_RG_DLDO_RSV_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dldo_rsv_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DLDO_ANA_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DLDO_RSV_L_MASK),
				    (unsigned int)(PMIC_RG_DLDO_RSV_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dldo_rsv_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DLDO_ANA_CON17),
				  (&val),
				  (unsigned int)(PMIC_RG_DLDO_RSV_L_MASK),
				  (unsigned int)(PMIC_RG_DLDO_RSV_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcamd_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMD_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcamd_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMD_CAL_MASK),
				  (unsigned int)(PMIC_RG_VCAMD_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcamd_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMD_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcamd_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMD_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMD_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcamd_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMD_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMD_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcamd_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMD_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCAMD_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VRF18_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf18_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF18_CAL_MASK),
				  (unsigned int)(PMIC_RG_VRF18_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF18_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf18_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF18_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VRF18_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_CAL_MASK),
				    (unsigned int)(PMIC_RG_VRF12_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_CAL_MASK),
				  (unsigned int)(PMIC_RG_VRF12_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VRF12_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VRF12_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VRF12_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_stb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_STB_SEL_MASK),
				    (unsigned int)(PMIC_RG_VRF12_STB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_stb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_STB_SEL_MASK),
				  (unsigned int)(PMIC_RG_VRF12_STB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_dummy_load(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_DUMMY_LOAD_MASK),
				    (unsigned int)(PMIC_RG_VRF12_DUMMY_LOAD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_dummy_load(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_DUMMY_LOAD_MASK),
				  (unsigned int)(PMIC_RG_VRF12_DUMMY_LOAD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_DL_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_DL_EN_MASK),
				  (unsigned int)(PMIC_RG_VRF12_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vrf12_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VRF12_CL_EN_MASK),
				    (unsigned int)(PMIC_RG_VRF12_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vrf12_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VRF12_CL_EN_MASK),
				  (unsigned int)(PMIC_RG_VRF12_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vio18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VIO18_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vio18_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VIO18_CAL_MASK),
				  (unsigned int)(PMIC_RG_VIO18_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vio18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VIO18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VIO18_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vio18_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_VIO18_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VIO18_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vdram_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CAL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vdram_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VDRAM_CAL_MASK),
				  (unsigned int)(PMIC_RG_VDRAM_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vdram_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vdram_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VDRAM_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VDRAM_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vdram_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vdram_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VDRAM_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VDRAM_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vdram_pcur_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_PCUR_CAL_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_PCUR_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vdram_pcur_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VDRAM_PCUR_CAL_MASK),
				  (unsigned int)(PMIC_RG_VDRAM_PCUR_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vdram_dl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_DL_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_DL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vdram_dl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VDRAM_DL_EN_MASK),
				  (unsigned int)(PMIC_RG_VDRAM_DL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vdram_cl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VDRAM_CL_EN_MASK),
				    (unsigned int)(PMIC_RG_VDRAM_CL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vdram_cl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_VDRAM_CL_EN_MASK),
				  (unsigned int)(PMIC_RG_VDRAM_CL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcamio_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcamio_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMIO_CAL_MASK),
				  (unsigned int)(PMIC_RG_VCAMIO_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcamio_vosel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_VOSEL_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_VOSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcamio_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMIO_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VCAMIO_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcamio_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCAMIO_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCAMIO_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcamio_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VCAMIO_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCAMIO_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn18_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_CAL_MASK),
				    (unsigned int)(PMIC_RG_VCN18_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn18_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN18_CAL_MASK),
				  (unsigned int)(PMIC_RG_VCN18_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcn18_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCN18_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VCN18_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcn18_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VCN18_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VCN18_NDIS_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_vsram_proc_vosel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_VOSEL_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_VOSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_ndis_plcur(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_PLCUR_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_PLCUR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_ndis_plcur(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_PLCUR_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_PLCUR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_ndis_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_ndis_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_EN_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_NDIS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vsram_proc_plcur_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_PLCUR_EN_MASK),
				    (unsigned int)(PMIC_RG_VSRAM_PROC_PLCUR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vsram_proc_plcur_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_PLCUR_EN_MASK),
				  (unsigned int)(PMIC_RG_VSRAM_PROC_PLCUR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_sldo_rsv_h(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLDO_RSV_H_MASK),
				    (unsigned int)(PMIC_RG_SLDO_RSV_H_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_sldo_rsv_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_SLDO_RSV_H_MASK),
				  (unsigned int)(PMIC_RG_SLDO_RSV_H_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_sldo_rsv_l(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SLDO_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SLDO_RSV_L_MASK),
				    (unsigned int)(PMIC_RG_SLDO_RSV_L_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_sldo_rsv_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SLDO_ANA_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_SLDO_RSV_L_MASK),
				  (unsigned int)(PMIC_RG_SLDO_RSV_L_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_pa(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PA_MASK),
				    (unsigned int)(PMIC_RG_OTP_PA_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_pa(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PA_MASK),
				  (unsigned int)(PMIC_RG_OTP_PA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_pdin(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PDIN_MASK),
				    (unsigned int)(PMIC_RG_OTP_PDIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_pdin(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PDIN_MASK),
				  (unsigned int)(PMIC_RG_OTP_PDIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_ptm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PTM_MASK),
				    (unsigned int)(PMIC_RG_OTP_PTM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_ptm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PTM_MASK),
				  (unsigned int)(PMIC_RG_OTP_PTM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_pwe(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PWE_MASK),
				    (unsigned int)(PMIC_RG_OTP_PWE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_pwe(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PWE_MASK),
				  (unsigned int)(PMIC_RG_OTP_PWE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_pprog(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PPROG_MASK),
				    (unsigned int)(PMIC_RG_OTP_PPROG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_pprog(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PPROG_MASK),
				  (unsigned int)(PMIC_RG_OTP_PPROG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_pwe_src(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PWE_SRC_MASK),
				    (unsigned int)(PMIC_RG_OTP_PWE_SRC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_pwe_src(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PWE_SRC_MASK),
				  (unsigned int)(PMIC_RG_OTP_PWE_SRC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_prog_pkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_PROG_PKEY_MASK),
				    (unsigned int)(PMIC_RG_OTP_PROG_PKEY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_prog_pkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PROG_PKEY_MASK),
				  (unsigned int)(PMIC_RG_OTP_PROG_PKEY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_rd_pkey(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_RD_PKEY_MASK),
				    (unsigned int)(PMIC_RG_OTP_RD_PKEY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_rd_pkey(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_PKEY_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_PKEY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_rd_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_RD_TRIG_MASK),
				    (unsigned int)(PMIC_RG_OTP_RD_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_rd_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_TRIG_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_TRIG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rd_rdy_bypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RD_RDY_BYPASS_MASK),
				    (unsigned int)(PMIC_RG_RD_RDY_BYPASS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rd_rdy_bypass(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_RD_RDY_BYPASS_MASK),
				  (unsigned int)(PMIC_RG_RD_RDY_BYPASS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_skip_otp_out(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SKIP_OTP_OUT_MASK),
				    (unsigned int)(PMIC_RG_SKIP_OTP_OUT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_skip_otp_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_SKIP_OTP_OUT_MASK),
				  (unsigned int)(PMIC_RG_SKIP_OTP_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_rd_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_RD_SW_MASK),
				    (unsigned int)(PMIC_RG_OTP_RD_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_rd_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON11),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_SW_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_SW_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_rd_busy(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_BUSY_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_BUSY_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_rd_ack(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_RD_ACK_MASK),
				  (unsigned int)(PMIC_RG_OTP_RD_ACK_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_pa_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_PA_SW_MASK),
				  (unsigned int)(PMIC_RG_OTP_PA_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_0_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_0_15),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_0_15_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_0_15_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_16_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_16_31),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_16_31_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_16_31_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_32_47(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_32_47),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_32_47_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_32_47_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_48_63(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_48_63),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_48_63_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_48_63_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_64_79(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_64_79),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_64_79_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_64_79_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_80_95(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_80_95),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_80_95_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_80_95_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_96_111(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_96_111),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_96_111_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_96_111_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_112_127(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_112_127),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_112_127_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_112_127_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_128_143(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_128_143),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_128_143_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_128_143_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_144_159(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_144_159),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_144_159_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_144_159_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_160_175(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_160_175),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_160_175_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_160_175_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_176_191(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_176_191),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_176_191_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_176_191_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_192_207(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_192_207),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_192_207_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_192_207_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_208_223(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_208_223),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_208_223_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_208_223_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_224_239(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_224_239),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_224_239_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_224_239_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_240_255(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_240_255),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_240_255_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_240_255_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_256_271(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_256_271),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_256_271_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_256_271_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_272_287(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_272_287),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_272_287_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_272_287_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_288_303(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_288_303),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_288_303_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_288_303_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_304_319(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_304_319),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_304_319_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_304_319_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_320_335(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_320_335),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_320_335_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_320_335_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_336_351(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_336_351),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_336_351_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_336_351_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_352_367(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_352_367),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_352_367_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_352_367_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_368_383(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_368_383),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_368_383_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_368_383_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_384_399(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_384_399),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_384_399_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_384_399_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_400_415(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_400_415),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_400_415_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_400_415_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_416_431(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_416_431),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_416_431_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_416_431_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_432_447(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_432_447),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_432_447_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_432_447_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_448_463(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_448_463),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_448_463_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_448_463_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_464_479(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_464_479),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_464_479_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_464_479_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_480_495(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_480_495),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_480_495_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_480_495_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rg_otp_dout_496_511(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_DOUT_496_511),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_DOUT_496_511_MASK),
				  (unsigned int)(PMIC_RG_OTP_DOUT_496_511_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_0_15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_0_15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_0_15_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_0_15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_0_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_0_15),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_0_15_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_0_15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_16_31(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_16_31),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_16_31_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_16_31_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_16_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_16_31),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_16_31_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_16_31_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_32_47(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_32_47),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_32_47_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_32_47_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_32_47(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_32_47),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_32_47_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_32_47_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_48_63(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_48_63),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_48_63_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_48_63_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_48_63(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_48_63),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_48_63_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_48_63_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_64_79(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_64_79),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_64_79_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_64_79_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_64_79(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_64_79),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_64_79_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_64_79_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_80_95(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_80_95),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_80_95_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_80_95_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_80_95(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_80_95),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_80_95_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_80_95_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_96_111(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_96_111),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_96_111_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_96_111_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_96_111(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_96_111),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_96_111_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_96_111_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_112_127(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_112_127),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_112_127_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_112_127_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_112_127(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_112_127),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_112_127_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_112_127_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_128_143(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_128_143),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_128_143_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_128_143_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_128_143(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_128_143),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_128_143_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_128_143_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_144_159(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_144_159),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_144_159_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_144_159_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_144_159(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_144_159),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_144_159_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_144_159_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_160_175(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_160_175),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_160_175_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_160_175_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_160_175(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_160_175),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_160_175_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_160_175_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_176_191(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_176_191),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_176_191_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_176_191_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_176_191(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_176_191),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_176_191_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_176_191_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_192_207(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_192_207),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_192_207_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_192_207_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_192_207(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_192_207),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_192_207_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_192_207_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_208_223(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_208_223),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_208_223_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_208_223_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_208_223(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_208_223),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_208_223_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_208_223_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_224_239(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_224_239),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_224_239_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_224_239_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_224_239(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_224_239),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_224_239_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_224_239_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_240_255(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_240_255),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_240_255_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_240_255_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_240_255(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_240_255),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_240_255_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_240_255_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_256_271(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_256_271),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_256_271_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_256_271_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_256_271(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_256_271),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_256_271_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_256_271_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_272_287(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_272_287),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_272_287_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_272_287_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_272_287(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_272_287),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_272_287_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_272_287_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_288_303(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_288_303),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_288_303_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_288_303_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_288_303(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_288_303),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_288_303_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_288_303_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_304_319(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_304_319),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_304_319_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_304_319_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_304_319(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_304_319),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_304_319_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_304_319_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_320_335(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_320_335),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_320_335_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_320_335_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_320_335(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_320_335),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_320_335_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_320_335_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_336_351(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_336_351),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_336_351_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_336_351_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_336_351(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_336_351),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_336_351_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_336_351_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_352_367(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_352_367),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_352_367_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_352_367_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_352_367(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_352_367),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_352_367_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_352_367_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_368_383(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_368_383),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_368_383_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_368_383_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_368_383(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_368_383),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_368_383_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_368_383_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_384_399(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_384_399),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_384_399_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_384_399_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_384_399(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_384_399),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_384_399_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_384_399_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_400_415(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_400_415),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_400_415_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_400_415_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_400_415(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_400_415),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_400_415_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_400_415_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_416_431(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_416_431),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_416_431_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_416_431_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_416_431(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_416_431),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_416_431_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_416_431_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_432_447(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_432_447),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_432_447_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_432_447_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_432_447(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_432_447),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_432_447_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_432_447_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_448_463(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_448_463),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_448_463_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_448_463_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_448_463(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_448_463),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_448_463_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_448_463_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_464_479(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_464_479),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_464_479_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_464_479_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_464_479(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_464_479),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_464_479_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_464_479_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_480_495(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_480_495),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_480_495_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_480_495_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_480_495(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_480_495),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_480_495_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_480_495_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otp_val_496_511(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_OTP_VAL_496_511),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTP_VAL_496_511_MASK),
				    (unsigned int)(PMIC_RG_OTP_VAL_496_511_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otp_val_496_511(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_OTP_VAL_496_511),
				  (&val),
				  (unsigned int)(PMIC_RG_OTP_VAL_496_511_MASK),
				  (unsigned int)(PMIC_RG_OTP_VAL_496_511_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_mix_eosc32_stp_lpdtb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_LPDTB_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_LPDTB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_eosc32_stp_lpden(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_LPDEN_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_LPDEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_eosc32_stp_lpden(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_LPDEN_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_LPDEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_xosc32_stp_pwdb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_PWDB_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_PWDB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_xosc32_stp_pwdb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_PWDB_MASK),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_PWDB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_mix_xosc32_stp_lpdtb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDTB_MASK),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDTB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_xosc32_stp_lpden(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDEN_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_xosc32_stp_lpden(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDEN_MASK),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_xosc32_stp_lpdrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDRST_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_LPDRST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_xosc32_stp_lpdrst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDRST_MASK),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_LPDRST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_xosc32_stp_cali(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_CALI_MASK),
				    (unsigned int)(PMIC_MIX_XOSC32_STP_CALI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_xosc32_stp_cali(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_CALI_MASK),
				  (unsigned int)(PMIC_MIX_XOSC32_STP_CALI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_stmp_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_STMP_MODE_MASK),
				    (unsigned int)(PMIC_STMP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_stmp_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON0),
				  (&val),
				  (unsigned int)(PMIC_STMP_MODE_MASK),
				  (unsigned int)(PMIC_STMP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_eosc32_stp_chop_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_CHOP_EN_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_CHOP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_eosc32_stp_chop_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_CHOP_EN_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_CHOP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_dcxo_stp_lvsh_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_MASK),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_dcxo_stp_lvsh_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_MASK),
				  (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_pmu_stp_ddlo_vrtc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_MASK),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_pmu_stp_ddlo_vrtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_MASK),
				  (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_pmu_stp_ddlo_vrtc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_EN_MASK),
				    (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_pmu_stp_ddlo_vrtc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_EN_MASK),
				  (unsigned int)(PMIC_MIX_PMU_STP_DDLO_VRTC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_stp_xosc32_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_XOSC32_ENB_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_XOSC32_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_stp_xosc32_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_STP_XOSC32_ENB_MASK),
				  (unsigned int)(PMIC_MIX_RTC_STP_XOSC32_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_dcxo_stp_test_deglitch_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_MASK),
				    (unsigned int)(PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_dcxo_stp_test_deglitch_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_MASK),
				  (unsigned int)(PMIC_MIX_DCXO_STP_TEST_DEGLITCH_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_eosc32_stp_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_RSV_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_STP_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_eosc32_stp_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_RSV_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_STP_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_eosc32_vct_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_VCT_EN_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_VCT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_eosc32_vct_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_VCT_EN_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_VCT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_eosc32_opt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EOSC32_OPT_MASK),
				    (unsigned int)(PMIC_MIX_EOSC32_OPT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_eosc32_opt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_EOSC32_OPT_MASK),
				  (unsigned int)(PMIC_MIX_EOSC32_OPT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_dcxo_stp_lvsh_en_int(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_INT_MASK),
				    (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_INT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_dcxo_stp_lvsh_en_int(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_INT_MASK),
				  (unsigned int)(PMIC_MIX_DCXO_STP_LVSH_EN_INT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_gpio_coredetb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_COREDETB_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_COREDETB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_gpio_coredetb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_COREDETB_MASK),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_COREDETB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_gpio_f32kob(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_F32KOB_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_F32KOB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_gpio_f32kob(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_F32KOB_MASK),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_F32KOB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_gpio_gpo(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_GPO_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_GPO_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_gpio_gpo(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_GPO_MASK),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_GPO_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_gpio_oe(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_OE_MASK),
				    (unsigned int)(PMIC_MIX_RTC_GPIO_OE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_gpio_oe(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON1),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_OE_MASK),
				  (unsigned int)(PMIC_MIX_RTC_GPIO_OE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_mix_rtc_stp_debug_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_OUT_MASK),
				  (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_stp_debug_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_SEL_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_stp_debug_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_SEL_MASK),
				  (unsigned int)(PMIC_MIX_RTC_STP_DEBUG_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_stp_k_eosc32_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_K_EOSC32_EN_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_K_EOSC32_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_stp_k_eosc32_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_STP_K_EOSC32_EN_MASK),
				  (unsigned int)(PMIC_MIX_RTC_STP_K_EOSC32_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_rtc_stp_embck_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_RTC_STP_EMBCK_SEL_MASK),
				    (unsigned int)(PMIC_MIX_RTC_STP_EMBCK_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_rtc_stp_embck_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_STP_EMBCK_SEL_MASK),
				  (unsigned int)(PMIC_MIX_RTC_STP_EMBCK_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_stp_bbwakeup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_STP_BBWAKEUP_MASK),
				    (unsigned int)(PMIC_MIX_STP_BBWAKEUP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_stp_bbwakeup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_STP_BBWAKEUP_MASK),
				  (unsigned int)(PMIC_MIX_STP_BBWAKEUP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_mix_stp_rtc_ddlo(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_STP_RTC_DDLO_MASK),
				  (unsigned int)(PMIC_MIX_STP_RTC_DDLO_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_mix_rtc_xosc32_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_RTC_XOSC32_ENB_MASK),
				  (unsigned int)(PMIC_MIX_RTC_XOSC32_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_mix_efuse_xosc32_enb_opt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_MIX_EFUSE_XOSC32_ENB_OPT_MASK),
				    (unsigned int)(PMIC_MIX_EFUSE_XOSC32_ENB_OPT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_mix_efuse_xosc32_enb_opt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_RTC_MIX_CON2),
				  (&val),
				  (unsigned int)(PMIC_MIX_EFUSE_XOSC32_ENB_OPT_MASK),
				  (unsigned int)(PMIC_MIX_EFUSE_XOSC32_ENB_OPT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ON_MASK),
				    (unsigned int)(PMIC_FG_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_ON_MASK), (unsigned int)(PMIC_FG_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_cal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CAL_MASK),
				    (unsigned int)(PMIC_FG_CAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_cal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_CAL_MASK),
				  (unsigned int)(PMIC_FG_CAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_autocalrate(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_AUTOCALRATE_MASK),
				    (unsigned int)(PMIC_FG_AUTOCALRATE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_autocalrate(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_AUTOCALRATE_MASK),
				  (unsigned int)(PMIC_FG_AUTOCALRATE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_sw_cr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_CR_MASK),
				    (unsigned int)(PMIC_FG_SW_CR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_sw_cr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_SW_CR_MASK),
				  (unsigned int)(PMIC_FG_SW_CR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_sw_read_pre(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_READ_PRE_MASK),
				    (unsigned int)(PMIC_FG_SW_READ_PRE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_sw_read_pre(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_SW_READ_PRE_MASK),
				  (unsigned int)(PMIC_FG_SW_READ_PRE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_latchdata_st(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_LATCHDATA_ST_MASK),
				  (unsigned int)(PMIC_FG_LATCHDATA_ST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_sw_clear(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_CLEAR_MASK),
				    (unsigned int)(PMIC_FG_SW_CLEAR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_sw_clear(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_SW_CLEAR_MASK),
				  (unsigned int)(PMIC_FG_SW_CLEAR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_offset_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_OFFSET_RST_MASK),
				    (unsigned int)(PMIC_FG_OFFSET_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_offset_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_OFFSET_RST_MASK),
				  (unsigned int)(PMIC_FG_OFFSET_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_time_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TIME_RST_MASK),
				    (unsigned int)(PMIC_FG_TIME_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_time_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_TIME_RST_MASK),
				  (unsigned int)(PMIC_FG_TIME_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_charge_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CHARGE_RST_MASK),
				    (unsigned int)(PMIC_FG_CHARGE_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_charge_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_CHARGE_RST_MASK),
				  (unsigned int)(PMIC_FG_CHARGE_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_sw_rstclr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SW_RSTCLR_MASK),
				    (unsigned int)(PMIC_FG_SW_RSTCLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_sw_rstclr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_FG_SW_RSTCLR_MASK),
				  (unsigned int)(PMIC_FG_SW_RSTCLR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_car_34_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON1),
				  (&val),
				  (unsigned int)(PMIC_FG_CAR_34_19_MASK),
				  (unsigned int)(PMIC_FG_CAR_34_19_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_car_18_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_FG_CAR_18_03_MASK),
				  (unsigned int)(PMIC_FG_CAR_18_03_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_car_02_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON3),
				  (&val),
				  (unsigned int)(PMIC_FG_CAR_02_00_MASK),
				  (unsigned int)(PMIC_FG_CAR_02_00_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_nter_32_17(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON4),
				  (&val),
				  (unsigned int)(PMIC_FG_NTER_32_17_MASK),
				  (unsigned int)(PMIC_FG_NTER_32_17_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_nter_16_01(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON5),
				  (&val),
				  (unsigned int)(PMIC_FG_NTER_16_01_MASK),
				  (unsigned int)(PMIC_FG_NTER_16_01_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_nter_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_FG_NTER_00_MASK),
				  (unsigned int)(PMIC_FG_NTER_00_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_bltr_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BLTR_31_16_MASK),
				    (unsigned int)(PMIC_FG_BLTR_31_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_bltr_31_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_FG_BLTR_31_16_MASK),
				  (unsigned int)(PMIC_FG_BLTR_31_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_bltr_15_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BLTR_15_00_MASK),
				    (unsigned int)(PMIC_FG_BLTR_15_00_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_bltr_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON8),
				  (&val),
				  (unsigned int)(PMIC_FG_BLTR_15_00_MASK),
				  (unsigned int)(PMIC_FG_BLTR_15_00_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_bftr_31_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BFTR_31_16_MASK),
				    (unsigned int)(PMIC_FG_BFTR_31_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_bftr_31_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON9),
				  (&val),
				  (unsigned int)(PMIC_FG_BFTR_31_16_MASK),
				  (unsigned int)(PMIC_FG_BFTR_31_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_bftr_15_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_BFTR_15_00_MASK),
				    (unsigned int)(PMIC_FG_BFTR_15_00_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_bftr_15_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_FG_BFTR_15_00_MASK),
				  (unsigned int)(PMIC_FG_BFTR_15_00_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_current_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON11),
				  (&val),
				  (unsigned int)(PMIC_FG_CURRENT_OUT_MASK),
				  (unsigned int)(PMIC_FG_CURRENT_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_adjust_offset_value(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ADJUST_OFFSET_VALUE_MASK),
				    (unsigned int)(PMIC_FG_ADJUST_OFFSET_VALUE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_adjust_offset_value(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_FG_ADJUST_OFFSET_VALUE_MASK),
				  (unsigned int)(PMIC_FG_ADJUST_OFFSET_VALUE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_offset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_FG_OFFSET_MASK),
				  (unsigned int)(PMIC_FG_OFFSET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fganalogtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGANALOGTEST_MASK),
				    (unsigned int)(PMIC_RG_FGANALOGTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fganalogtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_FGANALOGTEST_MASK),
				  (unsigned int)(PMIC_RG_FGANALOGTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fgintmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FGINTMODE_MASK),
				    (unsigned int)(PMIC_RG_FGINTMODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fgintmode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_FGINTMODE_MASK),
				  (unsigned int)(PMIC_RG_FGINTMODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_spare(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SPARE_MASK),
				    (unsigned int)(PMIC_RG_SPARE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_spare(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_SPARE_MASK),
				  (unsigned int)(PMIC_RG_SPARE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_osr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_OSR_MASK),
				    (unsigned int)(PMIC_FG_OSR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_osr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_FG_OSR_MASK),
				  (unsigned int)(PMIC_FG_OSR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_adj_offset_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ADJ_OFFSET_EN_MASK),
				    (unsigned int)(PMIC_FG_ADJ_OFFSET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_adj_offset_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_FG_ADJ_OFFSET_EN_MASK),
				  (unsigned int)(PMIC_FG_ADJ_OFFSET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_adc_autorst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ADC_AUTORST_MASK),
				    (unsigned int)(PMIC_FG_ADC_AUTORST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_adc_autorst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_FG_ADC_AUTORST_MASK),
				  (unsigned int)(PMIC_FG_ADC_AUTORST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_fir1bypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FIR1BYPASS_MASK),
				    (unsigned int)(PMIC_FG_FIR1BYPASS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_fir1bypass(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_FIR1BYPASS_MASK),
				  (unsigned int)(PMIC_FG_FIR1BYPASS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_fir2bypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FIR2BYPASS_MASK),
				    (unsigned int)(PMIC_FG_FIR2BYPASS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_fir2bypass(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_FIR2BYPASS_MASK),
				  (unsigned int)(PMIC_FG_FIR2BYPASS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_l_cur_int_sts(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_L_CUR_INT_STS_MASK),
				  (unsigned int)(PMIC_FG_L_CUR_INT_STS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_h_cur_int_sts(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_H_CUR_INT_STS_MASK),
				  (unsigned int)(PMIC_FG_H_CUR_INT_STS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_l_int_sts(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_L_INT_STS_MASK),
				  (unsigned int)(PMIC_FG_L_INT_STS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_h_int_sts(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_H_INT_STS_MASK),
				  (unsigned int)(PMIC_FG_H_INT_STS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_adc_rstdetect(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_ADC_RSTDETECT_MASK),
				  (unsigned int)(PMIC_FG_ADC_RSTDETECT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_slp_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SLP_EN_MASK),
				    (unsigned int)(PMIC_FG_SLP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_slp_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_SLP_EN_MASK),
				  (unsigned int)(PMIC_FG_SLP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_zcv_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_DET_EN_MASK),
				    (unsigned int)(PMIC_FG_ZCV_DET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_zcv_det_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_DET_EN_MASK),
				  (unsigned int)(PMIC_FG_ZCV_DET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_fg_auxadc_r(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FG_AUXADC_R_MASK),
				    (unsigned int)(PMIC_RG_FG_AUXADC_R_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_fg_auxadc_r(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_FG_AUXADC_R_MASK),
				  (unsigned int)(PMIC_RG_FG_AUXADC_R_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_fgadc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_DA_FGADC_EN_MASK),
				  (unsigned int)(PMIC_DA_FGADC_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_fgcal_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_DA_FGCAL_EN_MASK),
				  (unsigned int)(PMIC_DA_FGCAL_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_fg_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_DA_FG_RST_MASK),
				  (unsigned int)(PMIC_DA_FG_RST_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_cic2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON17),
				  (&val),
				  (unsigned int)(PMIC_FG_CIC2_MASK),
				  (unsigned int)(PMIC_FG_CIC2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_slp_cur_th(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SLP_CUR_TH_MASK),
				    (unsigned int)(PMIC_FG_SLP_CUR_TH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_slp_cur_th(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON18),
				  (&val),
				  (unsigned int)(PMIC_FG_SLP_CUR_TH_MASK),
				  (unsigned int)(PMIC_FG_SLP_CUR_TH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_slp_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SLP_TIME_MASK),
				    (unsigned int)(PMIC_FG_SLP_TIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_slp_time(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON19),
				  (&val),
				  (unsigned int)(PMIC_FG_SLP_TIME_MASK),
				  (unsigned int)(PMIC_FG_SLP_TIME_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_srcvolten_ftime(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_SRCVOLTEN_FTIME_MASK),
				    (unsigned int)(PMIC_FG_SRCVOLTEN_FTIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_srcvolten_ftime(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON20),
				  (&val),
				  (unsigned int)(PMIC_FG_SRCVOLTEN_FTIME_MASK),
				  (unsigned int)(PMIC_FG_SRCVOLTEN_FTIME_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_det_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_DET_TIME_MASK),
				    (unsigned int)(PMIC_FG_DET_TIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_det_time(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON20),
				  (&val),
				  (unsigned int)(PMIC_FG_DET_TIME_MASK),
				  (unsigned int)(PMIC_FG_DET_TIME_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_zcv_car_34_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON21),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_34_19_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_34_19_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_zcv_car_18_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON22),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_18_03_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_18_03_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_zcv_car_02_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON23),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_02_00_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_02_00_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_zcv_curr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON24),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CURR_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CURR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_fg_r_curr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON25),
				  (&val),
				  (unsigned int)(PMIC_FG_R_CURR_MASK),
				  (unsigned int)(PMIC_FG_R_CURR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_MODE_MASK),
				    (unsigned int)(PMIC_FG_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_MODE_MASK),
				  (unsigned int)(PMIC_FG_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_rst_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RST_SW_MASK),
				    (unsigned int)(PMIC_FG_RST_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_rst_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_RST_SW_MASK),
				  (unsigned int)(PMIC_FG_RST_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_fgcal_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FGCAL_EN_SW_MASK),
				    (unsigned int)(PMIC_FG_FGCAL_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_fgcal_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_FGCAL_EN_SW_MASK),
				  (unsigned int)(PMIC_FG_FGCAL_EN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_fgadc_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_FGADC_EN_SW_MASK),
				    (unsigned int)(PMIC_FG_FGADC_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_fgadc_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_FGADC_EN_SW_MASK),
				  (unsigned int)(PMIC_FG_FGADC_EN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_RSV1_MASK),
				    (unsigned int)(PMIC_FG_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_RSV1_MASK),
				  (unsigned int)(PMIC_FG_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_test_mode0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TEST_MODE0_MASK),
				    (unsigned int)(PMIC_FG_TEST_MODE0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_test_mode0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_TEST_MODE0_MASK),
				  (unsigned int)(PMIC_FG_TEST_MODE0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_test_mode1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_TEST_MODE1_MASK),
				    (unsigned int)(PMIC_FG_TEST_MODE1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_test_mode1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON26),
				  (&val),
				  (unsigned int)(PMIC_FG_TEST_MODE1_MASK),
				  (unsigned int)(PMIC_FG_TEST_MODE1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_gain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON27),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_GAIN_MASK),
				    (unsigned int)(PMIC_FG_GAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_gain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON27),
				  (&val),
				  (unsigned int)(PMIC_FG_GAIN_MASK),
				  (unsigned int)(PMIC_FG_GAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_cur_hth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON28),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CUR_HTH_MASK),
				    (unsigned int)(PMIC_FG_CUR_HTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_cur_hth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON28),
				  (&val),
				  (unsigned int)(PMIC_FG_CUR_HTH_MASK),
				  (unsigned int)(PMIC_FG_CUR_HTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_cur_lth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_CUR_LTH_MASK),
				    (unsigned int)(PMIC_FG_CUR_LTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_cur_lth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON29),
				  (&val),
				  (unsigned int)(PMIC_FG_CUR_LTH_MASK),
				  (unsigned int)(PMIC_FG_CUR_LTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_zcv_det_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_DET_TIME_MASK),
				    (unsigned int)(PMIC_FG_ZCV_DET_TIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_zcv_det_time(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON30),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_DET_TIME_MASK),
				  (unsigned int)(PMIC_FG_ZCV_DET_TIME_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_zcv_car_th_33_19(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON31),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_33_19_MASK),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_33_19_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_zcv_car_th_33_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON31),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_TH_33_19_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_TH_33_19_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_zcv_car_th_18_03(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON32),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_18_03_MASK),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_18_03_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_zcv_car_th_18_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON32),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_TH_18_03_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_TH_18_03_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_fg_zcv_car_th_02_00(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_FGADC_CON33),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_02_00_MASK),
				    (unsigned int)(PMIC_FG_ZCV_CAR_TH_02_00_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_fg_zcv_car_th_02_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_FGADC_CON33),
				  (&val),
				  (unsigned int)(PMIC_FG_ZCV_CAR_TH_02_00_MASK),
				  (unsigned int)(PMIC_FG_ZCV_CAR_TH_02_00_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_system_info_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SYSTEM_INFO_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON0_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_system_info_con0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SYSTEM_INFO_CON0),
				  (&val),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON0_MASK),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_system_info_con1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SYSTEM_INFO_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON1_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_system_info_con1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SYSTEM_INFO_CON1),
				  (&val),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON1_MASK),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_system_info_con2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SYSTEM_INFO_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON2_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_system_info_con2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SYSTEM_INFO_CON2),
				  (&val),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON2_MASK),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_system_info_con3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SYSTEM_INFO_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON3_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_system_info_con3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SYSTEM_INFO_CON3),
				  (&val),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON3_MASK),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_system_info_con4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_SYSTEM_INFO_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON4_MASK),
				    (unsigned int)(PMIC_SYSTEM_INFO_CON4_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_system_info_con4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_SYSTEM_INFO_CON4),
				  (&val),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON4_MASK),
				  (unsigned int)(PMIC_SYSTEM_INFO_CON4_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auddaclpwrup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDDACLPWRUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDDACLPWRUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auddaclpwrup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDDACLPWRUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDDACLPWRUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auddacrpwrup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDDACRPWRUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDDACRPWRUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auddacrpwrup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDDACRPWRUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDDACRPWRUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aud_dac_pwr_up_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUD_DAC_PWR_UP_VA28_MASK),
				    (unsigned int)(PMIC_RG_AUD_DAC_PWR_UP_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aud_dac_pwr_up_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUD_DAC_PWR_UP_VA28_MASK),
				  (unsigned int)(PMIC_RG_AUD_DAC_PWR_UP_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aud_dac_pwl_up_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUD_DAC_PWL_UP_VA28_MASK),
				    (unsigned int)(PMIC_RG_AUD_DAC_PWL_UP_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aud_dac_pwl_up_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUD_DAC_PWL_UP_VA28_MASK),
				  (unsigned int)(PMIC_RG_AUD_DAC_PWL_UP_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhspwrup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHSPWRUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHSPWRUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhspwrup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHSPWRUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHSPWRUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhplpwrup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLPWRUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLPWRUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhplpwrup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLPWRUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLPWRUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprpwrup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRPWRUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRPWRUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprpwrup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRPWRUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRPWRUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhsmuxinputsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHSMUXINPUTSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHSMUXINPUTSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhsmuxinputsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHSMUXINPUTSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHSMUXINPUTSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhplmuxinputsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLMUXINPUTSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLMUXINPUTSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhplmuxinputsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLMUXINPUTSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLMUXINPUTSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprmuxinputsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRMUXINPUTSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRMUXINPUTSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprmuxinputsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRMUXINPUTSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRMUXINPUTSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhsscdisable_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHSSCDISABLE_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHSSCDISABLE_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhsscdisable_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHSSCDISABLE_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHSSCDISABLE_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhplscdisable_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLSCDISABLE_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLSCDISABLE_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhplscdisable_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLSCDISABLE_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLSCDISABLE_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprscdisable_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRSCDISABLE_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRSCDISABLE_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprscdisable_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRSCDISABLE_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRSCDISABLE_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhplbsccurrent_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLBSCCURRENT_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLBSCCURRENT_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhplbsccurrent_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLBSCCURRENT_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLBSCCURRENT_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprbsccurrent_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRBSCCURRENT_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRBSCCURRENT_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprbsccurrent_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRBSCCURRENT_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRBSCCURRENT_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhsbsccurrent_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHSBSCCURRENT_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHSBSCCURRENT_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhsbsccurrent_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHSBSCCURRENT_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHSBSCCURRENT_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhpstartup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPSTARTUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPSTARTUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhpstartup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPSTARTUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPSTARTUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhsstartup_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHSSTARTUP_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHSSTARTUP_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhsstartup_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHSSTARTUP_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHSSTARTUP_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_prechargebuf_en_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PRECHARGEBUF_EN_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_PRECHARGEBUF_EN_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_prechargebuf_en_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_PRECHARGEBUF_EN_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_PRECHARGEBUF_EN_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hpinputstbenh_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HPINPUTSTBENH_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HPINPUTSTBENH_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hpinputstbenh_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HPINPUTSTBENH_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HPINPUTSTBENH_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hpoutputstbenh_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HPOUTPUTSTBENH_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HPOUTPUTSTBENH_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hpoutputstbenh_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HPOUTPUTSTBENH_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HPOUTPUTSTBENH_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hpinputreset0_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HPINPUTRESET0_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HPINPUTRESET0_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hpinputreset0_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HPINPUTRESET0_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HPINPUTRESET0_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hpoutputreset0_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HPOUTPUTRESET0_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HPOUTPUTRESET0_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hpoutputreset0_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HPOUTPUTRESET0_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HPOUTPUTRESET0_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hpout_shortvcm_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HPOUT_SHORTVCM_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HPOUT_SHORTVCM_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hpout_shortvcm_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HPOUT_SHORTVCM_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HPOUT_SHORTVCM_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hsinputstbenh_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HSINPUTSTBENH_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HSINPUTSTBENH_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hsinputstbenh_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HSINPUTSTBENH_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HSINPUTSTBENH_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hsoutputstbenh_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HSOUTPUTSTBENH_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HSOUTPUTSTBENH_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hsoutputstbenh_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HSOUTPUTSTBENH_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HSOUTPUTSTBENH_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hsinputreset0_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HSINPUTRESET0_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HSINPUTRESET0_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hsinputreset0_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HSINPUTRESET0_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HSINPUTRESET0_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hsoutputreset0_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HSOUTPUTRESET0_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HSOUTPUTRESET0_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hsoutputreset0_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_HSOUTPUTRESET0_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HSOUTPUTRESET0_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hpoutstb_rsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HPOUTSTB_RSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HPOUTSTB_RSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hpoutstb_rsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_HPOUTSTB_RSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HPOUTSTB_RSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hsout_shortvcm_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HSOUT_SHORTVCM_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_HSOUT_SHORTVCM_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hsout_shortvcm_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_HSOUT_SHORTVCM_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_HSOUT_SHORTVCM_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhpltrim_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLTRIM_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLTRIM_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhpltrim_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLTRIM_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLTRIM_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprtrim_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRTRIM_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRTRIM_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprtrim_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRTRIM_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRTRIM_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhptrim_en_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPTRIM_EN_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPTRIM_EN_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhptrim_en_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPTRIM_EN_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPTRIM_EN_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhplfinetrim_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPLFINETRIM_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPLFINETRIM_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhplfinetrim_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPLFINETRIM_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPLFINETRIM_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhprfinetrim_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPRFINETRIM_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPRFINETRIM_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhprfinetrim_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPRFINETRIM_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPRFINETRIM_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audtrimbuf_en_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDTRIMBUF_EN_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDTRIMBUF_EN_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audtrimbuf_en_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDTRIMBUF_EN_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDTRIMBUF_EN_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audtrimbuf_inputmuxsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDTRIMBUF_INPUTMUXSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDTRIMBUF_INPUTMUXSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audtrimbuf_inputmuxsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDTRIMBUF_INPUTMUXSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDTRIMBUF_INPUTMUXSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audtrimbuf_gainsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDTRIMBUF_GAINSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDTRIMBUF_GAINSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audtrimbuf_gainsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDTRIMBUF_GAINSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDTRIMBUF_GAINSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhpspkdet_en_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPSPKDET_EN_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPSPKDET_EN_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhpspkdet_en_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPSPKDET_EN_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPSPKDET_EN_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhpspkdet_inputmuxsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPSPKDET_INPUTMUXSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPSPKDET_INPUTMUXSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhpspkdet_inputmuxsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPSPKDET_INPUTMUXSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPSPKDET_INPUTMUXSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audhpspkdet_outputmuxsel_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDHPSPKDET_OUTPUTMUXSEL_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDHPSPKDET_OUTPUTMUXSEL_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audhpspkdet_outputmuxsel_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDHPSPKDET_OUTPUTMUXSEL_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDHPSPKDET_OUTPUTMUXSEL_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_abidec_reserved_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VA28_MASK),
				    (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_abidec_reserved_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VA28_MASK),
				  (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_abidec_reserved_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_abidec_reserved_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_ABIDEC_RESERVED_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audbiasadj_0_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDBIASADJ_0_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDBIASADJ_0_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audbiasadj_0_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDBIASADJ_0_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDBIASADJ_0_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audbiasadj_1_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDBIASADJ_1_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDBIASADJ_1_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audbiasadj_1_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDBIASADJ_1_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDBIASADJ_1_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audibiaspwrdn_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDIBIASPWRDN_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDIBIASPWRDN_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audibiaspwrdn_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDIBIASPWRDN_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDIBIASPWRDN_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rstb_decoder_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RSTB_DECODER_VA28_MASK),
				    (unsigned int)(PMIC_RG_RSTB_DECODER_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rstb_decoder_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_RSTB_DECODER_VA28_MASK),
				  (unsigned int)(PMIC_RG_RSTB_DECODER_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_rstb_encoder_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_RSTB_ENCODER_VA28_MASK),
				    (unsigned int)(PMIC_RG_RSTB_ENCODER_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_rstb_encoder_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_RSTB_ENCODER_VA28_MASK),
				  (unsigned int)(PMIC_RG_RSTB_ENCODER_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_sel_decoder_96k_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SEL_DECODER_96K_VA28_MASK),
				    (unsigned int)(PMIC_RG_SEL_DECODER_96K_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_sel_decoder_96k_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_SEL_DECODER_96K_VA28_MASK),
				  (unsigned int)(PMIC_RG_SEL_DECODER_96K_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_sel_encoder_96k_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SEL_ENCODER_96K_VA28_MASK),
				    (unsigned int)(PMIC_RG_SEL_ENCODER_96K_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_sel_encoder_96k_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_SEL_ENCODER_96K_VA28_MASK),
				  (unsigned int)(PMIC_RG_SEL_ENCODER_96K_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_sel_delay_vcore(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SEL_DELAY_VCORE_MASK),
				    (unsigned int)(PMIC_RG_SEL_DELAY_VCORE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_sel_delay_vcore(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_SEL_DELAY_VCORE_MASK),
				  (unsigned int)(PMIC_RG_SEL_DELAY_VCORE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hcldo_en_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HCLDO_EN_VA18_MASK),
				    (unsigned int)(PMIC_RG_HCLDO_EN_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hcldo_en_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_HCLDO_EN_VA18_MASK),
				  (unsigned int)(PMIC_RG_HCLDO_EN_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_en_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_EN_VA18_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_EN_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_en_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_EN_VA18_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_EN_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_enc_en_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_ENC_EN_VA28_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_ENC_EN_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_enc_en_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_ENC_EN_VA28_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_ENC_EN_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_va33refgen_en_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA33REFGEN_EN_VA18_MASK),
				    (unsigned int)(PMIC_RG_VA33REFGEN_EN_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_va33refgen_en_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VA33REFGEN_EN_VA18_MASK),
				  (unsigned int)(PMIC_RG_VA33REFGEN_EN_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hcldo_pddis_en_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HCLDO_PDDIS_EN_VA18_MASK),
				    (unsigned int)(PMIC_RG_HCLDO_PDDIS_EN_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hcldo_pddis_en_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_HCLDO_PDDIS_EN_VA18_MASK),
				  (unsigned int)(PMIC_RG_HCLDO_PDDIS_EN_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hcldo_remote_sense_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HCLDO_REMOTE_SENSE_VA18_MASK),
				    (unsigned int)(PMIC_RG_HCLDO_REMOTE_SENSE_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hcldo_remote_sense_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_HCLDO_REMOTE_SENSE_VA18_MASK),
				  (unsigned int)(PMIC_RG_HCLDO_REMOTE_SENSE_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_pddis_en_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_PDDIS_EN_VA18_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_PDDIS_EN_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_pddis_en_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_PDDIS_EN_VA18_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_PDDIS_EN_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_remote_sense_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_REMOTE_SENSE_VA18_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_REMOTE_SENSE_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_remote_sense_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_REMOTE_SENSE_VA18_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_REMOTE_SENSE_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_vosel_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_VOSEL_VA18_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_VOSEL_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_vosel_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_VOSEL_VA18_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_VOSEL_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hcldo_vosel_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HCLDO_VOSEL_VA18_MASK),
				    (unsigned int)(PMIC_RG_HCLDO_VOSEL_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hcldo_vosel_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_HCLDO_VOSEL_VA18_MASK),
				  (unsigned int)(PMIC_RG_HCLDO_VOSEL_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_enc_pddis_en_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_ENC_PDDIS_EN_VA28_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_ENC_PDDIS_EN_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_enc_pddis_en_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_ENC_PDDIS_EN_VA28_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_ENC_PDDIS_EN_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lcldo_enc_remote_sense_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LCLDO_ENC_REMOTE_SENSE_VA28_MASK),
				    (unsigned int)(PMIC_RG_LCLDO_ENC_REMOTE_SENSE_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lcldo_enc_remote_sense_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_LCLDO_ENC_REMOTE_SENSE_VA28_MASK),
				  (unsigned int)(PMIC_RG_LCLDO_ENC_REMOTE_SENSE_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_va28refgen_en_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VA28REFGEN_EN_VA28_MASK),
				    (unsigned int)(PMIC_RG_VA28REFGEN_EN_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_va28refgen_en_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_VA28REFGEN_EN_VA28_MASK),
				  (unsigned int)(PMIC_RG_VA28REFGEN_EN_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpmu_reserved_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA28_MASK),
				    (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpmu_reserved_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA28_MASK),
				  (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpmu_reserved_va18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA18_MASK),
				    (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpmu_reserved_va18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA18_MASK),
				  (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpmu_reserved_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpmu_reserved_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_AUDPMU_RESERVED_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nvreg_en_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NVREG_EN_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_NVREG_EN_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nvreg_en_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_NVREG_EN_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_NVREG_EN_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nvreg_pull0v_vaudp15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NVREG_PULL0V_VAUDP15_MASK),
				    (unsigned int)(PMIC_RG_NVREG_PULL0V_VAUDP15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nvreg_pull0v_vaudp15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_NVREG_PULL0V_VAUDP15_MASK),
				  (unsigned int)(PMIC_RG_NVREG_PULL0V_VAUDP15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audglb_pwrdn_va28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDDEC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDGLB_PWRDN_VA28_MASK),
				    (unsigned int)(PMIC_RG_AUDGLB_PWRDN_VA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audglb_pwrdn_va28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDDEC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDGLB_PWRDN_VA28_MASK),
				  (unsigned int)(PMIC_RG_AUDGLB_PWRDN_VA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamplon(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLON_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamplon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLON_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreampldccen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLDCCEN_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLDCCEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreampldccen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLDCCEN_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLDCCEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreampldcrpecharge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLDCRPECHARGE_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLDCRPECHARGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreampldcrpecharge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLDCRPECHARGE_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLDCRPECHARGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamplpgatest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLPGATEST_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLPGATEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamplpgatest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLPGATEST_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLPGATEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamplvscale(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLVSCALE_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLVSCALE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamplvscale(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLVSCALE_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLVSCALE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamplinputsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLINPUTSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLINPUTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamplinputsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLINPUTSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLINPUTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadclpwrup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCLPWRUP_MASK),
				    (unsigned int)(PMIC_RG_AUDADCLPWRUP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadclpwrup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCLPWRUP_MASK),
				  (unsigned int)(PMIC_RG_AUDADCLPWRUP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadclinputsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCLINPUTSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDADCLINPUTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadclinputsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCLINPUTSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDADCLINPUTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreampron(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRON_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreampron(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRON_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamprdccen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRDCCEN_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRDCCEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamprdccen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRDCCEN_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRDCCEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamprdcrpecharge(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRDCRPECHARGE_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRDCRPECHARGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamprdcrpecharge(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRDCRPECHARGE_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRDCRPECHARGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamprpgatest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRPGATEST_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRPGATEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamprpgatest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRPGATEST_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRPGATEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamprvscale(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRVSCALE_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRVSCALE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamprvscale(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRVSCALE_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRVSCALE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamprinputsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRINPUTSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRINPUTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamprinputsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRINPUTSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRINPUTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcrpwrup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCRPWRUP_MASK),
				    (unsigned int)(PMIC_RG_AUDADCRPWRUP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcrpwrup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCRPWRUP_MASK),
				  (unsigned int)(PMIC_RG_AUDADCRPWRUP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcrinputsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCRINPUTSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDADCRINPUTSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcrinputsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCRINPUTSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDADCRINPUTSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audulhalfbias(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDULHALFBIAS_MASK),
				    (unsigned int)(PMIC_RG_AUDULHALFBIAS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audulhalfbias(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDULHALFBIAS_MASK),
				  (unsigned int)(PMIC_RG_AUDULHALFBIAS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audglbmadlpwen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDGLBMADLPWEN_MASK),
				    (unsigned int)(PMIC_RG_AUDGLBMADLPWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audglbmadlpwen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDGLBMADLPWEN_MASK),
				  (unsigned int)(PMIC_RG_AUDGLBMADLPWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamplpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamplpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc1ststagelpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC1STSTAGELPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDADC1STSTAGELPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc1ststagelpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC1STSTAGELPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDADC1STSTAGELPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc2ndstagelpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC2NDSTAGELPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDADC2NDSTAGELPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc2ndstagelpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC2NDSTAGELPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDADC2NDSTAGELPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcflashlpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCFLASHLPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDADCFLASHLPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcflashlpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCFLASHLPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDADCFLASHLPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreampiddtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPIDDTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPIDDTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreampiddtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPIDDTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPIDDTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc1ststageiddtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC1STSTAGEIDDTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADC1STSTAGEIDDTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc1ststageiddtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC1STSTAGEIDDTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADC1STSTAGEIDDTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc2ndstageiddtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC2NDSTAGEIDDTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADC2NDSTAGEIDDTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc2ndstageiddtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC2NDSTAGEIDDTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADC2NDSTAGEIDDTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcrefbufiddtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCREFBUFIDDTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADCREFBUFIDDTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcrefbufiddtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCREFBUFIDDTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADCREFBUFIDDTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcflashiddtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCFLASHIDDTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADCFLASHIDDTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcflashiddtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCFLASHIDDTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADCFLASHIDDTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcdac0p25fs(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCDAC0P25FS_MASK),
				    (unsigned int)(PMIC_RG_AUDADCDAC0P25FS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcdac0p25fs(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCDAC0P25FS_MASK),
				  (unsigned int)(PMIC_RG_AUDADCDAC0P25FS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcclksel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCCLKSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDADCCLKSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcclksel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCCLKSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDADCCLKSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcclksource(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCCLKSOURCE_MASK),
				    (unsigned int)(PMIC_RG_AUDADCCLKSOURCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcclksource(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCCLKSOURCE_MASK),
				  (unsigned int)(PMIC_RG_AUDADCCLKSOURCE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcclkgenmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCCLKGENMODE_MASK),
				    (unsigned int)(PMIC_RG_AUDADCCLKGENMODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcclkgenmode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCCLKGENMODE_MASK),
				  (unsigned int)(PMIC_RG_AUDADCCLKGENMODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreampaafen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPAAFEN_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPAAFEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreampaafen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPAAFEN_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPAAFEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dccvcmbuflpmodsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DCCVCMBUFLPMODSEL_MASK),
				    (unsigned int)(PMIC_RG_DCCVCMBUFLPMODSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dccvcmbuflpmodsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_DCCVCMBUFLPMODSEL_MASK),
				  (unsigned int)(PMIC_RG_DCCVCMBUFLPMODSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dccvcmbuflpswen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DCCVCMBUFLPSWEN_MASK),
				    (unsigned int)(PMIC_RG_DCCVCMBUFLPSWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dccvcmbuflpswen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_DCCVCMBUFLPSWEN_MASK),
				  (unsigned int)(PMIC_RG_DCCVCMBUFLPSWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audsparepga(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDSPAREPGA_MASK),
				    (unsigned int)(PMIC_RG_AUDSPAREPGA_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audsparepga(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDSPAREPGA_MASK),
				  (unsigned int)(PMIC_RG_AUDSPAREPGA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc1ststagesdenb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC1STSTAGESDENB_MASK),
				    (unsigned int)(PMIC_RG_AUDADC1STSTAGESDENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc1ststagesdenb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC1STSTAGESDENB_MASK),
				  (unsigned int)(PMIC_RG_AUDADC1STSTAGESDENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc2ndstagereset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC2NDSTAGERESET_MASK),
				    (unsigned int)(PMIC_RG_AUDADC2NDSTAGERESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc2ndstagereset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC2NDSTAGERESET_MASK),
				  (unsigned int)(PMIC_RG_AUDADC2NDSTAGERESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadc3rdstagereset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADC3RDSTAGERESET_MASK),
				    (unsigned int)(PMIC_RG_AUDADC3RDSTAGERESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadc3rdstagereset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADC3RDSTAGERESET_MASK),
				  (unsigned int)(PMIC_RG_AUDADC3RDSTAGERESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcfsreset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCFSRESET_MASK),
				    (unsigned int)(PMIC_RG_AUDADCFSRESET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcfsreset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCFSRESET_MASK),
				  (unsigned int)(PMIC_RG_AUDADCFSRESET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcwidecm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCWIDECM_MASK),
				    (unsigned int)(PMIC_RG_AUDADCWIDECM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcwidecm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCWIDECM_MASK),
				  (unsigned int)(PMIC_RG_AUDADCWIDECM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcnopatest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCNOPATEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADCNOPATEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcnopatest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCNOPATEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADCNOPATEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcbypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCBYPASS_MASK),
				    (unsigned int)(PMIC_RG_AUDADCBYPASS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcbypass(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCBYPASS_MASK),
				  (unsigned int)(PMIC_RG_AUDADCBYPASS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcffbypass(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCFFBYPASS_MASK),
				    (unsigned int)(PMIC_RG_AUDADCFFBYPASS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcffbypass(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCFFBYPASS_MASK),
				  (unsigned int)(PMIC_RG_AUDADCFFBYPASS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcdacfbcurrent(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCDACFBCURRENT_MASK),
				    (unsigned int)(PMIC_RG_AUDADCDACFBCURRENT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcdacfbcurrent(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCDACFBCURRENT_MASK),
				  (unsigned int)(PMIC_RG_AUDADCDACFBCURRENT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcdaciddtest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCDACIDDTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADCDACIDDTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcdaciddtest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCDACIDDTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADCDACIDDTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcdacnrz(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCDACNRZ_MASK),
				    (unsigned int)(PMIC_RG_AUDADCDACNRZ_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcdacnrz(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCDACNRZ_MASK),
				  (unsigned int)(PMIC_RG_AUDADCDACNRZ_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcnodem(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCNODEM_MASK),
				    (unsigned int)(PMIC_RG_AUDADCNODEM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcnodem(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCNODEM_MASK),
				  (unsigned int)(PMIC_RG_AUDADCNODEM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadcdactest(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCDACTEST_MASK),
				    (unsigned int)(PMIC_RG_AUDADCDACTEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadcdactest(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCDACTEST_MASK),
				  (unsigned int)(PMIC_RG_AUDADCDACTEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audadctestdata(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDADCTESTDATA_MASK),
				    (unsigned int)(PMIC_RG_AUDADCTESTDATA_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audadctestdata(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDADCTESTDATA_MASK),
				  (unsigned int)(PMIC_RG_AUDADCTESTDATA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audrctunel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDRCTUNEL_MASK),
				    (unsigned int)(PMIC_RG_AUDRCTUNEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audrctunel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDRCTUNEL_MASK),
				  (unsigned int)(PMIC_RG_AUDRCTUNEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audrctunelsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDRCTUNELSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDRCTUNELSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audrctunelsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDRCTUNELSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDRCTUNELSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audrctuner(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDRCTUNER_MASK),
				    (unsigned int)(PMIC_RG_AUDRCTUNER_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audrctuner(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDRCTUNER_MASK),
				  (unsigned int)(PMIC_RG_AUDRCTUNER_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audrctunersel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDRCTUNERSEL_MASK),
				    (unsigned int)(PMIC_RG_AUDRCTUNERSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audrctunersel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDRCTUNERSEL_MASK),
				  (unsigned int)(PMIC_RG_AUDRCTUNERSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audspareva28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDSPAREVA28_MASK),
				    (unsigned int)(PMIC_RG_AUDSPAREVA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audspareva28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDSPAREVA28_MASK),
				  (unsigned int)(PMIC_RG_AUDSPAREVA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audspareva18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDSPAREVA18_MASK),
				    (unsigned int)(PMIC_RG_AUDSPAREVA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audspareva18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDSPAREVA18_MASK),
				  (unsigned int)(PMIC_RG_AUDSPAREVA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audencspareva28(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDENCSPAREVA28_MASK),
				    (unsigned int)(PMIC_RG_AUDENCSPAREVA28_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audencspareva28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDENCSPAREVA28_MASK),
				  (unsigned int)(PMIC_RG_AUDENCSPAREVA28_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audencspareva18(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDENCSPAREVA18_MASK),
				    (unsigned int)(PMIC_RG_AUDENCSPAREVA18_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audencspareva18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDENCSPAREVA18_MASK),
				  (unsigned int)(PMIC_RG_AUDENCSPAREVA18_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auddigmicen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDDIGMICEN_MASK),
				    (unsigned int)(PMIC_RG_AUDDIGMICEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auddigmicen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDDIGMICEN_MASK),
				  (unsigned int)(PMIC_RG_AUDDIGMICEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auddigmicbias(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDDIGMICBIAS_MASK),
				    (unsigned int)(PMIC_RG_AUDDIGMICBIAS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auddigmicbias(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDDIGMICBIAS_MASK),
				  (unsigned int)(PMIC_RG_AUDDIGMICBIAS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dmichpclken(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DMICHPCLKEN_MASK),
				    (unsigned int)(PMIC_RG_DMICHPCLKEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dmichpclken(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_DMICHPCLKEN_MASK),
				  (unsigned int)(PMIC_RG_DMICHPCLKEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auddigmicpduty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDDIGMICPDUTY_MASK),
				    (unsigned int)(PMIC_RG_AUDDIGMICPDUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auddigmicpduty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDDIGMICPDUTY_MASK),
				  (unsigned int)(PMIC_RG_AUDDIGMICPDUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auddigmicnduty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDDIGMICNDUTY_MASK),
				    (unsigned int)(PMIC_RG_AUDDIGMICNDUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auddigmicnduty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDDIGMICNDUTY_MASK),
				  (unsigned int)(PMIC_RG_AUDDIGMICNDUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dmicmonen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DMICMONEN_MASK),
				    (unsigned int)(PMIC_RG_DMICMONEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dmicmonen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_DMICMONEN_MASK),
				  (unsigned int)(PMIC_RG_DMICMONEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dmicmonsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DMICMONSEL_MASK),
				    (unsigned int)(PMIC_RG_DMICMONSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dmicmonsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_DMICMONSEL_MASK),
				  (unsigned int)(PMIC_RG_DMICMONSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audsparevmic(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDSPAREVMIC_MASK),
				    (unsigned int)(PMIC_RG_AUDSPAREVMIC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audsparevmic(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDSPAREVMIC_MASK),
				  (unsigned int)(PMIC_RG_AUDSPAREVMIC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpwdbmicbias0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPWDBMICBIAS0_MASK),
				    (unsigned int)(PMIC_RG_AUDPWDBMICBIAS0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpwdbmicbias0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPWDBMICBIAS0_MASK),
				  (unsigned int)(PMIC_RG_AUDPWDBMICBIAS0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbias0dcswpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbias0dcswpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbias0dcswnen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWNEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWNEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbias0dcswnen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWNEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIAS0DCSWNEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbias0bypassen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIAS0BYPASSEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIAS0BYPASSEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbias0bypassen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIAS0BYPASSEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIAS0BYPASSEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpwdbmicbias1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPWDBMICBIAS1_MASK),
				    (unsigned int)(PMIC_RG_AUDPWDBMICBIAS1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpwdbmicbias1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPWDBMICBIAS1_MASK),
				  (unsigned int)(PMIC_RG_AUDPWDBMICBIAS1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbias1dcswpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbias1dcswpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbias1dcswnen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWNEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWNEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbias1dcswnen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWNEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIAS1DCSWNEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbias1bypassen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIAS1BYPASSEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIAS1BYPASSEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbias1bypassen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIAS1BYPASSEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIAS1BYPASSEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbiasvref(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIASVREF_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIASVREF_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbiasvref(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIASVREF_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIASVREF_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audmicbiaslowpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDMICBIASLOWPEN_MASK),
				    (unsigned int)(PMIC_RG_AUDMICBIASLOWPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audmicbiaslowpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDMICBIASLOWPEN_MASK),
				  (unsigned int)(PMIC_RG_AUDMICBIASLOWPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bandgapgen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BANDGAPGEN_MASK),
				    (unsigned int)(PMIC_RG_BANDGAPGEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bandgapgen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_BANDGAPGEN_MASK),
				  (unsigned int)(PMIC_RG_BANDGAPGEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamplgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPLGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPLGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamplgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPLGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPLGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audpreamprgain(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDENC_ANA_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDPREAMPRGAIN_MASK),
				    (unsigned int)(PMIC_RG_AUDPREAMPRGAIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audpreamprgain(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDENC_ANA_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDPREAMPRGAIN_MASK),
				  (unsigned int)(PMIC_RG_AUDPREAMPRGAIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_divcks_chg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DIVCKS_CHG_MASK),
				    (unsigned int)(PMIC_RG_DIVCKS_CHG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_divcks_chg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_DIVCKS_CHG_MASK),
				  (unsigned int)(PMIC_RG_DIVCKS_CHG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_divcks_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DIVCKS_ON_MASK),
				    (unsigned int)(PMIC_RG_DIVCKS_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_divcks_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_DIVCKS_ON_MASK),
				  (unsigned int)(PMIC_RG_DIVCKS_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_divcks_prg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DIVCKS_PRG_MASK),
				    (unsigned int)(PMIC_RG_DIVCKS_PRG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_divcks_prg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_DIVCKS_PRG_MASK),
				  (unsigned int)(PMIC_RG_DIVCKS_PRG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_divcks_pwd_ncp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_MASK),
				    (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_divcks_pwd_ncp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_MASK),
				  (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_divcks_pwd_ncp_st_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_ST_SEL_MASK),
				    (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_ST_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_divcks_pwd_ncp_st_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUDNCP_CLKDIV_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_ST_SEL_MASK),
				  (unsigned int)(PMIC_RG_DIVCKS_PWD_NCP_ST_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf1_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf1_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF1_MODE_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF1_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf1_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf1_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF1_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF1_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf2_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf2_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF2_MODE_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF2_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf2_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf2_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF2_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF2_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf3_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf3_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF3_MODE_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF3_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf3_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf3_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF3_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF3_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf4_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_MODE_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf4_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF4_MODE_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF4_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf4_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf4_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF4_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF4_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_bb_lpm_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BB_LPM_EN_MASK),
				    (unsigned int)(PMIC_XO_BB_LPM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_bb_lpm_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_BB_LPM_EN_MASK),
				  (unsigned int)(PMIC_XO_BB_LPM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_enbb_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_ENBB_MAN_MASK),
				    (unsigned int)(PMIC_XO_ENBB_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_enbb_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_ENBB_MAN_MASK),
				  (unsigned int)(PMIC_XO_ENBB_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_enbb_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_ENBB_EN_M_MASK),
				    (unsigned int)(PMIC_XO_ENBB_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_enbb_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_ENBB_EN_M_MASK),
				  (unsigned int)(PMIC_XO_ENBB_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_clksel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW00),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CLKSEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_CLKSEL_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_clksel_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW00),
				  (&val),
				  (unsigned int)(PMIC_XO_CLKSEL_MAN_MASK),
				  (unsigned int)(PMIC_XO_CLKSEL_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_clksel_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CLKSEL_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CLKSEL_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_clksel_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_CLKSEL_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CLKSEL_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf1_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf1_ckg_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF1_CKG_MAN_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF1_CKG_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf1_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF1_CKG_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf1_ckg_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF1_CKG_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF1_CKG_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf2_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf2_ckg_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF2_CKG_MAN_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF2_CKG_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf2_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF2_CKG_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf2_ckg_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF2_CKG_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF2_CKG_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf3_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf3_ckg_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF3_CKG_MAN_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF3_CKG_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf3_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF3_CKG_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf3_ckg_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF3_CKG_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF3_CKG_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf4_ckg_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf4_ckg_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF4_CKG_MAN_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF4_CKG_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf4_ckg_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_EN_M_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_CKG_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf4_ckg_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF4_CKG_EN_M_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF4_CKG_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_intbuf_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_INTBUF_MAN_MASK),
				    (unsigned int)(PMIC_XO_INTBUF_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_intbuf_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_INTBUF_MAN_MASK),
				  (unsigned int)(PMIC_XO_INTBUF_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_pbuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_PBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_PBUF_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_pbuf_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_PBUF_EN_M_MASK),
				  (unsigned int)(PMIC_XO_PBUF_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ibuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_IBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_IBUF_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ibuf_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_IBUF_EN_M_MASK),
				  (unsigned int)(PMIC_XO_IBUF_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_lpmbuf_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPMBUF_MAN_MASK),
				    (unsigned int)(PMIC_XO_LPMBUF_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_lpmbuf_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_LPMBUF_MAN_MASK),
				  (unsigned int)(PMIC_XO_LPMBUF_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_lpm_prebuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPM_PREBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LPM_PREBUF_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_lpm_prebuf_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_LPM_PREBUF_EN_M_MASK),
				  (unsigned int)(PMIC_XO_LPM_PREBUF_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_lpbuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LPBUF_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_lpbuf_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_LPBUF_EN_M_MASK),
				  (unsigned int)(PMIC_XO_LPBUF_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_audio_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW01),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AUDIO_EN_M_MASK),
				    (unsigned int)(PMIC_XO_AUDIO_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_audio_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW01),
				  (&val),
				  (unsigned int)(PMIC_XO_AUDIO_EN_M_MASK),
				  (unsigned int)(PMIC_XO_AUDIO_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_en32k_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EN32K_MAN_MASK),
				    (unsigned int)(PMIC_XO_EN32K_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_en32k_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_EN32K_MAN_MASK),
				  (unsigned int)(PMIC_XO_EN32K_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_en32k_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EN32K_M_MASK),
				    (unsigned int)(PMIC_XO_EN32K_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_en32k_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_EN32K_M_MASK),
				  (unsigned int)(PMIC_XO_EN32K_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_xmode_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_XMODE_MAN_MASK),
				    (unsigned int)(PMIC_XO_XMODE_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_xmode_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_XMODE_MAN_MASK),
				  (unsigned int)(PMIC_XO_XMODE_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_xmode_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_XMODE_M_MASK),
				    (unsigned int)(PMIC_XO_XMODE_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_xmode_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_XMODE_M_MASK),
				  (unsigned int)(PMIC_XO_XMODE_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_strup_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_STRUP_MODE_MASK),
				    (unsigned int)(PMIC_XO_STRUP_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_strup_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_STRUP_MODE_MASK),
				  (unsigned int)(PMIC_XO_STRUP_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_fpm_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_FPM_TIME_MASK),
				    (unsigned int)(PMIC_XO_AAC_FPM_TIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_fpm_time(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_FPM_TIME_MASK),
				  (unsigned int)(PMIC_XO_AAC_FPM_TIME_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_mode_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_MODE_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_MODE_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_mode_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_MODE_LPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_MODE_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_mode_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_MODE_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_MODE_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_mode_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_MODE_FPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_MODE_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_en26m_offsq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EN26M_OFFSQ_EN_MASK),
				    (unsigned int)(PMIC_XO_EN26M_OFFSQ_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_en26m_offsq_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_EN26M_OFFSQ_EN_MASK),
				  (unsigned int)(PMIC_XO_EN26M_OFFSQ_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ldocal_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOCAL_EN_MASK),
				    (unsigned int)(PMIC_XO_LDOCAL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ldocal_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_LDOCAL_EN_MASK),
				  (unsigned int)(PMIC_XO_LDOCAL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cbank_sync_dyn(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_DYN_MASK),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_DYN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cbank_sync_dyn(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_CBANK_SYNC_DYN_MASK),
				  (unsigned int)(PMIC_XO_CBANK_SYNC_DYN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_26mlp_man_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_26MLP_MAN_EN_MASK),
				    (unsigned int)(PMIC_XO_26MLP_MAN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_26mlp_man_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_26MLP_MAN_EN_MASK),
				  (unsigned int)(PMIC_XO_26MLP_MAN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_opmode_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW02),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_OPMODE_MAN_MASK),
				    (unsigned int)(PMIC_XO_OPMODE_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_opmode_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW02),
				  (&val),
				  (unsigned int)(PMIC_XO_OPMODE_MAN_MASK),
				  (unsigned int)(PMIC_XO_OPMODE_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_bufldo13_vset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BUFLDO13_VSET_M_MASK),
				    (unsigned int)(PMIC_XO_BUFLDO13_VSET_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_bufldo13_vset_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW03),
				  (&val),
				  (unsigned int)(PMIC_XO_BUFLDO13_VSET_M_MASK),
				  (unsigned int)(PMIC_XO_BUFLDO13_VSET_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_reserved0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_RESERVED0_MASK),
				    (unsigned int)(PMIC_XO_RESERVED0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_reserved0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW03),
				  (&val),
				  (unsigned int)(PMIC_XO_RESERVED0_MASK),
				  (unsigned int)(PMIC_XO_RESERVED0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_lpm_isel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPM_ISEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_LPM_ISEL_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_lpm_isel_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW03),
				  (&val),
				  (unsigned int)(PMIC_XO_LPM_ISEL_MAN_MASK),
				  (unsigned int)(PMIC_XO_LPM_ISEL_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_fpm_isel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW03),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_FPM_ISEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_FPM_ISEL_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_fpm_isel_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW03),
				  (&val),
				  (unsigned int)(PMIC_XO_FPM_ISEL_MAN_MASK),
				  (unsigned int)(PMIC_XO_FPM_ISEL_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cdac_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW04),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CDAC_FPM_MASK),
				    (unsigned int)(PMIC_XO_CDAC_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cdac_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW04),
				  (&val),
				  (unsigned int)(PMIC_XO_CDAC_FPM_MASK),
				  (unsigned int)(PMIC_XO_CDAC_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cdac_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW04),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CDAC_LPM_MASK),
				    (unsigned int)(PMIC_XO_CDAC_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cdac_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW04),
				  (&val),
				  (unsigned int)(PMIC_XO_CDAC_LPM_MASK),
				  (unsigned int)(PMIC_XO_CDAC_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_32kdiv_nfrac_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW05),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_FPM_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_32kdiv_nfrac_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW05),
				  (&val),
				  (unsigned int)(PMIC_XO_32KDIV_NFRAC_FPM_MASK),
				  (unsigned int)(PMIC_XO_32KDIV_NFRAC_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cofst_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW05),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COFST_FPM_MASK),
				    (unsigned int)(PMIC_XO_COFST_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cofst_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW05),
				  (&val),
				  (unsigned int)(PMIC_XO_COFST_FPM_MASK),
				  (unsigned int)(PMIC_XO_COFST_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_32kdiv_nfrac_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW06),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_LPM_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_NFRAC_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_32kdiv_nfrac_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW06),
				  (&val),
				  (unsigned int)(PMIC_XO_32KDIV_NFRAC_LPM_MASK),
				  (unsigned int)(PMIC_XO_32KDIV_NFRAC_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cofst_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW06),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COFST_LPM_MASK),
				    (unsigned int)(PMIC_XO_COFST_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cofst_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW06),
				  (&val),
				  (unsigned int)(PMIC_XO_COFST_LPM_MASK),
				  (unsigned int)(PMIC_XO_COFST_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_MAN_MASK),
				    (unsigned int)(PMIC_XO_CORE_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_MAN_MASK),
				  (unsigned int)(PMIC_XO_CORE_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CORE_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_turbo_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_TURBO_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_TURBO_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_turbo_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_TURBO_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CORE_TURBO_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_aac_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_AAC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_AAC_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_aac_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_AAC_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CORE_AAC_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_startup_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_STARTUP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_STARTUP_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_startup_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_STARTUP_EN_M_MASK),
				  (unsigned int)(PMIC_XO_STARTUP_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_vbfpm_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_VBFPM_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_VBFPM_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_vbfpm_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_VBFPM_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CORE_VBFPM_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_vblpm_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_VBLPM_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CORE_VBLPM_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_vblpm_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_VBLPM_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CORE_VBLPM_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_lpmbias_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LPMBIAS_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LPMBIAS_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_lpmbias_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_LPMBIAS_EN_M_MASK),
				  (unsigned int)(PMIC_XO_LPMBIAS_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_vtcgen_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VTCGEN_EN_M_MASK),
				    (unsigned int)(PMIC_XO_VTCGEN_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_vtcgen_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_VTCGEN_EN_M_MASK),
				  (unsigned int)(PMIC_XO_VTCGEN_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_iaac_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_IAAC_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_IAAC_COMP_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_iaac_comp_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_IAAC_COMP_EN_M_MASK),
				  (unsigned int)(PMIC_XO_IAAC_COMP_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ifpm_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_IFPM_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_IFPM_COMP_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ifpm_comp_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_IFPM_COMP_EN_M_MASK),
				  (unsigned int)(PMIC_XO_IFPM_COMP_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ilpm_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_ILPM_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_ILPM_COMP_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ilpm_comp_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_ILPM_COMP_EN_M_MASK),
				  (unsigned int)(PMIC_XO_ILPM_COMP_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_bypcas_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_FPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_bypcas_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_BYPCAS_FPM_MASK),
				  (unsigned int)(PMIC_XO_CORE_BYPCAS_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_gmx2_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_GMX2_FPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_GMX2_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_gmx2_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_GMX2_FPM_MASK),
				  (unsigned int)(PMIC_XO_CORE_GMX2_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_idac_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW07),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_IDAC_FPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_IDAC_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_idac_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW07),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_IDAC_FPM_MASK),
				  (unsigned int)(PMIC_XO_CORE_IDAC_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_comp_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_MAN_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_comp_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_COMP_MAN_MASK),
				  (unsigned int)(PMIC_XO_AAC_COMP_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_AAC_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_EN_M_MASK),
				  (unsigned int)(PMIC_XO_AAC_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_monen_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_MONEN_M_MASK),
				    (unsigned int)(PMIC_XO_AAC_MONEN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_monen_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_MONEN_M_MASK),
				  (unsigned int)(PMIC_XO_AAC_MONEN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_comp_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COMP_EN_M_MASK),
				    (unsigned int)(PMIC_XO_COMP_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_comp_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_COMP_EN_M_MASK),
				  (unsigned int)(PMIC_XO_COMP_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_comp_tsten_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_COMP_TSTEN_M_MASK),
				    (unsigned int)(PMIC_XO_COMP_TSTEN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_comp_tsten_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_COMP_TSTEN_M_MASK),
				  (unsigned int)(PMIC_XO_COMP_TSTEN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_hv_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_HV_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_HV_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_hv_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_HV_FPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_HV_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_ibias_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_ibias_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_IBIAS_FPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_IBIAS_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_vofst_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VOFST_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VOFST_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_vofst_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_VOFST_FPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_VOFST_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_comp_hv_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_comp_hv_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_COMP_HV_FPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_COMP_HV_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_vsel_fpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VSEL_FPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VSEL_FPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_vsel_fpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_VSEL_FPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_VSEL_FPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_comp_pol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW08),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_POL_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_POL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_comp_pol(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW08),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_COMP_POL_MASK),
				  (unsigned int)(PMIC_XO_AAC_COMP_POL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_bypcas_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_LPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_BYPCAS_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_bypcas_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_BYPCAS_LPM_MASK),
				  (unsigned int)(PMIC_XO_CORE_BYPCAS_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_gmx2_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_GMX2_LPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_GMX2_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_gmx2_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_GMX2_LPM_MASK),
				  (unsigned int)(PMIC_XO_CORE_GMX2_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_core_idac_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CORE_IDAC_LPM_MASK),
				    (unsigned int)(PMIC_XO_CORE_IDAC_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_core_idac_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_CORE_IDAC_LPM_MASK),
				  (unsigned int)(PMIC_XO_CORE_IDAC_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_comp_hv_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_COMP_HV_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_comp_hv_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_COMP_HV_LPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_COMP_HV_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_vsel_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VSEL_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VSEL_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_vsel_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_VSEL_LPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_VSEL_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_hv_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_HV_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_HV_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_hv_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_HV_LPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_HV_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_ibias_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_IBIAS_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_ibias_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_IBIAS_LPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_IBIAS_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_vofst_lpm(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_VOFST_LPM_MASK),
				    (unsigned int)(PMIC_XO_AAC_VOFST_LPM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_vofst_lpm(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_VOFST_LPM_MASK),
				  (unsigned int)(PMIC_XO_AAC_VOFST_LPM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_aac_fpm_swen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AAC_FPM_SWEN_MASK),
				    (unsigned int)(PMIC_XO_AAC_FPM_SWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_aac_fpm_swen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_AAC_FPM_SWEN_MASK),
				  (unsigned int)(PMIC_XO_AAC_FPM_SWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW09),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_SWRST_MASK),
				    (unsigned int)(PMIC_XO_SWRST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_swrst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW09),
				  (&val),
				  (unsigned int)(PMIC_XO_SWRST_MASK),
				  (unsigned int)(PMIC_XO_SWRST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_32kdiv_swrst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_SWRST_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_SWRST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_32kdiv_swrst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_32KDIV_SWRST_MASK),
				  (unsigned int)(PMIC_XO_32KDIV_SWRST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_32kdiv_ratio_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_RATIO_MAN_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_RATIO_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_32kdiv_ratio_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_32KDIV_RATIO_MAN_MASK),
				  (unsigned int)(PMIC_XO_32KDIV_RATIO_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_32kdiv_test_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_32KDIV_TEST_EN_MASK),
				    (unsigned int)(PMIC_XO_32KDIV_TEST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_32kdiv_test_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_32KDIV_TEST_EN_MASK),
				  (unsigned int)(PMIC_XO_32KDIV_TEST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cbank_sync_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_MAN_MASK),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cbank_sync_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_CBANK_SYNC_MAN_MASK),
				  (unsigned int)(PMIC_XO_CBANK_SYNC_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cbank_sync_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CBANK_SYNC_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cbank_sync_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_CBANK_SYNC_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CBANK_SYNC_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ctl_sync_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CTL_SYNC_MAN_MASK),
				    (unsigned int)(PMIC_XO_CTL_SYNC_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ctl_sync_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_CTL_SYNC_MAN_MASK),
				  (unsigned int)(PMIC_XO_CTL_SYNC_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ctl_sync_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CTL_SYNC_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CTL_SYNC_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ctl_sync_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_CTL_SYNC_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CTL_SYNC_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ldo_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDO_MAN_MASK),
				    (unsigned int)(PMIC_XO_LDO_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ldo_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_LDO_MAN_MASK),
				  (unsigned int)(PMIC_XO_LDO_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ldopbuf_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOPBUF_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LDOPBUF_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ldopbuf_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_LDOPBUF_EN_M_MASK),
				  (unsigned int)(PMIC_XO_LDOPBUF_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ldopbuf_vset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOPBUF_VSET_M_MASK),
				    (unsigned int)(PMIC_XO_LDOPBUF_VSET_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ldopbuf_vset_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_LDOPBUF_VSET_M_MASK),
				  (unsigned int)(PMIC_XO_LDOPBUF_VSET_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_ldovtst_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_LDOVTST_EN_M_MASK),
				    (unsigned int)(PMIC_XO_LDOVTST_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_ldovtst_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_LDOVTST_EN_M_MASK),
				  (unsigned int)(PMIC_XO_LDOVTST_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_test_vcal_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_TEST_VCAL_EN_M_MASK),
				    (unsigned int)(PMIC_XO_TEST_VCAL_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_test_vcal_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_TEST_VCAL_EN_M_MASK),
				  (unsigned int)(PMIC_XO_TEST_VCAL_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_vbist_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VBIST_EN_M_MASK),
				    (unsigned int)(PMIC_XO_VBIST_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_vbist_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW10),
				  (&val),
				  (unsigned int)(PMIC_XO_VBIST_EN_M_MASK),
				  (unsigned int)(PMIC_XO_VBIST_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_vtest_sel_mux(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VTEST_SEL_MUX_MASK),
				    (unsigned int)(PMIC_XO_VTEST_SEL_MUX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_vtest_sel_mux(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_XO_VTEST_SEL_MUX_MASK),
				  (unsigned int)(PMIC_XO_VTEST_SEL_MUX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_core_osctd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CORE_OSCTD_MASK),
				    (unsigned int)(PMIC_RG_XO_CORE_OSCTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_core_osctd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_CORE_OSCTD_MASK),
				  (unsigned int)(PMIC_RG_XO_CORE_OSCTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_thadc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_THADC_EN_MASK),
				    (unsigned int)(PMIC_RG_XO_THADC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_thadc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_THADC_EN_MASK),
				  (unsigned int)(PMIC_RG_XO_THADC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_sync_ckpol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_SYNC_CKPOL_MASK),
				    (unsigned int)(PMIC_RG_XO_SYNC_CKPOL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_sync_ckpol(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_SYNC_CKPOL_MASK),
				  (unsigned int)(PMIC_RG_XO_SYNC_CKPOL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_cbank_pol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CBANK_POL_MASK),
				    (unsigned int)(PMIC_RG_XO_CBANK_POL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_cbank_pol(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_CBANK_POL_MASK),
				  (unsigned int)(PMIC_RG_XO_CBANK_POL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_cbank_sync_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CBANK_SYNC_BYP_MASK),
				    (unsigned int)(PMIC_RG_XO_CBANK_SYNC_BYP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_cbank_sync_byp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_CBANK_SYNC_BYP_MASK),
				  (unsigned int)(PMIC_RG_XO_CBANK_SYNC_BYP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_ctl_pol(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CTL_POL_MASK),
				    (unsigned int)(PMIC_RG_XO_CTL_POL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_ctl_pol(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_CTL_POL_MASK),
				  (unsigned int)(PMIC_RG_XO_CTL_POL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_ctl_sync_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_CTL_SYNC_BYP_MASK),
				    (unsigned int)(PMIC_RG_XO_CTL_SYNC_BYP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_ctl_sync_byp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_CTL_SYNC_BYP_MASK),
				  (unsigned int)(PMIC_RG_XO_CTL_SYNC_BYP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_lpbuf_inv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LPBUF_INV_MASK),
				    (unsigned int)(PMIC_RG_XO_LPBUF_INV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_lpbuf_inv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_LPBUF_INV_MASK),
				  (unsigned int)(PMIC_RG_XO_LPBUF_INV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_ldopbuf_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_BYP_MASK),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_BYP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_ldopbuf_byp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_LDOPBUF_BYP_MASK),
				  (unsigned int)(PMIC_RG_XO_LDOPBUF_BYP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_ldopbuf_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_LDOPBUF_ENCL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_ldopbuf_encl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW11),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_LDOPBUF_ENCL_MASK),
				  (unsigned int)(PMIC_RG_XO_LDOPBUF_ENCL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_vgbias_vset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_VGBIAS_VSET_MASK),
				    (unsigned int)(PMIC_RG_XO_VGBIAS_VSET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_vgbias_vset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_VGBIAS_VSET_MASK),
				  (unsigned int)(PMIC_RG_XO_VGBIAS_VSET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_pbuf_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_PBUF_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_PBUF_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_pbuf_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_PBUF_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_PBUF_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_ibuf_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_IBUF_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_IBUF_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_ibuf_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_IBUF_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_IBUF_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_bufldo13_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO13_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO13_ENCL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_bufldo13_encl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_BUFLDO13_ENCL_MASK),
				  (unsigned int)(PMIC_RG_XO_BUFLDO13_ENCL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_bufldo13_ibx2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO13_IBX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO13_IBX2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_bufldo13_ibx2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_BUFLDO13_IBX2_MASK),
				  (unsigned int)(PMIC_RG_XO_BUFLDO13_IBX2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_bufldo13_ix2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO13_IX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO13_IX2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_bufldo13_ix2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_BUFLDO13_IX2_MASK),
				  (unsigned int)(PMIC_RG_XO_BUFLDO13_IX2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_reserved1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_RESERVED1_MASK),
				    (unsigned int)(PMIC_XO_RESERVED1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_reserved1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_XO_RESERVED1_MASK),
				  (unsigned int)(PMIC_XO_RESERVED1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_bufldo24_encl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_ENCL_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_ENCL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_bufldo24_encl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_BUFLDO24_ENCL_MASK),
				  (unsigned int)(PMIC_RG_XO_BUFLDO24_ENCL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_bufldo24_ibx2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_IBX2_MASK),
				    (unsigned int)(PMIC_RG_XO_BUFLDO24_IBX2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_bufldo24_ibx2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_BUFLDO24_IBX2_MASK),
				  (unsigned int)(PMIC_RG_XO_BUFLDO24_IBX2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_bufldo24_vset_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_BUFLDO24_VSET_M_MASK),
				    (unsigned int)(PMIC_XO_BUFLDO24_VSET_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_bufldo24_vset_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW12),
				  (&val),
				  (unsigned int)(PMIC_XO_BUFLDO24_VSET_M_MASK),
				  (unsigned int)(PMIC_XO_BUFLDO24_VSET_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf1_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF1_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF1_HD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf1_hd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF1_HD_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF1_HD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf1_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF1_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF1_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf1_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF1_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF1_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf2_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF2_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF2_HD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf2_hd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF2_HD_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF2_HD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf2_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF2_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF2_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf2_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF2_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF2_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf3_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF3_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF3_HD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf3_hd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF3_HD_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF3_HD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf3_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF3_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF3_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf3_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF3_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF3_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf4_hd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF4_HD_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF4_HD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf4_hd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF4_HD_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF4_HD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_extbuf4_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_EXTBUF4_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_EXTBUF4_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_extbuf4_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW13),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_EXTBUF4_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_EXTBUF4_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_lpm_prebuf_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_LPM_PREBUF_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_LPM_PREBUF_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_lpm_prebuf_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_LPM_PREBUF_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_LPM_PREBUF_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_audio_atten(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ATTEN_MASK),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ATTEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_audio_atten(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_AUDIO_ATTEN_MASK),
				  (unsigned int)(PMIC_RG_XO_AUDIO_ATTEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_audio_iset(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ISET_MASK),
				    (unsigned int)(PMIC_RG_XO_AUDIO_ISET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_audio_iset(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_AUDIO_ISET_MASK),
				  (unsigned int)(PMIC_RG_XO_AUDIO_ISET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_extbuf4_clksel_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_EXTBUF4_CLKSEL_MAN_MASK),
				    (unsigned int)(PMIC_XO_EXTBUF4_CLKSEL_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_extbuf4_clksel_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_XO_EXTBUF4_CLKSEL_MAN_MASK),
				  (unsigned int)(PMIC_XO_EXTBUF4_CLKSEL_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_reserved0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_RESERVED0_MASK),
				    (unsigned int)(PMIC_RG_XO_RESERVED0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_reserved0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_RESERVED0_MASK),
				  (unsigned int)(PMIC_RG_XO_RESERVED0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_vio18pg_bufen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_VIO18PG_BUFEN_MASK),
				    (unsigned int)(PMIC_XO_VIO18PG_BUFEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_vio18pg_bufen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_XO_VIO18PG_BUFEN_MASK),
				  (unsigned int)(PMIC_XO_VIO18PG_BUFEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_xo_reserved1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_XO_RESERVED1_MASK),
				    (unsigned int)(PMIC_RG_XO_RESERVED1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_xo_reserved1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_RG_XO_RESERVED1_MASK),
				  (unsigned int)(PMIC_RG_XO_RESERVED1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cal_en_man(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CAL_EN_MAN_MASK),
				    (unsigned int)(PMIC_XO_CAL_EN_MAN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cal_en_man(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_XO_CAL_EN_MAN_MASK),
				  (unsigned int)(PMIC_XO_CAL_EN_MAN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_cal_en_m(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_CAL_EN_M_MASK),
				    (unsigned int)(PMIC_XO_CAL_EN_M_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_cal_en_m(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW14),
				  (&val),
				  (unsigned int)(PMIC_XO_CAL_EN_M_MASK),
				  (unsigned int)(PMIC_XO_CAL_EN_M_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_static_auxout_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_STATIC_AUXOUT_SEL_MASK),
				    (unsigned int)(PMIC_XO_STATIC_AUXOUT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_static_auxout_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW15),
				  (&val),
				  (unsigned int)(PMIC_XO_STATIC_AUXOUT_SEL_MASK),
				  (unsigned int)(PMIC_XO_STATIC_AUXOUT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_xo_auxout_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_DCXO_CW15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_XO_AUXOUT_SEL_MASK),
				    (unsigned int)(PMIC_XO_AUXOUT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_xo_auxout_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW15),
				  (&val),
				  (unsigned int)(PMIC_XO_AUXOUT_SEL_MASK),
				  (unsigned int)(PMIC_XO_AUXOUT_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_xo_static_auxout(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_DCXO_CW16),
				  (&val),
				  (unsigned int)(PMIC_XO_STATIC_AUXOUT_MASK),
				  (unsigned int)(PMIC_XO_STATIC_AUXOUT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH3_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH3_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH3_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH3_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH5_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH5_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH5_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH5_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH6_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH6_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH6_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH6_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH8_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH8_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH8_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH8_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH9_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH9_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH9_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH9_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH10_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH10_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH10_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH10_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH11_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH11_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH11_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH11_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch12_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH12_15_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH12_15_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch12_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH12_15_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH12_15_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_thr_hw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_THR_HW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_THR_HW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_thr_hw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_THR_HW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_THR_HW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_lbat2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_LBAT2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_lbat2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_LBAT2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch7_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch7_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch7_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch7_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch7_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH7_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch7_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH7_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch4_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH4_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch4_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH4_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_wakeup_pchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_PCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_PCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_wakeup_pchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_PCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_PCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_wakeup_swchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_SWCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_WAKEUP_SWCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_wakeup_swchr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_SWCHR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_SWCHR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch0_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch0_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch0_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH0_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch0_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH0_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch1_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch1_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_ch1_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_CH1_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_ch1_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_CH1_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_vismps0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_VISMPS0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_VISMPS0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_vismps0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_VISMPS0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_VISMPS0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_fgadc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_fgadc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_fgadc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_FGADC2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_fgadc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_FGADC2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_imp_avg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_AVG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_IMP_AVG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_imp_avg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_AVG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_IMP_AVG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_raw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_RAW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_RAW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC32),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC32),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_mdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC33),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDBG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_MDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_mdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC33),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDBG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_MDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_dcxo_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC34),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_dcxo_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC34),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_dcxo_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC35),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_dcxo_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC35),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_dcxo_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC36),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_dcxo_by_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC36),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_BY_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_dcxo_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC37),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_DCXO_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_dcxo_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC37),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_DCXO_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_nag(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC38),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_NAG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_NAG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_nag(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC38),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_NAG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_NAG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_typec_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC39),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_TYPEC_H_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_TYPEC_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_typec_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC39),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_TYPEC_H_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_TYPEC_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_out_typec_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC40),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_TYPEC_L_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_OUT_TYPEC_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_typec_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ADC40),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_TYPEC_L_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_TYPEC_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_00_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_00_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_00(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_00_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_00_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_01(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_01_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_01_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_01(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_01_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_01_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_02(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_02_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_02_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_02(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_02_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_02_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_03_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_03_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_03(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_03_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_03_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_04(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_04_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_04_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_04(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_04_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_04_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_05(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_05_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_05_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_05(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_05_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_05_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_06(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_06_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_06_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_06(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_06_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_06_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_07(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_07_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_07_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_07(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_07_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_07_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_08(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_08_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_08_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_08(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_08_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_08_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_09(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_09_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_09_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_09(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_09_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_09_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_10_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_10_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_10_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_10_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_11_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_11_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_11_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_11_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_12_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_12_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF12),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_12_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_12_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_13(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_13_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_13_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_13(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_13_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_13_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_14(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_14_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_14_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_14(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_14_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_14_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_15_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_15_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_15_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_15_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_16_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_16_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_16_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_16_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_17(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_17_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_17_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_17(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF17),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_17_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_17_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_18_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_18(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF18),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_18_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_18_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_19_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_19_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_19(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF19),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_19_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_19_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_20(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_20_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_20_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_20(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF20),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_20_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_20_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_21(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_21_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_21_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_21(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF21),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_21_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_21_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_22(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_22_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_22_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_22(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF22),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_22_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_22_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_23(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_23_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_23_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_23(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF23),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_23_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_23_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_24(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_24_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_24_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_24(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF24),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_24_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_24_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_25(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_25_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_25_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_25(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF25),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_25_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_25_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_26(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_26_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_26_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_26(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF26),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_26_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_26_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_27(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_27_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_27_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_27(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF27),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_27_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_27_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_28_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_28(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF28),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_28_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_28_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_29(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_29_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_29_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_29(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF29),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_29_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_29_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_30(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_30_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_30_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_30(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF30),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_30_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_30_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_out_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_31_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_OUT_31_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_buf_rdy_31(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_BUF31),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_31_MASK),
				  (unsigned int)(PMIC_AUXADC_BUF_RDY_31_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_lbat2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_LBAT2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_vismps0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_VISMPS0_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_VISMPS0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_wakeup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_WAKEUP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_WAKEUP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_dcxo_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_dcxo_gps_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_dcxo_gps_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_dcxo_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_DCXO_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_mdrt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDRT_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDRT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_mdbg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDBG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_MDBG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_share(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_SHARE_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_SHARE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_imp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_IMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_IMP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_fgadc1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC1_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC1_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_fgadc2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC2_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_FGADC2_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_gps_ap(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_AP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_AP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_gps_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_GPS_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_thr_hw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_HW_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_HW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_thr_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_THR_MD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_typec_h(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_TYPEC_H_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_TYPEC_H_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_typec_l(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_TYPEC_L_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_TYPEC_L_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_adc_busy_in_nag(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_STA2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_NAG_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_BUSY_IN_NAG_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH0_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH1_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH2_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH2_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH3_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH3_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH4_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH4_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH5_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH5_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH5_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH5_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH6_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH6_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH6_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH6_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH7_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH7_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch8(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH8_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH8_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH8_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH8_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch9(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH9_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH9_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH9_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH9_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch10(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH10_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH10_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH10_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH10_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch11(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH11_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH11_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH11_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH11_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH12_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH12_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH12_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH12_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch13(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH13_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH13_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch13(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH13_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH13_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch14(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH14_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH14_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch14(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH14_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH14_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch15(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH15_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH15_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch15(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH15_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH15_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch0_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH0_BY_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch0_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH0_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH0_BY_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch1_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH1_BY_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch1_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH1_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH1_BY_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_RSV0_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch4_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH4_BY_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch4_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH4_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH4_BY_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch7_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch7_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_ch7_by_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_GPS_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_GPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_ch7_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_CH7_BY_GPS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_dcxo_by_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_dcxo_by_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_dcxo_by_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_GPS_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_GPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_dcxo_by_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_DCXO_BY_GPS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rqst_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_RQST1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV1_MASK),
				    (unsigned int)(PMIC_AUXADC_RQST_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rqst_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_RQST1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RQST_RSV1_MASK),
				  (unsigned int)(PMIC_AUXADC_RQST_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_ck_on_extd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_ON_EXTD_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_ON_EXTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_ck_on_extd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_CK_ON_EXTD_MASK),
				  (unsigned int)(PMIC_AUXADC_CK_ON_EXTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_srclken_src_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_SRC_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_SRC_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_srclken_src_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SRCLKEN_SRC_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_SRCLKEN_SRC_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adc_pwdb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adc_pwdb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_PWDB_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_PWDB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adc_pwdb_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_PWDB_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adc_pwdb_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_PWDB_SWCTRL_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_PWDB_SWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_strup_ck_on_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_STRUP_CK_ON_ENB_MASK),
				    (unsigned int)(PMIC_AUXADC_STRUP_CK_ON_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_strup_ck_on_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_STRUP_CK_ON_ENB_MASK),
				  (unsigned int)(PMIC_AUXADC_STRUP_CK_ON_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adc_rdy_wakeup_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adc_rdy_wakeup_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_CLR_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_RDY_WAKEUP_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_srclken_ck_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_CK_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_SRCLKEN_CK_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_srclken_ck_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SRCLKEN_CK_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_SRCLKEN_CK_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_ck_aon_gps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_AON_GPS_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_AON_GPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_ck_aon_gps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_CK_AON_GPS_MASK),
				  (unsigned int)(PMIC_AUXADC_CK_AON_GPS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_ck_aon_md(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_AON_MD_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_AON_MD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_ck_aon_md(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_CK_AON_MD_MASK),
				  (unsigned int)(PMIC_AUXADC_CK_AON_MD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_ck_aon(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CK_AON_MASK),
				    (unsigned int)(PMIC_AUXADC_CK_AON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_ck_aon(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_CK_AON_MASK),
				  (unsigned int)(PMIC_AUXADC_CK_AON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_small(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SMALL_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SMALL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_small(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SMALL_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SMALL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_large(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_LARGE_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_LARGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_large(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_LARGE_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_LARGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_sel_share(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHARE_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHARE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_sel_share(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHARE_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_SHARE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_sel_lbat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_LBAT_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_LBAT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_sel_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_LBAT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_sel_vismps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_VISMPS_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_VISMPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_sel_vismps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_VISMPS_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_VISMPS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_avg_num_sel_wakeup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_WAKEUP_MASK),
				    (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_WAKEUP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_avg_num_sel_wakeup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_WAKEUP_MASK),
				  (unsigned int)(PMIC_AUXADC_AVG_NUM_SEL_WAKEUP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_large(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_LARGE_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_LARGE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_large(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_LARGE_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_LARGE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sleep(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sleep(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sleep_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sleep_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SLEEP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sel_share(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHARE_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHARE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sel_share(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHARE_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_SHARE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sel_lbat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_LBAT_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_LBAT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sel_lbat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_LBAT_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_LBAT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sel_vismps(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_VISMPS_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_VISMPS_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sel_vismps(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_VISMPS_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_VISMPS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_spl_num_sel_wakeup(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_WAKEUP_MASK),
				    (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_WAKEUP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_spl_num_sel_wakeup(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_WAKEUP_MASK),
				  (unsigned int)(PMIC_AUXADC_SPL_NUM_SEL_WAKEUP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch0_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH0_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH0_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch0_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH0_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH0_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH1_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH1_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH2_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH2_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch3_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH3_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH3_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch3_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH3_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH3_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch4_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH4_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH4_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch4_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH4_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH4_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch5_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH5_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH5_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch5_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH5_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH5_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch6_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH6_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH6_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch6_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH6_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH6_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch7_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH7_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH7_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch7_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH7_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH7_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch8_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH8_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH8_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch8_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH8_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH8_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch9_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH9_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH9_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch9_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH9_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH9_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch10_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH10_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH10_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch10_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH10_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH10_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_trim_ch11_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH11_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TRIM_CH11_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_trim_ch11_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH11_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TRIM_CH11_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adc_2s_comp_enb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_2S_COMP_ENB_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_2S_COMP_ENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adc_2s_comp_enb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_2S_COMP_ENB_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_2S_COMP_ENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adc_trim_comp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADC_TRIM_COMP_MASK),
				    (unsigned int)(PMIC_AUXADC_ADC_TRIM_COMP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adc_trim_comp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADC_TRIM_COMP_MASK),
				  (unsigned int)(PMIC_AUXADC_ADC_TRIM_COMP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_sw_gain_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SW_GAIN_TRIM_MASK),
				    (unsigned int)(PMIC_AUXADC_SW_GAIN_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_sw_gain_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SW_GAIN_TRIM_MASK),
				  (unsigned int)(PMIC_AUXADC_SW_GAIN_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_sw_offset_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SW_OFFSET_TRIM_MASK),
				    (unsigned int)(PMIC_AUXADC_SW_OFFSET_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_sw_offset_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON9),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SW_OFFSET_TRIM_MASK),
				  (unsigned int)(PMIC_AUXADC_SW_OFFSET_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_rng_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_RNG_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_RNG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_rng_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_RNG_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_RNG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_data_reuse_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DATA_REUSE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DATA_REUSE_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_data_reuse_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DATA_REUSE_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_DATA_REUSE_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_test_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TEST_MODE_MASK),
				    (unsigned int)(PMIC_AUXADC_TEST_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_test_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TEST_MODE_MASK),
				  (unsigned int)(PMIC_AUXADC_TEST_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_bit_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_BIT_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_BIT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_bit_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_BIT_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_BIT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_start_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_START_SW_MASK),
				  (unsigned int)(PMIC_AUXADC_START_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_start_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_start_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_START_SWCTRL_MASK),
				  (unsigned int)(PMIC_AUXADC_START_SWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_ts_vbe_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_ts_vbe_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_ts_vbe_sel_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_ts_vbe_sel_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SWCTRL_MASK),
				  (unsigned int)(PMIC_AUXADC_TS_VBE_SEL_SWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vbuf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vbuf_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VBUF_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_VBUF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vbuf_en_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_VBUF_EN_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vbuf_en_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VBUF_EN_SWCTRL_MASK),
				  (unsigned int)(PMIC_AUXADC_VBUF_EN_SWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_out_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_OUT_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_OUT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_out_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON10),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_OUT_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_OUT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_da_dac(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_MASK),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_da_dac(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DA_DAC_MASK),
				  (unsigned int)(PMIC_AUXADC_DA_DAC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_da_dac_swctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_SWCTRL_MASK),
				    (unsigned int)(PMIC_AUXADC_DA_DAC_SWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_da_dac_swctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON11),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DA_DAC_SWCTRL_MASK),
				  (unsigned int)(PMIC_AUXADC_DA_DAC_SWCTRL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_auxadc_comp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON11),
				  (&val),
				  (unsigned int)(PMIC_AD_AUXADC_COMP_MASK),
				  (unsigned int)(PMIC_AD_AUXADC_COMP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbuf_exten(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_EXTEN_MASK),
				    (unsigned int)(PMIC_RG_VBUF_EXTEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbuf_exten(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VBUF_EXTEN_MASK),
				  (unsigned int)(PMIC_RG_VBUF_EXTEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbuf_calen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_CALEN_MASK),
				    (unsigned int)(PMIC_RG_VBUF_CALEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbuf_calen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VBUF_CALEN_MASK),
				  (unsigned int)(PMIC_RG_VBUF_CALEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbuf_byp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_BYP_MASK),
				    (unsigned int)(PMIC_RG_VBUF_BYP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbuf_byp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VBUF_BYP_MASK),
				  (unsigned int)(PMIC_RG_VBUF_BYP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_aux_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUX_RSV_MASK),
				    (unsigned int)(PMIC_RG_AUX_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_aux_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_AUX_RSV_MASK),
				  (unsigned int)(PMIC_RG_AUX_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_auxadc_cali(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUXADC_CALI_MASK),
				    (unsigned int)(PMIC_RG_AUXADC_CALI_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_auxadc_cali(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_AUXADC_CALI_MASK),
				  (unsigned int)(PMIC_RG_AUXADC_CALI_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbuf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBUF_EN_MASK),
				    (unsigned int)(PMIC_RG_VBUF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbuf_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VBUF_EN_MASK),
				  (unsigned int)(PMIC_RG_VBUF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbe_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBE_SEL_MASK),
				    (unsigned int)(PMIC_RG_VBE_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbe_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_VBE_SEL_MASK),
				  (unsigned int)(PMIC_RG_VBE_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adcin_vsen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adcin_vsen_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adcin_vbat_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VBAT_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VBAT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adcin_vbat_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VBAT_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VBAT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adcin_vsen_mux_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_MUX_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_MUX_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adcin_vsen_mux_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_MUX_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_MUX_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adcin_vsen_ext_baton_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EXT_BATON_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EXT_BATON_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adcin_vsen_ext_baton_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EXT_BATON_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADCIN_VSEN_EXT_BATON_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adcin_chr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_CHR_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_CHR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adcin_chr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADCIN_CHR_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADCIN_CHR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_adcin_baton_tdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ADCIN_BATON_TDET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ADCIN_BATON_TDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_adcin_baton_tdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ADCIN_BATON_TDET_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ADCIN_BATON_TDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_accdet_anaswctrl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_ANASWCTRL_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_ANASWCTRL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_accdet_anaswctrl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ACCDET_ANASWCTRL_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_ACCDET_ANASWCTRL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dig0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dig0_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DIG0_RSV0_MASK),
				  (unsigned int)(PMIC_AUXADC_DIG0_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_chsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CHSEL_MASK),
				    (unsigned int)(PMIC_AUXADC_CHSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_chsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_CHSEL_MASK),
				  (unsigned int)(PMIC_AUXADC_CHSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_swctrl_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SWCTRL_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_SWCTRL_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_swctrl_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON13),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SWCTRL_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_SWCTRL_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_source_lbat_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_source_lbat_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SOURCE_LBAT_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_SOURCE_LBAT_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_source_lbat2_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT2_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_SOURCE_LBAT2_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_source_lbat2_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_SOURCE_LBAT2_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_SOURCE_LBAT2_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dig0_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV2_MASK),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dig0_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DIG0_RSV2_MASK),
				  (unsigned int)(PMIC_AUXADC_DIG0_RSV2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dig1_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DIG1_RSV2_MASK),
				    (unsigned int)(PMIC_AUXADC_DIG1_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dig1_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DIG1_RSV2_MASK),
				  (unsigned int)(PMIC_AUXADC_DIG1_RSV2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dac_extd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_MASK),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dac_extd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DAC_EXTD_MASK),
				  (unsigned int)(PMIC_AUXADC_DAC_EXTD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dac_extd_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DAC_EXTD_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dac_extd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON14),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DAC_EXTD_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_DAC_EXTD_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_pmu_thr_pdn_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_pmu_thr_pdn_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SW_MASK),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_pmu_thr_pdn_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_pmu_thr_pdn_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_pmu_thr_pdn_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_STATUS_MASK),
				  (unsigned int)(PMIC_AUXADC_PMU_THR_PDN_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dig0_rsv1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV1_MASK),
				    (unsigned int)(PMIC_AUXADC_DIG0_RSV1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dig0_rsv1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON15),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DIG0_RSV1_MASK),
				  (unsigned int)(PMIC_AUXADC_DIG0_RSV1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_start_shade_num(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_NUM_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_NUM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_start_shade_num(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_START_SHADE_NUM_MASK),
				  (unsigned int)(PMIC_AUXADC_START_SHADE_NUM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_start_shade_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_start_shade_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_START_SHADE_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_START_SHADE_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_start_shade_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_START_SHADE_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_start_shade_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_CON16),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_START_SHADE_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_START_SHADE_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_autorpt_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_AUTORPT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_PRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_autorpt_prd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_AUTORPT0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AUTORPT_PRD_MASK),
				  (unsigned int)(PMIC_AUXADC_AUTORPT_PRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_autorpt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_AUTORPT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_AUTORPT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_autorpt_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_AUTORPT0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_AUTORPT_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_AUTORPT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_debt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_debt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_det_prd_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_19_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_det_prd_19_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_19_16_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DET_PRD_19_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_volt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_irq_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_EN_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_volt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_VOLT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_irq_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_IRQ_EN_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_EN_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_accdet_auto_spl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_SPL_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_SPL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_accdet_auto_spl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_SPL_MASK),
				  (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_SPL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_accdet_auto_rqst_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_RQST_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_RQST_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_accdet_auto_rqst_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_RQST_CLR_MASK),
				  (unsigned int)(PMIC_AUXADC_ACCDET_AUTO_RQST_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_accdet_dig1_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG1_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG1_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_accdet_dig1_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ACCDET_DIG1_RSV0_MASK),
				  (unsigned int)(PMIC_AUXADC_ACCDET_DIG1_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_accdet_dig0_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG0_RSV0_MASK),
				    (unsigned int)(PMIC_AUXADC_ACCDET_DIG0_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_accdet_dig0_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_ACCDET),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_ACCDET_DIG0_RSV0_MASK),
				  (unsigned int)(PMIC_AUXADC_ACCDET_DIG0_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_debt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DEBT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DEBT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DEBT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_debt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DEBT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DEBT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_det_prd_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DET_PRD_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DET_PRD_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_DET_PRD_19_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_det_prd_19_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DET_PRD_19_16_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DET_PRD_19_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_volt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_VOLT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_VOLT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_irq_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_EN_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_thr_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_VOLT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_volt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_VOLT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_VOLT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_irq_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_IRQ_EN_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_thr_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_THR4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_THR_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_thr_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_EN_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_thr_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_thr_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_thr_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_THR6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_THR_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_gain_ch4_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_EFUSE0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH4_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH4_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_gain_ch4_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_EFUSE0),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_GAIN_CH4_TRIM_MASK),
				  (unsigned int)(PMIC_EFUSE_GAIN_CH4_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_offset_ch4_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_EFUSE1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH4_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH4_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_offset_ch4_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_EFUSE1),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_OFFSET_CH4_TRIM_MASK),
				  (unsigned int)(PMIC_EFUSE_OFFSET_CH4_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_gain_ch0_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_EFUSE2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH0_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH0_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_gain_ch0_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_EFUSE2),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_GAIN_CH0_TRIM_MASK),
				  (unsigned int)(PMIC_EFUSE_GAIN_CH0_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_offset_ch0_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_EFUSE3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH0_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH0_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_offset_ch0_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_EFUSE3),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_OFFSET_CH0_TRIM_MASK),
				  (unsigned int)(PMIC_EFUSE_OFFSET_CH0_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_gain_ch7_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_EFUSE4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH7_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_GAIN_CH7_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_gain_ch7_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_EFUSE4),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_GAIN_CH7_TRIM_MASK),
				  (unsigned int)(PMIC_EFUSE_GAIN_CH7_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_efuse_offset_ch7_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_EFUSE5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH7_TRIM_MASK),
				    (unsigned int)(PMIC_EFUSE_OFFSET_CH7_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_efuse_offset_ch7_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_EFUSE5),
				  (&val),
				  (unsigned int)(PMIC_EFUSE_OFFSET_CH7_TRIM_MASK),
				  (unsigned int)(PMIC_EFUSE_OFFSET_CH7_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_fgadc_start_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_fgadc_start_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DBG0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_FGADC_START_SW_MASK),
				  (unsigned int)(PMIC_AUXADC_FGADC_START_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_fgadc_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_START_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_fgadc_start_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DBG0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_FGADC_START_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_FGADC_START_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_fgadc_r_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SW_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_fgadc_r_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DBG0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_FGADC_R_SW_MASK),
				  (unsigned int)(PMIC_AUXADC_FGADC_R_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_fgadc_r_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_FGADC_R_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_fgadc_r_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DBG0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_FGADC_R_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_FGADC_R_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dbg_dig0_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG0_RSV2_MASK),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG0_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dbg_dig0_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DBG0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DBG_DIG0_RSV2_MASK),
				  (unsigned int)(PMIC_AUXADC_DBG_DIG0_RSV2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dbg_dig1_rsv2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DBG0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG1_RSV2_MASK),
				    (unsigned int)(PMIC_AUXADC_DBG_DIG1_RSV2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dbg_dig1_rsv2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DBG0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DBG_DIG1_RSV2_MASK),
				  (unsigned int)(PMIC_AUXADC_DBG_DIG1_RSV2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_impedance_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CNT_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CNT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_impedance_cnt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_CNT_MASK),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_CNT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_impedance_chsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CHSEL_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_CHSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_impedance_chsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_CHSEL_MASK),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_CHSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_impedance_irq_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_impedance_irq_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_CLR_MASK),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_CLR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_impedance_irq_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_STATUS_MASK),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_IRQ_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_clr_imp_cnt_stop(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_CLR_IMP_CNT_STOP_MASK),
				    (unsigned int)(PMIC_AUXADC_CLR_IMP_CNT_STOP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_clr_imp_cnt_stop(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_CLR_IMP_CNT_STOP_MASK),
				  (unsigned int)(PMIC_AUXADC_CLR_IMP_CNT_STOP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_impedance_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_MODE_MASK),
				    (unsigned int)(PMIC_AUXADC_IMPEDANCE_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_impedance_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_MODE_MASK),
				  (unsigned int)(PMIC_AUXADC_IMPEDANCE_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_imp_autorpt_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_PRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_imp_autorpt_prd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_PRD_MASK),
				  (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_PRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_imp_autorpt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_IMP1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_imp_autorpt_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_IMP1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_IMP_AUTORPT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_debt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_debt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_det_prd_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_19_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_det_prd_19_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_19_16_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DET_PRD_19_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_volt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_irq_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_vismps0_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_volt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_VOLT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_irq_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_IRQ_EN_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_vismps0_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_vismps0_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_EN_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_vismps0_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_vismps0_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_vismps0_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_VISMPS0_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_VISMPS0_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_debt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_debt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_det_prd_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_19_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_det_prd_19_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_19_16_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DET_PRD_19_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_volt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_irq_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_EN_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat2_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_volt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_VOLT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_irq_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_IRQ_EN_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_lbat2_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_LBAT2_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_lbat2_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_EN_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat2_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat2_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_lbat2_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_LBAT2_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_LBAT2_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdbg_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDBG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_PRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdbg_det_prd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDBG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_DET_PRD_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_DET_PRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdbg_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDBG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDBG_DET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdbg_det_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDBG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_DET_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_DET_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_mdbg_r_ptr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDBG_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_R_PTR_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_R_PTR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_mdbg_w_ptr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDBG_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_W_PTR_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_W_PTR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdbg_buf_length(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDBG_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDBG_BUF_LENGTH_MASK),
				    (unsigned int)(PMIC_AUXADC_MDBG_BUF_LENGTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdbg_buf_length(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDBG_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDBG_BUF_LENGTH_MASK),
				  (unsigned int)(PMIC_AUXADC_MDBG_BUF_LENGTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_PRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_prd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_PRD_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_PRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_wkup_start_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CNT_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CNT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_wkup_start_cnt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CNT_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CNT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_wkup_start_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_wkup_start_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CLR_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_wkup_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_wkup_start(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_wkup_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_wkup_start_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_START_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_wkup_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_wkup_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_WKUP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_mdrt_det_srclken_ind(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_SRCLKEN_IND_MASK),
				    (unsigned int)(PMIC_AUXADC_MDRT_DET_SRCLKEN_IND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_mdrt_det_srclken_ind(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_SRCLKEN_IND_MASK),
				  (unsigned int)(PMIC_AUXADC_MDRT_DET_SRCLKEN_IND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_PRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_prd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_PRD_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_PRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_wkup_start_cnt(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_wkup_start_cnt(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CNT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_wkup_start_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_wkup_start_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_wkup_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_wkup_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_wkup_start_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_wkup_start_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_wkup_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_wkup_start(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_WKUP_START_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_mdrt_det_srclken_ind(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_mdrt_det_srclken_ind(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_MDRT_DET_SRCLKEN_IND_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_dcxo_ch4_mux_ap_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_DCXO_CH4_MUX_AP_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_DCXO_CH4_MUX_AP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_dcxo_ch4_mux_ap_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_DCXO_MDRT_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_DCXO_CH4_MUX_AP_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_DCXO_CH4_MUX_AP_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_CLR_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_CLR_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_vbat1_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_VBAT1_SEL_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_VBAT1_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_vbat1_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_VBAT1_SEL_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_VBAT1_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_prd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_PRD_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_PRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_prd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_PRD_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_PRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_irq_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_IRQ_EN_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_IRQ_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_irq_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_IRQ_EN_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_IRQ_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_nag_c_dltv_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_0),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_IRQ_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_IRQ_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_zcv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_ZCV_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_ZCV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_zcv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_ZCV_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_ZCV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_c_dltv_th_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_c_dltv_th_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_nag_c_dltv_th_26_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_NAG_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_26_16_MASK),
				    (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_26_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_nag_c_dltv_th_26_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_26_16_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_TH_26_16_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_nag_cnt_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_15_0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_nag_cnt_25_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_25_16_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_CNT_25_16_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_nag_dltv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_DLTV_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_DLTV_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_nag_c_dltv_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_15_0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_nag_c_dltv_26_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_NAG_8),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_26_16_MASK),
				  (unsigned int)(PMIC_AUXADC_NAG_C_DLTV_26_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_debt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_debt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_det_prd_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_19_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_det_prd_19_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_19_16_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DET_PRD_19_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_volt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_irq_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_h_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_volt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_VOLT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_irq_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_IRQ_EN_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_h_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_h_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_EN_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_h_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_h_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_h_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_H_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_H_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_debt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_debt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_debt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_debt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_1),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_det_prd_15_0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_15_0_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_15_0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_det_prd_15_0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_2),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_15_0_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_15_0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_det_prd_19_16(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_19_16_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_19_16_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_det_prd_19_16(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_3),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_19_16_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DET_PRD_19_16_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_volt_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_volt_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_irq_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_irq_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_en_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MAX_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_en_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_l_max_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_4),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_MAX_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_MAX_IRQ_B_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_volt_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_volt_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_VOLT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_irq_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_irq_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_IRQ_EN_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_auxadc_typec_l_en_min(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MIN_MASK),
				    (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MIN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_auxadc_typec_l_en_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_EN_MIN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_l_min_irq_b(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_5),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_MIN_IRQ_B_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_MIN_IRQ_B_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_l_debounce_count_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_6),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBOUNCE_COUNT_MAX_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBOUNCE_COUNT_MAX_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_auxadc_typec_l_debounce_count_min(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_AUXADC_TYPEC_L_7),
				  (&val),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBOUNCE_COUNT_MIN_MASK),
				  (unsigned int)(PMIC_AUXADC_TYPEC_L_DEBOUNCE_COUNT_MIN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetvthbcal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETVTHBCAL_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETVTHBCAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetvthbcal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETVTHBCAL_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETVTHBCAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetvthacal(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETVTHACAL_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETVTHACAL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetvthacal(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETVTHACAL_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETVTHACAL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetanaswctrlenb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETANASWCTRLENB_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETANASWCTRLENB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetanaswctrlenb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETANASWCTRLENB_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETANASWCTRLENB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_accdetsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ACCDETSEL_MASK),
				    (unsigned int)(PMIC_RG_ACCDETSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_accdetsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_ACCDETSEL_MASK),
				  (unsigned int)(PMIC_RG_ACCDETSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetswctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETSWCTRL_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETSWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetswctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETSWCTRL_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETSWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetmicbias1pulllow(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETMICBIAS1PULLLOW_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETMICBIAS1PULLLOW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetmicbias1pulllow(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETMICBIAS1PULLLOW_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETMICBIAS1PULLLOW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdettvdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETTVDET_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETTVDET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdettvdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETTVDET_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETTVDET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetvin1pulllow(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETVIN1PULLLOW_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETVIN1PULLLOW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetvin1pulllow(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETVIN1PULLLOW_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETVIN1PULLLOW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_audaccdetauxadcswctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_MASK),
				    (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_audaccdetauxadcswctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_MASK),
				  (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_audaccdetauxadcswctrl_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_SEL_MASK),
				    (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_audaccdetauxadcswctrl_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_SEL_MASK),
				  (unsigned int)(PMIC_AUDACCDETAUXADCSWCTRL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetmicbias0pulllow(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETMICBIAS0PULLLOW_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETMICBIAS0PULLLOW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetmicbias0pulllow(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETMICBIAS0PULLLOW_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETMICBIAS0PULLLOW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_audaccdetrsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_AUDACCDETRSV_MASK),
				    (unsigned int)(PMIC_RG_AUDACCDETRSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_audaccdetrsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_AUDACCDETRSV_MASK),
				  (unsigned int)(PMIC_RG_AUDACCDETRSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_seq_init(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_SEQ_INIT_MASK),
				    (unsigned int)(PMIC_ACCDET_SEQ_INIT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_seq_init(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_SEQ_INIT_MASK),
				  (unsigned int)(PMIC_ACCDET_SEQ_INIT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eintdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINTDET_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_EINTDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eintdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINTDET_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINTDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_seq_init(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_SEQ_INIT_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_SEQ_INIT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_seq_init(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_SEQ_INIT_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_SEQ_INIT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_negvdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_NEGVDET_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_NEGVDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_negvdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGVDET_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGVDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_negvdet_en_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_NEGVDET_EN_CTRL_MASK),
				    (unsigned int)(PMIC_ACCDET_NEGVDET_EN_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_negvdet_en_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGVDET_EN_CTRL_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGVDET_EN_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_anaswctrl_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_ANASWCTRL_SEL_MASK),
				    (unsigned int)(PMIC_ACCDET_ANASWCTRL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_anaswctrl_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON1),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_ANASWCTRL_SEL_MASK),
				  (unsigned int)(PMIC_ACCDET_ANASWCTRL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_cmp_pwm_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_CMP_PWM_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_CMP_PWM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_cmp_pwm_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_CMP_PWM_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_CMP_PWM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_vth_pwm_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_VTH_PWM_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_VTH_PWM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_vth_pwm_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_VTH_PWM_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_VTH_PWM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_mbias_pwm_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_MBIAS_PWM_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_MBIAS_PWM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_mbias_pwm_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_MBIAS_PWM_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_MBIAS_PWM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_pwm_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_EN_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_pwm_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_EN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_cmp_pwm_idle(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_CMP_PWM_IDLE_MASK),
				    (unsigned int)(PMIC_ACCDET_CMP_PWM_IDLE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_cmp_pwm_idle(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_CMP_PWM_IDLE_MASK),
				  (unsigned int)(PMIC_ACCDET_CMP_PWM_IDLE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_vth_pwm_idle(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_VTH_PWM_IDLE_MASK),
				    (unsigned int)(PMIC_ACCDET_VTH_PWM_IDLE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_vth_pwm_idle(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_VTH_PWM_IDLE_MASK),
				  (unsigned int)(PMIC_ACCDET_VTH_PWM_IDLE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_mbias_pwm_idle(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_MBIAS_PWM_IDLE_MASK),
				    (unsigned int)(PMIC_ACCDET_MBIAS_PWM_IDLE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_mbias_pwm_idle(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_MBIAS_PWM_IDLE_MASK),
				  (unsigned int)(PMIC_ACCDET_MBIAS_PWM_IDLE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_pwm_idle(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_IDLE_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_IDLE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_pwm_idle(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON2),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_IDLE_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_IDLE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_pwm_width(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_PWM_WIDTH_MASK),
				    (unsigned int)(PMIC_ACCDET_PWM_WIDTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_pwm_width(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON3),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_PWM_WIDTH_MASK),
				  (unsigned int)(PMIC_ACCDET_PWM_WIDTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_pwm_thresh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_PWM_THRESH_MASK),
				    (unsigned int)(PMIC_ACCDET_PWM_THRESH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_pwm_thresh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON4),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_PWM_THRESH_MASK),
				  (unsigned int)(PMIC_ACCDET_PWM_THRESH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_rise_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_RISE_DELAY_MASK),
				    (unsigned int)(PMIC_ACCDET_RISE_DELAY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_rise_delay(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON5),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_RISE_DELAY_MASK),
				  (unsigned int)(PMIC_ACCDET_RISE_DELAY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_fall_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_FALL_DELAY_MASK),
				    (unsigned int)(PMIC_ACCDET_FALL_DELAY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_fall_delay(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON5),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_FALL_DELAY_MASK),
				  (unsigned int)(PMIC_ACCDET_FALL_DELAY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_debounce0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE0_MASK),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_debounce0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON6),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE0_MASK),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_debounce1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE1_MASK),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_debounce1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON7),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE1_MASK),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_debounce2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE2_MASK),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_debounce2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON8),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE2_MASK),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_debounce3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE3_MASK),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_debounce3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON9),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE3_MASK),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_debounce4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE4_MASK),
				    (unsigned int)(PMIC_ACCDET_DEBOUNCE4_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_debounce4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON10),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE4_MASK),
				  (unsigned int)(PMIC_ACCDET_DEBOUNCE4_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_ival_cur_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_IVAL_CUR_IN_MASK),
				    (unsigned int)(PMIC_ACCDET_IVAL_CUR_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_ival_cur_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IVAL_CUR_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_IVAL_CUR_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_ival_cur_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_CUR_IN_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_CUR_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_ival_cur_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_CUR_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_CUR_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_ival_sam_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_IVAL_SAM_IN_MASK),
				    (unsigned int)(PMIC_ACCDET_IVAL_SAM_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_ival_sam_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IVAL_SAM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_IVAL_SAM_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_ival_sam_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_SAM_IN_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_SAM_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_ival_sam_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_SAM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_SAM_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_ival_mem_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_IVAL_MEM_IN_MASK),
				    (unsigned int)(PMIC_ACCDET_IVAL_MEM_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_ival_mem_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IVAL_MEM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_IVAL_MEM_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_ival_mem_in(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_MEM_IN_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_MEM_IN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_ival_mem_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_MEM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_MEM_IN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_ival_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_SEL_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_IVAL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_ival_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_SEL_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IVAL_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_ival_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_IVAL_SEL_MASK),
				    (unsigned int)(PMIC_ACCDET_IVAL_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_ival_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON11),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IVAL_SEL_MASK),
				  (unsigned int)(PMIC_ACCDET_IVAL_SEL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IRQ_MASK),
				  (unsigned int)(PMIC_ACCDET_IRQ_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_IRQ_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_IRQ_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_eint_irq(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IRQ_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IRQ_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_irq_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_IRQ_CLR_MASK),
				    (unsigned int)(PMIC_ACCDET_IRQ_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_irq_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IRQ_CLR_MASK),
				  (unsigned int)(PMIC_ACCDET_IRQ_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_negv_irq_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_NEGV_IRQ_CLR_MASK),
				    (unsigned int)(PMIC_ACCDET_NEGV_IRQ_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_negv_irq_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_IRQ_CLR_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_IRQ_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_irq_clr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_IRQ_CLR_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_IRQ_CLR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_irq_clr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IRQ_CLR_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IRQ_CLR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_irq_polarity(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_IRQ_POLARITY_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_IRQ_POLARITY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_irq_polarity(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON12),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_IRQ_POLARITY_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_IRQ_POLARITY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE0_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE0_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE1_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE1_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE2_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE2_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE3_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE3_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE4_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE4_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE4_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE4_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE5_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE5_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE5_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE5_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_pwm_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_PWM_SEL_MASK),
				    (unsigned int)(PMIC_ACCDET_PWM_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_pwm_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_PWM_SEL_MASK),
				  (unsigned int)(PMIC_ACCDET_PWM_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_in_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_IN_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_IN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_in_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IN_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_IN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_cmp_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_CMP_EN_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_CMP_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_cmp_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_CMP_EN_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_CMP_EN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_vth_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_VTH_EN_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_VTH_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_vth_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_VTH_EN_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_VTH_EN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_mbias_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_MBIAS_EN_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_MBIAS_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_mbias_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_MBIAS_EN_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_MBIAS_EN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_pwm_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_PWM_EN_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_PWM_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_pwm_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON13),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_PWM_EN_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_PWM_EN_SW_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_cur_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_CUR_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_CUR_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_sam_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_SAM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_SAM_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_mem_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_MEM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_MEM_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_state(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_STATE_MASK),
				  (unsigned int)(PMIC_ACCDET_STATE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_mbias_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_MBIAS_CLK_MASK),
				  (unsigned int)(PMIC_ACCDET_MBIAS_CLK_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_vth_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_VTH_CLK_MASK),
				  (unsigned int)(PMIC_ACCDET_VTH_CLK_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_cmp_clk(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_CMP_CLK_MASK),
				  (unsigned int)(PMIC_ACCDET_CMP_CLK_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_audaccdetauxadcswctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON14),
				  (&val),
				  (unsigned int)(PMIC_DA_AUDACCDETAUXADCSWCTRL_MASK),
				  (unsigned int)(PMIC_DA_AUDACCDETAUXADCSWCTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_deb_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_DEB_SEL_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_DEB_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_deb_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON15),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_DEB_SEL_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_DEB_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_debounce(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_DEBOUNCE_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_DEBOUNCE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_debounce(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON15),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_DEBOUNCE_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_DEBOUNCE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_pwm_thresh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_THRESH_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_THRESH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_pwm_thresh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON15),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_THRESH_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_THRESH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_pwm_width(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_WIDTH_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_WIDTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_pwm_width(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON15),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_WIDTH_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_WIDTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_negv_thresh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_NEGV_THRESH_MASK),
				    (unsigned int)(PMIC_ACCDET_NEGV_THRESH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_negv_thresh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON16),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_THRESH_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_THRESH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_pwm_fall_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_FALL_DELAY_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_FALL_DELAY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_pwm_fall_delay(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON16),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_FALL_DELAY_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_FALL_DELAY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eint_pwm_rise_delay(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_RISE_DELAY_MASK),
				    (unsigned int)(PMIC_ACCDET_EINT_PWM_RISE_DELAY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eint_pwm_rise_delay(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON16),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_RISE_DELAY_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_PWM_RISE_DELAY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode13(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE13_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE13_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode13(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE13_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE13_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode12(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE12_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE12_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode12(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE12_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE12_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_nvdetectout_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_NVDETECTOUT_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_NVDETECTOUT_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_nvdetectout_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NVDETECTOUT_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_NVDETECTOUT_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode11(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE11_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE11_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode11(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE11_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE11_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode10(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE10_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE10_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode10(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE10_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE10_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eintcmpout_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINTCMPOUT_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_EINTCMPOUT_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eintcmpout_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINTCMPOUT_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_EINTCMPOUT_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode9(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE9_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE9_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode9(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE9_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE9_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode8(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE8_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE8_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode8(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE8_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE8_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_auxadc_ctrl_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_AUXADC_CTRL_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_AUXADC_CTRL_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_auxadc_ctrl_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_AUXADC_CTRL_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_AUXADC_CTRL_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode7(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE7_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE7_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode7(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE7_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE7_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_test_mode6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE6_MASK),
				    (unsigned int)(PMIC_ACCDET_TEST_MODE6_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_test_mode6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE6_MASK),
				  (unsigned int)(PMIC_ACCDET_TEST_MODE6_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_eintcmp_en_sw(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_EINTCMP_EN_SW_MASK),
				    (unsigned int)(PMIC_ACCDET_EINTCMP_EN_SW_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_eintcmp_en_sw(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON17),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINTCMP_EN_SW_MASK),
				  (unsigned int)(PMIC_ACCDET_EINTCMP_EN_SW_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nvcmpswen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NVCMPSWEN_MASK),
				    (unsigned int)(PMIC_RG_NVCMPSWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nvcmpswen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_NVCMPSWEN_MASK),
				  (unsigned int)(PMIC_RG_NVCMPSWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nvmodsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NVMODSEL_MASK),
				    (unsigned int)(PMIC_RG_NVMODSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nvmodsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_NVMODSEL_MASK),
				  (unsigned int)(PMIC_RG_NVMODSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_swbufswen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SWBUFSWEN_MASK),
				    (unsigned int)(PMIC_RG_SWBUFSWEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_swbufswen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_SWBUFSWEN_MASK),
				  (unsigned int)(PMIC_RG_SWBUFSWEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_swbufmodsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_SWBUFMODSEL_MASK),
				    (unsigned int)(PMIC_RG_SWBUFMODSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_swbufmodsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_SWBUFMODSEL_MASK),
				  (unsigned int)(PMIC_RG_SWBUFMODSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nvdetvth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NVDETVTH_MASK),
				    (unsigned int)(PMIC_RG_NVDETVTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nvdetvth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_NVDETVTH_MASK),
				  (unsigned int)(PMIC_RG_NVDETVTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_nvdetcmpen(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_NVDETCMPEN_MASK),
				    (unsigned int)(PMIC_RG_NVDETCMPEN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_nvdetcmpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_NVDETCMPEN_MASK),
				  (unsigned int)(PMIC_RG_NVDETCMPEN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_eintconfigaccdet(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EINTCONFIGACCDET_MASK),
				    (unsigned int)(PMIC_RG_EINTCONFIGACCDET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_eintconfigaccdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_EINTCONFIGACCDET_MASK),
				  (unsigned int)(PMIC_RG_EINTCONFIGACCDET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_eintcompvth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_EINTCOMPVTH_MASK),
				    (unsigned int)(PMIC_RG_EINTCOMPVTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_eintcompvth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_EINTCOMPVTH_MASK),
				  (unsigned int)(PMIC_RG_EINTCOMPVTH_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_eint_state(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_STATE_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_STATE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_auxadc_debounce_end(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_AUXADC_DEBOUNCE_END_MASK),
				  (unsigned int)(PMIC_ACCDET_AUXADC_DEBOUNCE_END_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_auxadc_connect_pre(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_AUXADC_CONNECT_PRE_MASK),
				  (unsigned int)(PMIC_ACCDET_AUXADC_CONNECT_PRE_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_eint_cur_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_CUR_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_CUR_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_eint_sam_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_SAM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_SAM_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_eint_mem_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_MEM_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_MEM_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_nvdetectout(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_AD_NVDETECTOUT_MASK),
				  (unsigned int)(PMIC_AD_NVDETECTOUT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_ad_eintcmpout(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_AD_EINTCMPOUT_MASK),
				  (unsigned int)(PMIC_AD_EINTCMPOUT_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_da_ni_eintcmpen(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON19),
				  (&val),
				  (unsigned int)(PMIC_DA_NI_EINTCMPEN_MASK),
				  (unsigned int)(PMIC_DA_NI_EINTCMPEN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_count_in(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON20),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_COUNT_IN_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_COUNT_IN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_en_final(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON20),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_EN_FINAL_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_EN_FINAL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_count_end(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON20),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_COUNT_END_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_COUNT_END_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_minu(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON20),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_MINU_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_MINU_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_add(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON20),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_ADD_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_ADD_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_negv_cmp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON20),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_NEGV_CMP_MASK),
				  (unsigned int)(PMIC_ACCDET_NEGV_CMP_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_cur_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON21),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_CUR_DEB_MASK),
				  (unsigned int)(PMIC_ACCDET_CUR_DEB_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_eint_cur_deb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON22),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_EINT_CUR_DEB_MASK),
				  (unsigned int)(PMIC_ACCDET_EINT_CUR_DEB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_rsv_con0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON23),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_RSV_CON0_MASK),
				    (unsigned int)(PMIC_ACCDET_RSV_CON0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_rsv_con0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON23),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_RSV_CON0_MASK),
				  (unsigned int)(PMIC_ACCDET_RSV_CON0_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_accdet_rsv_con1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON24),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_RSV_CON1_MASK),
				  (unsigned int)(PMIC_ACCDET_RSV_CON1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_accdet_auxadc_connect_time(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_ACCDET_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_ACCDET_AUXADC_CONNECT_TIME_MASK),
				    (unsigned int)(PMIC_ACCDET_AUXADC_CONNECT_TIME_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_accdet_auxadc_connect_time(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_ACCDET_CON25),
				  (&val),
				  (unsigned int)(PMIC_ACCDET_AUXADC_CONNECT_TIME_MASK),
				  (unsigned int)(PMIC_ACCDET_AUXADC_CONNECT_TIME_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcdt_hv_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_HV_EN_MASK),
				    (unsigned int)(PMIC_RG_VCDT_HV_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcdt_hv_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_VCDT_HV_EN_MASK),
				  (unsigned int)(PMIC_RG_VCDT_HV_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_chr_ldo_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_CHR_LDO_DET_MASK),
				  (unsigned int)(PMIC_RGS_CHR_LDO_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_automode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_AUTOMODE_MASK),
				    (unsigned int)(PMIC_RG_PCHR_AUTOMODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_automode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_AUTOMODE_MASK),
				  (unsigned int)(PMIC_RG_PCHR_AUTOMODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_EN_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_EN_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_EN_MASK),
				    (unsigned int)(PMIC_RG_CHR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_CHR_EN_MASK),
				  (unsigned int)(PMIC_RG_CHR_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_chrdet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_CHRDET_MASK),
				  (unsigned int)(PMIC_RGS_CHRDET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vcdt_lv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCDT_LV_DET_MASK),
				  (unsigned int)(PMIC_RGS_VCDT_LV_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vcdt_hv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_VCDT_HV_DET_MASK),
				  (unsigned int)(PMIC_RGS_VCDT_HV_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcdt_lv_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_LV_VTH_MASK),
				    (unsigned int)(PMIC_RG_VCDT_LV_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcdt_lv_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCDT_LV_VTH_MASK),
				  (unsigned int)(PMIC_RG_VCDT_LV_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcdt_hv_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_HV_VTH_MASK),
				    (unsigned int)(PMIC_RG_VCDT_HV_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcdt_hv_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON1),
				  (&val),
				  (unsigned int)(PMIC_RG_VCDT_HV_VTH_MASK),
				  (unsigned int)(PMIC_RG_VCDT_HV_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_cv_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_CV_EN_MASK),
				    (unsigned int)(PMIC_RG_VBAT_CV_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_cv_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_CV_EN_MASK),
				  (unsigned int)(PMIC_RG_VBAT_CV_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_cc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_CC_EN_MASK),
				    (unsigned int)(PMIC_RG_VBAT_CC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_cc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_CC_EN_MASK),
				  (unsigned int)(PMIC_RG_VBAT_CC_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cs_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON2),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CS_EN_MASK),
				    (unsigned int)(PMIC_RG_CS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cs_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RG_CS_EN_MASK),
				  (unsigned int)(PMIC_RG_CS_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_cs_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RGS_CS_DET_MASK),
				  (unsigned int)(PMIC_RGS_CS_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vbat_cv_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RGS_VBAT_CV_DET_MASK),
				  (unsigned int)(PMIC_RGS_VBAT_CV_DET_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vbat_cc_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON2),
				  (&val),
				  (unsigned int)(PMIC_RGS_VBAT_CC_DET_MASK),
				  (unsigned int)(PMIC_RGS_VBAT_CC_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_cv_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_CV_VTH_MASK),
				    (unsigned int)(PMIC_RG_VBAT_CV_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_cv_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_CV_VTH_MASK),
				  (unsigned int)(PMIC_RG_VBAT_CV_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_cc_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON3),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_CC_VTH_MASK),
				    (unsigned int)(PMIC_RG_VBAT_CC_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_cc_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON3),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_CC_VTH_MASK),
				  (unsigned int)(PMIC_RG_VBAT_CC_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cs_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON4),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CS_VTH_MASK),
				    (unsigned int)(PMIC_RG_CS_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cs_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON4),
				  (&val),
				  (unsigned int)(PMIC_RG_CS_VTH_MASK),
				  (unsigned int)(PMIC_RG_CS_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_tohtc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_TOHTC_MASK),
				    (unsigned int)(PMIC_RG_PCHR_TOHTC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_tohtc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_TOHTC_MASK),
				  (unsigned int)(PMIC_RG_PCHR_TOHTC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_toltc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON5),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_TOLTC_MASK),
				    (unsigned int)(PMIC_RG_PCHR_TOLTC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_toltc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON5),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_TOLTC_MASK),
				  (unsigned int)(PMIC_RG_PCHR_TOLTC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_ov_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_OV_EN_MASK),
				    (unsigned int)(PMIC_RG_VBAT_OV_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_ov_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_OV_EN_MASK),
				  (unsigned int)(PMIC_RG_VBAT_OV_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_ov_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_OV_VTH_MASK),
				    (unsigned int)(PMIC_RG_VBAT_OV_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_ov_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_OV_VTH_MASK),
				  (unsigned int)(PMIC_RG_VBAT_OV_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vbat_ov_deg(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON6),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VBAT_OV_DEG_MASK),
				    (unsigned int)(PMIC_RG_VBAT_OV_DEG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vbat_ov_deg(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON6),
				  (&val),
				  (unsigned int)(PMIC_RG_VBAT_OV_DEG_MASK),
				  (unsigned int)(PMIC_RG_VBAT_OV_DEG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_vbat_ov_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON6),
				  (&val),
				  (unsigned int)(PMIC_RGS_VBAT_OV_DET_MASK),
				  (unsigned int)(PMIC_RGS_VBAT_OV_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_baton_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_EN_MASK),
				    (unsigned int)(PMIC_RG_BATON_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_baton_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_BATON_EN_MASK),
				  (unsigned int)(PMIC_RG_BATON_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_baton_ht_en_rsv0(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_RSV0_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_EN_RSV0_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_baton_ht_en_rsv0(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_BATON_HT_EN_RSV0_MASK),
				  (unsigned int)(PMIC_RG_BATON_HT_EN_RSV0_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_baton_tdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_BATON_TDET_EN_MASK),
				    (unsigned int)(PMIC_BATON_TDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_baton_tdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON7),
				  (&val),
				  (unsigned int)(PMIC_BATON_TDET_EN_MASK),
				  (unsigned int)(PMIC_BATON_TDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_baton_ht_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_baton_ht_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_BATON_HT_TRIM_MASK),
				  (unsigned int)(PMIC_RG_BATON_HT_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_baton_ht_trim_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_SET_MASK),
				    (unsigned int)(PMIC_RG_BATON_HT_TRIM_SET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_baton_ht_trim_set(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_BATON_HT_TRIM_SET_MASK),
				  (unsigned int)(PMIC_RG_BATON_HT_TRIM_SET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_baton_tdet_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON7),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BATON_TDET_EN_MASK),
				    (unsigned int)(PMIC_RG_BATON_TDET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_baton_tdet_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON7),
				  (&val),
				  (unsigned int)(PMIC_RG_BATON_TDET_EN_MASK),
				  (unsigned int)(PMIC_RG_BATON_TDET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_data(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON8),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_DATA_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_DATA_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_data(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON8),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_DATA_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_DATA_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_frc_csvth_usbdl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON9),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_FRC_CSVTH_USBDL_MASK),
				    (unsigned int)(PMIC_RG_FRC_CSVTH_USBDL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_frc_csvth_usbdl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON9),
				  (&val),
				  (unsigned int)(PMIC_RG_FRC_CSVTH_USBDL_MASK),
				  (unsigned int)(PMIC_RG_FRC_CSVTH_USBDL_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_pchr_flag_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON10),
				  (&val),
				  (unsigned int)(PMIC_RGS_PCHR_FLAG_OUT_MASK),
				  (unsigned int)(PMIC_RGS_PCHR_FLAG_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_flag_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_EN_MASK),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_flag_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_FLAG_EN_MASK),
				  (unsigned int)(PMIC_RG_PCHR_FLAG_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_otg_bvalid_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON10),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OTG_BVALID_EN_MASK),
				    (unsigned int)(PMIC_RG_OTG_BVALID_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_otg_bvalid_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON10),
				  (&val),
				  (unsigned int)(PMIC_RG_OTG_BVALID_EN_MASK),
				  (unsigned int)(PMIC_RG_OTG_BVALID_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_otg_bvalid_det(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON10),
				  (&val),
				  (unsigned int)(PMIC_RGS_OTG_BVALID_DET_MASK),
				  (unsigned int)(PMIC_RGS_OTG_BVALID_DET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_flag_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON11),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_SEL_MASK),
				    (unsigned int)(PMIC_RG_PCHR_FLAG_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_flag_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON11),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_FLAG_SEL_MASK),
				  (unsigned int)(PMIC_RG_PCHR_FLAG_SEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_testmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_TESTMODE_MASK),
				    (unsigned int)(PMIC_RG_PCHR_TESTMODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_testmode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_TESTMODE_MASK),
				  (unsigned int)(PMIC_RG_PCHR_TESTMODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_testmode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_TESTMODE_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_TESTMODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_testmode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_TESTMODE_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_TESTMODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_RST_MASK),
				    (unsigned int)(PMIC_RG_PCHR_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_RST_MASK),
				  (unsigned int)(PMIC_RG_PCHR_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_ft_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON12),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_FT_CTRL_MASK),
				    (unsigned int)(PMIC_RG_PCHR_FT_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_ft_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON12),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_FT_CTRL_MASK),
				  (unsigned int)(PMIC_RG_PCHR_FT_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_TD_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_TD_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_EN_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_EN_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_wr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON13),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_WR_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_WR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_wr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON13),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_WR_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_WR_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_rv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON14),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_RV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_RV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_rv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON14),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_RV_MASK),
				  (unsigned int)(PMIC_RG_PCHR_RV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_INT_EN_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_INT_EN_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrwdt_flag_wr(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON15),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_WR_MASK),
				    (unsigned int)(PMIC_RG_CHRWDT_FLAG_WR_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrwdt_flag_wr(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON15),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRWDT_FLAG_WR_MASK),
				  (unsigned int)(PMIC_RG_CHRWDT_FLAG_WR_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_chrwdt_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON15),
				  (&val),
				  (unsigned int)(PMIC_RGS_CHRWDT_OUT_MASK),
				  (unsigned int)(PMIC_RGS_CHRWDT_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_usbdl_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_USBDL_RST_MASK),
				    (unsigned int)(PMIC_RG_USBDL_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_usbdl_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_USBDL_RST_MASK),
				  (unsigned int)(PMIC_RG_USBDL_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_usbdl_set(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_USBDL_SET_MASK),
				    (unsigned int)(PMIC_RG_USBDL_SET_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_usbdl_set(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_USBDL_SET_MASK),
				  (unsigned int)(PMIC_RG_USBDL_SET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_adcin_vsen_mux_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_MUX_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_MUX_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_adcin_vsen_mux_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_ADCIN_VSEN_MUX_EN_MASK),
				  (unsigned int)(PMIC_RG_ADCIN_VSEN_MUX_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_adcin_vsen_ext_baton_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_adcin_vsen_ext_baton_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_MASK),
				  (unsigned int)(PMIC_RG_ADCIN_VSEN_EXT_BATON_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_adcin_vbat_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VBAT_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VBAT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_adcin_vbat_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_ADCIN_VBAT_EN_MASK),
				  (unsigned int)(PMIC_RG_ADCIN_VBAT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_adcin_vsen_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_VSEN_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_adcin_vsen_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_ADCIN_VSEN_EN_MASK),
				  (unsigned int)(PMIC_RG_ADCIN_VSEN_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_adcin_chr_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON16),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ADCIN_CHR_EN_MASK),
				    (unsigned int)(PMIC_RG_ADCIN_CHR_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_adcin_chr_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON16),
				  (&val),
				  (unsigned int)(PMIC_RG_ADCIN_CHR_EN_MASK),
				  (unsigned int)(PMIC_RG_ADCIN_CHR_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_uvlo_vthl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_UVLO_VTHL_MASK),
				    (unsigned int)(PMIC_RG_UVLO_VTHL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_uvlo_vthl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON17),
				  (&val),
				  (unsigned int)(PMIC_RG_UVLO_VTHL_MASK),
				  (unsigned int)(PMIC_RG_UVLO_VTHL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_uvlo_vh_lat(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON17),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_UVLO_VH_LAT_MASK),
				    (unsigned int)(PMIC_RG_UVLO_VH_LAT_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_uvlo_vh_lat(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON17),
				  (&val),
				  (unsigned int)(PMIC_RG_UVLO_VH_LAT_MASK),
				  (unsigned int)(PMIC_RG_UVLO_VH_LAT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_lbat_int_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON18),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LBAT_INT_VTH_MASK),
				    (unsigned int)(PMIC_RG_LBAT_INT_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_lbat_int_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON18),
				  (&val),
				  (unsigned int)(PMIC_RG_LBAT_INT_VTH_MASK),
				  (unsigned int)(PMIC_RG_LBAT_INT_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_rsel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_RSEL_MASK),
				    (unsigned int)(PMIC_RG_BGR_RSEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_rsel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON19),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_RSEL_MASK),
				  (unsigned int)(PMIC_RG_BGR_RSEL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_unchop_ph(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_PH_MASK),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_PH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_unchop_ph(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON19),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_UNCHOP_PH_MASK),
				  (unsigned int)(PMIC_RG_BGR_UNCHOP_PH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_unchop(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON19),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_MASK),
				    (unsigned int)(PMIC_RG_BGR_UNCHOP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_unchop(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON19),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_UNCHOP_MASK),
				  (unsigned int)(PMIC_RG_BGR_UNCHOP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_bb_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_BB_CTRL_MASK),
				    (unsigned int)(PMIC_RG_BC11_BB_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_bb_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON20),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_BB_CTRL_MASK),
				  (unsigned int)(PMIC_RG_BC11_BB_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_rst(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_RST_MASK),
				    (unsigned int)(PMIC_RG_BC11_RST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_rst(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON20),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_RST_MASK),
				  (unsigned int)(PMIC_RG_BC11_RST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_vsrc_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON20),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_VSRC_EN_MASK),
				    (unsigned int)(PMIC_RG_BC11_VSRC_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_vsrc_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON20),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_VSRC_EN_MASK),
				  (unsigned int)(PMIC_RG_BC11_VSRC_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_bc11_cmp_out(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON20),
				  (&val),
				  (unsigned int)(PMIC_RGS_BC11_CMP_OUT_MASK),
				  (unsigned int)(PMIC_RGS_BC11_CMP_OUT_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_vref_vth(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_VREF_VTH_MASK),
				    (unsigned int)(PMIC_RG_BC11_VREF_VTH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_vref_vth(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON21),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_VREF_VTH_MASK),
				  (unsigned int)(PMIC_RG_BC11_VREF_VTH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_cmp_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_CMP_EN_MASK),
				    (unsigned int)(PMIC_RG_BC11_CMP_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_cmp_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON21),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_CMP_EN_MASK),
				  (unsigned int)(PMIC_RG_BC11_CMP_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_ipd_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_IPD_EN_MASK),
				    (unsigned int)(PMIC_RG_BC11_IPD_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_ipd_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON21),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_IPD_EN_MASK),
				  (unsigned int)(PMIC_RG_BC11_IPD_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_ipu_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_IPU_EN_MASK),
				    (unsigned int)(PMIC_RG_BC11_IPU_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_ipu_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON21),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_IPU_EN_MASK),
				  (unsigned int)(PMIC_RG_BC11_IPU_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bc11_bias_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON21),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BC11_BIAS_EN_MASK),
				    (unsigned int)(PMIC_RG_BC11_BIAS_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bc11_bias_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON21),
				  (&val),
				  (unsigned int)(PMIC_RG_BC11_BIAS_EN_MASK),
				  (unsigned int)(PMIC_RG_BC11_BIAS_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_stp_inc(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_STP_INC_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_STP_INC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_stp_inc(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON22),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_STP_INC_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_STP_INC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_stp_dec(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON22),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_STP_DEC_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_STP_DEC_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_stp_dec(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON22),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_STP_DEC_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_STP_DEC_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_dly(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON23),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_DLY_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_DLY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_dly(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON23),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_DLY_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_DLY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_stp(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON23),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_STP_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_STP_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_stp(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON23),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_STP_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_STP_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_low_ich_db(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON24),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_LOW_ICH_DB_MASK),
				    (unsigned int)(PMIC_RG_LOW_ICH_DB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_low_ich_db(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON24),
				  (&val),
				  (unsigned int)(PMIC_RG_LOW_ICH_DB_MASK),
				  (unsigned int)(PMIC_RG_LOW_ICH_DB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrind_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON24),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRIND_ON_MASK),
				    (unsigned int)(PMIC_RG_CHRIND_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrind_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON24),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRIND_ON_MASK),
				  (unsigned int)(PMIC_RG_CHRIND_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chrind_dimming(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON24),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHRIND_DIMMING_MASK),
				    (unsigned int)(PMIC_RG_CHRIND_DIMMING_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chrind_dimming(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON24),
				  (&val),
				  (unsigned int)(PMIC_RG_CHRIND_DIMMING_MASK),
				  (unsigned int)(PMIC_RG_CHRIND_DIMMING_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cv_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CV_MODE_MASK),
				    (unsigned int)(PMIC_RG_CV_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cv_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON25),
				  (&val),
				  (unsigned int)(PMIC_RG_CV_MODE_MASK),
				  (unsigned int)(PMIC_RG_CV_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcdt_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_MODE_MASK),
				    (unsigned int)(PMIC_RG_VCDT_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcdt_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON25),
				  (&val),
				  (unsigned int)(PMIC_RG_VCDT_MODE_MASK),
				  (unsigned int)(PMIC_RG_VCDT_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_csdac_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CSDAC_MODE_MASK),
				    (unsigned int)(PMIC_RG_CSDAC_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_csdac_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON25),
				  (&val),
				  (unsigned int)(PMIC_RG_CSDAC_MODE_MASK),
				  (unsigned int)(PMIC_RG_CSDAC_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_tracking_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_TRACKING_EN_MASK),
				    (unsigned int)(PMIC_RG_TRACKING_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_tracking_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON25),
				  (&val),
				  (unsigned int)(PMIC_RG_TRACKING_EN_MASK),
				  (unsigned int)(PMIC_RG_TRACKING_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hwcv_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HWCV_EN_MASK),
				    (unsigned int)(PMIC_RG_HWCV_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hwcv_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON25),
				  (&val),
				  (unsigned int)(PMIC_RG_HWCV_EN_MASK),
				  (unsigned int)(PMIC_RG_HWCV_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_ulc_det_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON25),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ULC_DET_EN_MASK),
				    (unsigned int)(PMIC_RG_ULC_DET_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_ulc_det_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON25),
				  (&val),
				  (unsigned int)(PMIC_RG_ULC_DET_EN_MASK),
				  (unsigned int)(PMIC_RG_ULC_DET_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_trim_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TRIM_EN_MASK),
				    (unsigned int)(PMIC_RG_BGR_TRIM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_trim_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON26),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_TRIM_EN_MASK),
				  (unsigned int)(PMIC_RG_BGR_TRIM_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_ichrg_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON26),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ICHRG_TRIM_MASK),
				    (unsigned int)(PMIC_RG_ICHRG_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_ichrg_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON26),
				  (&val),
				  (unsigned int)(PMIC_RG_ICHRG_TRIM_MASK),
				  (unsigned int)(PMIC_RG_ICHRG_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON27),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TRIM_MASK),
				    (unsigned int)(PMIC_RG_BGR_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON27),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_TRIM_MASK),
				  (unsigned int)(PMIC_RG_BGR_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_ovp_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON28),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_OVP_TRIM_MASK),
				    (unsigned int)(PMIC_RG_OVP_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_ovp_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON28),
				  (&val),
				  (unsigned int)(PMIC_RG_OVP_TRIM_MASK),
				  (unsigned int)(PMIC_RG_OVP_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_chr_osc_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CHR_OSC_TRIM_MASK),
				    (unsigned int)(PMIC_RG_CHR_OSC_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_chr_osc_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON29),
				  (&val),
				  (unsigned int)(PMIC_RG_CHR_OSC_TRIM_MASK),
				  (unsigned int)(PMIC_RG_CHR_OSC_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_da_qi_bgr_ext_buf_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_DA_QI_BGR_EXT_BUF_EN_MASK),
				    (unsigned int)(PMIC_DA_QI_BGR_EXT_BUF_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_da_qi_bgr_ext_buf_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON29),
				  (&val),
				  (unsigned int)(PMIC_DA_QI_BGR_EXT_BUF_EN_MASK),
				  (unsigned int)(PMIC_DA_QI_BGR_EXT_BUF_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_test_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_EN_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_test_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON29),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_TEST_EN_MASK),
				  (unsigned int)(PMIC_RG_BGR_TEST_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_bgr_test_rstb(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON29),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_BGR_TEST_RSTB_MASK),
				    (unsigned int)(PMIC_RG_BGR_TEST_RSTB_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_bgr_test_rstb(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON29),
				  (&val),
				  (unsigned int)(PMIC_RG_BGR_TEST_RSTB_MASK),
				  (unsigned int)(PMIC_RG_BGR_TEST_RSTB_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_dac_usbdl_max(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON30),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_DAC_USBDL_MAX_MASK),
				    (unsigned int)(PMIC_RG_DAC_USBDL_MAX_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_dac_usbdl_max(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON30),
				  (&val),
				  (unsigned int)(PMIC_RG_DAC_USBDL_MAX_MASK),
				  (unsigned int)(PMIC_RG_DAC_USBDL_MAX_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON31),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_TRIG_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON31),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_TRIG_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_TRIG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_pchr_cm_vdec_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON31),
				  (&val),
				  (unsigned int)(PMIC_PCHR_CM_VDEC_STATUS_MASK),
				  (unsigned int)(PMIC_PCHR_CM_VDEC_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_trig(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON32),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_TRIG_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_TRIG_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_trig(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON32),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_TRIG_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_TRIG_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_pchr_cm_vinc_status(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON32),
				  (&val),
				  (unsigned int)(PMIC_PCHR_CM_VINC_STATUS_MASK),
				  (unsigned int)(PMIC_PCHR_CM_VINC_STATUS_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_hprd1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON33),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD1_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_hprd1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON33),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD1_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_hprd2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON33),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD2_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_hprd2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON33),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD2_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_hprd3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON34),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD3_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_hprd3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON34),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD3_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_hprd4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON34),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD4_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD4_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_hprd4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON34),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD4_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD4_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_hprd5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON35),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD5_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD5_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_hprd5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON35),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD5_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD5_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_hprd6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON35),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD6_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_HPRD6_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_hprd6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON35),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD6_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_HPRD6_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_hprd1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON36),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD1_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_hprd1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON36),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD1_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_hprd2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON36),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD2_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_hprd2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON36),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD2_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_hprd3(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON37),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD3_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD3_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_hprd3(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON37),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD3_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD3_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_hprd4(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON37),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD4_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD4_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_hprd4(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON37),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD4_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD4_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_hprd5(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON38),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD5_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD5_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_hprd5(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON38),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD5_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD5_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_hprd6(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON38),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD6_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_HPRD6_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_hprd6(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON38),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD6_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_HPRD6_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_lprd(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON39),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_LPRD_MASK),
				    (unsigned int)(PMIC_RG_CM_LPRD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_lprd(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON39),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_LPRD_MASK),
				  (unsigned int)(PMIC_RG_CM_LPRD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_cs_vthl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON40),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_CS_VTHL_MASK),
				    (unsigned int)(PMIC_RG_CM_CS_VTHL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_cs_vthl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON40),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_CS_VTHL_MASK),
				  (unsigned int)(PMIC_RG_CM_CS_VTHL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_cs_vthh(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON40),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_CS_VTHH_MASK),
				    (unsigned int)(PMIC_RG_CM_CS_VTHH_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_cs_vthh(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON40),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_CS_VTHH_MASK),
				  (unsigned int)(PMIC_RG_CM_CS_VTHH_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_pchr_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON41),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_PCHR_RSV_MASK),
				    (unsigned int)(PMIC_RG_PCHR_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_pchr_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON41),
				  (&val),
				  (unsigned int)(PMIC_RG_PCHR_RSV_MASK),
				  (unsigned int)(PMIC_RG_PCHR_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_envtem_d(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON42),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ENVTEM_D_MASK),
				    (unsigned int)(PMIC_RG_ENVTEM_D_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_envtem_d(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON42),
				  (&val),
				  (unsigned int)(PMIC_RG_ENVTEM_D_MASK),
				  (unsigned int)(PMIC_RG_ENVTEM_D_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_envtem_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON42),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_ENVTEM_EN_MASK),
				    (unsigned int)(PMIC_RG_ENVTEM_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_envtem_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON42),
				  (&val),
				  (unsigned int)(PMIC_RG_ENVTEM_EN_MASK),
				  (unsigned int)(PMIC_RG_ENVTEM_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_baton_hv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_RGS_BATON_HV_MASK),
				  (unsigned int)(PMIC_RGS_BATON_HV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hw_vth_ctrl(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HW_VTH_CTRL_MASK),
				    (unsigned int)(PMIC_RG_HW_VTH_CTRL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hw_vth_ctrl(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_HW_VTH_CTRL_MASK),
				  (unsigned int)(PMIC_RG_HW_VTH_CTRL_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hw_vth2(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HW_VTH2_MASK),
				    (unsigned int)(PMIC_RG_HW_VTH2_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hw_vth2(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_HW_VTH2_MASK),
				  (unsigned int)(PMIC_RG_HW_VTH2_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_hw_vth1(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_BATON_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_HW_VTH1_MASK),
				    (unsigned int)(PMIC_RG_HW_VTH1_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_hw_vth1(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_BATON_CON0),
				  (&val),
				  (unsigned int)(PMIC_RG_HW_VTH1_MASK),
				  (unsigned int)(PMIC_RG_HW_VTH1_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vdec_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON43),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VDEC_INT_EN_MASK),
				    (unsigned int)(PMIC_RG_CM_VDEC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vdec_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON43),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VDEC_INT_EN_MASK),
				  (unsigned int)(PMIC_RG_CM_VDEC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_cm_vinc_int_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON43),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_CM_VINC_INT_EN_MASK),
				    (unsigned int)(PMIC_RG_CM_VINC_INT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_cm_vinc_int_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON43),
				  (&val),
				  (unsigned int)(PMIC_RG_CM_VINC_INT_EN_MASK),
				  (unsigned int)(PMIC_RG_CM_VINC_INT_EN_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_qi_baton_lt_en(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON44),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_QI_BATON_LT_EN_MASK),
				    (unsigned int)(PMIC_RG_QI_BATON_LT_EN_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_qi_baton_lt_en(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON44),
				  (&val),
				  (unsigned int)(PMIC_RG_QI_BATON_LT_EN_MASK),
				  (unsigned int)(PMIC_RG_QI_BATON_LT_EN_SHIFT)
	    );


	return val;
}

unsigned int mt6353_upmu_get_rgs_baton_undet(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON44),
				  (&val),
				  (unsigned int)(PMIC_RGS_BATON_UNDET_MASK),
				  (unsigned int)(PMIC_RGS_BATON_UNDET_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_vcdt_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON48),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_VCDT_TRIM_MASK),
				    (unsigned int)(PMIC_RG_VCDT_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_vcdt_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON48),
				  (&val),
				  (unsigned int)(PMIC_RG_VCDT_TRIM_MASK),
				  (unsigned int)(PMIC_RG_VCDT_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_rg_indicator_trim(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_CHR_CON48),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_RG_INDICATOR_TRIM_MASK),
				    (unsigned int)(PMIC_RG_INDICATOR_TRIM_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_rg_indicator_trim(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_CHR_CON48),
				  (&val),
				  (unsigned int)(PMIC_RG_INDICATOR_TRIM_MASK),
				  (unsigned int)(PMIC_RG_INDICATOR_TRIM_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_eosc_cali_start(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_EOSC_CALI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_START_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_START_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_eosc_cali_start(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EOSC_CALI_CON0),
				  (&val),
				  (unsigned int)(PMIC_EOSC_CALI_START_MASK),
				  (unsigned int)(PMIC_EOSC_CALI_START_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_eosc_cali_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_EOSC_CALI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_TD_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_eosc_cali_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EOSC_CALI_CON0),
				  (&val),
				  (unsigned int)(PMIC_EOSC_CALI_TD_MASK),
				  (unsigned int)(PMIC_EOSC_CALI_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_eosc_cali_test(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_EOSC_CALI_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_TEST_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_TEST_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_eosc_cali_test(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EOSC_CALI_CON0),
				  (&val),
				  (unsigned int)(PMIC_EOSC_CALI_TEST_MASK),
				  (unsigned int)(PMIC_EOSC_CALI_TEST_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_eosc_cali_dcxo_rdy_td(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_EOSC_CALI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_DCXO_RDY_TD_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_DCXO_RDY_TD_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_eosc_cali_dcxo_rdy_td(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EOSC_CALI_CON1),
				  (&val),
				  (unsigned int)(PMIC_EOSC_CALI_DCXO_RDY_TD_MASK),
				  (unsigned int)(PMIC_EOSC_CALI_DCXO_RDY_TD_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_frc_vtcxo0_on(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_EOSC_CALI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_FRC_VTCXO0_ON_MASK),
				    (unsigned int)(PMIC_FRC_VTCXO0_ON_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_frc_vtcxo0_on(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EOSC_CALI_CON1),
				  (&val),
				  (unsigned int)(PMIC_FRC_VTCXO0_ON_MASK),
				  (unsigned int)(PMIC_FRC_VTCXO0_ON_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_eosc_cali_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_EOSC_CALI_CON1),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_EOSC_CALI_RSV_MASK),
				    (unsigned int)(PMIC_EOSC_CALI_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_eosc_cali_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_EOSC_CALI_CON1),
				  (&val),
				  (unsigned int)(PMIC_EOSC_CALI_RSV_MASK),
				  (unsigned int)(PMIC_EOSC_CALI_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_vrtc_pwm_mode(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_MODE_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_MODE_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_vrtc_pwm_mode(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_VRTC_PWM_MODE_MASK),
				  (unsigned int)(PMIC_VRTC_PWM_MODE_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_vrtc_pwm_rsv(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_RSV_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_RSV_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_vrtc_pwm_rsv(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_VRTC_PWM_RSV_MASK),
				  (unsigned int)(PMIC_VRTC_PWM_RSV_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_vrtc_pwm_l_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_L_DUTY_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_L_DUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_vrtc_pwm_l_duty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_VRTC_PWM_L_DUTY_MASK),
				  (unsigned int)(PMIC_VRTC_PWM_L_DUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_vrtc_pwm_h_duty(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_PWM_H_DUTY_MASK),
				    (unsigned int)(PMIC_VRTC_PWM_H_DUTY_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_vrtc_pwm_h_duty(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_VRTC_PWM_H_DUTY_MASK),
				  (unsigned int)(PMIC_VRTC_PWM_H_DUTY_SHIFT)
	    );


	return val;
}

void mt6353_upmu_set_vrtc_cap_sel(unsigned int val)
{
	unsigned int ret = 0;


	ret = pmic_config_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				    (unsigned int)(val),
				    (unsigned int)(PMIC_VRTC_CAP_SEL_MASK),
				    (unsigned int)(PMIC_VRTC_CAP_SEL_SHIFT)
	    );

}

unsigned int mt6353_upmu_get_vrtc_cap_sel(void)
{
	unsigned int ret = 0;
	unsigned int val = 0;


	ret = pmic_read_interface((unsigned int)(MT6353_VRTC_PWM_CON0),
				  (&val),
				  (unsigned int)(PMIC_VRTC_CAP_SEL_MASK),
				  (unsigned int)(PMIC_VRTC_CAP_SEL_SHIFT)
	    );


	return val;
}
